﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MCEBuddy.Globals
{
    public class ISO639_3
    {
        // Taken from www.sil.org/iso639-3/
        // The format for the ISO Language codes
        // 3 Digit Code, Print Name, Inverted Name
        public static string[,] ISOLanguageCodes = {
                                    { "", "<Default>", "<Default>" },
                                    { "qaa", "<Original>", "<Original>" },
                                    { "aiw", "Aari", "Aari" },
                                    { "aas", "Aasáx", "Aasáx" },
                                    { "kbt", "Abadi", "Abadi" },
                                    { "abg", "Abaga", "Abaga" },
                                    { "abf", "Abai Sungai", "Abai Sungai" },
                                    { "abm", "Abanyom", "Abanyom" },
                                    { "mij", "Abar", "Abar" },
                                    { "aau", "Abau", "Abau" },
                                    { "abq", "Abaza", "Abaza" },
                                    { "aba", "Abé", "Abé" },
                                    { "abi", "Abidji", "Abidji" },
                                    { "bsa", "Abinomn", "Abinomn" },
                                    { "axb", "Abipon", "Abipon" },
                                    { "ash", "Abishira", "Abishira" },
                                    { "abk", "Abkhazian", "Abkhazian" },
                                    { "aaq", "Eastern Abnaki", "Abnaki, Eastern" },
                                    { "abe", "Western Abnaki", "Abnaki, Western" },
                                    { "aob", "Abom", "Abom" },
                                    { "abo", "Abon", "Abon" },
                                    { "abr", "Abron", "Abron" },
                                    { "ado", "Abu", "Abu" },
                                    { "abn", "Abua", "Abua" },
                                    { "abz", "Abui", "Abui" },
                                    { "kgr", "Abun", "Abun" },
                                    { "abu", "Abure", "Abure" },
                                    { "mgj", "Abureni", "Abureni" },
                                    { "aca", "Achagua", "Achagua" },
                                    { "acn", "Achang", "Achang" },
                                    { "yif", "Ache", "Ache" },
                                    { "guq", "Aché", "Aché" },
                                    { "acz", "Acheron", "Acheron" },
                                    { "acr", "Achi", "Achi" },
                                    { "ace", "Achinese", "Achinese" },
                                    { "act", "Achterhoeks", "Achterhoeks" },
                                    { "acu", "Achuar-Shiwiar", "Achuar-Shiwiar" },
                                    { "acv", "Achumawi", "Achumawi" },
                                    { "acp", "Eastern Acipa", "Acipa, Eastern" },
                                    { "ach", "Acoli", "Acoli" },
                                    { "acs", "Acroá", "Acroá" },
                                    { "adb", "Adabe", "Adabe" },
                                    { "xad", "Adai", "Adai" },
                                    { "ads", "Adamorobe Sign Language", "Adamorobe Sign Language" },
                                    { "adn", "Adang", "Adang" },
                                    { "adq", "Adangbe", "Adangbe" },
                                    { "ada", "Adangme", "Adangme" },
                                    { "adp", "Adap", "Adap" },
                                    { "kad", "Adara", "Adara" },
                                    { "tiu", "Adasen", "Adasen" },
                                    { "ade", "Adele", "Adele" },
                                    { "adh", "Adhola", "Adhola" },
                                    { "adi", "Adi", "Adi" },
                                    { "adj", "Adioukrou", "Adioukrou" },
                                    { "dth", "Adithinngithigh", "Adithinngithigh" },
                                    { "adt", "Adnyamathanha", "Adnyamathanha" },
                                    { "adr", "Adonara", "Adonara" },
                                    { "adu", "Aduge", "Aduge" },
                                    { "ady", "Adyghe", "Adyghe" },
                                    { "adz", "Adzera", "Adzera" },
                                    { "aez", "Aeka", "Aeka" },
                                    { "awi", "Aekyom", "Aekyom" },
                                    { "xae", "Aequian", "Aequian" },
                                    { "aeq", "Aer", "Aer" },
                                    { "aal", "Afade", "Afade" },
                                    { "aar", "Afar", "Afar" },
                                    { "afg", "Afghan Sign Language", "Afghan Sign Language" },
                                    { "aft", "Afitti", "Afitti" },
                                    { "afh", "Afrihili", "Afrihili" },
                                    { "afr", "Afrikaans", "Afrikaans" },
                                    { "agd", "Agarabi", "Agarabi" },
                                    { "agi", "Agariya", "Agariya" },
                                    { "agc", "Agatu", "Agatu" },
                                    { "avo", "Agavotaguerra", "Agavotaguerra" },
                                    { "agq", "Aghem", "Aghem" },
                                    { "ahh", "Aghu", "Aghu" },
                                    { "ggr", "Aghu Tharnggalu", "Aghu Tharnggalu" },
                                    { "agx", "Aghul", "Aghul" },
                                    { "xag", "Aghwan", "Aghwan" },
                                    { "aif", "Agi", "Agi" },
                                    { "kit", "Agob", "Agob" },
                                    { "ibm", "Agoi", "Agoi" },
                                    { "dul", "Alabat Island Agta", "Agta, Alabat Island" },
                                    { "dgc", "Casiguran Dumagat Agta", "Agta, Casiguran Dumagat" },
                                    { "agt", "Central Cagayan Agta", "Agta, Central Cagayan" },
                                    { "duy", "Dicamay Agta", "Agta, Dicamay" },
                                    { "duo", "Dupaninan Agta", "Agta, Dupaninan" },
                                    { "agk", "Isarog Agta", "Agta, Isarog" },
                                    { "atl", "Mt. Iraya Agta", "Agta, Mt. Iraya" },
                                    { "agz", "Mt. Iriga Agta", "Agta, Mt. Iriga" },
                                    { "apf", "Pahanan Agta", "Agta, Pahanan" },
                                    { "due", "Umiray Dumaget Agta", "Agta, Umiray Dumaget" },
                                    { "dyg", "Villa Viciosa Agta", "Agta, Villa Viciosa" },
                                    { "agu", "Aguacateco", "Aguacateco" },
                                    { "aga", "Aguano", "Aguano" },
                                    { "agr", "Aguaruna", "Aguaruna" },
                                    { "aug", "Aguna", "Aguna" },
                                    { "agn", "Agutaynen", "Agutaynen" },
                                    { "yay", "Agwagwune", "Agwagwune" },
                                    { "ahn", "Àhàn", "Àhàn" },
                                    { "aha", "Ahanta", "Ahanta" },
                                    { "thm", "Aheu", "Aheu" },
                                    { "ahr", "Ahirani", "Ahirani" },
                                    { "aho", "Ahom", "Ahom" },
                                    { "aht", "Ahtena", "Ahtena" },
                                    { "nfd", "Ahwai", "Ahwai" },
                                    { "aih", "Ai-Cham", "Ai-Cham" },
                                    { "aix", "Aighon", "Aighon" },
                                    { "tba", "Aikanã", "Aikanã" },
                                    { "mwg", "Aiklep", "Aiklep" },
                                    { "aiq", "Aimaq", "Aimaq" },
                                    { "ail", "Aimele", "Aimele" },
                                    { "aim", "Aimol", "Aimol" },
                                    { "aic", "Ainbai", "Ainbai" },
                                    { "aib", "Ainu (China)", "Ainu (China)" },
                                    { "ain", "Ainu (Japan)", "Ainu (Japan)" },
                                    { "aki", "Aiome", "Aiome" },
                                    { "air", "Airoran", "Airoran" },
                                    { "aio", "Aiton", "Aiton" },
                                    { "nfl", "Äiwoo", "Äiwoo" },
                                    { "ahp", "Aproumu Aizi", "Aizi, Aproumu" },
                                    { "ahm", "Mobumrin Aizi", "Aizi, Mobumrin" },
                                    { "ahi", "Tiagbamrin Aizi", "Aizi, Tiagbamrin" },
                                    { "ajg", "Aja (Benin)", "Aja (Benin)" },
                                    { "aja", "Aja (Sudan)", "Aja (Sudan)" },
                                    { "ajw", "Ajawa", "Ajawa" },
                                    { "aji", "Ajië", "Ajië" },
                                    { "cpc", "Ajyíninka Apurucayali", "Ajyíninka Apurucayali" },
                                    { "akq", "Ak", "Ak" },
                                    { "soh", "Aka", "Aka" },
                                    { "abj", "Aka-Bea", "Aka-Bea" },
                                    { "akm", "Aka-Bo", "Aka-Bo" },
                                    { "aci", "Aka-Cari", "Aka-Cari" },
                                    { "akj", "Aka-Jeru", "Aka-Jeru" },
                                    { "akx", "Aka-Kede", "Aka-Kede" },
                                    { "aky", "Aka-Kol", "Aka-Kol" },
                                    { "ack", "Aka-Kora", "Aka-Kora" },
                                    { "aka", "Akan", "Akan" },
                                    { "acl", "Akar-Bale", "Akar-Bale" },
                                    { "aks", "Akaselem", "Akaselem" },
                                    { "ake", "Akawaio", "Akawaio" },
                                    { "aik", "Ake", "Ake" },
                                    { "keu", "Akebu", "Akebu" },
                                    { "tsr", "Akei", "Akei" },
                                    { "aeu", "Akeu", "Akeu" },
                                    { "ahk", "Akha", "Akha" },
                                    { "akv", "Akhvakh", "Akhvakh" },
                                    { "akk", "Akkadian", "Akkadian" },
                                    { "akl", "Aklanon", "Aklanon" },
                                    { "akt", "Akolet", "Akolet" },
                                    { "bss", "Akoose", "Akoose" },
                                    { "miw", "Akoye", "Akoye" },
                                    { "akf", "Akpa", "Akpa" },
                                    { "ibe", "Akpes", "Akpes" },
                                    { "afi", "Akrukay", "Akrukay" },
                                    { "spm", "Akukem", "Akukem" },
                                    { "ayk", "Akuku", "Akuku" },
                                    { "aku", "Akum", "Akum" },
                                    { "aqz", "Akuntsu", "Akuntsu" },
                                    { "ako", "Akurio", "Akurio" },
                                    { "akw", "Akwa", "Akwa" },
                                    { "akz", "Alabama", "Alabama" },
                                    { "ala", "Alago", "Alago" },
                                    { "wbj", "Alagwa", "Alagwa" },
                                    { "alk", "Alak", "Alak" },
                                    { "amp", "Alamblak", "Alamblak" },
                                    { "alj", "Alangan", "Alangan" },
                                    { "xln", "Alanic", "Alanic" },
                                    { "apv", "Alapmunte", "Alapmunte" },
                                    { "alh", "Alawa", "Alawa" },
                                    { "sqi", "Albanian", "Albanian" },
                                    { "sqk", "Albanian Sign Language", "Albanian Sign Language" },
                                    { "aae", "Arbëreshë Albanian", "Albanian, Arbëreshë" },
                                    { "aat", "Arvanitika Albanian", "Albanian, Arvanitika" },
                                    { "aln", "Gheg Albanian", "Albanian, Gheg" },
                                    { "als", "Tosk Albanian", "Albanian, Tosk" },
                                    { "alf", "Alege", "Alege" },
                                    { "gah", "Alekano", "Alekano" },
                                    { "ale", "Aleut", "Aleut" },
                                    { "mud", "Mednyj Aleut", "Aleut, Mednyj" },
                                    { "asp", "Algerian Sign Language", "Algerian Sign Language" },
                                    { "crr", "Carolina Algonquian", "Algonquian, Carolina" },
                                    { "alq", "Algonquin", "Algonquin" },
                                    { "aiy", "Ali", "Ali" },
                                    { "ald", "Alladian", "Alladian" },
                                    { "all", "Allar", "Allar" },
                                    { "aid", "Alngith", "Alngith" },
                                    { "aol", "Alor", "Alor" },
                                    { "syy", "Al-Sayyid Bedouin Sign Language", "Al-Sayyid Bedouin Sign Language" },
                                    { "aes", "Alsea", "Alsea" },
                                    { "aqn", "Northern Alta", "Alta, Northern" },
                                    { "agy", "Southern Alta", "Alta, Southern" },
                                    { "atv", "Northern Altai", "Altai, Northern" },
                                    { "alt", "Southern Altai", "Altai, Southern" },
                                    { "aub", "Alugu", "Alugu" },
                                    { "aab", "Alumu-Tesu", "Alumu-Tesu" },
                                    { "alp", "Alune", "Alune" },
                                    { "yna", "Aluo", "Aluo" },
                                    { "alz", "Alur", "Alur" },
                                    { "alr", "Alutor", "Alutor" },
                                    { "avd", "Alviri-Vidari", "Alviri-Vidari" },
                                    { "aly", "Alyawarr", "Alyawarr" },
                                    { "amm", "Ama (Papua New Guinea)", "Ama (Papua New Guinea)" },
                                    { "nyi", "Ama (Sudan)", "Ama (Sudan)" },
                                    { "amq", "Amahai", "Amahai" },
                                    { "amc", "Amahuaca", "Amahuaca" },
                                    { "ali", "Amaimon", "Amaimon" },
                                    { "aad", "Amal", "Amal" },
                                    { "ryn", "Northern Amami-Oshima", "Amami-Oshima, Northern" },
                                    { "ams", "Southern Amami-Oshima", "Amami-Oshima, Southern" },
                                    { "amn", "Amanab", "Amanab" },
                                    { "ama", "Amanayé", "Amanayé" },
                                    { "aie", "Amara", "Amara" },
                                    { "amr", "Amarakaeri", "Amarakaeri" },
                                    { "aaz", "Amarasi", "Amarasi" },
                                    { "utp", "Amba (Solomon Islands)", "Amba (Solomon Islands)" },
                                    { "rwm", "Amba (Uganda)", "Amba (Uganda)" },
                                    { "omb", "East Ambae", "Ambae, East" },
                                    { "nnd", "West Ambae", "Ambae, West" },
                                    { "amk", "Ambai", "Ambai" },
                                    { "aew", "Ambakich", "Ambakich" },
                                    { "amv", "Ambelau", "Ambelau" },
                                    { "ael", "Ambele", "Ambele" },
                                    { "alm", "Amblong", "Amblong" },
                                    { "amb", "Ambo", "Ambo" },
                                    { "aag", "Ambrak", "Ambrak" },
                                    { "mmg", "North Ambrym", "Ambrym, North" },
                                    { "tvk", "Southeast Ambrym", "Ambrym, Southeast" },
                                    { "apo", "Ambul", "Ambul" },
                                    { "abt", "Ambulas", "Ambulas" },
                                    { "amj", "Amdang", "Amdang" },
                                    { "aey", "Amele", "Amele" },
                                    { "ase", "American Sign Language", "American Sign Language" },
                                    { "amh", "Amharic", "Amharic" },
                                    { "amy", "Ami", "Ami" },
                                    { "ami", "Amis", "Amis" },
                                    { "ais", "Nataoran Amis", "Amis, Nataoran" },
                                    { "amo", "Amo", "Amo" },
                                    { "alx", "Amol", "Amol" },
                                    { "apg", "Ampanang", "Ampanang" },
                                    { "amt", "Amto", "Amto" },
                                    { "adw", "Amundava", "Amundava" },
                                    { "amg", "Amurdak", "Amurdak" },
                                    { "amu", "Guerrero Amuzgo", "Amuzgo, Guerrero" },
                                    { "azm", "Ipalapa Amuzgo", "Amuzgo, Ipalapa" },
                                    { "azg", "San Pedro Amuzgos Amuzgo", "Amuzgo, San Pedro Amuzgos" },
                                    { "anw", "Anaang", "Anaang" },
                                    { "akg", "Anakalangu", "Anakalangu" },
                                    { "anm", "Anal", "Anal" },
                                    { "pda", "Anam", "Anam" },
                                    { "aan", "Anambé", "Anambé" },
                                    { "imi", "Anamgura", "Anamgura" },
                                    { "bpo", "Anasi", "Anasi" },
                                    { "acb", "Áncá", "Áncá" },
                                    { "afd", "Andai", "Andai" },
                                    { "ajn", "Andajin", "Andajin" },
                                    { "ana", "Andaqui", "Andaqui" },
                                    { "aod", "Andarum", "Andarum" },
                                    { "adg", "Andegerebinha", "Andegerebinha" },
                                    { "anr", "Andh", "Andh" },
                                    { "ani", "Andi", "Andi" },
                                    { "bzb", "Andio", "Andio" },
                                    { "anb", "Andoa", "Andoa" },
                                    { "ano", "Andoque", "Andoque" },
                                    { "anx", "Andra-Hus", "Andra-Hus" },
                                    { "aty", "Aneityum", "Aneityum" },
                                    { "anz", "Anem", "Anem" },
                                    { "aby", "Aneme Wake", "Aneme Wake" },
                                    { "myo", "Anfillo", "Anfillo" },
                                    { "agm", "Angaataha", "Angaataha" },
                                    { "age", "Angal", "Angal" },
                                    { "aoe", "Angal Enen", "Angal Enen" },
                                    { "akh", "Angal Heneng", "Angal Heneng" },
                                    { "anp", "Angika", "Angika" },
                                    { "avm", "Angkamuthi", "Angkamuthi" },
                                    { "xno", "Anglo-Norman", "Anglo-Norman" },
                                    { "rme", "Angloromani", "Angloromani" },
                                    { "aoa", "Angolar", "Angolar" },
                                    { "agg", "Angor", "Angor" },
                                    { "aog", "Angoram", "Angoram" },
                                    { "awg", "Anguthimri", "Anguthimri" },
                                    { "hnh", "Ani", "Ani" },
                                    { "blo", "Anii", "Anii" },
                                    { "anf", "Animere", "Animere" },
                                    { "aoi", "Anindilyakwa", "Anindilyakwa" },
                                    { "boj", "Anjam", "Anjam" },
                                    { "aak", "Ankave", "Ankave" },
                                    { "amx", "Anmatyerre", "Anmatyerre" },
                                    { "nun", "Anong", "Anong" },
                                    { "anj", "Anor", "Anor" },
                                    { "ans", "Anserma", "Anserma" },
                                    { "and", "Ansus", "Ansus" },
                                    { "ant", "Antakarinya", "Antakarinya" },
                                    { "anu", "Anuak", "Anuak" },
                                    { "cko", "Anufo", "Anufo" },
                                    { "aui", "Anuki", "Anuki" },
                                    { "auq", "Anus", "Anus" },
                                    { "aud", "Anuta", "Anuta" },
                                    { "any", "Anyin", "Anyin" },
                                    { "mtb", "Anyin Morofo", "Anyin Morofo" },
                                    { "pni", "Aoheng", "Aoheng" },
                                    { "aor", "Aore", "Aore" },
                                    { "aou", "A'ou", "A'ou" },
                                    { "kbx", "Ap Ma", "Ap Ma" },
                                    { "apj", "Jicarilla Apache", "Apache, Jicarilla" },
                                    { "apk", "Kiowa Apache", "Apache, Kiowa" },
                                    { "apl", "Lipan Apache", "Apache, Lipan" },
                                    { "apm", "Mescalero-Chiricahua Apache", "Apache, Mescalero-Chiricahua" },
                                    { "apw", "Western Apache", "Apache, Western" },
                                    { "xap", "Apalachee", "Apalachee" },
                                    { "apy", "Apalaí", "Apalaí" },
                                    { "ena", "Apali", "Apali" },
                                    { "apt", "Apatani", "Apatani" },
                                    { "api", "Apiaká", "Apiaká" },
                                    { "apn", "Apinayé", "Apinayé" },
                                    { "app", "Apma", "Apma" },
                                    { "apq", "A-Pucikwar", "A-Pucikwar" },
                                    { "apu", "Apurinã", "Apurinã" },
                                    { "apx", "Aputai", "Aputai" },
                                    { "xaq", "Aquitanian", "Aquitanian" },
                                    { "ard", "Arabana", "Arabana" },
                                    { "arl", "Arabela", "Arabela" },
                                    { "ara", "Arabic", "Arabic" },
                                    { "arq", "Algerian Arabic", "Arabic, Algerian" },
                                    { "aao", "Algerian Saharan Arabic", "Arabic, Algerian Saharan" },
                                    { "xaa", "Andalusian Arabic", "Arabic, Andalusian" },
                                    { "abv", "Baharna Arabic", "Arabic, Baharna" },
                                    { "shu", "Chadian Arabic", "Arabic, Chadian" },
                                    { "acy", "Cypriot Arabic", "Arabic, Cypriot" },
                                    { "adf", "Dhofari Arabic", "Arabic, Dhofari" },
                                    { "avl", "Eastern Egyptian Bedawi Arabic", "Arabic, Eastern Egyptian Bedawi" },
                                    { "arz", "Egyptian Arabic", "Arabic, Egyptian" },
                                    { "afb", "Gulf Arabic", "Arabic, Gulf" },
                                    { "ayh", "Hadrami Arabic", "Arabic, Hadrami" },
                                    { "acw", "Hijazi Arabic", "Arabic, Hijazi" },
                                    { "yhd", "Judeo-Iraqi Arabic", "Arabic, Judeo-Iraqi" },
                                    { "aju", "Judeo-Moroccan Arabic", "Arabic, Judeo-Moroccan" },
                                    { "yud", "Judeo-Tripolitanian Arabic", "Arabic, Judeo-Tripolitanian" },
                                    { "ajt", "Judeo-Tunisian Arabic", "Arabic, Judeo-Tunisian" },
                                    { "jye", "Judeo-Yemeni Arabic", "Arabic, Judeo-Yemeni" },
                                    { "ayl", "Libyan Arabic", "Arabic, Libyan" },
                                    { "acm", "Mesopotamian Arabic", "Arabic, Mesopotamian" },
                                    { "ary", "Moroccan Arabic", "Arabic, Moroccan" },
                                    { "ars", "Najdi Arabic", "Arabic, Najdi" },
                                    { "apc", "North Levantine Arabic", "Arabic, North Levantine" },
                                    { "ayp", "North Mesopotamian Arabic", "Arabic, North Mesopotamian" },
                                    { "acx", "Omani Arabic", "Arabic, Omani" },
                                    { "aec", "Saidi Arabic", "Arabic, Saidi" },
                                    { "ayn", "Sanaani Arabic", "Arabic, Sanaani" },
                                    { "ssh", "Shihhi Arabic", "Arabic, Shihhi" },
                                    { "sqr", "Siculo Arabic", "Arabic, Siculo" },
                                    { "ajp", "South Levantine Arabic", "Arabic, South Levantine" },
                                    { "arb", "Standard Arabic", "Arabic, Standard" },
                                    { "apd", "Sudanese Arabic", "Arabic, Sudanese" },
                                    { "acq", "Ta'izzi-Adeni Arabic", "Arabic, Ta'izzi-Adeni" },
                                    { "abh", "Tajiki Arabic", "Arabic, Tajiki" },
                                    { "aeb", "Tunisian Arabic", "Arabic, Tunisian" },
                                    { "auz", "Uzbeki Arabic", "Arabic, Uzbeki" },
                                    { "arg", "Aragonese", "Aragonese" },
                                    { "akr", "Araki", "Araki" },
                                    { "atq", "Aralle-Tabulahan", "Aralle-Tabulahan" },
                                    { "oar", "Ancient Aramaic (up to 700 BCE)", "Aramaic, Ancient (up to 700 BCE)" },
                                    { "tmr", "Jewish Babylonian Aramaic (ca. 200-1200 CE)", "Aramaic, Jewish Babylonian (ca. 200-1200 CE)" },
                                    { "jpa", "Jewish Palestinian Aramaic", "Aramaic, Jewish Palestinian" },
                                    { "arc", "Official Aramaic (700-300 BCE)", "Aramaic, Official (700-300 BCE)" },
                                    { "sam", "Samaritan Aramaic", "Aramaic, Samaritan" },
                                    { "aam", "Aramanik", "Aramanik" },
                                    { "stk", "Arammba", "Arammba" },
                                    { "aaf", "Aranadan", "Aranadan" },
                                    { "xrt", "Aranama-Tamique", "Aranama-Tamique" },
                                    { "jbj", "Arandai", "Arandai" },
                                    { "aro", "Araona", "Araona" },
                                    { "arp", "Arapaho", "Arapaho" },
                                    { "arj", "Arapaso", "Arapaso" },
                                    { "aah", "Abu' Arapesh", "Arapesh, Abu'" },
                                    { "aon", "Bumbita Arapesh", "Arapesh, Bumbita" },
                                    { "axg", "Mato Grosso Arára", "Arára, Mato Grosso" },
                                    { "aap", "Pará Arára", "Arára, Pará" },
                                    { "aru", "Arawá", "Arawá" },
                                    { "arw", "Arawak", "Arawak" },
                                    { "awt", "Araweté", "Araweté" },
                                    { "awm", "Arawum", "Arawum" },
                                    { "arv", "Arbore", "Arbore" },
                                    { "aqc", "Archi", "Archi" },
                                    { "mwc", "Are", "Are" },
                                    { "alu", "'Are'are", "'Are'are" },
                                    { "aea", "Areba", "Areba" },
                                    { "aem", "Arem", "Arem" },
                                    { "aed", "Argentine Sign Language", "Argentine Sign Language" },
                                    { "agj", "Argobba", "Argobba" },
                                    { "agf", "Arguni", "Arguni" },
                                    { "aqr", "Arhâ", "Arhâ" },
                                    { "aok", "Arhö", "Arhö" },
                                    { "arh", "Arhuaco", "Arhuaco" },
                                    { "aac", "Ari", "Ari" },
                                    { "laz", "Aribwatsa", "Aribwatsa" },
                                    { "ylu", "Aribwaung", "Aribwaung" },
                                    { "aai", "Arifama-Miniafia", "Arifama-Miniafia" },
                                    { "aqg", "Arigidi", "Arigidi" },
                                    { "ark", "Arikapú", "Arikapú" },
                                    { "ari", "Arikara", "Arikara" },
                                    { "ait", "Arikem", "Arikem" },
                                    { "xrn", "Arin", "Arin" },
                                    { "luc", "Aringa", "Aringa" },
                                    { "aoh", "Arma", "Arma" },
                                    { "xrm", "Armazic", "Armazic" },
                                    { "hye", "Armenian", "Armenian" },
                                    { "aen", "Armenian Sign Language", "Armenian Sign Language" },
                                    { "xcl", "Classical Armenian", "Armenian, Classical" },
                                    { "axm", "Middle Armenian", "Armenian, Middle" },
                                    { "apr", "Arop-Lokep", "Arop-Lokep" },
                                    { "aps", "Arop-Sissano", "Arop-Sissano" },
                                    { "aia", "Arosi", "Arosi" },
                                    { "are", "Western Arrarnta", "Arrarnta, Western" },
                                    { "aer", "Eastern Arrernte", "Arrernte, Eastern" },
                                    { "rrt", "Arritinngithigh", "Arritinngithigh" },
                                    { "atz", "Arta", "Arta" },
                                    { "arx", "Aruá (Rodonia State)", "Aruá (Rodonia State)" },
                                    { "msy", "Aruamu", "Aruamu" },
                                    { "aur", "Aruek", "Aruek" },
                                    { "lsr", "Aruop", "Aruop" },
                                    { "atx", "Arutani", "Arutani" },
                                    { "asz", "As", "As" },
                                    { "mtv", "Asaro'o", "Asaro'o" },
                                    { "asd", "Asas", "Asas" },
                                    { "cni", "Asháninka", "Asháninka" },
                                    { "ahs", "Ashe", "Ashe" },
                                    { "cjo", "Ashéninka Pajonal", "Ashéninka Pajonal" },
                                    { "prq", "Ashéninka Perené", "Ashéninka Perené" },
                                    { "cpu", "Pichis Ashéninka", "Ashéninka, Pichis" },
                                    { "cpy", "South Ucayali Ashéninka", "Ashéninka, South Ucayali" },
                                    { "cpb", "Ucayali-Yurúa Ashéninka", "Ashéninka, Ucayali-Yurúa" },
                                    { "ask", "Ashkun", "Ashkun" },
                                    { "atn", "Ashtiani", "Ashtiani" },
                                    { "asl", "Asilulu", "Asilulu" },
                                    { "eiv", "Askopan", "Askopan" },
                                    { "asc", "Casuarina Coast Asmat", "Asmat, Casuarina Coast" },
                                    { "cns", "Central Asmat", "Asmat, Central" },
                                    { "nks", "North Asmat", "Asmat, North" },
                                    { "asy", "Yaosakor Asmat", "Asmat, Yaosakor" },
                                    { "asv", "Asoa", "Asoa" },
                                    { "asm", "Assamese", "Assamese" },
                                    { "xss", "Assan", "Assan" },
                                    { "sjg", "Assangori", "Assangori" },
                                    { "asb", "Assiniboine", "Assiniboine" },
                                    { "ast", "Asturleonese", "Asturleonese" },
                                    { "aum", "Asu (Nigeria)", "Asu (Nigeria)" },
                                    { "asa", "Asu (Tanzania)", "Asu (Tanzania)" },
                                    { "aua", "Asumboa", "Asumboa" },
                                    { "asr", "Asuri", "Asuri" },
                                    { "asu", "Tocantins Asurini", "Asurini, Tocantins" },
                                    { "asn", "Xingú Asuriní", "Asuriní, Xingú" },
                                    { "atm", "Ata", "Ata" },
                                    { "aqp", "Atakapa", "Atakapa" },
                                    { "amz", "Atampaya", "Atampaya" },
                                    { "tay", "Atayal", "Atayal" },
                                    { "ate", "Atemble", "Atemble" },
                                    { "aph", "Athpariya", "Athpariya" },
                                    { "atk", "Ati", "Ati" },
                                    { "atj", "Atikamekw", "Atikamekw" },
                                    { "aqm", "Atohwaim", "Atohwaim" },
                                    { "ato", "Atong", "Atong" },
                                    { "aot", "A'tong", "A'tong" },
                                    { "aox", "Atorada", "Atorada" },
                                    { "atc", "Atsahuaca", "Atsahuaca" },
                                    { "cch", "Atsam", "Atsam" },
                                    { "atw", "Atsugewi", "Atsugewi" },
                                    { "azt", "Faire Atta", "Atta, Faire" },
                                    { "att", "Pamplona Atta", "Atta, Pamplona" },
                                    { "atp", "Pudtol Atta", "Atta, Pudtol" },
                                    { "ati", "Attié", "Attié" },
                                    { "avt", "Au", "Au" },
                                    { "kud", "'Auhelawa", "'Auhelawa" },
                                    { "aul", "Aulua", "Aulua" },
                                    { "aux", "Aurá", "Aurá" },
                                    { "auh", "Aushi", "Aushi" },
                                    { "avs", "Aushiri", "Aushiri" },
                                    { "aut", "Austral", "Austral" },
                                    { "asw", "Australian Aborigines Sign Language", "Australian Aborigines Sign Language" },
                                    { "asf", "Australian Sign Language", "Australian Sign Language" },
                                    { "asq", "Austrian Sign Language", "Austrian Sign Language" },
                                    { "smf", "Auwe", "Auwe" },
                                    { "auu", "Auye", "Auye" },
                                    { "auo", "Auyokawa", "Auyokawa" },
                                    { "avv", "Avá-Canoeiro", "Avá-Canoeiro" },
                                    { "oav", "Old Avar", "Avar, Old" },
                                    { "ava", "Avaric", "Avaric" },
                                    { "avn", "Avatime", "Avatime" },
                                    { "avb", "Avau", "Avau" },
                                    { "ave", "Avestan", "Avestan" },
                                    { "avi", "Avikam", "Avikam" },
                                    { "avu", "Avokaya", "Avokaya" },
                                    { "vwa", "Awa (China)", "Awa (China)" },
                                    { "awb", "Awa (Papua New Guinea)", "Awa (Papua New Guinea)" },
                                    { "awk", "Awabakal", "Awabakal" },
                                    { "kwi", "Awa-Cuaiquer", "Awa-Cuaiquer" },
                                    { "bcu", "Awad Bing", "Awad Bing" },
                                    { "awa", "Awadhi", "Awadhi" },
                                    { "awo", "Awak", "Awak" },
                                    { "aya", "Awar", "Awar" },
                                    { "awx", "Awara", "Awara" },
                                    { "awh", "Awbono", "Awbono" },
                                    { "bob", "Aweer", "Aweer" },
                                    { "awr", "Awera", "Awera" },
                                    { "awe", "Awetí", "Awetí" },
                                    { "azo", "Awing", "Awing" },
                                    { "auy", "Awiyaana", "Awiyaana" },
                                    { "auj", "Awjilah", "Awjilah" },
                                    { "awn", "Awngi", "Awngi" },
                                    { "gwm", "Awngthim", "Awngthim" },
                                    { "kmn", "Awtuw", "Awtuw" },
                                    { "yiu", "Awu", "Awu" },
                                    { "aww", "Awun", "Awun" },
                                    { "afu", "Awutu", "Awutu" },
                                    { "auw", "Awyi", "Awyi" },
                                    { "psa", "Asue Awyu", "Awyu, Asue" },
                                    { "awu", "Central Awyu", "Awyu, Central" },
                                    { "awy", "Edera Awyu", "Awyu, Edera" },
                                    { "awv", "Jair Awyu", "Awyu, Jair" },
                                    { "yir", "North Awyu", "Awyu, North" },
                                    { "aws", "South Awyu", "Awyu, South" },
                                    { "ahb", "Axamb", "Axamb" },
                                    { "ayd", "Ayabadhu", "Ayabadhu" },
                                    { "aye", "Ayere", "Ayere" },
                                    { "axe", "Ayerrerenge", "Ayerrerenge" },
                                    { "ayq", "Ayi (Papua New Guinea)", "Ayi (Papua New Guinea)" },
                                    { "yyz", "Ayizi", "Ayizi" },
                                    { "aym", "Aymara", "Aymara" },
                                    { "ayr", "Central Aymara", "Aymara, Central" },
                                    { "ayc", "Southern Aymara", "Aymara, Southern" },
                                    { "ayo", "Ayoreo", "Ayoreo" },
                                    { "abp", "Abellen Ayta", "Ayta, Abellen" },
                                    { "abc", "Ambala Ayta", "Ayta, Ambala" },
                                    { "sgb", "Mag-antsi Ayta", "Ayta, Mag-antsi" },
                                    { "ayt", "Magbukun Ayta", "Ayta, Magbukun" },
                                    { "blx", "Mag-Indi Ayta", "Ayta, Mag-Indi" },
                                    { "ays", "Sorsogon Ayta", "Ayta, Sorsogon" },
                                    { "ayy", "Tayabas Ayta", "Ayta, Tayabas" },
                                    { "ayu", "Ayu", "Ayu" },
                                    { "aze", "Azerbaijani", "Azerbaijani" },
                                    { "azj", "North Azerbaijani", "Azerbaijani, North" },
                                    { "azb", "South Azerbaijani", "Azerbaijani, South" },
                                    { "aza", "Azha", "Azha" },
                                    { "yiz", "Azhe", "Azhe" },
                                    { "bvj", "Baan", "Baan" },
                                    { "bqx", "Baangi", "Baangi" },
                                    { "bba", "Baatonum", "Baatonum" },
                                    { "bbw", "Baba", "Baba" },
                                    { "bbm", "Babango", "Babango" },
                                    { "bbk", "Babanki", "Babanki" },
                                    { "bcd", "North Babar", "Babar, North" },
                                    { "vbb", "Southeast Babar", "Babar, Southeast" },
                                    { "baa", "Babatana", "Babatana" },
                                    { "bcr", "Babine", "Babine" },
                                    { "bzg", "Babuza", "Babuza" },
                                    { "bcy", "Bacama", "Bacama" },
                                    { "xbc", "Bactrian", "Bactrian" },
                                    { "bhz", "Bada (Indonesia)", "Bada (Indonesia)" },
                                    { "bau", "Bada (Nigeria)", "Bada (Nigeria)" },
                                    { "bfq", "Badaga", "Badaga" },
                                    { "bde", "Bade", "Bade" },
                                    { "bdz", "Badeshi", "Badeshi" },
                                    { "bia", "Badimaya", "Badimaya" },
                                    { "bac", "Badui", "Badui" },
                                    { "pbp", "Badyara", "Badyara" },
                                    { "bvd", "Baeggu", "Baeggu" },
                                    { "bvc", "Baelelea", "Baelelea" },
                                    { "btr", "Baetora", "Baetora" },
                                    { "bfj", "Bafanji", "Bafanji" },
                                    { "bwt", "Bafaw-Balong", "Bafaw-Balong" },
                                    { "ksf", "Bafia", "Bafia" },
                                    { "bfd", "Bafut", "Bafut" },
                                    { "bcg", "Baga Binari", "Baga Binari" },
                                    { "bqf", "Baga Kaloum", "Baga Kaloum" },
                                    { "bgo", "Baga Koga", "Baga Koga" },
                                    { "bgm", "Baga Mboteni", "Baga Mboteni" },
                                    { "bsp", "Baga Sitemu", "Baga Sitemu" },
                                    { "bsv", "Baga Sobané", "Baga Sobané" },
                                    { "bfy", "Bagheli", "Bagheli" },
                                    { "bmi", "Bagirmi", "Bagirmi" },
                                    { "bqg", "Bago-Kusuntu", "Bago-Kusuntu" },
                                    { "bgq", "Bagri", "Bagri" },
                                    { "bpi", "Bagupi", "Bagupi" },
                                    { "bqb", "Bagusa", "Bagusa" },
                                    { "kva", "Bagvalal", "Bagvalal" },
                                    { "bdw", "Baham", "Baham" },
                                    { "bhv", "Bahau", "Bahau" },
                                    { "bjh", "Bahinemo", "Bahinemo" },
                                    { "bhj", "Bahing", "Bahing" },
                                    { "bdq", "Bahnar", "Bahnar" },
                                    { "bsu", "Bahonsuai", "Bahonsuai" },
                                    { "bdj", "Bai", "Bai" },
                                    { "bca", "Central Bai", "Bai, Central" },
                                    { "bfc", "Northern Bai", "Bai, Northern" },
                                    { "bfs", "Southern Bai", "Bai, Southern" },
                                    { "bbf", "Baibai", "Baibai" },
                                    { "bkx", "Baikeno", "Baikeno" },
                                    { "bqh", "Baima", "Baima" },
                                    { "bmx", "Baimak", "Baimak" },
                                    { "bcz", "Bainouk-Gunyaamolo", "Bainouk-Gunyaamolo" },
                                    { "bab", "Bainouk-Gunyuño", "Bainouk-Gunyuño" },
                                    { "bcb", "Bainouk-Samik", "Bainouk-Samik" },
                                    { "bsw", "Baiso", "Baiso" },
                                    { "bjs", "Bajan", "Bajan" },
                                    { "bdl", "Indonesian Bajau", "Bajau, Indonesian" },
                                    { "bdr", "West Coast Bajau", "Bajau, West Coast" },
                                    { "bjm", "Bajelani", "Bajelani" },
                                    { "bkc", "Baka (Cameroon)", "Baka (Cameroon)" },
                                    { "bdh", "Baka (Sudan)", "Baka (Sudan)" },
                                    { "bkq", "Bakairí", "Bakairí" },
                                    { "bqz", "Bakaka", "Bakaka" },
                                    { "bqi", "Bakhtiari", "Bakhtiari" },
                                    { "bki", "Baki", "Baki" },
                                    { "bkh", "Bakoko", "Bakoko" },
                                    { "kme", "Bakole", "Bakole" },
                                    { "bbs", "Bakpinka", "Bakpinka" },
                                    { "bkr", "Bakumpai", "Bakumpai" },
                                    { "bjw", "Bakwé", "Bakwé" },
                                    { "bls", "Balaesang", "Balaesang" },
                                    { "blw", "Balangao", "Balangao" },
                                    { "bjt", "Balanta-Ganja", "Balanta-Ganja" },
                                    { "blz", "Balantak", "Balantak" },
                                    { "ble", "Balanta-Kentohe", "Balanta-Kentohe" },
                                    { "blg", "Balau", "Balau" },
                                    { "bdn", "Baldemu", "Baldemu" },
                                    { "bcp", "Bali (Democratic Republic of Congo)", "Bali (Democratic Republic of Congo)" },
                                    { "bcn", "Bali (Nigeria)", "Bali (Nigeria)" },
                                    { "ban", "Balinese", "Balinese" },
                                    { "bqo", "Balo", "Balo" },
                                    { "bgp", "Eastern Balochi", "Balochi, Eastern" },
                                    { "bcc", "Southern Balochi", "Balochi, Southern" },
                                    { "bgn", "Western Balochi", "Balochi, Western" },
                                    { "biz", "Baloi", "Baloi" },
                                    { "bft", "Balti", "Balti" },
                                    { "blq", "Baluan-Pam", "Baluan-Pam" },
                                    { "bal", "Baluchi", "Baluchi" },
                                    { "bog", "Bamako Sign Language", "Bamako Sign Language" },
                                    { "bbq", "Bamali", "Bamali" },
                                    { "bmo", "Bambalang", "Bambalang" },
                                    { "ptu", "Bambam", "Bambam" },
                                    { "bam", "Bambara", "Bambara" },
                                    { "myf", "Bambassi", "Bambassi" },
                                    { "baw", "Bambili-Bambui", "Bambili-Bambui" },
                                    { "bce", "Bamenyam", "Bamenyam" },
                                    { "bcf", "Bamu", "Bamu" },
                                    { "bqt", "Bamukumbit", "Bamukumbit" },
                                    { "bax", "Bamun", "Bamun" },
                                    { "bvm", "Bamunka", "Bamunka" },
                                    { "bmg", "Bamwe", "Bamwe" },
                                    { "bfk", "Ban Khor Sign Language", "Ban Khor Sign Language" },
                                    { "bcw", "Bana", "Bana" },
                                    { "byz", "Banaro", "Banaro" },
                                    { "bnd", "Banda (Indonesia)", "Banda (Indonesia)" },
                                    { "bjo", "Mid-Southern Banda", "Banda, Mid-Southern" },
                                    { "lnl", "South Central Banda", "Banda, South Central" },
                                    { "tor", "Togbo-Vara Banda", "Banda, Togbo-Vara" },
                                    { "bbp", "West Central Banda", "Banda, West Central" },
                                    { "liy", "Banda-Bambari", "Banda-Bambari" },
                                    { "bpd", "Banda-Banda", "Banda-Banda" },
                                    { "bqk", "Banda-Mbrès", "Banda-Mbrès" },
                                    { "bfl", "Banda-Ndélé", "Banda-Ndélé" },
                                    { "yaj", "Banda-Yangere", "Banda-Yangere" },
                                    { "bza", "Bandi", "Bandi" },
                                    { "bqj", "Bandial", "Bandial" },
                                    { "bdy", "Bandjalang", "Bandjalang" },
                                    { "bxg", "Bangala", "Bangala" },
                                    { "bgf", "Bangandu", "Bangandu" },
                                    { "bbe", "Bangba", "Bangba" },
                                    { "bgz", "Banggai", "Banggai" },
                                    { "bjb", "Banggarla", "Banggarla" },
                                    { "bni", "Bangi", "Bangi" },
                                    { "dba", "Bangi Me", "Bangi Me" },
                                    { "mfb", "Bangka", "Bangka" },
                                    { "bgj", "Bangolan", "Bangolan" },
                                    { "bnx", "Bangubangu", "Bangubangu" },
                                    { "bsj", "Bangwinji", "Bangwinji" },
                                    { "bvv", "Baniva", "Baniva" },
                                    { "bwi", "Baniwa", "Baniwa" },
                                    { "bjn", "Banjar", "Banjar" },
                                    { "bxw", "Bankagooma", "Bankagooma" },
                                    { "jjr", "Bankal", "Bankal" },
                                    { "abb", "Bankon", "Bankon" },
                                    { "bcm", "Bannoni", "Bannoni" },
                                    { "bap", "Bantawa", "Bantawa" },
                                    { "bfx", "Bantayanon", "Bantayanon" },
                                    { "bnq", "Bantik", "Bantik" },
                                    { "bno", "Bantoanon", "Bantoanon" },
                                    { "bci", "Baoulé", "Baoulé" },
                                    { "brd", "Baraamu", "Baraamu" },
                                    { "rbp", "Barababaraba", "Barababaraba" },
                                    { "bbb", "Barai", "Barai" },
                                    { "baj", "Barakai", "Barakai" },
                                    { "bbg", "Barama", "Barama" },
                                    { "brm", "Barambu", "Barambu" },
                                    { "bmz", "Baramu", "Baramu" },
                                    { "brp", "Barapasi", "Barapasi" },
                                    { "brs", "Baras", "Baras" },
                                    { "bsn", "Barasana-Eduria", "Barasana-Eduria" },
                                    { "bpb", "Barbacoas", "Barbacoas" },
                                    { "boi", "Barbareño", "Barbareño" },
                                    { "bcj", "Bardi", "Bardi" },
                                    { "bae", "Baré", "Baré" },
                                    { "bva", "Barein", "Barein" },
                                    { "bpx", "Palya Bareli", "Bareli, Palya" },
                                    { "bfb", "Pauri Bareli", "Bareli, Pauri" },
                                    { "bgd", "Rathwi Bareli", "Bareli, Rathwi" },
                                    { "mlp", "Bargam", "Bargam" },
                                    { "bfa", "Bari", "Bari" },
                                    { "mot", "Barí", "Barí" },
                                    { "bch", "Bariai", "Bariai" },
                                    { "bjc", "Bariji", "Bariji" },
                                    { "bxo", "Barikanchi", "Barikanchi" },
                                    { "jbk", "Barikewa", "Barikewa" },
                                    { "bjk", "Barok", "Barok" },
                                    { "bbi", "Barombi", "Barombi" },
                                    { "bpt", "Barrow Point", "Barrow Point" },
                                    { "bjz", "Baruga", "Baruga" },
                                    { "byr", "Baruya", "Baruya" },
                                    { "bwg", "Barwe", "Barwe" },
                                    { "bas", "Basa (Cameroon)", "Basa (Cameroon)" },
                                    { "bzw", "Basa (Nigeria)", "Basa (Nigeria)" },
                                    { "bsl", "Basa-Gumna", "Basa-Gumna" },
                                    { "buj", "Basa-Gurmana", "Basa-Gurmana" },
                                    { "bdb", "Basap", "Basap" },
                                    { "byq", "Basay", "Basay" },
                                    { "bsg", "Bashkardi", "Bashkardi" },
                                    { "bak", "Bashkir", "Bashkir" },
                                    { "bst", "Basketo", "Basketo" },
                                    { "eus", "Basque", "Basque" },
                                    { "bsq", "Bassa", "Bassa" },
                                    { "bsr", "Bassa-Kontagora", "Bassa-Kontagora" },
                                    { "bsc", "Bassari", "Bassari" },
                                    { "bsi", "Bassossi", "Bassossi" },
                                    { "bta", "Bata", "Bata" },
                                    { "bya", "Batak", "Batak" },
                                    { "btz", "Batak Alas-Kluet", "Batak Alas-Kluet" },
                                    { "akb", "Batak Angkola", "Batak Angkola" },
                                    { "btd", "Batak Dairi", "Batak Dairi" },
                                    { "btx", "Batak Karo", "Batak Karo" },
                                    { "btm", "Batak Mandailing", "Batak Mandailing" },
                                    { "bts", "Batak Simalungun", "Batak Simalungun" },
                                    { "bbc", "Batak Toba", "Batak Toba" },
                                    { "bnm", "Batanga", "Batanga" },
                                    { "btq", "Batek", "Batek" },
                                    { "btv", "Bateri", "Bateri" },
                                    { "bhm", "Bathari", "Bathari" },
                                    { "btc", "Bati (Cameroon)", "Bati (Cameroon)" },
                                    { "bvt", "Bati (Indonesia)", "Bati (Indonesia)" },
                                    { "bbl", "Bats", "Bats" },
                                    { "btu", "Batu", "Batu" },
                                    { "zbt", "Batui", "Batui" },
                                    { "bay", "Batuley", "Batuley" },
                                    { "bbd", "Bau", "Bau" },
                                    { "bsf", "Bauchi", "Bauchi" },
                                    { "brg", "Baure", "Baure" },
                                    { "bge", "Bauria", "Bauria" },
                                    { "bxa", "Bauro", "Bauro" },
                                    { "bwk", "Bauwaki", "Bauwaki" },
                                    { "bvz", "Bauzi", "Bauzi" },
                                    { "bar", "Bavarian", "Bavarian" },
                                    { "bjy", "Bayali", "Bayali" },
                                    { "bvy", "Baybayanon", "Baybayanon" },
                                    { "byg", "Baygo", "Baygo" },
                                    { "byl", "Bayono", "Bayono" },
                                    { "bda", "Bayot", "Bayot" },
                                    { "bxj", "Bayungu", "Bayungu" },
                                    { "bfr", "Bazigar", "Bazigar" },
                                    { "beo", "Beami", "Beami" },
                                    { "bea", "Beaver", "Beaver" },
                                    { "bfp", "Beba", "Beba" },
                                    { "bzv", "Bebe", "Bebe" },
                                    { "beb", "Bebele", "Bebele" },
                                    { "bek", "Bebeli", "Bebeli" },
                                    { "bxp", "Bebil", "Bebil" },
                                    { "bej", "Bedawiyet", "Bedawiyet" },
                                    { "tnr", "Bedik", "Bedik" },
                                    { "bjv", "Bedjond", "Bedjond" },
                                    { "bed", "Bedoanas", "Bedoanas" },
                                    { "bkf", "Beeke", "Beeke" },
                                    { "bxq", "Beele", "Beele" },
                                    { "beq", "Beembe", "Beembe" },
                                    { "bnz", "Beezen", "Beezen" },
                                    { "bby", "Befang", "Befang" },
                                    { "bqv", "Begbere-Ejar", "Begbere-Ejar" },
                                    { "bei", "Bekati'", "Bekati'" },
                                    { "bkv", "Bekwarra", "Bekwarra" },
                                    { "bkw", "Bekwel", "Bekwel" },
                                    { "beg", "Belait", "Belait" },
                                    { "bvi", "Belanda Viri", "Belanda Viri" },
                                    { "bel", "Belarusian", "Belarusian" },
                                    { "byw", "Belhariya", "Belhariya" },
                                    { "bey", "Beli (Papua New Guinea)", "Beli (Papua New Guinea)" },
                                    { "blm", "Beli (Sudan)", "Beli (Sudan)" },
                                    { "blc", "Bella Coola", "Bella Coola" },
                                    { "brw", "Bellari", "Bellari" },
                                    { "bmy", "Bemba (Democratic Republic of Congo)", "Bemba (Democratic Republic of Congo)" },
                                    { "bem", "Bemba (Zambia)", "Bemba (Zambia)" },
                                    { "bmb", "Bembe", "Bembe" },
                                    { "yun", "Bena (Nigeria)", "Bena (Nigeria)" },
                                    { "bez", "Bena (Tanzania)", "Bena (Tanzania)" },
                                    { "bef", "Benabena", "Benabena" },
                                    { "bcq", "Bench", "Bench" },
                                    { "bdp", "Bende", "Bende" },
                                    { "bct", "Bendi", "Bendi" },
                                    { "bnv", "Beneraf", "Beneraf" },
                                    { "nhb", "Beng", "Beng" },
                                    { "bng", "Benga", "Benga" },
                                    { "ben", "Bengali", "Bengali" },
                                    { "bgy", "Benggoi", "Benggoi" },
                                    { "bqy", "Bengkala Sign Language", "Bengkala Sign Language" },
                                    { "bnu", "Bentong", "Bentong" },
                                    { "byd", "Benyadu'", "Benyadu'" },
                                    { "bue", "Beothuk", "Beothuk" },
                                    { "bie", "Bepour", "Bepour" },
                                    { "brf", "Bera", "Bera" },
                                    { "bxv", "Berakou", "Berakou" },
                                    { "zbc", "Central Berawan", "Berawan, Central" },
                                    { "zbe", "East Berawan", "Berawan, East" },
                                    { "zbw", "West Berawan", "Berawan, West" },
                                    { "bkl", "Berik", "Berik" },
                                    { "bit", "Berinomo", "Berinomo" },
                                    { "bom", "Berom", "Berom" },
                                    { "wti", "Berta", "Berta" },
                                    { "byt", "Berti", "Berti" },
                                    { "mhe", "Besisi", "Besisi" },
                                    { "bes", "Besme", "Besme" },
                                    { "bep", "Besoa", "Besoa" },
                                    { "bfe", "Betaf", "Betaf" },
                                    { "bew", "Betawi", "Betawi" },
                                    { "byf", "Bete", "Bete" },
                                    { "bev", "Daloa Bété", "Bété, Daloa" },
                                    { "btg", "Gagnoa Bété", "Bété, Gagnoa" },
                                    { "bet", "Guiberoua Béte", "Béte, Guiberoua" },
                                    { "btt", "Bete-Bendi", "Bete-Bendi" },
                                    { "eot", "Beti (Côte d'Ivoire)", "Beti (Côte d'Ivoire)" },
                                    { "kap", "Bezhta", "Bezhta" },
                                    { "bhd", "Bhadrawahi", "Bhadrawahi" },
                                    { "bhx", "Bhalay", "Bhalay" },
                                    { "bha", "Bharia", "Bharia" },
                                    { "btl", "Bhatola", "Bhatola" },
                                    { "bgw", "Bhatri", "Bhatri" },
                                    { "bht", "Bhattiyali", "Bhattiyali" },
                                    { "bhe", "Bhaya", "Bhaya" },
                                    { "bhy", "Bhele", "Bhele" },
                                    { "sbn", "Sindhi Bhil", "Bhil, Sindhi" },
                                    { "bhi", "Bhilali", "Bhilali" },
                                    { "bhb", "Bhili", "Bhili" },
                                    { "bho", "Bhojpuri", "Bhojpuri" },
                                    { "spt", "Spiti Bhoti", "Bhoti, Spiti" },
                                    { "sbu", "Stod Bhoti", "Bhoti, Stod" },
                                    { "byh", "Bhujel", "Bhujel" },
                                    { "bhu", "Bhunjia", "Bhunjia" },
                                    { "bif", "Biafada", "Biafada" },
                                    { "bdf", "Biage", "Biage" },
                                    { "bhw", "Biak", "Biak" },
                                    { "beh", "Biali", "Biali" },
                                    { "big", "Biangai", "Biangai" },
                                    { "byk", "Biao", "Biao" },
                                    { "bmt", "Biao Mon", "Biao Mon" },
                                    { "sne", "Bau Bidayuh", "Bidayuh, Bau" },
                                    { "bth", "Biatah Bidayuh", "Bidayuh, Biatah" },
                                    { "sdo", "Bukar-Sadung Bidayuh", "Bidayuh, Bukar-Sadung" },
                                    { "trx", "Tringgus-Sembaan Bidayuh", "Bidayuh, Tringgus-Sembaan" },
                                    { "ihw", "Bidhawal", "Bidhawal" },
                                    { "bid", "Bidiyo", "Bidiyo" },
                                    { "bym", "Bidyara", "Bidyara" },
                                    { "bjg", "Bidyogo", "Bidyogo" },
                                    { "bmc", "Biem", "Biem" },
                                    { "bnk", "Bierebo", "Bierebo" },
                                    { "brj", "Bieria", "Bieria" },
                                    { "biu", "Biete", "Biete" },
                                    { "bhc", "Biga", "Biga" },
                                    { "bix", "Bijori", "Bijori" },
                                    { "bic", "Bikaru", "Bikaru" },
                                    { "bik", "Bikol", "Bikol" },
                                    { "ubl", "Buhi'non Bikol", "Bikol, Buhi'non" },
                                    { "bcl", "Central Bikol", "Bikol, Central" },
                                    { "lbl", "Libon Bikol", "Bikol, Libon" },
                                    { "rbl", "Miraya Bikol", "Bikol, Miraya" },
                                    { "cts", "Northern Catanduanes Bikol", "Bikol, Northern Catanduanes" },
                                    { "bto", "Rinconada Bikol", "Bikol, Rinconada" },
                                    { "bln", "Southern Catanduanes Bikol", "Bikol, Southern Catanduanes" },
                                    { "fbl", "West Albay Bikol", "Bikol, West Albay" },
                                    { "byb", "Bikya", "Bikya" },
                                    { "bip", "Bila", "Bila" },
                                    { "bql", "Bilakura", "Bilakura" },
                                    { "kfs", "Bilaspuri", "Bilaspuri" },
                                    { "bpz", "Bilba", "Bilba" },
                                    { "brz", "Bilbil", "Bilbil" },
                                    { "bil", "Bile", "Bile" },
                                    { "byn", "Bilin", "Bilin" },
                                    { "bll", "Biloxi", "Biloxi" },
                                    { "blb", "Bilua", "Bilua" },
                                    { "bxf", "Bilur", "Bilur" },
                                    { "bhp", "Bima", "Bima" },
                                    { "bhl", "Bimin", "Bimin" },
                                    { "bim", "Bimoba", "Bimoba" },
                                    { "byj", "Bina (Nigeria)", "Bina (Nigeria)" },
                                    { "bmn", "Bina (Papua New Guinea)", "Bina (Papua New Guinea)" },
                                    { "bxz", "Binahari", "Binahari" },
                                    { "bhg", "Binandere", "Binandere" },
                                    { "bon", "Bine", "Bine" },
                                    { "bin", "Bini", "Bini" },
                                    { "bpj", "Binji", "Binji" },
                                    { "bne", "Bintauna", "Bintauna" },
                                    { "bny", "Bintulu", "Bintulu" },
                                    { "bkd", "Binukid", "Binukid" },
                                    { "kyn", "Northern Binukidnon", "Binukidnon, Northern" },
                                    { "mtw", "Southern Binukidnon", "Binukidnon, Southern" },
                                    { "bjr", "Binumarien", "Binumarien" },
                                    { "biq", "Bipi", "Bipi" },
                                    { "bxe", "Birale", "Birale" },
                                    { "brr", "Birao", "Birao" },
                                    { "btf", "Birgit", "Birgit" },
                                    { "biy", "Birhor", "Birhor" },
                                    { "bzr", "Biri", "Biri" },
                                    { "bfo", "Malba Birifor", "Birifor, Malba" },
                                    { "biv", "Southern Birifor", "Birifor, Southern" },
                                    { "bqq", "Biritai", "Biritai" },
                                    { "brk", "Birked", "Birked" },
                                    { "bvq", "Birri", "Birri" },
                                    { "brl", "Birwa", "Birwa" },
                                    { "bsb", "Brunei Bisaya", "Bisaya, Brunei" },
                                    { "bsy", "Sabah Bisaya", "Bisaya, Sabah" },
                                    { "ije", "Biseni", "Biseni" },
                                    { "bpy", "Bishnupriya", "Bishnupriya" },
                                    { "bwh", "Bishuo", "Bishuo" },
                                    { "bnw", "Bisis", "Bisis" },
                                    { "bis", "Bislama", "Bislama" },
                                    { "bir", "Bisorio", "Bisorio" },
                                    { "bib", "Bissa", "Bissa" },
                                    { "bzi", "Bisu", "Bisu" },
                                    { "brt", "Bitare", "Bitare" },
                                    { "mcc", "Bitur", "Bitur" },
                                    { "bwm", "Biwat", "Biwat" },
                                    { "byo", "Biyo", "Biyo" },
                                    { "bpm", "Biyom", "Biyom" },
                                    { "bpr", "Koronadal Blaan", "Blaan, Koronadal" },
                                    { "bps", "Sarangani Blaan", "Blaan, Sarangani" },
                                    { "blp", "Blablanga", "Blablanga" },
                                    { "bfh", "Blafe", "Blafe" },
                                    { "beu", "Blagar", "Blagar" },
                                    { "blr", "Blang", "Blang" },
                                    { "zbl", "Blissymbols", "Blissymbols" },
                                    { "bgl", "Bo (Laos)", "Bo (Laos)" },
                                    { "bpw", "Bo (Papua New Guinea)", "Bo (Papua New Guinea)" },
                                    { "bzn", "Boano (Maluku)", "Boano (Maluku)" },
                                    { "bzl", "Boano (Sulawesi)", "Boano (Sulawesi)" },
                                    { "bwq", "Southern Bobo Madaré", "Bobo Madaré, Southern" },
                                    { "bgb", "Bobongko", "Bobongko" },
                                    { "bty", "Bobot", "Bobot" },
                                    { "boy", "Bodo (Central African Republic)", "Bodo (Central African Republic)" },
                                    { "brx", "Bodo (India)", "Bodo (India)" },
                                    { "bdv", "Bodo Parja", "Bodo Parja" },
                                    { "bff", "Bofi", "Bofi" },
                                    { "bvw", "Boga", "Boga" },
                                    { "boq", "Bogaya", "Bogaya" },
                                    { "bux", "Boghom", "Boghom" },
                                    { "bqu", "Boguru", "Boguru" },
                                    { "bzf", "Boikin", "Boikin" },
                                    { "ybk", "Bokha", "Bokha" },
                                    { "bqc", "Boko (Benin)", "Boko (Benin)" },
                                    { "bkp", "Boko (Democratic Republic of Congo)", "Boko (Democratic Republic of Congo)" },
                                    { "bus", "Bokobaru", "Bokobaru" },
                                    { "bdt", "Bokoto", "Bokoto" },
                                    { "bky", "Bokyi", "Bokyi" },
                                    { "bnp", "Bola", "Bola" },
                                    { "bld", "Bolango", "Bolango" },
                                    { "bol", "Bole", "Bole" },
                                    { "xbo", "Bolgarian", "Bolgarian" },
                                    { "bvo", "Bolgo", "Bolgo" },
                                    { "bli", "Bolia", "Bolia" },
                                    { "smk", "Bolinao", "Bolinao" },
                                    { "bvl", "Bolivian Sign Language", "Bolivian Sign Language" },
                                    { "blv", "Bolo", "Bolo" },
                                    { "bkt", "Boloki", "Boloki" },
                                    { "bof", "Bolon", "Bolon" },
                                    { "bzm", "Bolondo", "Bolondo" },
                                    { "blj", "Bolongan", "Bolongan" },
                                    { "ply", "Bolyu", "Bolyu" },
                                    { "bmf", "Bom", "Bom" },
                                    { "boh", "Boma", "Boma" },
                                    { "bml", "Bomboli", "Bomboli" },
                                    { "bws", "Bomboma", "Bomboma" },
                                    { "zmx", "Bomitaba", "Bomitaba" },
                                    { "bmq", "Bomu", "Bomu" },
                                    { "bmw", "Bomwali", "Bomwali" },
                                    { "glc", "Bon Gula", "Bon Gula" },
                                    { "peh", "Bonan", "Bonan" },
                                    { "bou", "Bondei", "Bondei" },
                                    { "bfw", "Bondo", "Bondo" },
                                    { "bna", "Bonerate", "Bonerate" },
                                    { "bdg", "Bonggi", "Bonggi" },
                                    { "bpg", "Bonggo", "Bonggo" },
                                    { "bui", "Bongili", "Bongili" },
                                    { "bot", "Bongo", "Bongo" },
                                    { "bpu", "Bongu", "Bongu" },
                                    { "bok", "Bonjo", "Bonjo" },
                                    { "bvg", "Bonkeng", "Bonkeng" },
                                    { "bop", "Bonkiman", "Bonkiman" },
                                    { "bnc", "Bontok", "Bontok" },
                                    { "lbk", "Central Bontok", "Bontok, Central" },
                                    { "ebk", "Eastern Bontok", "Bontok, Eastern" },
                                    { "rbk", "Northern Bontok", "Bontok, Northern" },
                                    { "obk", "Southern Bontok", "Bontok, Southern" },
                                    { "vbk", "Southwestern Bontok", "Bontok, Southwestern" },
                                    { "bnb", "Bookan", "Bookan" },
                                    { "bnl", "Boon", "Boon" },
                                    { "bvf", "Boor", "Boor" },
                                    { "bxb", "Belanda Bor", "Bor, Belanda" },
                                    { "boa", "Bora", "Bora" },
                                    { "gai", "Borei", "Borei" },
                                    { "bxx", "Borna (Democratic Republic of Congo)", "Borna (Democratic Republic of Congo)" },
                                    { "bwo", "Borna (Ethiopia)", "Borna (Ethiopia)" },
                                    { "xxb", "Boro (Ghana)", "Boro (Ghana)" },
                                    { "ksr", "Borong", "Borong" },
                                    { "bor", "Borôro", "Borôro" },
                                    { "brn", "Boruca", "Boruca" },
                                    { "mae", "Bo-Rukul", "Bo-Rukul" },
                                    { "bwf", "Boselewa", "Boselewa" },
                                    { "bqs", "Bosngun", "Bosngun" },
                                    { "bos", "Bosnian", "Bosnian" },
                                    { "bmj", "Bote-Majhi", "Bote-Majhi" },
                                    { "bph", "Botlikh", "Botlikh" },
                                    { "mux", "Bo-Ung", "Bo-Ung" },
                                    { "pcc", "Bouyei", "Bouyei" },
                                    { "bzo", "Bozaba", "Bozaba" },
                                    { "bze", "Jenaama Bozo", "Bozo, Jenaama" },
                                    { "bzx", "Kɛlɛngaxo Bozo", "Bozo, Kɛlɛngaxo" },
                                    { "boo", "Tiemacèwè Bozo", "Bozo, Tiemacèwè" },
                                    { "boz", "Tiéyaxo Bozo", "Bozo, Tiéyaxo" },
                                    { "aof", "Bragat", "Bragat" },
                                    { "brh", "Brahui", "Brahui" },
                                    { "bra", "Braj", "Braj" },
                                    { "bzs", "Brazilian Sign Language", "Brazilian Sign Language" },
                                    { "buq", "Brem", "Brem" },
                                    { "brq", "Breri", "Breri" },
                                    { "bre", "Breton", "Breton" },
                                    { "xbm", "Middle Breton", "Breton, Middle" },
                                    { "obt", "Old Breton", "Breton, Old" },
                                    { "bzd", "Bribri", "Bribri" },
                                    { "bzt", "Brithenig", "Brithenig" },
                                    { "bfi", "British Sign Language", "British Sign Language" },
                                    { "bro", "Brokkat", "Brokkat" },
                                    { "sgt", "Brokpake", "Brokpake" },
                                    { "bkk", "Brokskat", "Brokskat" },
                                    { "bpl", "Broome Pearling Lugger Pidgin", "Broome Pearling Lugger Pidgin" },
                                    { "bru", "Eastern Bru", "Bru, Eastern" },
                                    { "brv", "Western Bru", "Bru, Western" },
                                    { "kxd", "Brunei", "Brunei" },
                                    { "jid", "Bu", "Bu" },
                                    { "bub", "Bua", "Bua" },
                                    { "box", "Buamu", "Buamu" },
                                    { "mmo", "Mangga Buang", "Buang, Mangga" },
                                    { "bzh", "Mapos Buang", "Buang, Mapos" },
                                    { "bvb", "Bube", "Bube" },
                                    { "buw", "Bubi", "Bubi" },
                                    { "bbx", "Bubia", "Bubia" },
                                    { "btp", "Budibud", "Budibud" },
                                    { "bdx", "Budong-Budong", "Budong-Budong" },
                                    { "buu", "Budu", "Budu" },
                                    { "bdk", "Budukh", "Budukh" },
                                    { "bdm", "Buduma", "Buduma" },
                                    { "bja", "Budza", "Budza" },
                                    { "bbh", "Bugan", "Bugan" },
                                    { "buk", "Bugawac", "Bugawac" },
                                    { "bgt", "Bughotu", "Bughotu" },
                                    { "bug", "Buginese", "Buginese" },
                                    { "sab", "Buglere", "Buglere" },
                                    { "bgg", "Bugun", "Bugun" },
                                    { "bku", "Buhid", "Buhid" },
                                    { "bxh", "Buhutu", "Buhutu" },
                                    { "bvk", "Bukat", "Bukat" },
                                    { "bhh", "Bukharic", "Bukharic" },
                                    { "bkn", "Bukitan", "Bukitan" },
                                    { "ape", "Bukiyip", "Bukiyip" },
                                    { "tkb", "Buksa", "Buksa" },
                                    { "bxk", "Bukusu", "Bukusu" },
                                    { "buz", "Bukwen", "Bukwen" },
                                    { "bul", "Bulgarian", "Bulgarian" },
                                    { "bqn", "Bulgarian Sign Language", "Bulgarian Sign Language" },
                                    { "bmp", "Bulgebi", "Bulgebi" },
                                    { "bwu", "Buli (Ghana)", "Buli (Ghana)" },
                                    { "bzq", "Buli (Indonesia)", "Buli (Indonesia)" },
                                    { "buy", "Bullom So", "Bullom So" },
                                    { "bum", "Bulu (Cameroon)", "Bulu (Cameroon)" },
                                    { "bjl", "Bulu (Papua New Guinea)", "Bulu (Papua New Guinea)" },
                                    { "bmv", "Bum", "Bum" },
                                    { "byp", "Bumaji", "Bumaji" },
                                    { "kjz", "Bumthangkha", "Bumthangkha" },
                                    { "buv", "Bun", "Bun" },
                                    { "bvn", "Buna", "Buna" },
                                    { "bck", "Bunaba", "Bunaba" },
                                    { "bfn", "Bunak", "Bunak" },
                                    { "bdd", "Bunama", "Bunama" },
                                    { "bns", "Bundeli", "Bundeli" },
                                    { "bqd", "Bung", "Bung" },
                                    { "but", "Bungain", "Bungain" },
                                    { "bkz", "Bungku", "Bungku" },
                                    { "wun", "Bungu", "Bungu" },
                                    { "bwx", "Bu-Nao Bunu", "Bunu, Bu-Nao" },
                                    { "pnu", "Jiongnai Bunu", "Bunu, Jiongnai" },
                                    { "bwn", "Wunai Bunu", "Bunu, Wunai" },
                                    { "buh", "Younuo Bunu", "Bunu, Younuo" },
                                    { "bnn", "Bunun", "Bunun" },
                                    { "blf", "Buol", "Buol" },
                                    { "bys", "Burak", "Burak" },
                                    { "bkg", "Buraka", "Buraka" },
                                    { "bwr", "Bura-Pabir", "Bura-Pabir" },
                                    { "bvr", "Burarra", "Burarra" },
                                    { "bti", "Burate", "Burate" },
                                    { "xbb", "Lower Burdekin", "Burdekin, Lower" },
                                    { "bxn", "Burduna", "Burduna" },
                                    { "bvh", "Bure", "Bure" },
                                    { "bua", "Buriat", "Buriat" },
                                    { "bxu", "China Buriat", "Buriat, China" },
                                    { "bxm", "Mongolia Buriat", "Buriat, Mongolia" },
                                    { "bxr", "Russia Buriat", "Buriat, Russia" },
                                    { "bji", "Burji", "Burji" },
                                    { "vrt", "Burmbar", "Burmbar" },
                                    { "mya", "Burmese", "Burmese" },
                                    { "obr", "Old Burmese", "Burmese, Old" },
                                    { "bzu", "Burmeso", "Burmeso" },
                                    { "mhs", "Buru (Indonesia)", "Buru (Indonesia)" },
                                    { "bqw", "Buru (Nigeria)", "Buru (Nigeria)" },
                                    { "bry", "Burui", "Burui" },
                                    { "aip", "Burumakok", "Burumakok" },
                                    { "bdi", "Burun", "Burun" },
                                    { "bds", "Burunge", "Burunge" },
                                    { "bsk", "Burushaski", "Burushaski" },
                                    { "bqr", "Burusu", "Burusu" },
                                    { "asi", "Buruwai", "Buruwai" },
                                    { "bqp", "Busa", "Busa" },
                                    { "bxs", "Busam", "Busam" },
                                    { "bsm", "Busami", "Busami" },
                                    { "buc", "Bushi", "Bushi" },
                                    { "buf", "Bushoong", "Bushoong" },
                                    { "djk", "Businenge Tongo", "Businenge Tongo" },
                                    { "bso", "Buso", "Buso" },
                                    { "bup", "Busoa", "Busoa" },
                                    { "dox", "Bussa", "Bussa" },
                                    { "bju", "Busuu", "Busuu" },
                                    { "bnr", "Butmas-Tur", "Butmas-Tur" },
                                    { "btw", "Butuanon", "Butuanon" },
                                    { "bhs", "Buwal", "Buwal" },
                                    { "bgk", "Buxinhua", "Buxinhua" },
                                    { "byy", "Buya", "Buya" },
                                    { "yha", "Baha Buyang", "Buyang, Baha" },
                                    { "yzg", "E'ma Buyang", "Buyang, E'ma" },
                                    { "yln", "Langnian Buyang", "Buyang, Langnian" },
                                    { "byi", "Buyu", "Buyu" },
                                    { "bww", "Bwa", "Bwa" },
                                    { "bwd", "Bwaidoka", "Bwaidoka" },
                                    { "bwy", "Cwi Bwamu", "Bwamu, Cwi" },
                                    { "bwj", "Láá Láá Bwamu", "Bwamu, Láá Láá" },
                                    { "tte", "Bwanabwana", "Bwanabwana" },
                                    { "bwa", "Bwatoo", "Bwatoo" },
                                    { "bwl", "Bwela", "Bwela" },
                                    { "bwc", "Bwile", "Bwile" },
                                    { "bwz", "Bwisi", "Bwisi" },
                                    { "bee", "Byangsi", "Byangsi" },
                                    { "mkk", "Byep", "Byep" },
                                    { "msq", "Caac", "Caac" },
                                    { "cjp", "Cabécar", "Cabécar" },
                                    { "cbb", "Cabiyarí", "Cabiyarí" },
                                    { "ccr", "Cacaopera", "Cacaopera" },
                                    { "cbv", "Cacua", "Cacua" },
                                    { "cad", "Caddo", "Caddo" },
                                    { "cbh", "Cagua", "Cagua" },
                                    { "cah", "Cahuarano", "Cahuarano" },
                                    { "chl", "Cahuilla", "Cahuilla" },
                                    { "ckx", "Caka", "Caka" },
                                    { "cak", "Cakchiquel", "Cakchiquel" },
                                    { "ckz", "Cakchiquel-Quiché Mixed Language", "Cakchiquel-Quiché Mixed Language" },
                                    { "cky", "Cakfem-Mushere", "Cakfem-Mushere" },
                                    { "caw", "Callawalla", "Callawalla" },
                                    { "rmq", "Caló", "Caló" },
                                    { "clu", "Caluyanun", "Caluyanun" },
                                    { "rab", "Camling", "Camling" },
                                    { "cml", "Campalagian", "Campalagian" },
                                    { "kbh", "Camsá", "Camsá" },
                                    { "cmt", "Camtho", "Camtho" },
                                    { "xcc", "Camunic", "Camunic" },
                                    { "cbu", "Candoshi-Shapra", "Candoshi-Shapra" },
                                    { "ram", "Canela", "Canela" },
                                    { "caz", "Canichana", "Canichana" },
                                    { "mlc", "Cao Lan", "Cao Lan" },
                                    { "cov", "Cao Miao", "Cao Miao" },
                                    { "kaq", "Capanahua", "Capanahua" },
                                    { "cps", "Capiznon", "Capiznon" },
                                    { "cot", "Caquinte", "Caquinte" },
                                    { "cfd", "Cara", "Cara" },
                                    { "cby", "Carabayo", "Carabayo" },
                                    { "crf", "Caramanta", "Caramanta" },
                                    { "cbc", "Carapana", "Carapana" },
                                    { "xcr", "Carian", "Carian" },
                                    { "car", "Galibi Carib", "Carib, Galibi" },
                                    { "crb", "Island Carib", "Carib, Island" },
                                    { "cbd", "Carijona", "Carijona" },
                                    { "cal", "Carolinian", "Carolinian" },
                                    { "crx", "Carrier", "Carrier" },
                                    { "caf", "Southern Carrier", "Carrier, Southern" },
                                    { "cbr", "Cashibo-Cacataibo", "Cashibo-Cacataibo" },
                                    { "cbs", "Cashinahua", "Cashinahua" },
                                    { "cat", "Catalan", "Catalan" },
                                    { "csc", "Catalan Sign Language", "Catalan Sign Language" },
                                    { "chc", "Catawba", "Catawba" },
                                    { "cca", "Cauca", "Cauca" },
                                    { "cav", "Cavineña", "Cavineña" },
                                    { "cyb", "Cayubaba", "Cayubaba" },
                                    { "cay", "Cayuga", "Cayuga" },
                                    { "xcy", "Cayuse", "Cayuse" },
                                    { "ceb", "Cebuano", "Cebuano" },
                                    { "xce", "Celtiberian", "Celtiberian" },
                                    { "cam", "Cemuhî", "Cemuhî" },
                                    { "cen", "Cen", "Cen" },
                                    { "cet", "Centúúm", "Centúúm" },
                                    { "cme", "Cerma", "Cerma" },
                                    { "cbi", "Chachi", "Chachi" },
                                    { "cao", "Chácobo", "Chácobo" },
                                    { "cds", "Chadian Sign Language", "Chadian Sign Language" },
                                    { "cdy", "Chadong", "Chadong" },
                                    { "chg", "Chagatai", "Chagatai" },
                                    { "ciy", "Chaima", "Chaima" },
                                    { "ckh", "Chak", "Chak" },
                                    { "cli", "Chakali", "Chakali" },
                                    { "ccp", "Chakma", "Chakma" },
                                    { "cll", "Chala", "Chala" },
                                    { "tgf", "Chalikha", "Chalikha" },
                                    { "cjm", "Eastern Cham", "Cham, Eastern" },
                                    { "cja", "Western Cham", "Cham, Western" },
                                    { "ceg", "Chamacoco", "Chamacoco" },
                                    { "cji", "Chamalal", "Chamalal" },
                                    { "cdg", "Chamari", "Chamari" },
                                    { "cdh", "Chambeali", "Chambeali" },
                                    { "can", "Chambri", "Chambri" },
                                    { "ccc", "Chamicuro", "Chamicuro" },
                                    { "cha", "Chamorro", "Chamorro" },
                                    { "caj", "Chané", "Chané" },
                                    { "cga", "Changriwa", "Changriwa" },
                                    { "cna", "Changthang", "Changthang" },
                                    { "chx", "Chantyal", "Chantyal" },
                                    { "cra", "Chara", "Chara" },
                                    { "cly", "Eastern Highland Chatino", "Chatino, Eastern Highland" },
                                    { "cya", "Nopala Chatino", "Chatino, Nopala" },
                                    { "cta", "Tataltepec Chatino", "Chatino, Tataltepec" },
                                    { "ctp", "Western Highland Chatino", "Chatino, Western Highland" },
                                    { "ctz", "Zacatepec Chatino", "Chatino, Zacatepec" },
                                    { "czn", "Zenzontepec Chatino", "Chatino, Zenzontepec" },
                                    { "cdn", "Chaudangsi", "Chaudangsi" },
                                    { "crv", "Chaura", "Chaura" },
                                    { "cbk", "Chavacano", "Chavacano" },
                                    { "cbt", "Chayahuita", "Chayahuita" },
                                    { "ruk", "Che", "Che" },
                                    { "che", "Chechen", "Chechen" },
                                    { "cea", "Lower Chehalis", "Chehalis, Lower" },
                                    { "cjh", "Upper Chehalis", "Chehalis, Upper" },
                                    { "mrn", "Cheke Holo", "Cheke Holo" },
                                    { "cjn", "Chenapian", "Chenapian" },
                                    { "cde", "Chenchu", "Chenchu" },
                                    { "cnu", "Chenoua", "Chenoua" },
                                    { "cdm", "Chepang", "Chepang" },
                                    { "ycp", "Chepya", "Chepya" },
                                    { "cwg", "Cheq Wong", "Cheq Wong" },
                                    { "cpn", "Cherepon", "Cherepon" },
                                    { "chr", "Cherokee", "Cherokee" },
                                    { "ych", "Chesu", "Chesu" },
                                    { "ctc", "Chetco", "Chetco" },
                                    { "ctt", "Wayanad Chetti", "Chetti, Wayanad" },
                                    { "nya", "Chewa", "Chewa" },
                                    { "chy", "Cheyenne", "Cheyenne" },
                                    { "hne", "Chhattisgarhi", "Chhattisgarhi" },
                                    { "ctn", "Chhintange", "Chhintange" },
                                    { "cur", "Chhulung", "Chhulung" },
                                    { "csd", "Chiangmai Sign Language", "Chiangmai Sign Language" },
                                    { "cip", "Chiapanec", "Chiapanec" },
                                    { "chb", "Chibcha", "Chibcha" },
                                    { "pei", "Chichimeca-Jonaz", "Chichimeca-Jonaz" },
                                    { "coh", "Chichonyi-Chidzihana-Chikauma", "Chichonyi-Chidzihana-Chikauma" },
                                    { "cic", "Chickasaw", "Chickasaw" },
                                    { "cob", "Chicomuceltec", "Chicomuceltec" },
                                    { "cgg", "Chiga", "Chiga" },
                                    { "clc", "Chilcotin", "Chilcotin" },
                                    { "csg", "Chilean Sign Language", "Chilean Sign Language" },
                                    { "clh", "Chilisso", "Chilisso" },
                                    { "xch", "Chimakum", "Chimakum" },
                                    { "cid", "Chimariko", "Chimariko" },
                                    { "cbg", "Chimila", "Chimila" },
                                    { "anl", "Anu-Hkongso Chin", "Chin, Anu-Hkongso" },
                                    { "csh", "Asho Chin", "Chin, Asho" },
                                    { "bgr", "Bawm Chin", "Chin, Bawm" },
                                    { "cbl", "Bualkhaw Chin", "Chin, Bualkhaw" },
                                    { "cnb", "Chinbon Chin", "Chin, Chinbon" },
                                    { "dao", "Daai Chin", "Chin, Daai" },
                                    { "cek", "Eastern Khumi Chin", "Chin, Eastern Khumi" },
                                    { "cfm", "Falam Chin", "Chin, Falam" },
                                    { "cnh", "Haka Chin", "Chin, Haka" },
                                    { "cnk", "Khumi Chin", "Chin, Khumi" },
                                    { "clj", "Laitu Chin", "Chin, Laitu" },
                                    { "clt", "Lautu Chin", "Chin, Lautu" },
                                    { "mrh", "Mara Chin", "Chin, Mara" },
                                    { "hlt", "Matu Chin", "Chin, Matu" },
                                    { "cmr", "Mro-Khimi Chin", "Chin, Mro-Khimi" },
                                    { "mwq", "Mün Chin", "Chin, Mün" },
                                    { "cnw", "Ngawn Chin", "Chin, Ngawn" },
                                    { "pck", "Paite Chin", "Chin, Paite" },
                                    { "weu", "Rawngtu Chin", "Chin, Rawngtu" },
                                    { "rtc", "Rungtu Chin", "Chin, Rungtu" },
                                    { "sez", "Senthang Chin", "Chin, Senthang" },
                                    { "csy", "Siyin Chin", "Chin, Siyin" },
                                    { "csv", "Sumtu Chin", "Chin, Sumtu" },
                                    { "tcp", "Tawr Chin", "Chin, Tawr" },
                                    { "ctd", "Tedim Chin", "Chin, Tedim" },
                                    { "tcz", "Thado Chin", "Chin, Thado" },
                                    { "cth", "Thaiphum Chin", "Chin, Thaiphum" },
                                    { "czt", "Zotung Chin", "Chin, Zotung" },
                                    { "cih", "Chinali", "Chinali" },
                                    { "csa", "Chiltepec Chinantec", "Chinantec, Chiltepec" },
                                    { "cco", "Comaltepec Chinantec", "Chinantec, Comaltepec" },
                                    { "cnl", "Lalana Chinantec", "Chinantec, Lalana" },
                                    { "cle", "Lealao Chinantec", "Chinantec, Lealao" },
                                    { "chj", "Ojitlán Chinantec", "Chinantec, Ojitlán" },
                                    { "chz", "Ozumacín Chinantec", "Chinantec, Ozumacín" },
                                    { "cpa", "Palantla Chinantec", "Chinantec, Palantla" },
                                    { "chq", "Quiotepec Chinantec", "Chinantec, Quiotepec" },
                                    { "cso", "Sochiapam Chinantec", "Chinantec, Sochiapam" },
                                    { "cnt", "Tepetotutla Chinantec", "Chinantec, Tepetotutla" },
                                    { "cte", "Tepinapa Chinantec", "Chinantec, Tepinapa" },
                                    { "ctl", "Tlacoatzintepec Chinantec", "Chinantec, Tlacoatzintepec" },
                                    { "cuc", "Usila Chinantec", "Chinantec, Usila" },
                                    { "cvn", "Valle Nacional Chinantec", "Chinantec, Valle Nacional" },
                                    { "zho", "Chinese", "Chinese" },
                                    { "csl", "Chinese Sign Language", "Chinese Sign Language" },
                                    { "gan", "Gan Chinese", "Chinese, Gan" },
                                    { "hak", "Hakka Chinese", "Chinese, Hakka" },
                                    { "czh", "Huizhou Chinese", "Chinese, Huizhou" },
                                    { "cjy", "Jinyu Chinese", "Chinese, Jinyu" },
                                    { "ltc", "Late Middle Chinese", "Chinese, Late Middle" },
                                    { "lzh", "Literary Chinese", "Chinese, Literary" },
                                    { "cmn", "Mandarin Chinese", "Chinese, Mandarin" },
                                    { "mnp", "Min Bei Chinese", "Chinese, Min Bei" },
                                    { "cdo", "Min Dong Chinese", "Chinese, Min Dong" },
                                    { "nan", "Min Nan Chinese", "Chinese, Min Nan" },
                                    { "czo", "Min Zhong Chinese", "Chinese, Min Zhong" },
                                    { "och", "Old Chinese", "Chinese, Old" },
                                    { "cpx", "Pu-Xian Chinese", "Chinese, Pu-Xian" },
                                    { "wuu", "Wu Chinese", "Chinese, Wu" },
                                    { "hsn", "Xiang Chinese", "Chinese, Xiang" },
                                    { "yue", "Yue Chinese", "Chinese, Yue" },
                                    { "chh", "Chinook", "Chinook" },
                                    { "chn", "Chinook jargon", "Chinook jargon" },
                                    { "cap", "Chipaya", "Chipaya" },
                                    { "chp", "Chipewyan", "Chipewyan" },
                                    { "cbe", "Chipiajes", "Chipiajes" },
                                    { "ciw", "Chippewa", "Chippewa" },
                                    { "cax", "Chiquitano", "Chiquitano" },
                                    { "cdf", "Chiru", "Chiru" },
                                    { "ctm", "Chitimacha", "Chitimacha" },
                                    { "ctg", "Chittagonian", "Chittagonian" },
                                    { "cgk", "Chocangacakha", "Chocangacakha" },
                                    { "coz", "Chochotec", "Chochotec" },
                                    { "cho", "Choctaw", "Choctaw" },
                                    { "cdi", "Chodri", "Chodri" },
                                    { "cjk", "Chokwe", "Chokwe" },
                                    { "ctu", "Chol", "Chol" },
                                    { "cht", "Cholón", "Cholón" },
                                    { "cog", "Chong", "Chong" },
                                    { "cda", "Choni", "Choni" },
                                    { "chd", "Highland Oaxaca Chontal", "Chontal, Highland Oaxaca" },
                                    { "clo", "Lowland Oaxaca Chontal", "Chontal, Lowland Oaxaca" },
                                    { "chf", "Tabasco Chontal", "Chontal, Tabasco" },
                                    { "cce", "Chopi", "Chopi" },
                                    { "xco", "Chorasmian", "Chorasmian" },
                                    { "crt", "Iyojwa'ja Chorote", "Chorote, Iyojwa'ja" },
                                    { "crq", "Iyo'wujwa Chorote", "Chorote, Iyo'wujwa" },
                                    { "caa", "Chortí", "Chortí" },
                                    { "crw", "Chrau", "Chrau" },
                                    { "cje", "Chru", "Chru" },
                                    { "cjv", "Chuave", "Chuave" },
                                    { "cvg", "Chug", "Chug" },
                                    { "cac", "Chuj", "Chuj" },
                                    { "cuh", "Chuka", "Chuka" },
                                    { "ckt", "Chukot", "Chukot" },
                                    { "cuw", "Chukwa", "Chukwa" },
                                    { "clw", "Chulym", "Chulym" },
                                    { "ncu", "Chumburung", "Chumburung" },
                                    { "cdj", "Churahi", "Churahi" },
                                    { "scb", "Chut", "Chut" },
                                    { "chk", "Chuukese", "Chuukese" },
                                    { "xcv", "Chuvantsy", "Chuvantsy" },
                                    { "chv", "Chuvash", "Chuvash" },
                                    { "chw", "Chuwabu", "Chuwabu" },
                                    { "cia", "Cia-Cia", "Cia-Cia" },
                                    { "ckl", "Cibak", "Cibak" },
                                    { "awc", "Cicipu", "Cicipu" },
                                    { "cim", "Cimbrian", "Cimbrian" },
                                    { "cdr", "Cinda-Regi-Tiyal", "Cinda-Regi-Tiyal" },
                                    { "cie", "Cineni", "Cineni" },
                                    { "cin", "Cinta Larga", "Cinta Larga" },
                                    { "asg", "Cishingini", "Cishingini" },
                                    { "txt", "Citak", "Citak" },
                                    { "tml", "Tamnim Citak", "Citak, Tamnim" },
                                    { "tgd", "Ciwogai", "Ciwogai" },
                                    { "clm", "Clallam", "Clallam" },
                                    { "dri", "C'lela", "C'lela" },
                                    { "xcw", "Coahuilteco", "Coahuilteco" },
                                    { "loe", "Saluan", "Coastal" },
                                    { "cod", "Cocama-Cocamilla", "Cocama-Cocamilla" },
                                    { "coj", "Cochimi", "Cochimi" },
                                    { "coc", "Cocopa", "Cocopa" },
                                    { "crd", "Coeur d'Alene", "Coeur d'Alene" },
                                    { "con", "Cofán", "Cofán" },
                                    { "liw", "Col", "Col" },
                                    { "csn", "Colombian Sign Language", "Colombian Sign Language" },
                                    { "cof", "Colorado", "Colorado" },
                                    { "col", "Columbia-Wenatchi", "Columbia-Wenatchi" },
                                    { "com", "Comanche", "Comanche" },
                                    { "xcm", "Comecrudo", "Comecrudo" },
                                    { "cfg", "Como Karim", "Como Karim" },
                                    { "swb", "Maore Comorian", "Comorian, Maore" },
                                    { "wlc", "Mwali Comorian", "Comorian, Mwali" },
                                    { "wni", "Ndzwani Comorian", "Comorian, Ndzwani" },
                                    { "zdj", "Ngazidja Comorian", "Comorian, Ngazidja" },
                                    { "coo", "Comox", "Comox" },
                                    { "cno", "Con", "Con" },
                                    { "cnc", "Côông", "Côông" },
                                    { "csz", "Coos", "Coos" },
                                    { "cop", "Coptic", "Coptic" },
                                    { "coq", "Coquille", "Coquille" },
                                    { "crn", "El Nayar Cora", "Cora, El Nayar" },
                                    { "cok", "Santa Teresa Cora", "Cora, Santa Teresa" },
                                    { "cry", "Cori", "Cori" },
                                    { "cor", "Cornish", "Cornish" },
                                    { "cnx", "Middle Cornish", "Cornish, Middle" },
                                    { "oco", "Old Cornish", "Cornish, Old" },
                                    { "cos", "Corsican", "Corsican" },
                                    { "csr", "Costa Rican Sign Language", "Costa Rican Sign Language" },
                                    { "xcn", "Cotoname", "Cotoname" },
                                    { "cow", "Cowlitz", "Cowlitz" },
                                    { "kox", "Coxima", "Coxima" },
                                    { "coy", "Coyaima", "Coyaima" },
                                    { "cre", "Cree", "Cree" },
                                    { "crm", "Moose Cree", "Cree, Moose" },
                                    { "crl", "Northern East Cree", "Cree, Northern East" },
                                    { "crk", "Plains Cree", "Cree, Plains" },
                                    { "crj", "Southern East Cree", "Cree, Southern East" },
                                    { "csw", "Swampy Cree", "Cree, Swampy" },
                                    { "cwd", "Woods Cree", "Cree, Woods" },
                                    { "mus", "Creek", "Creek" },
                                    { "bbz", "Babalia Creole Arabic", "Creole Arabic, Babalia" },
                                    { "pga", "Sudanese Creole Arabic", "Creole Arabic, Sudanese" },
                                    { "brc", "Berbice Creole Dutch", "Creole Dutch, Berbice" },
                                    { "skw", "Skepi Creole Dutch", "Creole Dutch, Skepi" },
                                    { "aig", "Antigua and Barbuda Creole English", "Creole English, Antigua and Barbuda" },
                                    { "bah", "Bahamas Creole English", "Creole English, Bahamas" },
                                    { "fpe", "Fernando Po Creole English", "Creole English, Fernando Po" },
                                    { "gcl", "Grenadian Creole English", "Creole English, Grenadian" },
                                    { "gyn", "Guyanese Creole English", "Creole English, Guyanese" },
                                    { "hwc", "Hawai'i Creole English", "Creole English, Hawai'i" },
                                    { "icr", "Islander Creole English", "Creole English, Islander" },
                                    { "jam", "Jamaican Creole English", "Creole English, Jamaican" },
                                    { "bzk", "Nicaragua Creole English", "Creole English, Nicaragua" },
                                    { "gul", "Sea Island Creole English", "Creole English, Sea Island" },
                                    { "tgh", "Tobagonian Creole English", "Creole English, Tobagonian" },
                                    { "trf", "Trinidadian Creole English", "Creole English, Trinidadian" },
                                    { "tch", "Turks And Caicos Creole English", "Creole English, Turks And Caicos" },
                                    { "svc", "Vincentian Creole English", "Creole English, Vincentian" },
                                    { "vic", "Virgin Islands Creole English", "Creole English, Virgin Islands" },
                                    { "gcf", "Guadeloupean Creole French", "Creole French, Guadeloupean" },
                                    { "gcr", "Guianese Creole French", "Creole French, Guianese" },
                                    { "kmv", "Karipúna Creole French", "Creole French, Karipúna" },
                                    { "lou", "Louisiana Creole French", "Creole French, Louisiana" },
                                    { "rcf", "Réunion Creole French", "Creole French, Réunion" },
                                    { "acf", "Saint Lucian Creole French", "Creole French, Saint Lucian" },
                                    { "scf", "San Miguel Creole French", "Creole French, San Miguel" },
                                    { "crs", "Seselwa Creole French", "Creole French, Seselwa" },
                                    { "hca", "Andaman Creole Hindi", "Creole Hindi, Andaman" },
                                    { "ccm", "Malaccan Creole Malay", "Creole Malay, Malaccan" },
                                    { "sci", "Sri Lankan Creole Malay", "Creole Malay, Sri Lankan" },
                                    { "vkp", "Korlai Creole Portuguese", "Creole Portuguese, Korlai" },
                                    { "mcm", "Malaccan Creole Portuguese", "Creole Portuguese, Malaccan" },
                                    { "afs", "Afro-Seminole Creole", "Creole, Afro-Seminole" },
                                    { "ccd", "Cafundo Creole", "Creole, Cafundo" },
                                    { "tcs", "Torres Strait Creole", "Creole, Torres Strait" },
                                    { "pov", "Upper Guinea Crioulo", "Crioulo, Upper Guinea" },
                                    { "csq", "Croatia Sign Language", "Croatia Sign Language" },
                                    { "hrv", "Croatian", "Croatian" },
                                    { "cro", "Crow", "Crow" },
                                    { "crz", "Cruzeño", "Cruzeño" },
                                    { "cua", "Cua", "Cua" },
                                    { "csf", "Cuba Sign Language", "Cuba Sign Language" },
                                    { "cub", "Cubeo", "Cubeo" },
                                    { "cui", "Cuiba", "Cuiba" },
                                    { "cux", "Tepeuxila Cuicatec", "Cuicatec, Tepeuxila" },
                                    { "cut", "Teutila Cuicatec", "Cuicatec, Teutila" },
                                    { "cul", "Culina", "Culina" },
                                    { "cuo", "Cumanagoto", "Cumanagoto" },
                                    { "xcb", "Cumbric", "Cumbric" },
                                    { "cum", "Cumeral", "Cumeral" },
                                    { "cuq", "Cun", "Cun" },
                                    { "cug", "Cung", "Cung" },
                                    { "cup", "Cupeño", "Cupeño" },
                                    { "xcu", "Curonian", "Curonian" },
                                    { "kpc", "Curripaco", "Curripaco" },
                                    { "ccl", "Cutchi-Swahili", "Cutchi-Swahili" },
                                    { "cuv", "Cuvok", "Cuvok" },
                                    { "cyo", "Cuyonon", "Cuyonon" },
                                    { "ces", "Czech", "Czech" },
                                    { "cse", "Czech Sign Language", "Czech Sign Language" },
                                    { "lni", "Daantanai'", "Daantanai'" },
                                    { "dsh", "Daasanach", "Daasanach" },
                                    { "dbq", "Daba", "Daba" },
                                    { "dbr", "Dabarre", "Dabarre" },
                                    { "dbe", "Dabe", "Dabe" },
                                    { "xdc", "Dacian", "Dacian" },
                                    { "dda", "Dadi Dadi", "Dadi Dadi" },
                                    { "mps", "Dadibi", "Dadibi" },
                                    { "dbd", "Dadiya", "Dadiya" },
                                    { "dgz", "Daga", "Daga" },
                                    { "dga", "Southern Dagaare", "Dagaare, Southern" },
                                    { "dgd", "Dagaari Dioula", "Dagaari Dioula" },
                                    { "dgi", "Northern Dagara", "Dagara, Northern" },
                                    { "dgk", "Dagba", "Dagba" },
                                    { "dag", "Dagbani", "Dagbani" },
                                    { "dec", "Dagik", "Dagik" },
                                    { "dgn", "Dagoman", "Dagoman" },
                                    { "dal", "Dahalo", "Dahalo" },
                                    { "das", "Daho-Doo", "Daho-Doo" },
                                    { "dij", "Dai", "Dai" },
                                    { "drb", "Dair", "Dair" },
                                    { "djc", "Dar Daju Daju", "Daju, Dar Daju" },
                                    { "daj", "Dar Fur Daju", "Daju, Dar Fur" },
                                    { "dau", "Dar Sila Daju", "Daju, Dar Sila" },
                                    { "ccg", "Samba Daka", "Daka, Samba" },
                                    { "bpa", "Dakaka", "Dakaka" },
                                    { "dkk", "Dakka", "Dakka" },
                                    { "dak", "Dakota", "Dakota" },
                                    { "dka", "Dakpakha", "Dakpakha" },
                                    { "dlm", "Dalmatian", "Dalmatian" },
                                    { "dmm", "Dama", "Dama" },
                                    { "dam", "Damakawa", "Damakawa" },
                                    { "uhn", "Damal", "Damal" },
                                    { "dmr", "East Damar", "Damar, East" },
                                    { "drn", "West Damar", "Damar, West" },
                                    { "dac", "Dambi", "Dambi" },
                                    { "dml", "Dameli", "Dameli" },
                                    { "dms", "Dampelas", "Dampelas" },
                                    { "daf", "Dan", "Dan" },
                                    { "dnr", "Danaru", "Danaru" },
                                    { "dnu", "Danau", "Danau" },
                                    { "daa", "Dangaléat", "Dangaléat" },
                                    { "dni", "Lower Grand Valley Dani", "Dani, Lower Grand Valley" },
                                    { "dnt", "Mid Grand Valley Dani", "Dani, Mid Grand Valley" },
                                    { "dna", "Upper Grand Valley Dani", "Dani, Upper Grand Valley" },
                                    { "dnw", "Western Dani", "Dani, Western" },
                                    { "dan", "Danish", "Danish" },
                                    { "dsl", "Danish Sign Language", "Danish Sign Language" },
                                    { "rmd", "Traveller Danish", "Danish, Traveller" },
                                    { "aso", "Dano", "Dano" },
                                    { "dnv", "Danu", "Danu" },
                                    { "daz", "Dao", "Dao" },
                                    { "dnd", "Daonda", "Daonda" },
                                    { "dry", "Darai", "Darai" },
                                    { "dar", "Dargwa", "Dargwa" },
                                    { "gbz", "Zoroastrian Dari", "Dari, Zoroastrian" },
                                    { "dln", "Darlong", "Darlong" },
                                    { "drd", "Darmiya", "Darmiya" },
                                    { "dot", "Dass", "Dass" },
                                    { "tcc", "Datooga", "Datooga" },
                                    { "dgw", "Daungwurrung", "Daungwurrung" },
                                    { "dta", "Daur", "Daur" },
                                    { "daw", "Davawenyo", "Davawenyo" },
                                    { "kwa", "Dâw", "Dâw" },
                                    { "dww", "Dawawa", "Dawawa" },
                                    { "ddw", "Dawera-Daweloor", "Dawera-Daweloor" },
                                    { "dav", "Dawida", "Dawida" },
                                    { "dwr", "Dawro", "Dawro" },
                                    { "dai", "Day", "Day" },
                                    { "xdy", "Malayic Dayak", "Dayak, Malayic" },
                                    { "dax", "Dayi", "Dayi" },
                                    { "dzd", "Daza", "Daza" },
                                    { "dzg", "Dazaga", "Dazaga" },
                                    { "dcc", "Deccan", "Deccan" },
                                    { "ded", "Dedua", "Dedua" },
                                    { "afn", "Defaka", "Defaka" },
                                    { "mzw", "Deg", "Deg" },
                                    { "dgu", "Degaru", "Degaru" },
                                    { "deg", "Degema", "Degema" },
                                    { "dge", "Degenan", "Degenan" },
                                    { "ing", "Degexit'an", "Degexit'an" },
                                    { "dhv", "Dehu", "Dehu" },
                                    { "deh", "Dehwari", "Dehwari" },
                                    { "dek", "Dek", "Dek" },
                                    { "row", "Dela-Oenale", "Dela-Oenale" },
                                    { "del", "Delaware", "Delaware" },
                                    { "dep", "Pidgin Delaware", "Delaware, Pidgin" },
                                    { "ntr", "Delo", "Delo" },
                                    { "dem", "Dem", "Dem" },
                                    { "dmx", "Dema", "Dema" },
                                    { "dei", "Demisa", "Demisa" },
                                    { "dmy", "Demta", "Demta" },
                                    { "ddn", "Dendi (Benin)", "Dendi (Benin)" },
                                    { "deq", "Dendi (Central African Republic)", "Dendi (Central African Republic)" },
                                    { "mhu", "Darang Deng", "Deng, Darang" },
                                    { "mxj", "Geman Deng", "Deng, Geman" },
                                    { "dez", "Dengese", "Dengese" },
                                    { "dnk", "Dengka", "Dengka" },
                                    { "dny", "Dení", "Dení" },
                                    { "dbb", "Deno", "Deno" },
                                    { "anv", "Denya", "Denya" },
                                    { "der", "Deori", "Deori" },
                                    { "kbv", "Dera (Indonesia)", "Dera (Indonesia)" },
                                    { "kna", "Dera (Nigeria)", "Dera (Nigeria)" },
                                    { "des", "Desano", "Desano" },
                                    { "dso", "Desiya", "Desiya" },
                                    { "dee", "Dewoin", "Dewoin" },
                                    { "def", "Dezfuli", "Dezfuli" },
                                    { "dgh", "Dghwede", "Dghwede" },
                                    { "dhs", "Dhaiso", "Dhaiso" },
                                    { "dhl", "Dhalandji", "Dhalandji" },
                                    { "dhg", "Dhangu", "Dhangu" },
                                    { "dhn", "Dhanki", "Dhanki" },
                                    { "dhw", "Dhanwar (Nepal)", "Dhanwar (Nepal)" },
                                    { "nfa", "Dhao", "Dhao" },
                                    { "dhr", "Dhargari", "Dhargari" },
                                    { "mki", "Dhatki", "Dhatki" },
                                    { "dhi", "Dhimal", "Dhimal" },
                                    { "div", "Dhivehi", "Dhivehi" },
                                    { "dho", "Dhodia", "Dhodia" },
                                    { "ddr", "Dhudhuroa", "Dhudhuroa" },
                                    { "dhd", "Dhundari", "Dhundari" },
                                    { "dhu", "Dhurga", "Dhurga" },
                                    { "duj", "Dhuwal", "Dhuwal" },
                                    { "dia", "Dia", "Dia" },
                                    { "dby", "Dibiyaso", "Dibiyaso" },
                                    { "dio", "Dibo", "Dibo" },
                                    { "bvx", "Dibole", "Dibole" },
                                    { "dic", "Lakota Dida", "Dida, Lakota" },
                                    { "gud", "Yocoboué Dida", "Dida, Yocoboué" },
                                    { "did", "Didinga", "Didinga" },
                                    { "ddo", "Dido", "Dido" },
                                    { "dif", "Dieri", "Dieri" },
                                    { "dig", "Digo", "Digo" },
                                    { "dur", "Dii", "Dii" },
                                    { "cfa", "Dijim-Bwilim", "Dijim-Bwilim" },
                                    { "dil", "Dilling", "Dilling" },
                                    { "jma", "Dima", "Dima" },
                                    { "dis", "Dimasa", "Dimasa" },
                                    { "dii", "Dimbong", "Dimbong" },
                                    { "dim", "Dime", "Dime" },
                                    { "dmc", "Dimir", "Dimir" },
                                    { "diq", "Dimli (individual language)", "Dimli (individual language)" },
                                    { "mrx", "Dineor", "Dineor" },
                                    { "diz", "Ding", "Ding" },
                                    { "din", "Dinka", "Dinka" },
                                    { "dip", "Northeastern Dinka", "Dinka, Northeastern" },
                                    { "diw", "Northwestern Dinka", "Dinka, Northwestern" },
                                    { "dib", "South Central Dinka", "Dinka, South Central" },
                                    { "dks", "Southeastern Dinka", "Dinka, Southeastern" },
                                    { "dik", "Southwestern Dinka", "Dinka, Southwestern" },
                                    { "dit", "Dirari", "Dirari" },
                                    { "gdl", "Dirasha", "Dirasha" },
                                    { "dwa", "Diri", "Diri" },
                                    { "diu", "Diriku", "Diriku" },
                                    { "dir", "Dirim", "Dirim" },
                                    { "dsi", "Disa", "Disa" },
                                    { "tbz", "Ditammari", "Ditammari" },
                                    { "dtd", "Ditidaht", "Ditidaht" },
                                    { "diy", "Diuwe", "Diuwe" },
                                    { "dix", "Dixon Reef", "Dixon Reef" },
                                    { "mdx", "Dizin", "Dizin" },
                                    { "dja", "Djadjawurrung", "Djadjawurrung" },
                                    { "djr", "Djambarrpuyngu", "Djambarrpuyngu" },
                                    { "djd", "Djamindjung", "Djamindjung" },
                                    { "djf", "Djangun", "Djangun" },
                                    { "djn", "Djauan", "Djauan" },
                                    { "djw", "Djawi", "Djawi" },
                                    { "djj", "Djeebbana", "Djeebbana" },
                                    { "dji", "Djinang", "Djinang" },
                                    { "djb", "Djinba", "Djinba" },
                                    { "jig", "Djingili", "Djingili" },
                                    { "djl", "Djiwarli", "Djiwarli" },
                                    { "kvo", "Dobel", "Dobel" },
                                    { "dob", "Dobu", "Dobu" },
                                    { "doe", "Doe", "Doe" },
                                    { "dgg", "Doga", "Doga" },
                                    { "dgx", "Doghoro", "Doghoro" },
                                    { "aqd", "Ampari Dogon", "Dogon, Ampari" },
                                    { "dti", "Ana Tinga Dogon", "Dogon, Ana Tinga" },
                                    { "dbw", "Bankan Tey Dogon", "Dogon, Bankan Tey" },
                                    { "dbt", "Ben Tey Dogon", "Dogon, Ben Tey" },
                                    { "dbu", "Bondum Dom Dogon", "Dogon, Bondum Dom" },
                                    { "dgb", "Bunoge Dogon", "Dogon, Bunoge" },
                                    { "dbg", "Dogul Dom Dogon", "Dogon, Dogul Dom" },
                                    { "dds", "Donno So Dogon", "Dogon, Donno So" },
                                    { "djm", "Jamsay Dogon", "Dogon, Jamsay" },
                                    { "dmb", "Mombo Dogon", "Dogon, Mombo" },
                                    { "nzz", "Nanga Dama Dogon", "Dogon, Nanga Dama" },
                                    { "dtu", "Tebul Ure Dogon", "Dogon, Tebul Ure" },
                                    { "dtk", "Tene Kan Dogon", "Dogon, Tene Kan" },
                                    { "tde", "Tiranige Diga Dogon", "Dogon, Tiranige Diga" },
                                    { "dto", "Tommo So Dogon", "Dogon, Tommo So" },
                                    { "dtm", "Tomo Kan Dogon", "Dogon, Tomo Kan" },
                                    { "dts", "Toro So Dogon", "Dogon, Toro So" },
                                    { "dtt", "Toro Tegu Dogon", "Dogon, Toro Tegu" },
                                    { "dym", "Yanda Dom Dogon", "Dogon, Yanda Dom" },
                                    { "dos", "Dogosé", "Dogosé" },
                                    { "dgs", "Dogoso", "Dogoso" },
                                    { "dgo", "Dogri (individual language)", "Dogri (individual language)" },
                                    { "doi", "Dogri (macrolanguage)", "Dogri (macrolanguage)" },
                                    { "dgr", "Dogrib", "Dogrib" },
                                    { "dbi", "Doka", "Doka" },
                                    { "uya", "Doko-Uyanga", "Doko-Uyanga" },
                                    { "dlg", "Dolgan", "Dolgan" },
                                    { "dre", "Dolpo", "Dolpo" },
                                    { "doa", "Dom", "Dom" },
                                    { "dmk", "Domaaki", "Domaaki" },
                                    { "rmt", "Domari", "Domari" },
                                    { "dov", "Dombe", "Dombe" },
                                    { "doq", "Dominican Sign Language", "Dominican Sign Language" },
                                    { "doy", "Dompo", "Dompo" },
                                    { "dof", "Domu", "Domu" },
                                    { "dev", "Domung", "Domung" },
                                    { "dok", "Dondo", "Dondo" },
                                    { "doh", "Dong", "Dong" },
                                    { "doc", "Northern Dong", "Dong, Northern" },
                                    { "kmc", "Southern Dong", "Dong, Southern" },
                                    { "doo", "Dongo", "Dongo" },
                                    { "dgl", "Dongolawi", "Dongolawi" },
                                    { "ddd", "Dongotono", "Dongotono" },
                                    { "sce", "Dongxiang", "Dongxiang" },
                                    { "dde", "Doondo", "Doondo" },
                                    { "dor", "Dori'o", "Dori'o" },
                                    { "kqc", "Doromu-Koki", "Doromu-Koki" },
                                    { "drr", "Dororo", "Dororo" },
                                    { "doz", "Dorze", "Dorze" },
                                    { "dol", "Doso", "Doso" },
                                    { "dty", "Dotyali", "Dotyali" },
                                    { "tds", "Doutai", "Doutai" },
                                    { "dow", "Doyayo", "Doyayo" },
                                    { "drt", "Drents", "Drents" },
                                    { "duu", "Drung", "Drung" },
                                    { "dua", "Duala", "Duala" },
                                    { "dup", "Duano", "Duano" },
                                    { "dva", "Duau", "Duau" },
                                    { "dub", "Dubli", "Dubli" },
                                    { "dmu", "Dubu", "Dubu" },
                                    { "ndu", "Dugun", "Dugun" },
                                    { "dbm", "Duguri", "Duguri" },
                                    { "dme", "Dugwor", "Dugwor" },
                                    { "kbz", "Duhwa", "Duhwa" },
                                    { "nke", "Duke", "Duke" },
                                    { "dbo", "Dulbu", "Dulbu" },
                                    { "duz", "Duli", "Duli" },
                                    { "dma", "Duma", "Duma" },
                                    { "agv", "Remontado Dumagat", "Dumagat, Remontado" },
                                    { "duf", "Dumbea", "Dumbea" },
                                    { "dus", "Dumi", "Dumi" },
                                    { "dmv", "Dumpas", "Dumpas" },
                                    { "dui", "Dumun", "Dumun" },
                                    { "duc", "Duna", "Duna" },
                                    { "dng", "Dungan", "Dungan" },
                                    { "raa", "Dungmali", "Dungmali" },
                                    { "duh", "Dungra Bhil", "Dungra Bhil" },
                                    { "dbv", "Dungu", "Dungu" },
                                    { "drq", "Dura", "Dura" },
                                    { "mvp", "Duri", "Duri" },
                                    { "dbn", "Duriankere", "Duriankere" },
                                    { "dug", "Duruma", "Duruma" },
                                    { "pci", "Duruwa", "Duruwa" },
                                    { "dsn", "Dusner", "Dusner" },
                                    { "dun", "Dusun Deyah", "Dusun Deyah" },
                                    { "duq", "Dusun Malang", "Dusun Malang" },
                                    { "duw", "Dusun Witu", "Dusun Witu" },
                                    { "dtp", "Central Dusun", "Dusun, Central" },
                                    { "kzs", "Sugut Dusun", "Dusun, Sugut" },
                                    { "kzt", "Tambunan Dusun", "Dusun, Tambunan" },
                                    { "tdu", "Tempasuk Dusun", "Dusun, Tempasuk" },
                                    { "nld", "Dutch", "Dutch" },
                                    { "dse", "Dutch Sign Language", "Dutch Sign Language" },
                                    { "dum", "Middle Dutch (ca. 1050-1350)", "Dutch, Middle (ca. 1050-1350)" },
                                    { "odt", "Old Dutch", "Dutch, Old" },
                                    { "dws", "Dutton World Speedwords", "Dutton World Speedwords" },
                                    { "dux", "Duungooma", "Duungooma" },
                                    { "dae", "Duupa", "Duupa" },
                                    { "duv", "Duvle", "Duvle" },
                                    { "dbp", "Duwai", "Duwai" },
                                    { "gve", "Duwet", "Duwet" },
                                    { "ldb", "Dũya", "Dũya" },
                                    { "nnu", "Dwang", "Dwang" },
                                    { "dyy", "Dyaabugay", "Dyaabugay" },
                                    { "dyb", "Dyaberdyaber", "Dyaberdyaber" },
                                    { "dya", "Dyan", "Dyan" },
                                    { "dyn", "Dyangadi", "Dyangadi" },
                                    { "dbl", "Dyirbal", "Dyirbal" },
                                    { "dyd", "Dyugun", "Dyugun" },
                                    { "dyu", "Dyula", "Dyula" },
                                    { "jen", "Dza", "Dza" },
                                    { "dzl", "Dzalakha", "Dzalakha" },
                                    { "dzn", "Dzando", "Dzando" },
                                    { "bpn", "Dzao Min", "Dzao Min" },
                                    { "add", "Dzodinka", "Dzodinka" },
                                    { "dzo", "Dzongkha", "Dzongkha" },
                                    { "dnn", "Dzùùngoo", "Dzùùngoo" },
                                    { "eee", "E", "E" },
                                    { "igb", "Ebira", "Ebira" },
                                    { "xeb", "Eblan", "Eblan" },
                                    { "ebr", "Ebrié", "Ebrié" },
                                    { "ebg", "Ebughu", "Ebughu" },
                                    { "ecs", "Ecuadorian Sign Language", "Ecuadorian Sign Language" },
                                    { "cbj", "Ede Cabe", "Ede Cabe" },
                                    { "ica", "Ede Ica", "Ede Ica" },
                                    { "idd", "Ede Idaca", "Ede Idaca" },
                                    { "ijj", "Ede Ije", "Ede Ije" },
                                    { "nqk", "Kura Ede Nago", "Ede Nago, Kura" },
                                    { "etr", "Edolo", "Edolo" },
                                    { "xdm", "Edomite", "Edomite" },
                                    { "dbf", "Edopi", "Edopi" },
                                    { "efa", "Efai", "Efai" },
                                    { "llp", "North Efate", "Efate, North" },
                                    { "erk", "South Efate", "Efate, South" },
                                    { "efe", "Efe", "Efe" },
                                    { "efi", "Efik", "Efik" },
                                    { "ofu", "Efutop", "Efutop" },
                                    { "ega", "Ega", "Ega" },
                                    { "ego", "Eggon", "Eggon" },
                                    { "esl", "Egypt Sign Language", "Egypt Sign Language" },
                                    { "egy", "Egyptian (Ancient)", "Egyptian (Ancient)" },
                                    { "ehu", "Ehueun", "Ehueun" },
                                    { "eip", "Eipomek", "Eipomek" },
                                    { "eit", "Eitiep", "Eitiep" },
                                    { "etu", "Ejagham", "Ejagham" },
                                    { "eja", "Ejamat", "Ejamat" },
                                    { "eka", "Ekajuk", "Ekajuk" },
                                    { "ekg", "Ekari", "Ekari" },
                                    { "eki", "Eki", "Eki" },
                                    { "eke", "Ekit", "Ekit" },
                                    { "ekp", "Ekpeye", "Ekpeye" },
                                    { "elh", "El Hugeirat", "El Hugeirat" },
                                    { "elo", "El Molo", "El Molo" },
                                    { "elx", "Elamite", "Elamite" },
                                    { "elm", "Eleme", "Eleme" },
                                    { "ele", "Elepi", "Elepi" },
                                    { "ekm", "Elip", "Elip" },
                                    { "elk", "Elkei", "Elkei" },
                                    { "afo", "Eloyi", "Eloyi" },
                                    { "mrf", "Elseng", "Elseng" },
                                    { "elu", "Elu", "Elu" },
                                    { "xly", "Elymian", "Elymian" },
                                    { "mmw", "Emae", "Emae" },
                                    { "ema", "Emai-Iuleha-Ora", "Emai-Iuleha-Ora" },
                                    { "emn", "Eman", "Eman" },
                                    { "emb", "Embaloh", "Embaloh" },
                                    { "emp", "Northern Emberá", "Emberá, Northern" },
                                    { "bdc", "Emberá-Baudó", "Emberá-Baudó" },
                                    { "cto", "Emberá-Catío", "Emberá-Catío" },
                                    { "cmi", "Emberá-Chamí", "Emberá-Chamí" },
                                    { "tdc", "Emberá-Tadó", "Emberá-Tadó" },
                                    { "ebu", "Embu", "Embu" },
                                    { "eme", "Emerillon", "Emerillon" },
                                    { "egl", "Emilian", "Emilian" },
                                    { "emo", "Emok", "Emok" },
                                    { "emw", "Emplawas", "Emplawas" },
                                    { "enr", "Emumu", "Emumu" },
                                    { "enc", "En", "En" },
                                    { "pbh", "E'ñapa Woromaipu", "E'ñapa Woromaipu" },
                                    { "unk", "Enawené-Nawé", "Enawené-Nawé" },
                                    { "end", "Ende", "Ende" },
                                    { "enf", "Forest Enets", "Enets, Forest" },
                                    { "enh", "Tundra Enets", "Enets, Tundra" },
                                    { "enq", "Enga", "Enga" },
                                    { "ngr", "Engdewu", "Engdewu" },
                                    { "enn", "Engenni", "Engenni" },
                                    { "eno", "Enggano", "Enggano" },
                                    { "eng", "English", "English" },
                                    { "lir", "Liberian English", "English, Liberian" },
                                    { "enm", "Middle English (1100-1500)", "English, Middle (1100-1500)" },
                                    { "ang", "Old English (ca. 450-1100)", "English, Old (ca. 450-1100)" },
                                    { "ptt", "Enrekang", "Enrekang" },
                                    { "enu", "Enu", "Enu" },
                                    { "enw", "Enwan (Akwa Ibom State)", "Enwan (Akwa Ibom State)" },
                                    { "env", "Enwan (Edu State)", "Enwan (Edu State)" },
                                    { "gey", "Enya", "Enya" },
                                    { "sja", "Epena", "Epena" },
                                    { "epi", "Epie", "Epie" },
                                    { "xep", "Epi-Olmec", "Epi-Olmec" },
                                    { "era", "Eravallan", "Eravallan" },
                                    { "kjy", "Erave", "Erave" },
                                    { "twp", "Ere", "Ere" },
                                    { "ert", "Eritai", "Eritai" },
                                    { "erw", "Erokwanas", "Erokwanas" },
                                    { "err", "Erre", "Erre" },
                                    { "emx", "Erromintxela", "Erromintxela" },
                                    { "ers", "Ersu", "Ersu" },
                                    { "erh", "Eruwa", "Eruwa" },
                                    { "myv", "Erzya", "Erzya" },
                                    { "ish", "Esan", "Esan" },
                                    { "mcq", "Ese", "Ese" },
                                    { "ese", "Ese Ejja", "Ese Ejja" },
                                    { "esh", "Eshtehardi", "Eshtehardi" },
                                    { "ags", "Esimbi", "Esimbi" },
                                    { "epo", "Esperanto", "Esperanto" },
                                    { "esq", "Esselen", "Esselen" },
                                    { "est", "Estonian", "Estonian" },
                                    { "eso", "Estonian Sign Language", "Estonian Sign Language" },
                                    { "ekk", "Standard Estonian", "Estonian, Standard" },
                                    { "esm", "Esuma", "Esuma" },
                                    { "etc", "Etchemin", "Etchemin" },
                                    { "etb", "Etebi", "Etebi" },
                                    { "etx", "Eten", "Eten" },
                                    { "ecr", "Eteocretan", "Eteocretan" },
                                    { "ecy", "Eteocypriot", "Eteocypriot" },
                                    { "eth", "Ethiopian Sign Language", "Ethiopian Sign Language" },
                                    { "ich", "Etkywan", "Etkywan" },
                                    { "eto", "Eton (Cameroon)", "Eton (Cameroon)" },
                                    { "etn", "Eton (Vanuatu)", "Eton (Vanuatu)" },
                                    { "ett", "Etruscan", "Etruscan" },
                                    { "utr", "Etulo", "Etulo" },
                                    { "bzz", "Evant", "Evant" },
                                    { "eve", "Even", "Even" },
                                    { "evn", "Evenki", "Evenki" },
                                    { "nou", "Ewage-Notu", "Ewage-Notu" },
                                    { "ewe", "Ewe", "Ewe" },
                                    { "ewo", "Ewondo", "Ewondo" },
                                    { "ext", "Extremaduran", "Extremaduran" },
                                    { "eya", "Eyak", "Eyak" },
                                    { "fab", "Fa D'ambu", "Fa D'ambu" },
                                    { "faf", "Fagani", "Fagani" },
                                    { "faj", "Faita", "Faita" },
                                    { "fai", "Faiwol", "Faiwol" },
                                    { "fax", "Fala", "Fala" },
                                    { "fli", "Fali", "Fali" },
                                    { "fah", "Baissa Fali", "Fali, Baissa" },
                                    { "fll", "North Fali", "Fali, North" },
                                    { "fal", "South Fali", "Fali, South" },
                                    { "xfa", "Faliscan", "Faliscan" },
                                    { "fam", "Fam", "Fam" },
                                    { "fng", "Fanagalo", "Fanagalo" },
                                    { "fak", "Fang (Cameroon)", "Fang (Cameroon)" },
                                    { "fan", "Fang (Equatorial Guinea)", "Fang (Equatorial Guinea)" },
                                    { "fni", "Fania", "Fania" },
                                    { "fat", "Fanti", "Fanti" },
                                    { "gur", "Farefare", "Farefare" },
                                    { "fao", "Faroese", "Faroese" },
                                    { "faz", "Northwestern Fars", "Fars, Northwestern" },
                                    { "fay", "Southwestern Fars", "Fars, Southwestern" },
                                    { "fqs", "Fas", "Fas" },
                                    { "faa", "Fasu", "Fasu" },
                                    { "far", "Fataleka", "Fataleka" },
                                    { "ddg", "Fataluku", "Fataluku" },
                                    { "fau", "Fayu", "Fayu" },
                                    { "fmp", "Fe'fe'", "Fe'fe'" },
                                    { "agl", "Fembe", "Fembe" },
                                    { "fer", "Feroge", "Feroge" },
                                    { "fij", "Fijian", "Fijian" },
                                    { "wyy", "Western Fijian", "Fijian, Western" },
                                    { "fil", "Filipino", "Filipino" },
                                    { "fss", "finlandssvenskt teckenspråk", "finlandssvenskt teckenspråk" },
                                    { "fin", "Finnish", "Finnish" },
                                    { "fse", "Finnish Sign Language", "Finnish Sign Language" },
                                    { "fkv", "Kven Finnish", "Finnish, Kven" },
                                    { "fit", "Tornedalen Finnish", "Finnish, Tornedalen" },
                                    { "fag", "Finongan", "Finongan" },
                                    { "fip", "Fipa", "Fipa" },
                                    { "fir", "Firan", "Firan" },
                                    { "fiw", "Fiwaga", "Fiwaga" },
                                    { "fln", "Flinders Island", "Flinders Island" },
                                    { "flh", "Foau", "Foau" },
                                    { "foi", "Foi", "Foi" },
                                    { "ffi", "Foia Foia", "Foia Foia" },
                                    { "ppo", "Folopa", "Folopa" },
                                    { "fom", "Foma", "Foma" },
                                    { "fon", "Fon", "Fon" },
                                    { "fgr", "Fongoro", "Fongoro" },
                                    { "fod", "Foodo", "Foodo" },
                                    { "frq", "Forak", "Forak" },
                                    { "frd", "Fordata", "Fordata" },
                                    { "for", "Fore", "Fore" },
                                    { "frt", "Fortsenal", "Fortsenal" },
                                    { "frp", "Francoprovençal", "Francoprovençal" },
                                    { "frk", "Frankish", "Frankish" },
                                    { "fra", "French", "French" },
                                    { "sfb", "French Belgian Sign Language", "French Belgian Sign Language" },
                                    { "fsl", "French Sign Language", "French Sign Language" },
                                    { "frc", "Cajun French", "French, Cajun" },
                                    { "frm", "Middle French (ca. 1400-1600)", "French, Middle (ca. 1400-1600)" },
                                    { "fro", "Old French (842-ca. 1400)", "French, Old (842-ca. 1400)" },
                                    { "frs", "Eastern Frisian", "Frisian, Eastern" },
                                    { "frr", "Northern Frisian", "Frisian, Northern" },
                                    { "ofs", "Old Frisian", "Frisian, Old" },
                                    { "fry", "Western Frisian", "Frisian, Western" },
                                    { "fur", "Friulian", "Friulian" },
                                    { "ful", "Fulah", "Fulah" },
                                    { "fub", "Adamawa Fulfulde", "Fulfulde, Adamawa" },
                                    { "fui", "Bagirmi Fulfulde", "Fulfulde, Bagirmi" },
                                    { "fue", "Borgu Fulfulde", "Fulfulde, Borgu" },
                                    { "fuq", "Central-Eastern Niger Fulfulde", "Fulfulde, Central-Eastern Niger" },
                                    { "ffm", "Maasina Fulfulde", "Fulfulde, Maasina" },
                                    { "fuv", "Nigerian Fulfulde", "Fulfulde, Nigerian" },
                                    { "fuh", "Western Niger Fulfulde", "Fulfulde, Western Niger" },
                                    { "flr", "Fuliiru", "Fuliiru" },
                                    { "fun", "Fulniô", "Fulniô" },
                                    { "fum", "Fum", "Fum" },
                                    { "ula", "Fungwa", "Fungwa" },
                                    { "fvr", "Fur", "Fur" },
                                    { "fuu", "Furu", "Furu" },
                                    { "fud", "East Futuna", "Futuna, East" },
                                    { "fut", "Futuna-Aniwa", "Futuna-Aniwa" },
                                    { "fuy", "Fuyug", "Fuyug" },
                                    { "fwa", "Fwâi", "Fwâi" },
                                    { "fwe", "Fwe", "Fwe" },
                                    { "pym", "Fyam", "Fyam" },
                                    { "fie", "Fyer", "Fyer" },
                                    { "gaa", "Ga", "Ga" },
                                    { "ttb", "Gaa", "Gaa" },
                                    { "tbi", "Gaam", "Gaam" },
                                    { "gqa", "Ga'anda", "Ga'anda" },
                                    { "gab", "Gabri", "Gabri" },
                                    { "xgf", "Gabrielino-Fernandeño", "Gabrielino-Fernandeño" },
                                    { "gbj", "Bodo Gadaba", "Gadaba, Bodo" },
                                    { "gau", "Mudhili Gadaba", "Gadaba, Mudhili" },
                                    { "gdb", "Pottangi Ollar Gadaba", "Gadaba, Pottangi Ollar" },
                                    { "gdk", "Gadang", "Gadang" },
                                    { "gdg", "Ga'dang", "Ga'dang" },
                                    { "gad", "Gaddang", "Gaddang" },
                                    { "gbk", "Gaddi", "Gaddi" },
                                    { "ged", "Gade", "Gade" },
                                    { "gdh", "Gadjerawang", "Gadjerawang" },
                                    { "gaj", "Gadsup", "Gadsup" },
                                    { "ghc", "Hiberno-Scottish Gaelic", "Gaelic, Hiberno-Scottish" },
                                    { "gla", "Scottish Gaelic", "Gaelic, Scottish" },
                                    { "gft", "Gafat", "Gafat" },
                                    { "gbu", "Gagadu", "Gagadu" },
                                    { "gag", "Gagauz", "Gagauz" },
                                    { "ggu", "Gagu", "Gagu" },
                                    { "bfu", "Gahri", "Gahri" },
                                    { "gbf", "Gaikundi", "Gaikundi" },
                                    { "gic", "Gail", "Gail" },
                                    { "gcn", "Gaina", "Gaina" },
                                    { "gap", "Gal", "Gal" },
                                    { "glo", "Galambu", "Galambu" },
                                    { "xga", "Galatian", "Galatian" },
                                    { "gbi", "Galela", "Galela" },
                                    { "gar", "Galeya", "Galeya" },
                                    { "gce", "Galice", "Galice" },
                                    { "glg", "Galician", "Galician" },
                                    { "xgl", "Galindan", "Galindan" },
                                    { "adl", "Galo", "Galo" },
                                    { "gal", "Galoli", "Galoli" },
                                    { "gma", "Gambera", "Gambera" },
                                    { "kld", "Gamilaraay", "Gamilaraay" },
                                    { "gbl", "Gamit", "Gamit" },
                                    { "gak", "Gamkonora", "Gamkonora" },
                                    { "gmv", "Gamo", "Gamo" },
                                    { "bte", "Gamo-Ningi", "Gamo-Ningi" },
                                    { "gnk", "Gana", "Gana" },
                                    { "gnq", "Gana", "Gana" },
                                    { "gne", "Ganang", "Ganang" },
                                    { "lug", "Ganda", "Ganda" },
                                    { "gzn", "Gane", "Gane" },
                                    { "gcd", "Ganggalida", "Ganggalida" },
                                    { "ggl", "Ganglau", "Ganglau" },
                                    { "gnb", "Gangte", "Gangte" },
                                    { "gnl", "Gangulu", "Gangulu" },
                                    { "gao", "Gants", "Gants" },
                                    { "gza", "Ganza", "Ganza" },
                                    { "gnz", "Ganzi", "Ganzi" },
                                    { "gga", "Gao", "Gao" },
                                    { "pwg", "Gapapaiwa", "Gapapaiwa" },
                                    { "gas", "Adiwasi Garasia", "Garasia, Adiwasi" },
                                    { "gra", "Rajput Garasia", "Garasia, Rajput" },
                                    { "gbm", "Garhwali", "Garhwali" },
                                    { "cab", "Garifuna", "Garifuna" },
                                    { "ilg", "Garig-Ilgar", "Garig-Ilgar" },
                                    { "grt", "Garo", "Garo" },
                                    { "gex", "Garre", "Garre" },
                                    { "wrk", "Garrwa", "Garrwa" },
                                    { "gyb", "Garus", "Garus" },
                                    { "xgr", "Garza", "Garza" },
                                    { "gaq", "Gata'", "Gata'" },
                                    { "xcg", "Cisalpine Gaulish", "Gaulish, Cisalpine" },
                                    { "xtg", "Transalpine Gaulish", "Gaulish, Transalpine" },
                                    { "gou", "Gavar", "Gavar" },
                                    { "gvo", "Gavião Do Jiparaná", "Gavião Do Jiparaná" },
                                    { "gvp", "Pará Gavião", "Gavião, Pará" },
                                    { "gwt", "Gawar-Bati", "Gawar-Bati" },
                                    { "gwd", "Gawwada", "Gawwada" },
                                    { "gyl", "Gayil", "Gayil" },
                                    { "gay", "Gayo", "Gayo" },
                                    { "gzi", "Gazi", "Gazi" },
                                    { "gbr", "Gbagyi", "Gbagyi" },
                                    { "gbv", "Gbanu", "Gbanu" },
                                    { "gbg", "Gbanziri", "Gbanziri" },
                                    { "gby", "Gbari", "Gbari" },
                                    { "gti", "Gbati-ri", "Gbati-ri" },
                                    { "gba", "Gbaya (Central African Republic)", "Gbaya (Central African Republic)" },
                                    { "krs", "Gbaya (Sudan)", "Gbaya (Sudan)" },
                                    { "gya", "Northwest Gbaya", "Gbaya, Northwest" },
                                    { "gso", "Southwest Gbaya", "Gbaya, Southwest" },
                                    { "gbp", "Gbaya-Bossangoa", "Gbaya-Bossangoa" },
                                    { "gbq", "Gbaya-Bozoum", "Gbaya-Bozoum" },
                                    { "gmm", "Gbaya-Mbodomo", "Gbaya-Mbodomo" },
                                    { "gyg", "Gbayi", "Gbayi" },
                                    { "ayb", "Ayizo Gbe", "Gbe, Ayizo" },
                                    { "cib", "Ci Gbe", "Gbe, Ci" },
                                    { "gbh", "Defi Gbe", "Gbe, Defi" },
                                    { "gbx", "Eastern Xwla Gbe", "Gbe, Eastern Xwla" },
                                    { "gbs", "Gbesi Gbe", "Gbe, Gbesi" },
                                    { "kqk", "Kotafon Gbe", "Gbe, Kotafon" },
                                    { "mxl", "Maxi Gbe", "Gbe, Maxi" },
                                    { "sxw", "Saxwe Gbe", "Gbe, Saxwe" },
                                    { "tfi", "Tofin Gbe", "Gbe, Tofin" },
                                    { "wci", "Waci Gbe", "Gbe, Waci" },
                                    { "wem", "Weme Gbe", "Gbe, Weme" },
                                    { "xwl", "Western Xwla Gbe", "Gbe, Western Xwla" },
                                    { "xwe", "Xwela Gbe", "Gbe, Xwela" },
                                    { "ggb", "Gbii", "Gbii" },
                                    { "xgb", "Gbin", "Gbin" },
                                    { "grh", "Gbiri-Niragu", "Gbiri-Niragu" },
                                    { "gei", "Gebe", "Gebe" },
                                    { "gdd", "Gedaged", "Gedaged" },
                                    { "drs", "Gedeo", "Gedeo" },
                                    { "gez", "Geez", "Geez" },
                                    { "gji", "Geji", "Geji" },
                                    { "hmj", "Gejia", "Gejia" },
                                    { "nlg", "Gela", "Gela" },
                                    { "giq", "Green Gelao", "Gelao, Green" },
                                    { "gir", "Red Gelao", "Gelao, Red" },
                                    { "giw", "White Gelao", "Gelao, White" },
                                    { "geq", "Geme", "Geme" },
                                    { "gej", "Gen", "Gen" },
                                    { "gaf", "Gende", "Gende" },
                                    { "geg", "Gengle", "Gengle" },
                                    { "kat", "Georgian", "Georgian" },
                                    { "oge", "Old Georgian", "Georgian, Old" },
                                    { "ygp", "Gepo", "Gepo" },
                                    { "gew", "Gera", "Gera" },
                                    { "moz", "Gergiko", "Gergiko" },
                                    { "deu", "German", "German" },
                                    { "gsg", "German Sign Language", "German Sign Language" },
                                    { "gct", "Colonia Tovar German", "German, Colonia Tovar" },
                                    { "geh", "Hutterite German", "German, Hutterite" },
                                    { "nds", "Low German", "German, Low" },
                                    { "gmh", "Middle High German (ca. 1050-1500)", "German, Middle High (ca. 1050-1500)" },
                                    { "gml", "Middle Low German", "German, Middle Low" },
                                    { "goh", "Old High German (ca. 750-1050)", "German, Old High (ca. 750-1050)" },
                                    { "pdc", "Pennsylvania German", "German, Pennsylvania" },
                                    { "gsw", "Swiss German", "German, Swiss" },
                                    { "gea", "Geruma", "Geruma" },
                                    { "ges", "Geser-Gorom", "Geser-Gorom" },
                                    { "guv", "Gey", "Gey" },
                                    { "gha", "Ghadamès", "Ghadamès" },
                                    { "ght", "Kutang Ghale", "Ghale, Kutang" },
                                    { "ghh", "Northern Ghale", "Ghale, Northern" },
                                    { "ghe", "Southern Ghale", "Ghale, Southern" },
                                    { "gse", "Ghanaian Sign Language", "Ghanaian Sign Language" },
                                    { "gds", "Ghandruk Sign Language", "Ghandruk Sign Language" },
                                    { "ghn", "Ghanongga", "Ghanongga" },
                                    { "gri", "Ghari", "Ghari" },
                                    { "bmk", "Ghayavi", "Ghayavi" },
                                    { "ghr", "Ghera", "Ghera" },
                                    { "gdo", "Ghodoberi", "Ghodoberi" },
                                    { "bbj", "Ghomálá'", "Ghomálá'" },
                                    { "gho", "Ghomara", "Ghomara" },
                                    { "aaa", "Ghotuo", "Ghotuo" },
                                    { "ghl", "Ghulfan", "Ghulfan" },
                                    { "bgi", "Giangan", "Giangan" },
                                    { "gib", "Gibanawa", "Gibanawa" },
                                    { "gid", "Gidar", "Gidar" },
                                    { "kks", "Giiwo", "Giiwo" },
                                    { "acd", "Gikyode", "Gikyode" },
                                    { "glk", "Gilaki", "Gilaki" },
                                    { "gil", "Gilbertese", "Gilbertese" },
                                    { "gix", "Gilima", "Gilima" },
                                    { "niv", "Gilyak", "Gilyak" },
                                    { "gim", "Gimi (Eastern Highlands)", "Gimi (Eastern Highlands)" },
                                    { "gip", "Gimi (West New Britain)", "Gimi (West New Britain)" },
                                    { "kmp", "Gimme", "Gimme" },
                                    { "gmn", "Gimnime", "Gimnime" },
                                    { "gnm", "Ginuman", "Ginuman" },
                                    { "ayg", "Ginyanga", "Ginyanga" },
                                    { "bbr", "Girawa", "Girawa" },
                                    { "nyf", "Giryama", "Giryama" },
                                    { "toh", "Gitonga", "Gitonga" },
                                    { "ggt", "Gitua", "Gitua" },
                                    { "git", "Gitxsan", "Gitxsan" },
                                    { "giy", "Giyug", "Giyug" },
                                    { "gis", "North Giziga", "Giziga, North" },
                                    { "giz", "South Giziga", "Giziga, South" },
                                    { "tof", "Gizrra", "Gizrra" },
                                    { "glr", "Glaro-Twabo", "Glaro-Twabo" },
                                    { "glw", "Glavda", "Glavda" },
                                    { "oub", "Glio-Oubi", "Glio-Oubi" },
                                    { "gnu", "Gnau", "Gnau" },
                                    { "gig", "Goaria", "Goaria" },
                                    { "goi", "Gobasi", "Gobasi" },
                                    { "gox", "Gobu", "Gobu" },
                                    { "god", "Godié", "Godié" },
                                    { "gdx", "Godwari", "Godwari" },
                                    { "ank", "Goemai", "Goemai" },
                                    { "gof", "Gofa", "Gofa" },
                                    { "gog", "Gogo", "Gogo" },
                                    { "ggw", "Gogodala", "Gogodala" },
                                    { "gkn", "Gokana", "Gokana" },
                                    { "gol", "Gola", "Gola" },
                                    { "gvf", "Golin", "Golin" },
                                    { "gon", "Gondi", "Gondi" },
                                    { "gno", "Northern Gondi", "Gondi, Northern" },
                                    { "ggo", "Southern Gondi", "Gondi, Southern" },
                                    { "goo", "Gone Dau", "Gone Dau" },
                                    { "goe", "Gongduk", "Gongduk" },
                                    { "gjn", "Gonja", "Gonja" },
                                    { "ddi", "West Goodenough", "Goodenough, West" },
                                    { "gni", "Gooniyandi", "Gooniyandi" },
                                    { "gqr", "Gor", "Gor" },
                                    { "goc", "Gorakor", "Gorakor" },
                                    { "goq", "Gorap", "Gorap" },
                                    { "gor", "Gorontalo", "Gorontalo" },
                                    { "grq", "Gorovu", "Gorovu" },
                                    { "gow", "Gorowa", "Gorowa" },
                                    { "got", "Gothic", "Gothic" },
                                    { "goy", "Goundo", "Goundo" },
                                    { "gux", "Gourmanchéma", "Gourmanchéma" },
                                    { "goj", "Gowlan", "Gowlan" },
                                    { "gok", "Gowli", "Gowli" },
                                    { "gwf", "Gowro", "Gowro" },
                                    { "goz", "Gozarkhani", "Gozarkhani" },
                                    { "nli", "Grangali", "Grangali" },
                                    { "gac", "Mixed Great Andamanese", "Great Andamanese, Mixed" },
                                    { "grb", "Grebo", "Grebo" },
                                    { "gry", "Barclayville Grebo", "Grebo, Barclayville" },
                                    { "grv", "Central Grebo", "Grebo, Central" },
                                    { "gec", "Gboloo Grebo", "Grebo, Gboloo" },
                                    { "gbo", "Northern Grebo", "Grebo, Northern" },
                                    { "grj", "Southern Grebo", "Grebo, Southern" },
                                    { "gss", "Greek Sign Language", "Greek Sign Language" },
                                    { "grc", "Ancient Greek (to 1453)", "Greek, Ancient (to 1453)" },
                                    { "cpg", "Cappadocian Greek", "Greek, Cappadocian" },
                                    { "ell", "Modern Greek (1453-)", "Greek, Modern (1453-)" },
                                    { "gmy", "Mycenaean Greek", "Greek, Mycenaean" },
                                    { "grs", "Gresi", "Gresi" },
                                    { "gro", "Groma", "Groma" },
                                    { "gos", "Gronings", "Gronings" },
                                    { "ats", "Gros Ventre", "Gros Ventre" },
                                    { "gwx", "Gua", "Gua" },
                                    { "guh", "Guahibo", "Guahibo" },
                                    { "gvj", "Guajá", "Guajá" },
                                    { "gub", "Guajajára", "Guajajára" },
                                    { "gum", "Guambiano", "Guambiano" },
                                    { "gqn", "Guana (Brazil)", "Guana (Brazil)" },
                                    { "gva", "Guana (Paraguay)", "Guana (Paraguay)" },
                                    { "gvc", "Guanano", "Guanano" },
                                    { "gnc", "Guanche", "Guanche" },
                                    { "jiq", "Guanyinqiao", "Guanyinqiao" },
                                    { "grn", "Guarani", "Guarani" },
                                    { "nhd", "Ava Guaraní", "Guaraní, Ava" },
                                    { "gui", "Eastern Bolivian Guaraní", "Guaraní, Eastern Bolivian" },
                                    { "gun", "Mbyá Guaraní", "Guaraní, Mbyá" },
                                    { "gug", "Paraguayan Guaraní", "Guaraní, Paraguayan" },
                                    { "gnw", "Western Bolivian Guaraní", "Guaraní, Western Bolivian" },
                                    { "gyr", "Guarayu", "Guarayu" },
                                    { "gae", "Guarequena", "Guarequena" },
                                    { "gsm", "Guatemalan Sign Language", "Guatemalan Sign Language" },
                                    { "gta", "Guató", "Guató" },
                                    { "guo", "Guayabero", "Guayabero" },
                                    { "nji", "Gudanji", "Gudanji" },
                                    { "gde", "Gude", "Gude" },
                                    { "gdu", "Gudu", "Gudu" },
                                    { "gdf", "Guduf-Gava", "Guduf-Gava" },
                                    { "ggd", "Gugadj", "Gugadj" },
                                    { "gdc", "Gugu Badhun", "Gugu Badhun" },
                                    { "wrw", "Gugu Warra", "Gugu Warra" },
                                    { "kkp", "Gugubera", "Gugubera" },
                                    { "kky", "Guguyimidjir", "Guguyimidjir" },
                                    { "ghs", "Guhu-Samane", "Guhu-Samane" },
                                    { "gus", "Guinean Sign Language", "Guinean Sign Language" },
                                    { "gqi", "Guiqiong", "Guiqiong" },
                                    { "guj", "Gujarati", "Gujarati" },
                                    { "gju", "Gujari", "Gujari" },
                                    { "kcm", "Gula (Central African Republic)", "Gula (Central African Republic)" },
                                    { "glu", "Gula (Chad)", "Gula (Chad)" },
                                    { "glj", "Gula Iro", "Gula Iro" },
                                    { "gmb", "Gula'alaa", "Gula'alaa" },
                                    { "gvl", "Gulay", "Gulay" },
                                    { "gly", "Gule", "Gule" },
                                    { "gli", "Guliguli", "Guliguli" },
                                    { "gmu", "Gumalu", "Gumalu" },
                                    { "gnn", "Gumatj", "Gumatj" },
                                    { "gvs", "Gumawana", "Gumawana" },
                                    { "guk", "Gumuz", "Gumuz" },
                                    { "guw", "Gun", "Gun" },
                                    { "gdi", "Gundi", "Gundi" },
                                    { "gyf", "Gungabula", "Gungabula" },
                                    { "rub", "Gungu", "Gungu" },
                                    { "gnt", "Guntai", "Guntai" },
                                    { "gup", "Gunwinggu", "Gunwinggu" },
                                    { "gyy", "Gunya", "Gunya" },
                                    { "gpa", "Gupa-Abawa", "Gupa-Abawa" },
                                    { "guf", "Gupapuyngu", "Gupapuyngu" },
                                    { "gge", "Guragone", "Guragone" },
                                    { "grz", "Guramalum", "Guramalum" },
                                    { "hac", "Gurani", "Gurani" },
                                    { "gdj", "Gurdjar", "Gurdjar" },
                                    { "gnr", "Gureng Gureng", "Gureng Gureng" },
                                    { "ggg", "Gurgula", "Gurgula" },
                                    { "grx", "Guriaso", "Guriaso" },
                                    { "gue", "Gurinji", "Gurinji" },
                                    { "gvm", "Gurmana", "Gurmana" },
                                    { "goa", "Guro", "Guro" },
                                    { "ggn", "Eastern Gurung", "Gurung, Eastern" },
                                    { "gvr", "Western Gurung", "Gurung, Western" },
                                    { "grd", "Guruntum-Mbaaru", "Guruntum-Mbaaru" },
                                    { "gsn", "Gusan", "Gusan" },
                                    { "guz", "Gusii", "Gusii" },
                                    { "gsl", "Gusilay", "Gusilay" },
                                    { "gwu", "Guwamu", "Guwamu" },
                                    { "gka", "Guya", "Guya" },
                                    { "gvy", "Guyani", "Guyani" },
                                    { "ngs", "Gvoko", "Gvoko" },
                                    { "gwb", "Gwa", "Gwa" },
                                    { "dah", "Gwahatike", "Gwahatike" },
                                    { "jgk", "Gwak", "Gwak" },
                                    { "bga", "Gwamhi-Wuri", "Gwamhi-Wuri" },
                                    { "gwn", "Gwandara", "Gwandara" },
                                    { "grw", "Gweda", "Gweda" },
                                    { "gwe", "Gweno", "Gweno" },
                                    { "gwr", "Gwere", "Gwere" },
                                    { "gwj", "Gwi", "Gwi" },
                                    { "gwi", "Gwichʼin", "Gwichʼin" },
                                    { "gyi", "Gyele", "Gyele" },
                                    { "gye", "Gyem", "Gyem" },
                                    { "haq", "Ha", "Ha" },
                                    { "hbu", "Habu", "Habu" },
                                    { "hdy", "Hadiyya", "Hadiyya" },
                                    { "hoj", "Hadothi", "Hadothi" },
                                    { "xhd", "Hadrami", "Hadrami" },
                                    { "hts", "Hadza", "Hadza" },
                                    { "aek", "Haeke", "Haeke" },
                                    { "hah", "Hahon", "Hahon" },
                                    { "hgm", "Hai//om", "Hai//om" },
                                    { "hai", "Haida", "Haida" },
                                    { "hdn", "Northern Haida", "Haida, Northern" },
                                    { "hax", "Southern Haida", "Haida, Southern" },
                                    { "hgw", "Haigwai", "Haigwai" },
                                    { "haf", "Haiphong Sign Language", "Haiphong Sign Language" },
                                    { "has", "Haisla", "Haisla" },
                                    { "hat", "Haitian", "Haitian" },
                                    { "hvc", "Haitian Vodoun Culture Language", "Haitian Vodoun Culture Language" },
                                    { "hji", "Haji", "Haji" },
                                    { "haj", "Hajong", "Hajong" },
                                    { "hao", "Hakö", "Hakö" },
                                    { "hal", "Halang", "Halang" },
                                    { "hld", "Halang Doan", "Halang Doan" },
                                    { "hlb", "Halbi", "Halbi" },
                                    { "hla", "Halia", "Halia" },
                                    { "hur", "Halkomelem", "Halkomelem" },
                                    { "hmu", "Hamap", "Hamap" },
                                    { "hba", "Hamba", "Hamba" },
                                    { "amf", "Hamer-Banna", "Hamer-Banna" },
                                    { "hmt", "Hamtai", "Hamtai" },
                                    { "haa", "Han", "Han" },
                                    { "hag", "Hanga", "Hanga" },
                                    { "wos", "Hanga Hundi", "Hanga Hundi" },
                                    { "han", "Hangaza", "Hangaza" },
                                    { "hni", "Hani", "Hani" },
                                    { "lml", "Hano", "Hano" },
                                    { "hab", "Hanoi Sign Language", "Hanoi Sign Language" },
                                    { "hnn", "Hanunoo", "Hanunoo" },
                                    { "xha", "Harami", "Harami" },
                                    { "har", "Harari", "Harari" },
                                    { "hro", "Haroi", "Haroi" },
                                    { "hss", "Harsusi", "Harsusi" },
                                    { "tmd", "Haruai", "Haruai" },
                                    { "hrk", "Haruku", "Haruku" },
                                    { "bgc", "Haryanvi", "Haryanvi" },
                                    { "hrz", "Harzani", "Harzani" },
                                    { "ybj", "Hasha", "Hasha" },
                                    { "mey", "Hassaniyya", "Hassaniyya" },
                                    { "had", "Hatam", "Hatam" },
                                    { "xht", "Hattic", "Hattic" },
                                    { "hau", "Hausa", "Hausa" },
                                    { "hsl", "Hausa Sign Language", "Hausa Sign Language" },
                                    { "yuf", "Havasupai-Walapai-Yavapai", "Havasupai-Walapai-Yavapai" },
                                    { "hvk", "Haveke", "Haveke" },
                                    { "hav", "Havu", "Havu" },
                                    { "hps", "Hawai'i Pidgin Sign Language", "Hawai'i Pidgin Sign Language" },
                                    { "haw", "Hawaiian", "Hawaiian" },
                                    { "hay", "Haya", "Haya" },
                                    { "haz", "Hazaragi", "Hazaragi" },
                                    { "xed", "Hdi", "Hdi" },
                                    { "heb", "Hebrew", "Hebrew" },
                                    { "hbo", "Ancient Hebrew", "Hebrew, Ancient" },
                                    { "heh", "Hehe", "Hehe" },
                                    { "hbn", "Heiban", "Heiban" },
                                    { "hei", "Heiltsuk", "Heiltsuk" },
                                    { "scp", "Helambu Sherpa", "Helambu Sherpa" },
                                    { "heg", "Helong", "Helong" },
                                    { "nix", "Hema", "Hema" },
                                    { "hem", "Hemba", "Hemba" },
                                    { "hed", "Herdé", "Herdé" },
                                    { "her", "Herero", "Herero" },
                                    { "llf", "Hermit", "Hermit" },
                                    { "xhr", "Hernican", "Hernican" },
                                    { "hrt", "Hértevin", "Hértevin" },
                                    { "hks", "Heung Kong Sau Yue", "Heung Kong Sau Yue" },
                                    { "ham", "Hewa", "Hewa" },
                                    { "auk", "Heyo", "Heyo" },
                                    { "hib", "Hibito", "Hibito" },
                                    { "hid", "Hidatsa", "Hidatsa" },
                                    { "mba", "Higaonon", "Higaonon" },
                                    { "hij", "Hijuk", "Hijuk" },
                                    { "hil", "Hiligaynon", "Hiligaynon" },
                                    { "hir", "Himarimã", "Himarimã" },
                                    { "hin", "Hindi", "Hindi" },
                                    { "hif", "Fiji Hindi", "Hindi, Fiji" },
                                    { "hno", "Northern Hindko", "Hindko, Northern" },
                                    { "hnd", "Southern Hindko", "Hindko, Southern" },
                                    { "hii", "Hinduri", "Hinduri" },
                                    { "hns", "Caribbean Hindustani", "Hindustani, Caribbean" },
                                    { "gin", "Hinukh", "Hinukh" },
                                    { "hmo", "Hiri Motu", "Hiri Motu" },
                                    { "hit", "Hittite", "Hittite" },
                                    { "htx", "Middle Hittite", "Hittite, Middle" },
                                    { "nei", "Neo-Hittite", "Hittite, Neo-" },
                                    { "oht", "Old Hittite", "Hittite, Old" },
                                    { "htu", "Hitu", "Hitu" },
                                    { "hiw", "Hiw", "Hiw" },
                                    { "hix", "Hixkaryána", "Hixkaryána" },
                                    { "lic", "Hlai", "Hlai" },
                                    { "hle", "Hlersu", "Hlersu" },
                                    { "hmr", "Hmar", "Hmar" },
                                    { "hmn", "Hmong", "Hmong" },
                                    { "mww", "Hmong Daw", "Hmong Daw" },
                                    { "hmv", "Hmong Dô", "Hmong Dô" },
                                    { "hmf", "Hmong Don", "Hmong Don" },
                                    { "hnj", "Hmong Njua", "Hmong Njua" },
                                    { "hmz", "Hmong Shua", "Hmong Shua" },
                                    { "hmc", "Central Huishui Hmong", "Hmong, Central Huishui" },
                                    { "hmm", "Central Mashan Hmong", "Hmong, Central Mashan" },
                                    { "hme", "Eastern Huishui Hmong", "Hmong, Eastern Huishui" },
                                    { "hml", "Luopohe Hmong", "Hmong, Luopohe" },
                                    { "huj", "Northern Guiyang Hmong", "Hmong, Northern Guiyang" },
                                    { "hmi", "Northern Huishui Hmong", "Hmong, Northern Huishui" },
                                    { "hmp", "Northern Mashan Hmong", "Hmong, Northern Mashan" },
                                    { "hmy", "Southern Guiyang Hmong", "Hmong, Southern Guiyang" },
                                    { "hma", "Southern Mashan Hmong", "Hmong, Southern Mashan" },
                                    { "hmg", "Southwestern Guiyang Hmong", "Hmong, Southwestern Guiyang" },
                                    { "hmh", "Southwestern Huishui Hmong", "Hmong, Southwestern Huishui" },
                                    { "hmw", "Western Mashan Hmong", "Hmong, Western Mashan" },
                                    { "mrk", "Hmwaveke", "Hmwaveke" },
                                    { "hoc", "Ho", "Ho" },
                                    { "hos", "Ho Chi Minh City Sign Language", "Ho Chi Minh City Sign Language" },
                                    { "hoa", "Hoava", "Hoava" },
                                    { "hoh", "Hobyót", "Hobyót" },
                                    { "win", "Ho-Chunk", "Ho-Chunk" },
                                    { "hhi", "Hoia Hoia", "Hoia Hoia" },
                                    { "hoi", "Holikachuk", "Holikachuk" },
                                    { "hoy", "Holiya", "Holiya" },
                                    { "hod", "Holma", "Holma" },
                                    { "hoo", "Holoholo", "Holoholo" },
                                    { "hol", "Holu", "Holu" },
                                    { "hom", "Homa", "Homa" },
                                    { "hds", "Honduras Sign Language", "Honduras Sign Language" },
                                    { "juh", "Hõne", "Hõne" },
                                    { "how", "Honi", "Honi" },
                                    { "hop", "Hopi", "Hopi" },
                                    { "hor", "Horo", "Horo" },
                                    { "hoe", "Horom", "Horom" },
                                    { "ero", "Horpa", "Horpa" },
                                    { "hot", "Hote", "Hote" },
                                    { "hti", "Hoti", "Hoti" },
                                    { "hov", "Hovongan", "Hovongan" },
                                    { "hhy", "Hoyahoya", "Hoyahoya" },
                                    { "hoz", "Hozo", "Hozo" },
                                    { "hpo", "Hpon", "Hpon" },
                                    { "hra", "Hrangkhol", "Hrangkhol" },
                                    { "hre", "Hre", "Hre" },
                                    { "hru", "Hruso", "Hruso" },
                                    { "huo", "Hu", "Hu" },
                                    { "huc", "Hua", "Hua" },
                                    { "hug", "Huachipaeri", "Huachipaeri" },
                                    { "hub", "Huambisa", "Huambisa" },
                                    { "var", "Huarijio", "Huarijio" },
                                    { "hus", "Huastec", "Huastec" },
                                    { "hud", "Huaulu", "Huaulu" },
                                    { "hve", "San Dionisio Del Mar Huave", "Huave, San Dionisio Del Mar" },
                                    { "hue", "San Francisco Del Mar Huave", "Huave, San Francisco Del Mar" },
                                    { "huv", "San Mateo Del Mar Huave", "Huave, San Mateo Del Mar" },
                                    { "hvv", "Santa María Del Mar Huave", "Huave, Santa María Del Mar" },
                                    { "hbb", "Huba", "Huba" },
                                    { "hch", "Huichol", "Huichol" },
                                    { "huh", "Huilliche", "Huilliche" },
                                    { "hto", "Minica Huitoto", "Huitoto, Minica" },
                                    { "huu", "Murui Huitoto", "Huitoto, Murui" },
                                    { "hux", "Nüpode Huitoto", "Huitoto, Nüpode" },
                                    { "huw", "Hukumina", "Hukumina" },
                                    { "hul", "Hula", "Hula" },
                                    { "huy", "Hulaulá", "Hulaulá" },
                                    { "hui", "Huli", "Huli" },
                                    { "huk", "Hulung", "Hulung" },
                                    { "huf", "Humene", "Humene" },
                                    { "hut", "Humla", "Humla" },
                                    { "hke", "Hunde", "Hunde" },
                                    { "hnu", "Hung", "Hung" },
                                    { "hum", "Hungana", "Hungana" },
                                    { "hun", "Hungarian", "Hungarian" },
                                    { "hsh", "Hungarian Sign Language", "Hungarian Sign Language" },
                                    { "ohu", "Old Hungarian", "Hungarian, Old" },
                                    { "nat", "Hungworo", "Hungworo" },
                                    { "hkk", "Hunjara-Kaina Ke", "Hunjara-Kaina Ke" },
                                    { "xhc", "Hunnic", "Hunnic" },
                                    { "dud", "Hun-Saare", "Hun-Saare" },
                                    { "hrx", "Hunsrik", "Hunsrik" },
                                    { "huz", "Hunzib", "Hunzib" },
                                    { "hup", "Hupa", "Hupa" },
                                    { "jup", "Hupdë", "Hupdë" },
                                    { "hap", "Hupla", "Hupla" },
                                    { "xhu", "Hurrian", "Hurrian" },
                                    { "hwo", "Hwana", "Hwana" },
                                    { "hya", "Hya", "Hya" },
                                    { "jab", "Hyam", "Hyam" },
                                    { "iai", "Iaai", "Iaai" },
                                    { "yml", "Iamalele", "Iamalele" },
                                    { "iap", "Iapama", "Iapama" },
                                    { "ian", "Iatmul", "Iatmul" },
                                    { "tmu", "Iau", "Iau" },
                                    { "ibl", "Ibaloi", "Ibaloi" },
                                    { "iba", "Iban", "Iban" },
                                    { "ibg", "Ibanag", "Ibanag" },
                                    { "iby", "Ibani", "Ibani" },
                                    { "ivb", "Ibatan", "Ibatan" },
                                    { "xib", "Iberian", "Iberian" },
                                    { "ibb", "Ibibio", "Ibibio" },
                                    { "ibn", "Ibino", "Ibino" },
                                    { "ibu", "Ibu", "Ibu" },
                                    { "ibr", "Ibuoro", "Ibuoro" },
                                    { "isl", "Icelandic", "Icelandic" },
                                    { "icl", "Icelandic Sign Language", "Icelandic Sign Language" },
                                    { "bec", "Iceve-Maci", "Iceve-Maci" },
                                    { "dbj", "Ida'an", "Ida'an" },
                                    { "ida", "Idakho-Isukha-Tiriki", "Idakho-Isukha-Tiriki" },
                                    { "idt", "Idaté", "Idaté" },
                                    { "ide", "Idere", "Idere" },
                                    { "ids", "Idesa", "Idesa" },
                                    { "idi", "Idi", "Idi" },
                                    { "ido", "Ido", "Ido" },
                                    { "idu", "Idoma", "Idoma" },
                                    { "idc", "Idon", "Idon" },
                                    { "clk", "Idu-Mishmi", "Idu-Mishmi" },
                                    { "viv", "Iduna", "Iduna" },
                                    { "ife", "Ifè", "Ifè" },
                                    { "iff", "Ifo", "Ifo" },
                                    { "ifa", "Amganad Ifugao", "Ifugao, Amganad" },
                                    { "ifb", "Batad Ifugao", "Ifugao, Batad" },
                                    { "ifu", "Mayoyao Ifugao", "Ifugao, Mayoyao" },
                                    { "ifk", "Tuwali Ifugao", "Ifugao, Tuwali" },
                                    { "igl", "Igala", "Igala" },
                                    { "igg", "Igana", "Igana" },
                                    { "ibo", "Igbo", "Igbo" },
                                    { "ige", "Igede", "Igede" },
                                    { "ign", "Ignaciano", "Ignaciano" },
                                    { "ahl", "Igo", "Igo" },
                                    { "nar", "Iguta", "Iguta" },
                                    { "igw", "Igwe", "Igwe" },
                                    { "ihp", "Iha", "Iha" },
                                    { "ihb", "Iha Based Pidgin", "Iha Based Pidgin" },
                                    { "ihi", "Ihievbe", "Ihievbe" },
                                    { "vki", "Ija-Zuba", "Ija-Zuba" },
                                    { "ijs", "Southeast Ijo", "Ijo, Southeast" },
                                    { "ikx", "Ik", "Ik" },
                                    { "ikk", "Ika", "Ika" },
                                    { "ikz", "Ikizu", "Ikizu" },
                                    { "iki", "Iko", "Iko" },
                                    { "meb", "Ikobi", "Ikobi" },
                                    { "ntk", "Ikoma-Nata-Isenye", "Ikoma-Nata-Isenye" },
                                    { "txi", "Ikpeng", "Ikpeng" },
                                    { "ikp", "Ikpeshi", "Ikpeshi" },
                                    { "kpo", "Ikposo", "Ikposo" },
                                    { "ikv", "Iku-Gora-Ankwa", "Iku-Gora-Ankwa" },
                                    { "ikl", "Ikulu", "Ikulu" },
                                    { "ikw", "Ikwere", "Ikwere" },
                                    { "ilb", "Ila", "Ila" },
                                    { "ila", "Ile Ape", "Ile Ape" },
                                    { "ili", "Ili Turki", "Ili Turki" },
                                    { "ilu", "Ili'uun", "Ili'uun" },
                                    { "xil", "Illyrian", "Illyrian" },
                                    { "ilo", "Iloko", "Iloko" },
                                    { "ilk", "Ilongot", "Ilongot" },
                                    { "ilv", "Ilue", "Ilue" },
                                    { "imo", "Imbongu", "Imbongu" },
                                    { "ime", "Imeraguen", "Imeraguen" },
                                    { "imn", "Imonda", "Imonda" },
                                    { "imr", "Imroing", "Imroing" },
                                    { "abx", "Inabaknon", "Inabaknon" },
                                    { "mzu", "Inapang", "Inapang" },
                                    { "inp", "Iñapari", "Iñapari" },
                                    { "ins", "Indian Sign Language", "Indian Sign Language" },
                                    { "ind", "Indonesian", "Indonesian" },
                                    { "inl", "Indonesian Sign Language", "Indonesian Sign Language" },
                                    { "pea", "Peranakan Indonesian", "Indonesian, Peranakan" },
                                    { "idb", "Indo-Portuguese", "Indo-Portuguese" },
                                    { "idr", "Indri", "Indri" },
                                    { "xiv", "Indus Valley Language", "Indus Valley Language" },
                                    { "inz", "Ineseño", "Ineseño" },
                                    { "inb", "Inga", "Inga" },
                                    { "inj", "Jungle Inga", "Inga, Jungle" },
                                    { "izh", "Ingrian", "Ingrian" },
                                    { "inh", "Ingush", "Ingush" },
                                    { "ino", "Inoke-Yate", "Inoke-Yate" },
                                    { "loc", "Inonhan", "Inonhan" },
                                    { "ior", "Inor", "Inor" },
                                    { "igs", "Interglossa", "Interglossa" },
                                    { "ina", "Interlingua (International Auxiliary Language Association)", "Interlingua (International Auxiliary Language Association)" },
                                    { "ile", "Interlingue", "Interlingue" },
                                    { "ils", "International Sign", "International Sign" },
                                    { "int", "Intha", "Intha" },
                                    { "iku", "Inuktitut", "Inuktitut" },
                                    { "ike", "Eastern Canadian Inuktitut", "Inuktitut, Eastern Canadian" },
                                    { "ikt", "Western Canadian Inuktitut", "Inuktitut, Western Canadian" },
                                    { "ipk", "Inupiaq", "Inupiaq" },
                                    { "esi", "North Alaskan Inupiatun", "Inupiatun, North Alaskan" },
                                    { "esk", "Northwest Alaska Inupiatun", "Inupiatun, Northwest Alaska" },
                                    { "iow", "Iowa-Oto", "Iowa-Oto" },
                                    { "ipo", "Ipiko", "Ipiko" },
                                    { "ipi", "Ipili", "Ipili" },
                                    { "ass", "Ipulo", "Ipulo" },
                                    { "iqu", "Iquito", "Iquito" },
                                    { "irr", "Ir", "Ir" },
                                    { "irn", "Irántxe", "Irántxe" },
                                    { "ill", "Iranun", "Iranun" },
                                    { "irk", "Iraqw", "Iraqw" },
                                    { "irh", "Irarutu", "Irarutu" },
                                    { "iry", "Iraya", "Iraya" },
                                    { "ire", "Iresim", "Iresim" },
                                    { "iri", "Irigwe", "Irigwe" },
                                    { "gle", "Irish", "Irish" },
                                    { "isg", "Irish Sign Language", "Irish Sign Language" },
                                    { "mga", "Middle Irish (900-1200)", "Irish, Middle (900-1200)" },
                                    { "sga", "Old Irish (to 900)", "Irish, Old (to 900)" },
                                    { "pgl", "Primitive Irish", "Irish, Primitive" },
                                    { "iru", "Irula", "Irula" },
                                    { "isa", "Isabi", "Isabi" },
                                    { "isn", "Isanzu", "Isanzu" },
                                    { "isc", "Isconahua", "Isconahua" },
                                    { "igo", "Isebe", "Isebe" },
                                    { "its", "Isekiri", "Isekiri" },
                                    { "isk", "Ishkashimi", "Ishkashimi" },
                                    { "inn", "Isinai", "Isinai" },
                                    { "srl", "Isirawa", "Isirawa" },
                                    { "isd", "Isnag", "Isnag" },
                                    { "iso", "Isoko", "Isoko" },
                                    { "isr", "Israeli Sign Language", "Israeli Sign Language" },
                                    { "ist", "Istriot", "Istriot" },
                                    { "szv", "Isu (Fako Division)", "Isu (Fako Division)" },
                                    { "isu", "Isu (Menchum Division)", "Isu (Menchum Division)" },
                                    { "ita", "Italian", "Italian" },
                                    { "ise", "Italian Sign Language", "Italian Sign Language" },
                                    { "itv", "Itawit", "Itawit" },
                                    { "itl", "Itelmen", "Itelmen" },
                                    { "ite", "Itene", "Itene" },
                                    { "itr", "Iteri", "Iteri" },
                                    { "itx", "Itik", "Itik" },
                                    { "bjx", "Banao Itneg", "Itneg, Banao" },
                                    { "itb", "Binongan Itneg", "Itneg, Binongan" },
                                    { "iti", "Inlaod Itneg", "Itneg, Inlaod" },
                                    { "itt", "Maeng Itneg", "Itneg, Maeng" },
                                    { "tis", "Masadiit Itneg", "Itneg, Masadiit" },
                                    { "ity", "Moyadan Itneg", "Itneg, Moyadan" },
                                    { "itw", "Ito", "Ito" },
                                    { "ito", "Itonama", "Itonama" },
                                    { "itm", "Itu Mbon Uzo", "Itu Mbon Uzo" },
                                    { "itz", "Itzá", "Itzá" },
                                    { "ivv", "Ivatan", "Ivatan" },
                                    { "atg", "Ivbie North-Okpela-Arhe", "Ivbie North-Okpela-Arhe" },
                                    { "ibd", "Iwaidja", "Iwaidja" },
                                    { "iwk", "I-Wak", "I-Wak" },
                                    { "kbm", "Iwal", "Iwal" },
                                    { "iwm", "Iwam", "Iwam" },
                                    { "iws", "Sepik Iwam", "Iwam, Sepik" },
                                    { "iwo", "Iwur", "Iwur" },
                                    { "ixc", "Ixcatec", "Ixcatec" },
                                    { "ixl", "Ixil", "Ixil" },
                                    { "iya", "Iyayu", "Iyayu" },
                                    { "uiv", "Iyive", "Iyive" },
                                    { "nca", "Iyo", "Iyo" },
                                    { "izr", "Izere", "Izere" },
                                    { "izi", "Izi-Ezaa-Ikwo-Mgbo", "Izi-Ezaa-Ikwo-Mgbo" },
                                    { "ijc", "Izon", "Izon" },
                                    { "cbo", "Izora", "Izora" },
                                    { "jbt", "Jabutí", "Jabutí" },
                                    { "jda", "Jad", "Jad" },
                                    { "jdg", "Jadgali", "Jadgali" },
                                    { "jah", "Jah Hut", "Jah Hut" },
                                    { "jad", "Jahanka", "Jahanka" },
                                    { "jac", "Jakalteko", "Jakalteko" },
                                    { "jat", "Jakati", "Jakati" },
                                    { "jak", "Jakun", "Jakun" },
                                    { "bxl", "Jalkunan", "Jalkunan" },
                                    { "jcs", "Jamaican Country Sign Language", "Jamaican Country Sign Language" },
                                    { "jls", "Jamaican Sign Language", "Jamaican Sign Language" },
                                    { "jaa", "Jamamadí", "Jamamadí" },
                                    { "jan", "Jandai", "Jandai" },
                                    { "jnd", "Jandavra", "Jandavra" },
                                    { "djo", "Jangkang", "Jangkang" },
                                    { "jna", "Jangshung", "Jangshung" },
                                    { "jni", "Janji", "Janji" },
                                    { "jpn", "Japanese", "Japanese" },
                                    { "jsl", "Japanese Sign Language", "Japanese Sign Language" },
                                    { "ojp", "Old Japanese", "Japanese, Old" },
                                    { "jru", "Japrería", "Japrería" },
                                    { "jqr", "Jaqaru", "Jaqaru" },
                                    { "jaf", "Jara", "Jara" },
                                    { "jra", "Jarai", "Jarai" },
                                    { "anq", "Jarawa (India)", "Jarawa (India)" },
                                    { "ddj", "Jaru", "Jaru" },
                                    { "jns", "Jaunsari", "Jaunsari" },
                                    { "jav", "Javanese", "Javanese" },
                                    { "jvn", "Caribbean Javanese", "Javanese, Caribbean" },
                                    { "jas", "New Caledonian Javanese", "Javanese, New Caledonian" },
                                    { "jvd", "Javindo", "Javindo" },
                                    { "jaz", "Jawe", "Jawe" },
                                    { "jyy", "Jaya", "Jaya" },
                                    { "jeb", "Jebero", "Jebero" },
                                    { "jeh", "Jeh", "Jeh" },
                                    { "jhi", "Jehai", "Jehai" },
                                    { "tow", "Jemez", "Jemez" },
                                    { "jeg", "Jeng", "Jeng" },
                                    { "jer", "Jere", "Jere" },
                                    { "jek", "Jeri Kuo", "Jeri Kuo" },
                                    { "jee", "Jerung", "Jerung" },
                                    { "jhs", "Jhankot Sign Language", "Jhankot Sign Language" },
                                    { "jio", "Jiamao", "Jiamao" },
                                    { "jya", "Jiarong", "Jiarong" },
                                    { "juo", "Jiba", "Jiba" },
                                    { "jib", "Jibu", "Jibu" },
                                    { "jii", "Jiiddu", "Jiiddu" },
                                    { "jie", "Jilbe", "Jilbe" },
                                    { "jil", "Jilim", "Jilim" },
                                    { "jim", "Jimi (Cameroon)", "Jimi (Cameroon)" },
                                    { "jmi", "Jimi (Nigeria)", "Jimi (Nigeria)" },
                                    { "jia", "Jina", "Jina" },
                                    { "jiy", "Buyuan Jinuo", "Jinuo, Buyuan" },
                                    { "jiu", "Youle Jinuo", "Jinuo, Youle" },
                                    { "jul", "Jirel", "Jirel" },
                                    { "jrr", "Jiru", "Jiru" },
                                    { "jit", "Jita", "Jita" },
                                    { "kaj", "Jju", "Jju" },
                                    { "job", "Joba", "Joba" },
                                    { "jbr", "Jofotek-Bromnya", "Jofotek-Bromnya" },
                                    { "dyo", "Jola-Fonyi", "Jola-Fonyi" },
                                    { "csk", "Jola-Kasa", "Jola-Kasa" },
                                    { "jeu", "Jonkor Bourmataguil", "Jonkor Bourmataguil" },
                                    { "jor", "Jorá", "Jorá" },
                                    { "jos", "Jordanian Sign Language", "Jordanian Sign Language" },
                                    { "jrt", "Jorto", "Jorto" },
                                    { "jow", "Jowulu", "Jowulu" },
                                    { "juu", "Ju", "Ju" },
                                    { "ktz", "Ju/'hoan", "Ju/'hoan" },
                                    { "jun", "Juang", "Juang" },
                                    { "jrb", "Judeo-Arabic", "Judeo-Arabic" },
                                    { "jbe", "Judeo-Berber", "Judeo-Berber" },
                                    { "jge", "Judeo-Georgian", "Judeo-Georgian" },
                                    { "itk", "Judeo-Italian", "Judeo-Italian" },
                                    { "jpr", "Judeo-Persian", "Judeo-Persian" },
                                    { "jdt", "Judeo-Tat", "Judeo-Tat" },
                                    { "jbu", "Jukun Takum", "Jukun Takum" },
                                    { "jua", "Júma", "Júma" },
                                    { "jum", "Jumjum", "Jumjum" },
                                    { "jus", "Jumla Sign Language", "Jumla Sign Language" },
                                    { "jml", "Jumli", "Jumli" },
                                    { "bex", "Jur Modo", "Jur Modo" },
                                    { "juy", "Juray", "Juray" },
                                    { "juc", "Jurchen", "Jurchen" },
                                    { "jur", "Jurúna", "Jurúna" },
                                    { "jut", "Jutish", "Jutish" },
                                    { "mwb", "Juwal", "Juwal" },
                                    { "jwi", "Jwira-Pepesa", "Jwira-Pepesa" },
                                    { "xku", "Kaamba", "Kaamba" },
                                    { "ldl", "Kaan", "Kaan" },
                                    { "gna", "Kaansa", "Kaansa" },
                                    { "ksp", "Kaba", "Kaba" },
                                    { "kvf", "Kabalai", "Kabalai" },
                                    { "kbd", "Kabardian", "Kabardian" },
                                    { "xkp", "Kabatei", "Kabatei" },
                                    { "xbx", "Kabixí", "Kabixí" },
                                    { "kbp", "Kabiyè", "Kabiyè" },
                                    { "klz", "Kabola", "Kabola" },
                                    { "uka", "Kaburi", "Kaburi" },
                                    { "kbu", "Kabutra", "Kabutra" },
                                    { "kea", "Kabuverdianu", "Kabuverdianu" },
                                    { "cwa", "Kabwa", "Kabwa" },
                                    { "kcw", "Kabwari", "Kabwari" },
                                    { "kab", "Kabyle", "Kabyle" },
                                    { "kcx", "Kachama-Ganjule", "Kachama-Ganjule" },
                                    { "xac", "Kachari", "Kachari" },
                                    { "kfr", "Kachchi", "Kachchi" },
                                    { "kac", "Kachin", "Kachin" },
                                    { "koe", "Kacipo-Balesi", "Kacipo-Balesi" },
                                    { "xkk", "Kaco'", "Kaco'" },
                                    { "kzd", "Kadai", "Kadai" },
                                    { "kej", "Kadar", "Kadar" },
                                    { "kdu", "Kadaru", "Kadaru" },
                                    { "kzj", "Coastal Kadazan", "Kadazan, Coastal" },
                                    { "kqt", "Klias River Kadazan", "Kadazan, Klias River" },
                                    { "dtb", "Labuk-Kinabatangan Kadazan", "Kadazan, Labuk-Kinabatangan" },
                                    { "kbc", "Kadiwéu", "Kadiwéu" },
                                    { "zkd", "Kadu", "Kadu" },
                                    { "ktp", "Kaduo", "Kaduo" },
                                    { "kbr", "Kafa", "Kafa" },
                                    { "kpu", "Kafoa", "Kafoa" },
                                    { "syw", "Kagate", "Kagate" },
                                    { "cgc", "Kagayanen", "Kagayanen" },
                                    { "kdm", "Kagoma", "Kagoma" },
                                    { "xkg", "Kagoro", "Kagoro" },
                                    { "kki", "Kagulu", "Kagulu" },
                                    { "hka", "Kahe", "Kahe" },
                                    { "agw", "Kahua", "Kahua" },
                                    { "kct", "Kaian", "Kaian" },
                                    { "kzb", "Kaibobo", "Kaibobo" },
                                    { "kzp", "Kaidipang", "Kaidipang" },
                                    { "kbw", "Kaiep", "Kaiep" },
                                    { "kep", "Kaikadi", "Kaikadi" },
                                    { "kzq", "Kaike", "Kaike" },
                                    { "kkq", "Kaiku", "Kaiku" },
                                    { "kzf", "Da'a Kaili", "Kaili, Da'a" },
                                    { "lew", "Ledo Kaili", "Kaili, Ledo" },
                                    { "unz", "Unde Kaili", "Kaili, Unde" },
                                    { "xai", "Kaimbé", "Kaimbé" },
                                    { "zka", "Kaimbulawa", "Kaimbulawa" },
                                    { "kgp", "Kaingang", "Kaingang" },
                                    { "zkp", "São Paulo Kaingáng", "Kaingáng, São Paulo" },
                                    { "ckr", "Kairak", "Kairak" },
                                    { "kxa", "Kairiru", "Kairiru" },
                                    { "krd", "Kairui-Midiki", "Kairui-Midiki" },
                                    { "kzm", "Kais", "Kais" },
                                    { "kce", "Kaivi", "Kaivi" },
                                    { "kgk", "Kaiwá", "Kaiwá" },
                                    { "tcq", "Kaiy", "Kaiy" },
                                    { "ckq", "Kajakse", "Kajakse" },
                                    { "xkj", "Kajali", "Kajali" },
                                    { "kag", "Kajaman", "Kajaman" },
                                    { "kqf", "Kakabai", "Kakabai" },
                                    { "kke", "Kakabe", "Kakabe" },
                                    { "kka", "Kakanda", "Kakanda" },
                                    { "kbf", "Kakauhua", "Kakauhua" },
                                    { "tbd", "Kaki Ae", "Kaki Ae" },
                                    { "kxe", "Kakihum", "Kakihum" },
                                    { "kkj", "Kako", "Kako" },
                                    { "keo", "Kakwa", "Kakwa" },
                                    { "mwp", "Kala Lagaw Ya", "Kala Lagaw Ya" },
                                    { "kal", "Kalaallisut", "Kalaallisut" },
                                    { "kve", "Kalabakan", "Kalabakan" },
                                    { "ijn", "Kalabari", "Kalabari" },
                                    { "kzz", "Kalabra", "Kalabra" },
                                    { "kqe", "Kalagan", "Kalagan" },
                                    { "kll", "Kagan Kalagan", "Kalagan, Kagan" },
                                    { "kmh", "Kalam", "Kalam" },
                                    { "gwc", "Kalami", "Kalami" },
                                    { "knz", "Kalamsé", "Kalamsé" },
                                    { "wkl", "Kalanadi", "Kalanadi" },
                                    { "kck", "Kalanga", "Kalanga" },
                                    { "kly", "Kalao", "Kalao" },
                                    { "kyl", "Kalapuya", "Kalapuya" },
                                    { "nrt", "Northern Kalapuya", "Kalapuya, Northern" },
                                    { "sxk", "Southern Kalapuya", "Kalapuya, Southern" },
                                    { "kba", "Kalarko", "Kalarko" },
                                    { "kls", "Kalasha", "Kalasha" },
                                    { "kln", "Kalenjin", "Kalenjin" },
                                    { "kyb", "Butbut Kalinga", "Kalinga, Butbut" },
                                    { "kmk", "Limos Kalinga", "Kalinga, Limos" },
                                    { "knb", "Lubuagan Kalinga", "Kalinga, Lubuagan" },
                                    { "kkg", "Mabaka Valley Kalinga", "Kalinga, Mabaka Valley" },
                                    { "kmd", "Majukayang Kalinga", "Kalinga, Majukayang" },
                                    { "ksc", "Southern Kalinga", "Kalinga, Southern" },
                                    { "kml", "Tanudan Kalinga", "Kalinga, Tanudan" },
                                    { "fla", "Kalispel-Pend d'Oreille", "Kalispel-Pend d'Oreille" },
                                    { "xka", "Kalkoti", "Kalkoti" },
                                    { "ktg", "Kalkutung", "Kalkutung" },
                                    { "kak", "Kayapa Kallahan", "Kallahan, Kayapa" },
                                    { "ify", "Keley-I Kallahan", "Kallahan, Keley-I" },
                                    { "tne", "Tinoc Kallahan", "Kallahan, Tinoc" },
                                    { "ywa", "Kalou", "Kalou" },
                                    { "bco", "Kaluli", "Kaluli" },
                                    { "kli", "Kalumpang", "Kalumpang" },
                                    { "kdx", "Kam", "Kam" },
                                    { "vkm", "Kamakan", "Kamakan" },
                                    { "woi", "Kamang", "Kamang" },
                                    { "kbq", "Kamano", "Kamano" },
                                    { "kci", "Kamantan", "Kamantan" },
                                    { "keq", "Kamar", "Kamar" },
                                    { "jmr", "Kamara", "Kamara" },
                                    { "kzx", "Kamarian", "Kamarian" },
                                    { "kgx", "Kamaru", "Kamaru" },
                                    { "xas", "Kamas", "Kamas" },
                                    { "klp", "Kamasa", "Kamasa" },
                                    { "kms", "Kamasau", "Kamasau" },
                                    { "kyk", "Kamayo", "Kamayo" },
                                    { "kay", "Kamayurá", "Kamayurá" },
                                    { "xba", "Kamba (Brazil)", "Kamba (Brazil)" },
                                    { "kam", "Kamba (Kenya)", "Kamba (Kenya)" },
                                    { "ktb", "Kambaata", "Kambaata" },
                                    { "kyy", "Kambaira", "Kambaira" },
                                    { "xbr", "Kambera", "Kambera" },
                                    { "irx", "Kamberau", "Kamberau" },
                                    { "xbw", "Kambiwá", "Kambiwá" },
                                    { "kmi", "Kami (Nigeria)", "Kami (Nigeria)" },
                                    { "kcu", "Kami (Tanzania)", "Kami (Tanzania)" },
                                    { "kcq", "Kamo", "Kamo" },
                                    { "kgq", "Kamoro", "Kamoro" },
                                    { "xmu", "Kamu", "Kamu" },
                                    { "xla", "Kamula", "Kamula" },
                                    { "xvi", "Kamviri", "Kamviri" },
                                    { "hig", "Kamwe", "Kamwe" },
                                    { "xnb", "Kanakanabu", "Kanakanabu" },
                                    { "knm", "Kanamarí", "Kanamarí" },
                                    { "zkn", "Kanan", "Kanan" },
                                    { "xns", "Kanashi", "Kanashi" },
                                    { "soq", "Kanasi", "Kanasi" },
                                    { "bjj", "Kanauji", "Kanauji" },
                                    { "kqw", "Kandas", "Kandas" },
                                    { "gam", "Kandawo", "Kandawo" },
                                    { "kbs", "Kande", "Kande" },
                                    { "kbl", "Kanembu", "Kanembu" },
                                    { "kyp", "Kang", "Kang" },
                                    { "kcp", "Kanga", "Kanga" },
                                    { "kkv", "Kangean", "Kangean" },
                                    { "igm", "Kanggape", "Kanggape" },
                                    { "kxs", "Kangjia", "Kangjia" },
                                    { "kty", "Kango (Bas-Uélé District)", "Kango (Bas-Uélé District)" },
                                    { "kzy", "Kango (Tshopo District)", "Kango (Tshopo District)" },
                                    { "xnr", "Kangri", "Kangri" },
                                    { "ktk", "Kaniet", "Kaniet" },
                                    { "kev", "Kanikkaran", "Kanikkaran" },
                                    { "kdp", "Kaningdon-Nindem", "Kaningdon-Nindem" },
                                    { "kzo", "Kaningi", "Kaningi" },
                                    { "knr", "Kaningra", "Kaningra" },
                                    { "wat", "Kaninuwa", "Kaninuwa" },
                                    { "kmu", "Kanite", "Kanite" },
                                    { "kft", "Kanjari", "Kanjari" },
                                    { "kjb", "Kanjobal", "Kanjobal" },
                                    { "knj", "Western Kanjobal", "Kanjobal, Western" },
                                    { "kbe", "Kanju", "Kanju" },
                                    { "kne", "Kankanaey", "Kankanaey" },
                                    { "xnn", "Northern Kankanay", "Kankanay, Northern" },
                                    { "kan", "Kannada", "Kannada" },
                                    { "kxo", "Kanoé", "Kanoé" },
                                    { "ksk", "Kansa", "Kansa" },
                                    { "xkt", "Kantosi", "Kantosi" },
                                    { "khx", "Kanu", "Kanu" },
                                    { "kni", "Kanufi", "Kanufi" },
                                    { "khd", "Bädi Kanum", "Kanum, Bädi" },
                                    { "kcd", "Ngkâlmpw Kanum", "Kanum, Ngkâlmpw" },
                                    { "kxq", "Smärky Kanum", "Kanum, Smärky" },
                                    { "krz", "Sota Kanum", "Kanum, Sota" },
                                    { "kau", "Kanuri", "Kanuri" },
                                    { "bms", "Bilma Kanuri", "Kanuri, Bilma" },
                                    { "knc", "Central Kanuri", "Kanuri, Central" },
                                    { "kby", "Manga Kanuri", "Kanuri, Manga" },
                                    { "krt", "Tumari Kanuri", "Kanuri, Tumari" },
                                    { "kny", "Kanyok", "Kanyok" },
                                    { "kax", "Kao", "Kao" },
                                    { "kqn", "Kaonde", "Kaonde" },
                                    { "ykm", "Kap", "Kap" },
                                    { "khp", "Kapauri", "Kapauri" },
                                    { "tbx", "Kapin", "Kapin" },
                                    { "xpn", "Kapinawá", "Kapinawá" },
                                    { "kpg", "Kapingamarangi", "Kapingamarangi" },
                                    { "dju", "Kapriman", "Kapriman" },
                                    { "kbi", "Kaptiau", "Kaptiau" },
                                    { "klo", "Kapya", "Kapya" },
                                    { "kah", "Kara (Central African Republic)", "Kara (Central African Republic)" },
                                    { "zra", "Kara (Korea)", "Kara (Korea)" },
                                    { "leu", "Kara (Papua New Guinea)", "Kara (Papua New Guinea)" },
                                    { "reg", "Kara (Tanzania)", "Kara (Tanzania)" },
                                    { "xrb", "Eastern Karaboro", "Karaboro, Eastern" },
                                    { "kza", "Western Karaboro", "Karaboro, Western" },
                                    { "krc", "Karachay-Balkar", "Karachay-Balkar" },
                                    { "gbd", "Karadjeri", "Karadjeri" },
                                    { "kim", "Karagas", "Karagas" },
                                    { "xkh", "Karahawyana", "Karahawyana" },
                                    { "kdr", "Karaim", "Karaim" },
                                    { "kpj", "Karajá", "Karajá" },
                                    { "kaa", "Kara-Kalpak", "Kara-Kalpak" },
                                    { "xqa", "Karakhanid", "Karakhanid" },
                                    { "xar", "Karami", "Karami" },
                                    { "kdj", "Karamojong", "Karamojong" },
                                    { "kzr", "Karang", "Karang" },
                                    { "kth", "Karanga", "Karanga" },
                                    { "zkk", "Karankawa", "Karankawa" },
                                    { "kyj", "Karao", "Karao" },
                                    { "kgv", "Karas", "Karas" },
                                    { "kpt", "Karata", "Karata" },
                                    { "xrw", "Karawa", "Karawa" },
                                    { "mjw", "Karbi", "Karbi" },
                                    { "ajz", "Amri Karbi", "Karbi, Amri" },
                                    { "kbn", "Kare (Central African Republic)", "Kare (Central African Republic)" },
                                    { "kmf", "Kare (Papua New Guinea)", "Kare (Papua New Guinea)" },
                                    { "kai", "Karekare", "Karekare" },
                                    { "krl", "Karelian", "Karelian" },
                                    { "bwe", "Bwe Karen", "Karen, Bwe" },
                                    { "kvq", "Geba Karen", "Karen, Geba" },
                                    { "ghk", "Geko Karen", "Karen, Geko" },
                                    { "kvt", "Lahta Karen", "Karen, Lahta" },
                                    { "kxf", "Manumanaw Karen", "Karen, Manumanaw" },
                                    { "jkm", "Mobwa Karen", "Karen, Mobwa" },
                                    { "jkp", "Paku Karen", "Karen, Paku" },
                                    { "kjt", "Phrae Pwo Karen", "Karen, Phrae Pwo" },
                                    { "kjp", "Pwo Eastern Karen", "Karen, Pwo Eastern" },
                                    { "pww", "Pwo Northern Karen", "Karen, Pwo Northern" },
                                    { "pwo", "Pwo Western Karen", "Karen, Pwo Western" },
                                    { "ksw", "S'gaw Karen", "Karen, S'gaw" },
                                    { "kvu", "Yinbaw Karen", "Karen, Yinbaw" },
                                    { "kvy", "Yintale Karen", "Karen, Yintale" },
                                    { "kxk", "Zayein Karen", "Karen, Zayein" },
                                    { "kyd", "Karey", "Karey" },
                                    { "kbj", "Kari", "Kari" },
                                    { "kgn", "Karingani", "Karingani" },
                                    { "kuq", "Karipuna", "Karipuna" },
                                    { "kgm", "Karipúna", "Karipúna" },
                                    { "kzw", "Karirí-Xocó", "Karirí-Xocó" },
                                    { "ktn", "Karitiâna", "Karitiâna" },
                                    { "kil", "Kariya", "Kariya" },
                                    { "vka", "Kariyarra", "Kariyarra" },
                                    { "yuj", "Karkar-Yuri", "Karkar-Yuri" },
                                    { "krb", "Karkin", "Karkin" },
                                    { "kko", "Karko", "Karko" },
                                    { "bbv", "Karnai", "Karnai" },
                                    { "arr", "Karo (Brazil)", "Karo (Brazil)" },
                                    { "kxh", "Karo (Ethiopia)", "Karo (Ethiopia)" },
                                    { "kyh", "Karok", "Karok" },
                                    { "krx", "Karon", "Karon" },
                                    { "kgw", "Karon Dori", "Karon Dori" },
                                    { "xkx", "Karore", "Karore" },
                                    { "ccj", "Kasanga", "Kasanga" },
                                    { "xsm", "Kasem", "Kasem" },
                                    { "kju", "Kashaya", "Kashaya" },
                                    { "kas", "Kashmiri", "Kashmiri" },
                                    { "csb", "Kashubian", "Kashubian" },
                                    { "ksn", "Kasiguranin", "Kasiguranin" },
                                    { "kkz", "Kaska", "Kaska" },
                                    { "zsk", "Kaskean", "Kaskean" },
                                    { "kgc", "Kasseng", "Kasseng" },
                                    { "khs", "Kasua", "Kasua" },
                                    { "kgd", "Kataang", "Kataang" },
                                    { "ktq", "Katabaga", "Katabaga" },
                                    { "xat", "Katawixi", "Katawixi" },
                                    { "tmb", "Katbol", "Katbol" },
                                    { "xtc", "Katcha-Kadugli-Miri", "Katcha-Kadugli-Miri" },
                                    { "kmg", "Kâte", "Kâte" },
                                    { "ykt", "Kathu", "Kathu" },
                                    { "bsh", "Kati", "Kati" },
                                    { "kfu", "Katkari", "Katkari" },
                                    { "kcr", "Katla", "Katla" },
                                    { "ktw", "Kato", "Kato" },
                                    { "kaf", "Katso", "Katso" },
                                    { "ktv", "Eastern Katu", "Katu, Eastern" },
                                    { "kuf", "Western Katu", "Katu, Western" },
                                    { "kta", "Katua", "Katua" },
                                    { "kav", "Katukína", "Katukína" },
                                    { "knt", "Panoan Katukína", "Katukína, Panoan" },
                                    { "pss", "Kaulong", "Kaulong" },
                                    { "vkk", "Kaur", "Kaur" },
                                    { "bpp", "Kaure", "Kaure" },
                                    { "zku", "Kaurna", "Kaurna" },
                                    { "xau", "Kauwera", "Kauwera" },
                                    { "ckv", "Kavalan", "Kavalan" },
                                    { "krv", "Kavet", "Kavet" },
                                    { "kcb", "Kawacha", "Kawacha" },
                                    { "xaw", "Kawaiisu", "Kawaiisu" },
                                    { "kgb", "Kawe", "Kawe" },
                                    { "kaw", "Kawi", "Kawi" },
                                    { "ktx", "Kaxararí", "Kaxararí" },
                                    { "kbb", "Kaxuiâna", "Kaxuiâna" },
                                    { "kyz", "Kayabí", "Kayabí" },
                                    { "kyt", "Kayagar", "Kayagar" },
                                    { "eky", "Eastern Kayah", "Kayah, Eastern" },
                                    { "kyu", "Western Kayah", "Kayah, Western" },
                                    { "pdu", "Kayan", "Kayan" },
                                    { "xay", "Kayan Mahakam", "Kayan Mahakam" },
                                    { "kys", "Baram Kayan", "Kayan, Baram" },
                                    { "bfg", "Busang Kayan", "Kayan, Busang" },
                                    { "xkn", "Kayan River Kayan", "Kayan, Kayan River" },
                                    { "xkd", "Mendalam Kayan", "Kayan, Mendalam" },
                                    { "ree", "Rejang Kayan", "Kayan, Rejang" },
                                    { "whu", "Wahau Kayan", "Kayan, Wahau" },
                                    { "txu", "Kayapó", "Kayapó" },
                                    { "gyd", "Kayardild", "Kayardild" },
                                    { "kvl", "Kayaw", "Kayaw" },
                                    { "kzl", "Kayeli", "Kayeli" },
                                    { "kxy", "Kayong", "Kayong" },
                                    { "kyv", "Kayort", "Kayort" },
                                    { "gbb", "Kaytetye", "Kaytetye" },
                                    { "kzu", "Kayupulau", "Kayupulau" },
                                    { "kaz", "Kazakh", "Kazakh" },
                                    { "kzk", "Kazukuru", "Kazukuru" },
                                    { "keh", "Keak", "Keak" },
                                    { "khz", "Keapara", "Keapara" },
                                    { "ksx", "Kedang", "Kedang" },
                                    { "kdy", "Keder", "Keder" },
                                    { "khh", "Kehu", "Kehu" },
                                    { "kei", "Kei", "Kei" },
                                    { "kec", "Keiga", "Keiga" },
                                    { "bmh", "Kein", "Kein" },
                                    { "eyo", "Keiyo", "Keiyo" },
                                    { "kek", "Kekchí", "Kekchí" },
                                    { "kel", "Kela (Democratic Republic of Congo)", "Kela (Democratic Republic of Congo)" },
                                    { "kcl", "Kela (Papua New Guinea)", "Kela (Papua New Guinea)" },
                                    { "kzi", "Kelabit", "Kelabit" },
                                    { "keb", "Kélé", "Kélé" },
                                    { "khy", "Kele (Democratic Republic of Congo)", "Kele (Democratic Republic of Congo)" },
                                    { "sbc", "Kele (Papua New Guinea)", "Kele (Papua New Guinea)" },
                                    { "kbo", "Keliko", "Keliko" },
                                    { "xel", "Kelo", "Kelo" },
                                    { "kyo", "Kelon", "Kelon" },
                                    { "kem", "Kemak", "Kemak" },
                                    { "xem", "Kembayan", "Kembayan" },
                                    { "bzp", "Kemberano", "Kemberano" },
                                    { "xkw", "Kembra", "Kembra" },
                                    { "dmo", "Kemedzung", "Kemedzung" },
                                    { "kfj", "Kemiehua", "Kemiehua" },
                                    { "kmt", "Kemtuik", "Kemtuik" },
                                    { "xbn", "Kenaboi", "Kenaboi" },
                                    { "gat", "Kenati", "Kenati" },
                                    { "knx", "Kendayan", "Kendayan" },
                                    { "klf", "Kendeje", "Kendeje" },
                                    { "kvm", "Kendem", "Kendem" },
                                    { "kyq", "Kenga", "Kenga" },
                                    { "knl", "Keninjal", "Keninjal" },
                                    { "kns", "Kensiu", "Kensiu" },
                                    { "ndb", "Kenswei Nsei", "Kenswei Nsei" },
                                    { "okl", "Old Kentish Sign Language", "Kentish Sign Language, Old" },
                                    { "whk", "Wahau Kenyah", "Kenyah, Wahau" },
                                    { "xki", "Kenyan Sign Language", "Kenyan Sign Language" },
                                    { "ken", "Kenyang", "Kenyang" },
                                    { "lke", "Kenyi", "Kenyi" },
                                    { "xxk", "Ke'o", "Ke'o" },
                                    { "xeu", "Keoru-Ahia", "Keoru-Ahia" },
                                    { "kpn", "Kepkiriwát", "Kepkiriwát" },
                                    { "kuk", "Kepo'", "Kepo'" },
                                    { "ker", "Kera", "Kera" },
                                    { "hhr", "Kerak", "Kerak" },
                                    { "xke", "Kereho", "Kereho" },
                                    { "krk", "Kerek", "Kerek" },
                                    { "kee", "Eastern Keres", "Keres, Eastern" },
                                    { "kjq", "Western Keres", "Keres, Western" },
                                    { "ked", "Kerewe", "Kerewe" },
                                    { "kxz", "Kerewo", "Kerewo" },
                                    { "kvr", "Kerinci", "Kerinci" },
                                    { "xes", "Kesawai", "Kesawai" },
                                    { "ket", "Ket", "Ket" },
                                    { "kae", "Ketangalan", "Ketangalan" },
                                    { "kcv", "Kete", "Kete" },
                                    { "xte", "Ketengban", "Ketengban" },
                                    { "ktt", "Ketum", "Ketum" },
                                    { "kjs", "East Kewa", "Kewa, East" },
                                    { "kew", "West Kewa", "Kewa, West" },
                                    { "kyg", "Keyagana", "Keyagana" },
                                    { "xkv", "Kgalagadi", "Kgalagadi" },
                                    { "kjh", "Khakas", "Khakas" },
                                    { "kjf", "Khalaj", "Khalaj" },
                                    { "klj", "Turkic Khalaj", "Khalaj, Turkic" },
                                    { "klr", "Khaling", "Khaling" },
                                    { "kif", "Eastern Parbate Kham", "Kham, Eastern Parbate" },
                                    { "kgj", "Gamale Kham", "Kham, Gamale" },
                                    { "kip", "Sheshi Kham", "Kham, Sheshi" },
                                    { "kjl", "Western Parbate Kham", "Kham, Western Parbate" },
                                    { "kbg", "Khamba", "Khamba" },
                                    { "kht", "Khamti", "Khamti" },
                                    { "ksu", "Khamyang", "Khamyang" },
                                    { "ogo", "Khana", "Khana" },
                                    { "khn", "Khandesi", "Khandesi" },
                                    { "kjm", "Kháng", "Kháng" },
                                    { "kca", "Khanty", "Khanty" },
                                    { "xao", "Khao", "Khao" },
                                    { "khr", "Kharia", "Kharia" },
                                    { "ksy", "Kharia Thar", "Kharia Thar" },
                                    { "kha", "Khasi", "Khasi" },
                                    { "lko", "Khayo", "Khayo" },
                                    { "zkz", "Khazar", "Khazar" },
                                    { "kqg", "Khe", "Khe" },
                                    { "tlx", "Khehek", "Khehek" },
                                    { "xkf", "Khengkha", "Khengkha" },
                                    { "xhe", "Khetrani", "Khetrani" },
                                    { "kjj", "Khinalugh", "Khinalugh" },
                                    { "kwx", "Khirwar", "Khirwar" },
                                    { "kqm", "Khisa", "Khisa" },
                                    { "llo", "Khlor", "Khlor" },
                                    { "ykl", "Khlula", "Khlula" },
                                    { "khm", "Central Khmer", "Khmer, Central" },
                                    { "kxm", "Northern Khmer", "Khmer, Northern" },
                                    { "kjg", "Khmu", "Khmu" },
                                    { "xkc", "Kho'ini", "Kho'ini" },
                                    { "ktc", "Kholok", "Kholok" },
                                    { "kmz", "Khorasani Turkish", "Khorasani Turkish" },
                                    { "zkh", "Khorezmian", "Khorezmian" },
                                    { "kho", "Khotanese", "Khotanese" },
                                    { "khw", "Khowar", "Khowar" },
                                    { "xhv", "Khua", "Khua" },
                                    { "khf", "Khuen", "Khuen" },
                                    { "kkh", "Khün", "Khün" },
                                    { "kfm", "Khunsari", "Khunsari" },
                                    { "khv", "Khvarshi", "Khvarshi" },
                                    { "kie", "Kibet", "Kibet" },
                                    { "prm", "Kibiri", "Kibiri" },
                                    { "kic", "Kickapoo", "Kickapoo" },
                                    { "kzg", "Kikai", "Kikai" },
                                    { "kik", "Kikuyu", "Kikuyu" },
                                    { "kij", "Kilivila", "Kilivila" },
                                    { "klb", "Kiliwa", "Kiliwa" },
                                    { "kih", "Kilmeri", "Kilmeri" },
                                    { "kia", "Kim", "Kim" },
                                    { "mji", "Kim Mun", "Kim Mun" },
                                    { "kig", "Kimaama", "Kimaama" },
                                    { "kqr", "Kimaragang", "Kimaragang" },
                                    { "kiv", "Kimbu", "Kimbu" },
                                    { "kmb", "Kimbundu", "Kimbundu" },
                                    { "sbt", "Kimki", "Kimki" },
                                    { "kqp", "Kimré", "Kimré" },
                                    { "cbw", "Kinabalian", "Kinabalian" },
                                    { "dmg", "Upper Kinabatangan", "Kinabatangan, Upper" },
                                    { "kco", "Kinalakna", "Kinalakna" },
                                    { "krj", "Kinaray-A", "Kinaray-A" },
                                    { "zga", "Kinga", "Kinga" },
                                    { "kfk", "Kinnauri", "Kinnauri" },
                                    { "nes", "Bhoti Kinnauri", "Kinnauri, Bhoti" },
                                    { "cik", "Chitkuli Kinnauri", "Kinnauri, Chitkuli" },
                                    { "kjo", "Harijan Kinnauri", "Kinnauri, Harijan" },
                                    { "knq", "Kintaq", "Kintaq" },
                                    { "kkd", "Kinuku", "Kinuku" },
                                    { "kin", "Kinyarwanda", "Kinyarwanda" },
                                    { "ues", "Kioko", "Kioko" },
                                    { "kkm", "Kiong", "Kiong" },
                                    { "xko", "Kiorr", "Kiorr" },
                                    { "kio", "Kiowa", "Kiowa" },
                                    { "sgc", "Kipsigis", "Kipsigis" },
                                    { "kyi", "Kiput", "Kiput" },
                                    { "kkr", "Kir-Balar", "Kir-Balar" },
                                    { "geb", "Kire", "Kire" },
                                    { "kir", "Kirghiz", "Kirghiz" },
                                    { "okr", "Kirike", "Kirike" },
                                    { "kiy", "Kirikiri", "Kirikiri" },
                                    { "kiu", "Kirmanjki (individual language)", "Kirmanjki (individual language)" },
                                    { "fkk", "Kirya-Konzəl", "Kirya-Konzəl" },
                                    { "kis", "Kis", "Kis" },
                                    { "lks", "Kisa", "Kisa" },
                                    { "kqh", "Kisankasa", "Kisankasa" },
                                    { "kje", "Kisar", "Kisar" },
                                    { "kiz", "Kisi", "Kisi" },
                                    { "kss", "Southern Kisi", "Kisi, Southern" },
                                    { "kqs", "Northern Kissi", "Kissi, Northern" },
                                    { "gru", "Kistane", "Kistane" },
                                    { "zkt", "Kitan", "Kitan" },
                                    { "gia", "Kitja", "Kitja" },
                                    { "kii", "Kitsai", "Kitsai" },
                                    { "mkw", "Kituba (Congo)", "Kituba (Congo)" },
                                    { "ktu", "Kituba (Democratic Republic of Congo)", "Kituba (Democratic Republic of Congo)" },
                                    { "wei", "Kiunum", "Kiunum" },
                                    { "kiw", "Northeast Kiwai", "Kiwai, Northeast" },
                                    { "kjd", "Southern Kiwai", "Kiwai, Southern" },
                                    { "mlk", "Kiwilwana", "Kiwilwana" },
                                    { "kla", "Klamath-Modoc", "Klamath-Modoc" },
                                    { "klu", "Klao", "Klao" },
                                    { "czk", "Knaanic", "Knaanic" },
                                    { "fuj", "Ko", "Ko" },
                                    { "kib", "Koalib", "Koalib" },
                                    { "cku", "Koasati", "Koasati" },
                                    { "kpd", "Koba", "Koba" },
                                    { "kcj", "Kobiana", "Kobiana" },
                                    { "kgu", "Kobol", "Kobol" },
                                    { "kpw", "Kobon", "Kobon" },
                                    { "kdq", "Koch", "Koch" },
                                    { "cdz", "Koda", "Koda" },
                                    { "ksz", "Kodaku", "Kodaku" },
                                    { "kfa", "Kodava", "Kodava" },
                                    { "vko", "Kodeoha", "Kodeoha" },
                                    { "kod", "Kodi", "Kodi" },
                                    { "kwp", "Kodia", "Kodia" },
                                    { "kcs", "Koenoem", "Koenoem" },
                                    { "kso", "Kofa", "Kofa" },
                                    { "kpi", "Kofei", "Kofei" },
                                    { "kwl", "Kofyar", "Kofyar" },
                                    { "kog", "Kogi", "Kogi" },
                                    { "zkg", "Koguryo", "Koguryo" },
                                    { "kkx", "Kohin", "Kohin" },
                                    { "mvy", "Indus Kohistani", "Kohistani, Indus" },
                                    { "kpm", "Koho", "Koho" },
                                    { "bcs", "Kohumono", "Kohumono" },
                                    { "kkt", "Koi", "Koi" },
                                    { "kpx", "Mountain Koiali", "Koiali, Mountain" },
                                    { "kbk", "Grass Koiari", "Koiari, Grass" },
                                    { "zkb", "Koibal", "Koibal" },
                                    { "nkd", "Koireng", "Koireng" },
                                    { "kqi", "Koitabu", "Koitabu" },
                                    { "kxt", "Koiwat", "Koiwat" },
                                    { "trp", "Kok Borok", "Kok Borok" },
                                    { "ktd", "Kokata", "Kokata" },
                                    { "kou", "Koke", "Koke" },
                                    { "gko", "Kok-Nar", "Kok-Nar" },
                                    { "okg", "Koko Babangk", "Koko Babangk" },
                                    { "xod", "Kokoda", "Kokoda" },
                                    { "kzn", "Kokola", "Kokola" },
                                    { "kkk", "Kokota", "Kokota" },
                                    { "ekl", "Kol", "Kol" },
                                    { "biw", "Kol (Cameroon)", "Kol (Cameroon)" },
                                    { "kol", "Kol (Papua New Guinea)", "Kol (Papua New Guinea)" },
                                    { "kvv", "Kola", "Kola" },
                                    { "kfb", "Northwestern Kolami", "Kolami, Northwestern" },
                                    { "nit", "Southeastern Kolami", "Kolami, Southeastern" },
                                    { "klc", "Kolbila", "Kolbila" },
                                    { "gjk", "Kachi Koli", "Koli, Kachi" },
                                    { "kvx", "Parkari Koli", "Koli, Parkari" },
                                    { "kxp", "Wadiyara Koli", "Koli, Wadiyara" },
                                    { "ksh", "Kölsch", "Kölsch" },
                                    { "klx", "Koluwawa", "Koluwawa" },
                                    { "bkm", "Kom (Cameroon)", "Kom (Cameroon)" },
                                    { "kmm", "Kom (India)", "Kom (India)" },
                                    { "kmy", "Koma", "Koma" },
                                    { "kpf", "Komba", "Komba" },
                                    { "tyn", "Kombai", "Kombai" },
                                    { "xbi", "Kombio", "Kombio" },
                                    { "kge", "Komering", "Komering" },
                                    { "kom", "Komi", "Komi" },
                                    { "xoi", "Kominimung", "Kominimung" },
                                    { "koi", "Komi-Permyak", "Komi-Permyak" },
                                    { "kpv", "Komi-Zyrian", "Komi-Zyrian" },
                                    { "kmw", "Komo (Democratic Republic of Congo)", "Komo (Democratic Republic of Congo)" },
                                    { "xom", "Komo (Sudan)", "Komo (Sudan)" },
                                    { "kvh", "Komodo", "Komodo" },
                                    { "kvp", "Kompane", "Kompane" },
                                    { "kzv", "Komyandaret", "Komyandaret" },
                                    { "kkn", "Kon Keu", "Kon Keu" },
                                    { "bbo", "Konabéré", "Konabéré" },
                                    { "kxw", "Konai", "Konai" },
                                    { "knd", "Konda", "Konda" },
                                    { "kfc", "Konda-Dora", "Konda-Dora" },
                                    { "kdw", "Koneraw", "Koneraw" },
                                    { "kon", "Kongo", "Kongo" },
                                    { "kwy", "San Salvador Kongo", "Kongo, San Salvador" },
                                    { "kjc", "Coastal Konjo", "Konjo, Coastal" },
                                    { "kjk", "Highland Konjo", "Konjo, Highland" },
                                    { "knn", "Konkani (individual language)", "Konkani (individual language)" },
                                    { "kok", "Konkani (macrolanguage)", "Konkani (macrolanguage)" },
                                    { "gom", "Goan Konkani", "Konkani, Goan" },
                                    { "xon", "Konkomba", "Konkomba" },
                                    { "kma", "Konni", "Konni" },
                                    { "knu", "Kono (Guinea)", "Kono (Guinea)" },
                                    { "klk", "Kono (Nigeria)", "Kono (Nigeria)" },
                                    { "kno", "Kono (Sierra Leone)", "Kono (Sierra Leone)" },
                                    { "koa", "Konomala", "Konomala" },
                                    { "kcz", "Konongo", "Konongo" },
                                    { "kxc", "Konso", "Konso" },
                                    { "koo", "Konzo", "Konzo" },
                                    { "kng", "Koongo", "Koongo" },
                                    { "ozm", "Koonzime", "Koonzime" },
                                    { "kqy", "Koorete", "Koorete" },
                                    { "xop", "Kopar", "Kopar" },
                                    { "opk", "Kopkaka", "Kopkaka" },
                                    { "kpr", "Korafe-Yegha", "Korafe-Yegha" },
                                    { "kfd", "Korra Koraga", "Koraga, Korra" },
                                    { "vmd", "Mudu Koraga", "Koraga, Mudu" },
                                    { "koz", "Korak", "Korak" },
                                    { "kqz", "Korana", "Korana" },
                                    { "kcy", "Korandje", "Korandje" },
                                    { "kor", "Korean", "Korean" },
                                    { "kvk", "Korean Sign Language", "Korean Sign Language" },
                                    { "okm", "Middle Korean (10th-16th cent.)", "Korean, Middle (10th-16th cent.)" },
                                    { "oko", "Old Korean (3rd-9th cent.)", "Korean, Old (3rd-9th cent.)" },
                                    { "coe", "Koreguaje", "Koreguaje" },
                                    { "okh", "Koresh-e Rostam", "Koresh-e Rostam" },
                                    { "kfq", "Korku", "Korku" },
                                    { "kfo", "Koro (Côte d'Ivoire)", "Koro (Côte d'Ivoire)" },
                                    { "jkr", "Koro (India)", "Koro (India)" },
                                    { "kxr", "Koro (Papua New Guinea)", "Koro (Papua New Guinea)" },
                                    { "krf", "Koro (Vanuatu)", "Koro (Vanuatu)" },
                                    { "kfz", "Koromfé", "Koromfé" },
                                    { "kqj", "Koromira", "Koromira" },
                                    { "xkq", "Koroni", "Koroni" },
                                    { "krp", "Korop", "Korop" },
                                    { "xxr", "Koropó", "Koropó" },
                                    { "ktl", "Koroshi", "Koroshi" },
                                    { "khe", "Korowai", "Korowai" },
                                    { "xor", "Korubo", "Korubo" },
                                    { "kpq", "Korupun-Sela", "Korupun-Sela" },
                                    { "kfp", "Korwa", "Korwa" },
                                    { "kpy", "Koryak", "Koryak" },
                                    { "kiq", "Kosadle", "Kosadle" },
                                    { "kze", "Kosena", "Kosena" },
                                    { "kid", "Koshin", "Koshin" },
                                    { "kos", "Kosraean", "Kosraean" },
                                    { "koq", "Kota (Gabon)", "Kota (Gabon)" },
                                    { "kfe", "Kota (India)", "Kota (India)" },
                                    { "grm", "Kota Marudu Talantang", "Kota Marudu Talantang" },
                                    { "ktr", "Kota Marudu Tinagas", "Kota Marudu Tinagas" },
                                    { "avk", "Kotava", "Kotava" },
                                    { "eko", "Koti", "Koti" },
                                    { "zko", "Kott", "Kott" },
                                    { "kyf", "Kouya", "Kouya" },
                                    { "kqb", "Kovai", "Kovai" },
                                    { "kvc", "Kove", "Kove" },
                                    { "xow", "Kowaki", "Kowaki" },
                                    { "kwh", "Kowiai", "Kowiai" },
                                    { "kqd", "Koy Sanjaq Surat", "Koy Sanjaq Surat" },
                                    { "kff", "Koya", "Koya" },
                                    { "kga", "Koyaga", "Koyaga" },
                                    { "koh", "Koyo", "Koyo" },
                                    { "koy", "Koyukon", "Koyukon" },
                                    { "kuw", "Kpagua", "Kpagua" },
                                    { "kpl", "Kpala", "Kpala" },
                                    { "kpk", "Kpan", "Kpan" },
                                    { "pbn", "Kpasam", "Kpasam" },
                                    { "koc", "Kpati", "Kpati" },
                                    { "kym", "Kpatili", "Kpatili" },
                                    { "kpe", "Kpelle", "Kpelle" },
                                    { "gkp", "Guinea Kpelle", "Kpelle, Guinea" },
                                    { "xpe", "Liberia Kpelle", "Kpelle, Liberia" },
                                    { "kef", "Kpessi", "Kpessi" },
                                    { "kph", "Kplang", "Kplang" },
                                    { "kye", "Krache", "Krache" },
                                    { "kqo", "Eastern Krahn", "Krahn, Eastern" },
                                    { "krw", "Western Krahn", "Krahn, Western" },
                                    { "xra", "Krahô", "Krahô" },
                                    { "rka", "Kraol", "Kraol" },
                                    { "kqq", "Krenak", "Krenak" },
                                    { "zkv", "Krevinian", "Krevinian" },
                                    { "xre", "Kreye", "Kreye" },
                                    { "xri", "Krikati-Timbira", "Krikati-Timbira" },
                                    { "krm", "Krim", "Krim" },
                                    { "kri", "Krio", "Krio" },
                                    { "rop", "Kriol", "Kriol" },
                                    { "bzj", "Belize Kriol English", "Kriol English, Belize" },
                                    { "ksi", "Krisa", "Krisa" },
                                    { "kxb", "Krobu", "Krobu" },
                                    { "kgo", "Krongo", "Krongo" },
                                    { "ktj", "Plapo Krumen", "Krumen, Plapo" },
                                    { "pye", "Pye Krumen", "Krumen, Pye" },
                                    { "ted", "Tepo Krumen", "Krumen, Tepo" },
                                    { "krr", "Kru'ng 2", "Kru'ng 2" },
                                    { "jct", "Krymchak", "Krymchak" },
                                    { "kry", "Kryts", "Kryts" },
                                    { "tyu", "Kua", "Kua" },
                                    { "yku", "Kuamasi", "Kuamasi" },
                                    { "uan", "Kuan", "Kuan" },
                                    { "xnh", "Kuanhua", "Kuanhua" },
                                    { "ykn", "Kua-nsi", "Kua-nsi" },
                                    { "ksd", "Kuanua", "Kuanua" },
                                    { "kgf", "Kube", "Kube" },
                                    { "kof", "Kubi", "Kubi" },
                                    { "jko", "Kubo", "Kubo" },
                                    { "kvb", "Kubu", "Kubu" },
                                    { "lkc", "Kucong", "Kucong" },
                                    { "kfg", "Kudiya", "Kudiya" },
                                    { "kyw", "Kudmali", "Kudmali" },
                                    { "kov", "Kudu-Camo", "Kudu-Camo" },
                                    { "kow", "Kugama", "Kugama" },
                                    { "kes", "Kugbo", "Kugbo" },
                                    { "kxu", "Kui (India)", "Kui (India)" },
                                    { "kvd", "Kui (Indonesia)", "Kui (Indonesia)" },
                                    { "dkr", "Kuijau", "Kuijau" },
                                    { "kui", "Kuikúro-Kalapálo", "Kuikúro-Kalapálo" },
                                    { "vkj", "Kujarge", "Kujarge" },
                                    { "kfn", "Kuk", "Kuk" },
                                    { "kux", "Kukatja", "Kukatja" },
                                    { "kez", "Kukele", "Kukele" },
                                    { "kex", "Kukna", "Kukna" },
                                    { "xmq", "Kuku-Mangk", "Kuku-Mangk" },
                                    { "xmp", "Kuku-Mu'inh", "Kuku-Mu'inh" },
                                    { "xmh", "Kuku-Muminh", "Kuku-Muminh" },
                                    { "ugb", "Kuku-Ugbanh", "Kuku-Ugbanh" },
                                    { "uwa", "Kuku-Uwanh", "Kuku-Uwanh" },
                                    { "gvn", "Kuku-Yalanji", "Kuku-Yalanji" },
                                    { "tpg", "Kula", "Kula" },
                                    { "kzc", "Bondoukou Kulango", "Kulango, Bondoukou" },
                                    { "nku", "Bouna Kulango", "Kulango, Bouna" },
                                    { "kul", "Kulere", "Kulere" },
                                    { "kxj", "Kulfa", "Kulfa" },
                                    { "vkl", "Kulisusu", "Kulisusu" },
                                    { "uun", "Kulon-Pazeh", "Kulon-Pazeh" },
                                    { "kle", "Kulung (Nepal)", "Kulung (Nepal)" },
                                    { "bbu", "Kulung (Nigeria)", "Kulung (Nigeria)" },
                                    { "ksl", "Kumalu", "Kumalu" },
                                    { "kdi", "Kumam", "Kumam" },
                                    { "kue", "Kuman", "Kuman" },
                                    { "qwm", "Kuman (Russia)", "Kuman (Russia)" },
                                    { "kfy", "Kumaoni", "Kumaoni" },
                                    { "kmj", "Kumarbhag Paharia", "Kumarbhag Paharia" },
                                    { "ksm", "Kumba", "Kumba" },
                                    { "kgs", "Kumbainggar", "Kumbainggar" },
                                    { "wkb", "Kumbaran", "Kumbaran" },
                                    { "xks", "Kumbewaha", "Kumbewaha" },
                                    { "kra", "Kumhali", "Kumhali" },
                                    { "dih", "Kumiai", "Kumiai" },
                                    { "kuo", "Kumukio", "Kumukio" },
                                    { "kum", "Kumyk", "Kumyk" },
                                    { "zum", "Kumzari", "Kumzari" },
                                    { "kvn", "Border Kuna", "Kuna, Border" },
                                    { "cuk", "San Blas Kuna", "Kuna, San Blas" },
                                    { "kun", "Kunama", "Kunama" },
                                    { "wlg", "Kunbarlang", "Kunbarlang" },
                                    { "kdn", "Kunda", "Kunda" },
                                    { "shd", "Kundal Shahi", "Kundal Shahi" },
                                    { "wku", "Kunduvadi", "Kunduvadi" },
                                    { "kfl", "Kung", "Kung" },
                                    { "ggk", "Kungarakany", "Kungarakany" },
                                    { "knw", "Kung-Ekoka", "Kung-Ekoka" },
                                    { "kvs", "Kunggara", "Kunggara" },
                                    { "kgl", "Kunggari", "Kunggari" },
                                    { "kse", "Kuni", "Kuni" },
                                    { "kvg", "Kuni-Boazi", "Kuni-Boazi" },
                                    { "xug", "Kunigami", "Kunigami" },
                                    { "kup", "Kunimaipa", "Kunimaipa" },
                                    { "pep", "Kunja", "Kunja" },
                                    { "kjn", "Kunjen", "Kunjen" },
                                    { "njx", "Kunyi", "Kunyi" },
                                    { "kuz", "Kunza", "Kunza" },
                                    { "xuo", "Kuo", "Kuo" },
                                    { "kto", "Kuot", "Kuot" },
                                    { "kug", "Kupa", "Kupa" },
                                    { "key", "Kupia", "Kupia" },
                                    { "kpz", "Kupsabiny", "Kupsabiny" },
                                    { "kuv", "Kur", "Kur" },
                                    { "krh", "Kurama", "Kurama" },
                                    { "knk", "Kuranko", "Kuranko" },
                                    { "kur", "Kurdish", "Kurdish" },
                                    { "ckb", "Central Kurdish", "Kurdish, Central" },
                                    { "kmr", "Northern Kurdish", "Kurdish, Northern" },
                                    { "sdh", "Southern Kurdish", "Kurdish, Southern" },
                                    { "nbn", "Kuri", "Kuri" },
                                    { "kuj", "Kuria", "Kuria" },
                                    { "kfh", "Kurichiya", "Kurichiya" },
                                    { "kfv", "Kurmukar", "Kurmukar" },
                                    { "vku", "Kurrama", "Kurrama" },
                                    { "ktm", "Kurti", "Kurti" },
                                    { "xkz", "Kurtokha", "Kurtokha" },
                                    { "kyr", "Kuruáya", "Kuruáya" },
                                    { "kjr", "Kurudu", "Kurudu" },
                                    { "kru", "Kurukh", "Kurukh" },
                                    { "xua", "Alu Kurumba", "Kurumba, Alu" },
                                    { "pkr", "Attapady Kurumba", "Kurumba, Attapady" },
                                    { "xub", "Betta Kurumba", "Kurumba, Betta" },
                                    { "xuj", "Jennu Kurumba", "Kurumba, Jennu" },
                                    { "kfi", "Kannada Kurumba", "Kurumba, Kannada" },
                                    { "kpb", "Mullu Kurumba", "Kurumba, Mullu" },
                                    { "kxl", "Nepali Kurux", "Kurux, Nepali" },
                                    { "kus", "Kusaal", "Kusaal" },
                                    { "ksg", "Kusaghe", "Kusaghe" },
                                    { "kuh", "Kushi", "Kushi" },
                                    { "kuu", "Upper Kuskokwim", "Kuskokwim, Upper" },
                                    { "ksv", "Kusu", "Kusu" },
                                    { "kgg", "Kusunda", "Kusunda" },
                                    { "kut", "Kutenai", "Kutenai" },
                                    { "kub", "Kutep", "Kutep" },
                                    { "xut", "Kuthant", "Kuthant" },
                                    { "skm", "Kutong", "Kutong" },
                                    { "kpa", "Kutto", "Kutto" },
                                    { "kdc", "Kutu", "Kutu" },
                                    { "khj", "Kuturmi", "Kuturmi" },
                                    { "kuy", "Kuuku-Ya'u", "Kuuku-Ya'u" },
                                    { "uky", "Kuuk-Yak", "Kuuk-Yak" },
                                    { "kxv", "Kuvi", "Kuvi" },
                                    { "blh", "Kuwaa", "Kuwaa" },
                                    { "cwt", "Kuwaataay", "Kuwaataay" },
                                    { "kdt", "Kuy", "Kuy" },
                                    { "kwb", "Kwa", "Kwa" },
                                    { "bko", "Kwa'", "Kwa'" },
                                    { "ksq", "Kwaami", "Kwaami" },
                                    { "kwz", "Kwadi", "Kwadi" },
                                    { "wka", "Kw'adza", "Kw'adza" },
                                    { "kwd", "Kwaio", "Kwaio" },
                                    { "kdz", "Kwaja", "Kwaja" },
                                    { "kwq", "Kwak", "Kwak" },
                                    { "kwk", "Kwakiutl", "Kwakiutl" },
                                    { "kwu", "Kwakum", "Kwakum" },
                                    { "qwt", "Kwalhioqua-Tlatskanai", "Kwalhioqua-Tlatskanai" },
                                    { "kmq", "Kwama", "Kwama" },
                                    { "kwm", "Kwambi", "Kwambi" },
                                    { "tnk", "Kwamera", "Kwamera" },
                                    { "ktf", "Kwami", "Kwami" },
                                    { "kvi", "Kwang", "Kwang" },
                                    { "kwj", "Kwanga", "Kwanga" },
                                    { "kwn", "Kwangali", "Kwangali" },
                                    { "knp", "Kwanja", "Kwanja" },
                                    { "kua", "Kwanyama", "Kwanyama" },
                                    { "kwf", "Kwara'ae", "Kwara'ae" },
                                    { "nmg", "Kwasio", "Kwasio" },
                                    { "kya", "Kwaya", "Kwaya" },
                                    { "xwa", "Kwaza", "Kwaza" },
                                    { "xwg", "Kwegu", "Kwegu" },
                                    { "kwr", "Kwer", "Kwer" },
                                    { "kwe", "Kwerba", "Kwerba" },
                                    { "xwr", "Kwerba Mamberamo", "Kwerba Mamberamo" },
                                    { "cwe", "Kwere", "Kwere" },
                                    { "kkb", "Kwerisa", "Kwerisa" },
                                    { "kws", "Kwese", "Kwese" },
                                    { "kwt", "Kwesten", "Kwesten" },
                                    { "gww", "Kwini", "Kwini" },
                                    { "kuc", "Kwinsu", "Kwinsu" },
                                    { "kww", "Kwinti", "Kwinti" },
                                    { "kmo", "Kwoma", "Kwoma" },
                                    { "kwo", "Kwomtari", "Kwomtari" },
                                    { "aue", "Kx'au'ein", "Kx'au'ein" },
                                    { "xuu", "Kxoe", "Kxoe" },
                                    { "bka", "Kyak", "Kyak" },
                                    { "kyc", "Kyaka", "Kyaka" },
                                    { "kql", "Kyenele", "Kyenele" },
                                    { "tye", "Kyenga", "Kyenga" },
                                    { "kgy", "Kyerung", "Kyerung" },
                                    { "ldn", "Láadan", "Láadan" },
                                    { "gdm", "Laal", "Laal" },
                                    { "cae", "Laalaa", "Laalaa" },
                                    { "ldi", "Laari", "Laari" },
                                    { "lau", "Laba", "Laba" },
                                    { "lbb", "Label", "Label" },
                                    { "lbi", "La'bi", "La'bi" },
                                    { "jku", "Labir", "Labir" },
                                    { "mwi", "Labo", "Labo" },
                                    { "lbu", "Labu", "Labu" },
                                    { "lac", "Lacandon", "Lacandon" },
                                    { "lbt", "Lachi", "Lachi" },
                                    { "lwh", "White Lachi", "Lachi, White" },
                                    { "lbj", "Ladakhi", "Ladakhi" },
                                    { "lld", "Ladin", "Ladin" },
                                    { "lad", "Ladino", "Ladino" },
                                    { "llj", "Ladji Ladji", "Ladji Ladji" },
                                    { "lkl", "Laeko-Libuat", "Laeko-Libuat" },
                                    { "laf", "Lafofa", "Lafofa" },
                                    { "lgb", "Laghu", "Laghu" },
                                    { "lgh", "Laghuu", "Laghuu" },
                                    { "kot", "Lagwan", "Lagwan" },
                                    { "lhh", "Laha (Indonesia)", "Laha (Indonesia)" },
                                    { "lha", "Laha (Viet Nam)", "Laha (Viet Nam)" },
                                    { "lhn", "Lahanan", "Lahanan" },
                                    { "lah", "Lahnda", "Lahnda" },
                                    { "lhu", "Lahu", "Lahu" },
                                    { "lhi", "Lahu Shi", "Lahu Shi" },
                                    { "lmx", "Laimbue", "Laimbue" },
                                    { "lji", "Laiyolo", "Laiyolo" },
                                    { "lbe", "Lak", "Lak" },
                                    { "lap", "Laka (Chad)", "Laka (Chad)" },
                                    { "lak", "Laka (Nigeria)", "Laka (Nigeria)" },
                                    { "lka", "Lakalei", "Lakalei" },
                                    { "lkh", "Lakha", "Lakha" },
                                    { "lki", "Laki", "Laki" },
                                    { "lbc", "Lakkia", "Lakkia" },
                                    { "lkn", "Lakon", "Lakon" },
                                    { "lkd", "Lakondê", "Lakondê" },
                                    { "lkt", "Lakota", "Lakota" },
                                    { "nrz", "Lala", "Lala" },
                                    { "leb", "Lala-Bisa", "Lala-Bisa" },
                                    { "lla", "Lala-Roba", "Lala-Roba" },
                                    { "lal", "Lalia", "Lalia" },
                                    { "yik", "Dongshanba Lalo", "Lalo, Dongshanba" },
                                    { "ywt", "Xishanba Lalo", "Lalo, Xishanba" },
                                    { "yit", "Eastern Lalu", "Lalu, Eastern" },
                                    { "ywl", "Western Lalu", "Lalu, Western" },
                                    { "lay", "Lama (Myanmar)", "Lama (Myanmar)" },
                                    { "las", "Lama (Togo)", "Lama (Togo)" },
                                    { "slp", "Lamaholot", "Lamaholot" },
                                    { "lmr", "Lamalera", "Lamalera" },
                                    { "lmm", "Lamam", "Lamam" },
                                    { "hia", "Lamang", "Lamang" },
                                    { "lmq", "Lamatuka", "Lamatuka" },
                                    { "lam", "Lamba", "Lamba" },
                                    { "lmn", "Lambadi", "Lambadi" },
                                    { "lmh", "Lambichhong", "Lambichhong" },
                                    { "lmy", "Lamboya", "Lamboya" },
                                    { "lai", "Lambya", "Lambya" },
                                    { "bma", "Lame", "Lame" },
                                    { "lmu", "Lamenu", "Lamenu" },
                                    { "lbn", "Lamet", "Lamet" },
                                    { "ldh", "Lamja-Dengsa-Tola", "Lamja-Dengsa-Tola" },
                                    { "lmk", "Lamkang", "Lamkang" },
                                    { "lev", "Lamma", "Lamma" },
                                    { "lns", "Lamnso'", "Lamnso'" },
                                    { "lmg", "Lamogai", "Lamogai" },
                                    { "ljp", "Lampung Api", "Lampung Api" },
                                    { "abl", "Lampung Nyo", "Lampung Nyo" },
                                    { "llh", "Lamu", "Lamu" },
                                    { "lby", "Lamu-Lamu", "Lamu-Lamu" },
                                    { "ldm", "Landoma", "Landoma" },
                                    { "lnm", "Langam", "Langam" },
                                    { "lna", "Langbashe", "Langbashe" },
                                    { "yne", "Lang'e", "Lang'e" },
                                    { "lag", "Langi", "Langi" },
                                    { "lno", "Lango (Sudan)", "Lango (Sudan)" },
                                    { "laj", "Lango (Uganda)", "Lango (Uganda)" },
                                    { "lng", "Langobardic", "Langobardic" },
                                    { "lnh", "Lanoh", "Lanoh" },
                                    { "lao", "Lao", "Lao" },
                                    { "nlq", "Lao Naga", "Lao Naga" },
                                    { "lwm", "Laomian", "Laomian" },
                                    { "lbg", "Laopang", "Laopang" },
                                    { "lso", "Laos Sign Language", "Laos Sign Language" },
                                    { "lrg", "Laragia", "Laragia" },
                                    { "lbz", "Lardil", "Lardil" },
                                    { "lrv", "Larevat", "Larevat" },
                                    { "lrl", "Lari", "Lari" },
                                    { "alo", "Larike-Wakasihu", "Larike-Wakasihu" },
                                    { "lro", "Laro", "Laro" },
                                    { "lar", "Larteh", "Larteh" },
                                    { "lan", "Laru", "Laru" },
                                    { "llm", "Lasalimu", "Lasalimu" },
                                    { "lsa", "Lasgerdi", "Lasgerdi" },
                                    { "lsi", "Lashi", "Lashi" },
                                    { "lss", "Lasi", "Lasi" },
                                    { "ltg", "Latgalian", "Latgalian" },
                                    { "lat", "Latin", "Latin" },
                                    { "ltu", "Latu", "Latu" },
                                    { "ltn", "Latundê", "Latundê" },
                                    { "lav", "Latvian", "Latvian" },
                                    { "lsl", "Latvian Sign Language", "Latvian Sign Language" },
                                    { "lvs", "Standard Latvian", "Latvian, Standard" },
                                    { "llu", "Lau", "Lau" },
                                    { "luf", "Laua", "Laua" },
                                    { "llx", "Lauan", "Lauan" },
                                    { "law", "Lauje", "Lauje" },
                                    { "lur", "Laura", "Laura" },
                                    { "lre", "Laurentian", "Laurentian" },
                                    { "lbv", "Lavatbura-Lamusong", "Lavatbura-Lamusong" },
                                    { "brb", "Lave", "Lave" },
                                    { "lbo", "Laven", "Laven" },
                                    { "lvk", "Lavukaleve", "Lavukaleve" },
                                    { "lwl", "Eastern Lawa", "Lawa, Eastern" },
                                    { "lcp", "Western Lawa", "Lawa, Western" },
                                    { "lbx", "Lawangan", "Lawangan" },
                                    { "tgi", "Lawunuia", "Lawunuia" },
                                    { "lya", "Layakha", "Layakha" },
                                    { "lzz", "Laz", "Laz" },
                                    { "lec", "Leco", "Leco" },
                                    { "ldk", "Leelau", "Leelau" },
                                    { "lfa", "Lefa", "Lefa" },
                                    { "lgm", "Lega-Mwenga", "Lega-Mwenga" },
                                    { "lea", "Lega-Shabunda", "Lega-Shabunda" },
                                    { "agb", "Legbo", "Legbo" },
                                    { "lcc", "Legenyem", "Legenyem" },
                                    { "tql", "Lehali", "Lehali" },
                                    { "lek", "Leipon", "Leipon" },
                                    { "llk", "Lelak", "Lelak" },
                                    { "lln", "Lele (Chad)", "Lele (Chad)" },
                                    { "lel", "Lele (Democratic Republic of Congo)", "Lele (Democratic Republic of Congo)" },
                                    { "llc", "Lele (Guinea)", "Lele (Guinea)" },
                                    { "lle", "Lele (Papua New Guinea)", "Lele (Papua New Guinea)" },
                                    { "lef", "Lelemi", "Lelemi" },
                                    { "lpa", "Lelepa", "Lelepa" },
                                    { "lmf", "South Lembata", "Lembata, South" },
                                    { "lmj", "West Lembata", "Lembata, West" },
                                    { "leq", "Lembena", "Lembena" },
                                    { "lrz", "Lemerig", "Lemerig" },
                                    { "lei", "Lemio", "Lemio" },
                                    { "xle", "Lemnian", "Lemnian" },
                                    { "ley", "Lemolang", "Lemolang" },
                                    { "ldj", "Lemoro", "Lemoro" },
                                    { "tnl", "Lenakel", "Lenakel" },
                                    { "len", "Lenca", "Lenca" },
                                    { "led", "Lendu", "Lendu" },
                                    { "lgi", "Lengilu", "Lengilu" },
                                    { "lgr", "Lengo", "Lengo" },
                                    { "lej", "Lengola", "Lengola" },
                                    { "leg", "Lengua", "Lengua" },
                                    { "lsp", "Lengua de Señas Panameñas", "Lengua de Señas Panameñas" },
                                    { "lnj", "Leningitij", "Leningitij" },
                                    { "leh", "Lenje", "Lenje" },
                                    { "ler", "Lenkau", "Lenkau" },
                                    { "ldg", "Lenyima", "Lenyima" },
                                    { "lep", "Lepcha", "Lepcha" },
                                    { "lpe", "Lepki", "Lepki" },
                                    { "xlp", "Lepontic", "Lepontic" },
                                    { "gnh", "Lere", "Lere" },
                                    { "les", "Lese", "Lese" },
                                    { "let", "Lesing-Gelimi", "Lesing-Gelimi" },
                                    { "nms", "Letemboi", "Letemboi" },
                                    { "leo", "Leti (Cameroon)", "Leti (Cameroon)" },
                                    { "lti", "Leti (Indonesia)", "Leti (Indonesia)" },
                                    { "ltz", "Letzeburgesch", "Letzeburgesch" },
                                    { "lvu", "Levuka", "Levuka" },
                                    { "lww", "Lewo", "Lewo" },
                                    { "lwe", "Lewo Eleng", "Lewo Eleng" },
                                    { "lwt", "Lewotobi", "Lewotobi" },
                                    { "ayi", "Leyigha", "Leyigha" },
                                    { "lez", "Lezghian", "Lezghian" },
                                    { "mhx", "Lhaovo", "Lhaovo" },
                                    { "lhp", "Lhokpu", "Lhokpu" },
                                    { "lhm", "Lhomi", "Lhomi" },
                                    { "lix", "Liabuku", "Liabuku" },
                                    { "ste", "Liana-Seti", "Liana-Seti" },
                                    { "liq", "Libido", "Libido" },
                                    { "liz", "Libinza", "Libinza" },
                                    { "xli", "Liburnian", "Liburnian" },
                                    { "lbs", "Libyan Sign Language", "Libyan Sign Language" },
                                    { "lig", "Ligbi", "Ligbi" },
                                    { "lgz", "Ligenza", "Ligenza" },
                                    { "lij", "Ligurian", "Ligurian" },
                                    { "xlg", "Ligurian (Ancient)", "Ligurian (Ancient)" },
                                    { "lih", "Lihir", "Lihir" },
                                    { "mgi", "Lijili", "Lijili" },
                                    { "lik", "Lika", "Lika" },
                                    { "lio", "Liki", "Liki" },
                                    { "lie", "Likila", "Likila" },
                                    { "kxx", "Likuba", "Likuba" },
                                    { "lib", "Likum", "Likum" },
                                    { "kwc", "Likwala", "Likwala" },
                                    { "lll", "Lilau", "Lilau" },
                                    { "lil", "Lillooet", "Lillooet" },
                                    { "bme", "Limassa", "Limassa" },
                                    { "lma", "East Limba", "Limba, East" },
                                    { "lia", "West-Central Limba", "Limba, West-Central" },
                                    { "lif", "Limbu", "Limbu" },
                                    { "lmp", "Limbum", "Limbum" },
                                    { "lim", "Limburgan", "Limburgan" },
                                    { "ylm", "Limi", "Limi" },
                                    { "lmc", "Limilngan", "Limilngan" },
                                    { "klw", "Lindu", "Lindu" },
                                    { "lab", "Linear A", "Linear A" },
                                    { "lin", "Lingala", "Lingala" },
                                    { "onb", "Lingao", "Lingao" },
                                    { "lgk", "Lingarak", "Lingarak" },
                                    { "lii", "Lingkhim", "Lingkhim" },
                                    { "pml", "Lingua Franca", "Lingua Franca" },
                                    { "lfn", "Lingua Franca Nova", "Lingua Franca Nova" },
                                    { "ljl", "Li'o", "Li'o" },
                                    { "lpo", "Lipo", "Lipo" },
                                    { "lcs", "Lisabata-Nuniali", "Lisabata-Nuniali" },
                                    { "lcl", "Lisela", "Lisela" },
                                    { "lsh", "Lish", "Lish" },
                                    { "trg", "Lishán Didán", "Lishán Didán" },
                                    { "lsd", "Lishana Deni", "Lishana Deni" },
                                    { "aij", "Lishanid Noshan", "Lishanid Noshan" },
                                    { "lis", "Lisu", "Lisu" },
                                    { "lit", "Lithuanian", "Lithuanian" },
                                    { "lls", "Lithuanian Sign Language", "Lithuanian Sign Language" },
                                    { "lzl", "Litzlitz", "Litzlitz" },
                                    { "liv", "Liv", "Liv" },
                                    { "olo", "Livvi", "Livvi" },
                                    { "lrk", "Loarki", "Loarki" },
                                    { "loq", "Lobala", "Lobala" },
                                    { "lob", "Lobi", "Lobi" },
                                    { "ruu", "Lanas Lobu", "Lobu, Lanas" },
                                    { "low", "Tampias Lobu", "Lobu, Tampias" },
                                    { "lbm", "Lodhi", "Lodhi" },
                                    { "lgq", "Logba", "Logba" },
                                    { "log", "Logo", "Logo" },
                                    { "lof", "Logol", "Logol" },
                                    { "rag", "Logooli", "Logooli" },
                                    { "liu", "Logorik", "Logorik" },
                                    { "gda", "Gade Lohar", "Lohar, Gade" },
                                    { "lhl", "Lahul Lohar", "Lohar, Lahul" },
                                    { "lbr", "Lohorung", "Lohorung" },
                                    { "jbo", "Lojban", "Lojban" },
                                    { "yaz", "Lokaa", "Lokaa" },
                                    { "loy", "Loke", "Loke" },
                                    { "lok", "Loko", "Loko" },
                                    { "lky", "Lokoya", "Lokoya" },
                                    { "lcd", "Lola", "Lola" },
                                    { "llq", "Lolak", "Lolak" },
                                    { "llg", "Lole", "Lole" },
                                    { "llb", "Lolo", "Lolo" },
                                    { "loa", "Loloda", "Loloda" },
                                    { "ycl", "Lolopo", "Lolopo" },
                                    { "ysp", "Southern Lolopo", "Lolopo, Southern" },
                                    { "loi", "Loma (Côte d'Ivoire)", "Loma (Côte d'Ivoire)" },
                                    { "lom", "Loma (Liberia)", "Loma (Liberia)" },
                                    { "lmv", "Lomaiviti", "Lomaiviti" },
                                    { "rmi", "Lomavren", "Lomavren" },
                                    { "lmo", "Lombard", "Lombard" },
                                    { "lmi", "Lombi", "Lombi" },
                                    { "loo", "Lombo", "Lombo" },
                                    { "ngl", "Lomwe", "Lomwe" },
                                    { "lon", "Malawi Lomwe", "Lomwe, Malawi" },
                                    { "lce", "Loncong", "Loncong" },
                                    { "ttw", "Long Wat", "Long Wat" },
                                    { "lgu", "Longgu", "Longgu" },
                                    { "wok", "Longto", "Longto" },
                                    { "lnu", "Longuda", "Longuda" },
                                    { "los", "Loniu", "Loniu" },
                                    { "crc", "Lonwolwol", "Lonwolwol" },
                                    { "lnz", "Lonzo", "Lonzo" },
                                    { "ldo", "Loo", "Loo" },
                                    { "lop", "Lopa", "Lopa" },
                                    { "lov", "Lopi", "Lopi" },
                                    { "lpx", "Lopit", "Lopit" },
                                    { "lrn", "Lorang", "Lorang" },
                                    { "lnn", "Lorediakarkar", "Lorediakarkar" },
                                    { "uvl", "Lote", "Lote" },
                                    { "lht", "Lo-Toga", "Lo-Toga" },
                                    { "dtr", "Lotud", "Lotud" },
                                    { "loj", "Lou", "Lou" },
                                    { "lox", "Loun", "Loun" },
                                    { "xlo", "Loup A", "Loup A" },
                                    { "xlb", "Loup B", "Loup B" },
                                    { "urr", "Löyöp", "Löyöp" },
                                    { "loz", "Lozi", "Lozi" },
                                    { "khb", "Lü", "Lü" },
                                    { "prb", "Lua'", "Lua'" },
                                    { "lex", "Luang", "Luang" },
                                    { "lub", "Luba-Katanga", "Luba-Katanga" },
                                    { "lua", "Luba-Lulua", "Luba-Lulua" },
                                    { "kcc", "Lubila", "Lubila" },
                                    { "lcf", "Lubu", "Lubu" },
                                    { "lch", "Luchazi", "Luchazi" },
                                    { "luq", "Lucumi", "Lucumi" },
                                    { "lud", "Ludian", "Ludian" },
                                    { "ldq", "Lufu", "Lufu" },
                                    { "lgg", "Lugbara", "Lugbara" },
                                    { "ruf", "Luguru", "Luguru" },
                                    { "lba", "Lui", "Lui" },
                                    { "lum", "Luimbi", "Luimbi" },
                                    { "lui", "Luiseno", "Luiseno" },
                                    { "lkb", "Lukabaras", "Lukabaras" },
                                    { "dop", "Lukpa", "Lukpa" },
                                    { "smj", "Lule Sami", "Lule Sami" },
                                    { "luu", "Lumba-Yakkha", "Lumba-Yakkha" },
                                    { "lmz", "Lumbee", "Lumbee" },
                                    { "lup", "Lumbu", "Lumbu" },
                                    { "lmd", "Lumun", "Lumun" },
                                    { "lnd", "Lun Bawang", "Lun Bawang" },
                                    { "luj", "Luna", "Luna" },
                                    { "luk", "Lunanakha", "Lunanakha" },
                                    { "lun", "Lunda", "Lunda" },
                                    { "lga", "Lungga", "Lungga" },
                                    { "luw", "Luo (Cameroon)", "Luo (Cameroon)" },
                                    { "luo", "Luo (Kenya and Tanzania)", "Luo (Kenya and Tanzania)" },
                                    { "ldd", "Luri", "Luri" },
                                    { "lrc", "Northern Luri", "Luri, Northern" },
                                    { "luz", "Southern Luri", "Luri, Southern" },
                                    { "lse", "Lusengo", "Lusengo" },
                                    { "lus", "Lushai", "Lushai" },
                                    { "lut", "Lushootseed", "Lushootseed" },
                                    { "khl", "Lusi", "Lusi" },
                                    { "xls", "Lusitanian", "Lusitanian" },
                                    { "lts", "Lutachoni", "Lutachoni" },
                                    { "ndy", "Lutos", "Lutos" },
                                    { "lue", "Luvale", "Luvale" },
                                    { "luv", "Luwati", "Luwati" },
                                    { "xlu", "Cuneiform Luwian", "Luwian, Cuneiform" },
                                    { "hlu", "Hieroglyphic Luwian", "Luwian, Hieroglyphic" },
                                    { "lwo", "Luwo", "Luwo" },
                                    { "lyn", "Luyana", "Luyana" },
                                    { "luy", "Luyia", "Luyia" },
                                    { "lwa", "Lwalu", "Lwalu" },
                                    { "xlc", "Lycian", "Lycian" },
                                    { "xld", "Lydian", "Lydian" },
                                    { "lee", "Lyélé", "Lyélé" },
                                    { "lyg", "Lyngngam", "Lyngngam" },
                                    { "lsg", "Lyons Sign Language", "Lyons Sign Language" },
                                    { "msj", "Ma (Democratic Republic of Congo)", "Ma (Democratic Republic of Congo)" },
                                    { "mjn", "Ma (Papua New Guinea)", "Ma (Papua New Guinea)" },
                                    { "skc", "Ma Manda", "Ma Manda" },
                                    { "cma", "Maa", "Maa" },
                                    { "mew", "Maaka", "Maaka" },
                                    { "mhy", "Ma'anyan", "Ma'anyan" },
                                    { "ymm", "Maay", "Maay" },
                                    { "mde", "Maba (Chad)", "Maba (Chad)" },
                                    { "mqa", "Maba (Indonesia)", "Maba (Indonesia)" },
                                    { "mmz", "Mabaale", "Mabaale" },
                                    { "mfz", "Mabaan", "Mabaan" },
                                    { "muj", "Mabire", "Mabire" },
                                    { "mca", "Maca", "Maca" },
                                    { "mcl", "Macaguaje", "Macaguaje" },
                                    { "mbn", "Macaguán", "Macaguán" },
                                    { "mzs", "Macanese", "Macanese" },
                                    { "mkd", "Macedonian", "Macedonian" },
                                    { "xmk", "Ancient Macedonian", "Macedonian, Ancient" },
                                    { "jmc", "Machame", "Machame" },
                                    { "mcb", "Machiguenga", "Machiguenga" },
                                    { "mpd", "Machinere", "Machinere" },
                                    { "mvw", "Machinga", "Machinga" },
                                    { "wpc", "Maco", "Maco" },
                                    { "myy", "Macuna", "Macuna" },
                                    { "mbc", "Macushi", "Macushi" },
                                    { "mxu", "Mada (Cameroon)", "Mada (Cameroon)" },
                                    { "mda", "Mada (Nigeria)", "Mada (Nigeria)" },
                                    { "mzc", "Madagascar Sign Language", "Madagascar Sign Language" },
                                    { "mmx", "Madak", "Madak" },
                                    { "xmx", "Maden", "Maden" },
                                    { "dmd", "Madhi Madhi", "Madhi Madhi" },
                                    { "grg", "Madi", "Madi" },
                                    { "mhi", "Ma'di", "Ma'di" },
                                    { "snm", "Southern Ma'di", "Ma'di, Southern" },
                                    { "zml", "Madngele", "Madngele" },
                                    { "mad", "Madurese", "Madurese" },
                                    { "mme", "Mae", "Mae" },
                                    { "hmk", "Maek", "Maek" },
                                    { "mwo", "Central Maewo", "Maewo, Central" },
                                    { "maf", "Mafa", "Mafa" },
                                    { "mkv", "Mafea", "Mafea" },
                                    { "mag", "Magahi", "Magahi" },
                                    { "mgp", "Eastern Magar", "Magar, Eastern" },
                                    { "mrd", "Western Magar", "Magar, Western" },
                                    { "gmd", "Mághdì", "Mághdì" },
                                    { "gmx", "Magoma", "Magoma" },
                                    { "zgr", "Magori", "Magori" },
                                    { "mdh", "Maguindanaon", "Maguindanaon" },
                                    { "mjx", "Mahali", "Mahali" },
                                    { "mjy", "Mahican", "Mahican" },
                                    { "mhb", "Mahongwe", "Mahongwe" },
                                    { "mxx", "Mahou", "Mahou" },
                                    { "ayz", "Mai Brat", "Mai Brat" },
                                    { "sks", "Maia", "Maia" },
                                    { "mzz", "Maiadomu", "Maiadomu" },
                                    { "tnh", "Maiani", "Maiani" },
                                    { "nmu", "Northeast Maidu", "Maidu, Northeast" },
                                    { "mjd", "Northwest Maidu", "Maidu, Northwest" },
                                    { "vmv", "Valley Maidu", "Maidu, Valley" },
                                    { "mmm", "Maii", "Maii" },
                                    { "mgu", "Mailu", "Mailu" },
                                    { "cwb", "Maindo", "Maindo" },
                                    { "vmf", "Mainfränkisch", "Mainfränkisch" },
                                    { "xkl", "Mainstream Kenyah", "Mainstream Kenyah" },
                                    { "zrs", "Mairasi", "Mairasi" },
                                    { "mbq", "Maisin", "Maisin" },
                                    { "mai", "Maithili", "Maithili" },
                                    { "wmm", "Maiwa (Indonesia)", "Maiwa (Indonesia)" },
                                    { "mti", "Maiwa (Papua New Guinea)", "Maiwa (Papua New Guinea)" },
                                    { "mum", "Maiwala", "Maiwala" },
                                    { "mpe", "Majang", "Majang" },
                                    { "xmj", "Majera", "Majera" },
                                    { "mjz", "Majhi", "Majhi" },
                                    { "mmj", "Majhwar", "Majhwar" },
                                    { "mkg", "Mak (China)", "Mak (China)" },
                                    { "pbl", "Mak (Nigeria)", "Mak (Nigeria)" },
                                    { "mcp", "Makaa", "Makaa" },
                                    { "myh", "Makah", "Makah" },
                                    { "mkz", "Makasae", "Makasae" },
                                    { "mak", "Makasar", "Makasar" },
                                    { "aup", "Makayam", "Makayam" },
                                    { "vmw", "Makhuwa", "Makhuwa" },
                                    { "xmc", "Makhuwa-Marrevone", "Makhuwa-Marrevone" },
                                    { "mgh", "Makhuwa-Meetto", "Makhuwa-Meetto" },
                                    { "mhm", "Makhuwa-Moniga", "Makhuwa-Moniga" },
                                    { "xsq", "Makhuwa-Saka", "Makhuwa-Saka" },
                                    { "vmk", "Makhuwa-Shirima", "Makhuwa-Shirima" },
                                    { "mky", "East Makian", "Makian, East" },
                                    { "mqs", "West Makian", "Makian, West" },
                                    { "mgf", "Maklew", "Maklew" },
                                    { "zmh", "Makolkol", "Makolkol" },
                                    { "kde", "Makonde", "Makonde" },
                                    { "lva", "Maku'a", "Maku'a" },
                                    { "mpu", "Makuráp", "Makuráp" },
                                    { "ymk", "Makwe", "Makwe" },
                                    { "mlf", "Mal", "Mal" },
                                    { "mkb", "Mal Paharia", "Mal Paharia" },
                                    { "ruy", "Mala (Nigeria)", "Mala (Nigeria)" },
                                    { "ped", "Mala (Papua New Guinea)", "Mala (Papua New Guinea)" },
                                    { "mlg", "Malagasy", "Malagasy" },
                                    { "bhr", "Bara Malagasy", "Malagasy, Bara" },
                                    { "msh", "Masikoro Malagasy", "Malagasy, Masikoro" },
                                    { "bmm", "Northern Betsimisaraka Malagasy", "Malagasy, Northern Betsimisaraka" },
                                    { "plt", "Plateau Malagasy", "Malagasy, Plateau" },
                                    { "skg", "Sakalava Malagasy", "Malagasy, Sakalava" },
                                    { "bzc", "Southern Betsimisaraka Malagasy", "Malagasy, Southern Betsimisaraka" },
                                    { "tdx", "Tandroy-Mahafaly Malagasy", "Malagasy, Tandroy-Mahafaly" },
                                    { "xmv", "Tankarana Malagasy", "Malagasy, Tankarana" },
                                    { "txy", "Tanosy Malagasy", "Malagasy, Tanosy" },
                                    { "tkg", "Tesaka Malagasy", "Malagasy, Tesaka" },
                                    { "xmw", "Tsimihety Malagasy", "Malagasy, Tsimihety" },
                                    { "mld", "Malakhel", "Malakhel" },
                                    { "mmt", "Malalamai", "Malalamai" },
                                    { "mln", "Malango", "Malango" },
                                    { "mjo", "Malankuravan", "Malankuravan" },
                                    { "mjp", "Malapandaram", "Malapandaram" },
                                    { "mjq", "Malaryan", "Malaryan" },
                                    { "mkr", "Malas", "Malas" },
                                    { "ymr", "Malasar", "Malasar" },
                                    { "ima", "Mala Malasar", "Malasar, Mala" },
                                    { "mjr", "Malavedan", "Malavedan" },
                                    { "zlm", "Malay (individual language)", "Malay (individual language)" },
                                    { "msa", "Malay (macrolanguage)", "Malay (macrolanguage)" },
                                    { "abs", "Ambonese Malay", "Malay, Ambonese" },
                                    { "mbf", "Baba Malay", "Malay, Baba" },
                                    { "btj", "Bacanese Malay", "Malay, Bacanese" },
                                    { "mhp", "Balinese Malay", "Malay, Balinese" },
                                    { "bpq", "Banda Malay", "Malay, Banda" },
                                    { "bve", "Berau Malay", "Malay, Berau" },
                                    { "bvu", "Bukit Malay", "Malay, Bukit" },
                                    { "pse", "Central Malay", "Malay, Central" },
                                    { "coa", "Cocos Islands Malay", "Malay, Cocos Islands" },
                                    { "jax", "Jambi Malay", "Malay, Jambi" },
                                    { "meo", "Kedah Malay", "Malay, Kedah" },
                                    { "mqg", "Kota Bangun Kutai Malay", "Malay, Kota Bangun Kutai" },
                                    { "mkn", "Kupang Malay", "Malay, Kupang" },
                                    { "lrt", "Larantuka Malay", "Malay, Larantuka" },
                                    { "mfp", "Makassar Malay", "Malay, Makassar" },
                                    { "xmm", "Manado Malay", "Malay, Manado" },
                                    { "max", "North Moluccan Malay", "Malay, North Moluccan" },
                                    { "pmy", "Papuan Malay", "Malay, Papuan" },
                                    { "mfa", "Pattani Malay", "Malay, Pattani" },
                                    { "msi", "Sabah Malay", "Malay, Sabah" },
                                    { "zsm", "Standard Malay", "Malay, Standard" },
                                    { "vkt", "Tenggarong Kutai Malay", "Malay, Tenggarong Kutai" },
                                    { "mal", "Malayalam", "Malayalam" },
                                    { "mlz", "Malaynon", "Malaynon" },
                                    { "mbp", "Malayo", "Malayo" },
                                    { "xml", "Malaysian Sign Language", "Malaysian Sign Language" },
                                    { "mdy", "Male (Ethiopia)", "Male (Ethiopia)" },
                                    { "mdc", "Male (Papua New Guinea)", "Male (Papua New Guinea)" },
                                    { "pqm", "Malecite-Passamaquoddy", "Malecite-Passamaquoddy" },
                                    { "gut", "Maléku Jaíka", "Maléku Jaíka" },
                                    { "pkt", "Maleng", "Maleng" },
                                    { "mgl", "Maleu-Kilenge", "Maleu-Kilenge" },
                                    { "mlx", "Malfaxal", "Malfaxal" },
                                    { "vml", "Malgana", "Malgana" },
                                    { "mxf", "Malgbe", "Malgbe" },
                                    { "gcc", "Mali", "Mali" },
                                    { "mwj", "Maligo", "Maligo" },
                                    { "mgq", "Malila", "Malila" },
                                    { "mzd", "Malimba", "Malimba" },
                                    { "mli", "Malimpung", "Malimpung" },
                                    { "mla", "Malo", "Malo" },
                                    { "mbk", "Malol", "Malol" },
                                    { "mlt", "Maltese", "Maltese" },
                                    { "mdl", "Maltese Sign Language", "Maltese Sign Language" },
                                    { "mll", "Malua Bay", "Malua Bay" },
                                    { "mup", "Malvi", "Malvi" },
                                    { "yga", "Malyangapa", "Malyangapa" },
                                    { "mam", "Mam", "Mam" },
                                    { "mma", "Mama", "Mama" },
                                    { "mhf", "Mamaa", "Mamaa" },
                                    { "wmd", "Mamaindé", "Mamaindé" },
                                    { "mmn", "Mamanwa", "Mamanwa" },
                                    { "mqj", "Mamasa", "Mamasa" },
                                    { "mgm", "Mambae", "Mambae" },
                                    { "mcs", "Mambai", "Mambai" },
                                    { "mcu", "Cameroon Mambila", "Mambila, Cameroon" },
                                    { "mzk", "Nigeria Mambila", "Mambila, Nigeria" },
                                    { "mvd", "Mamboru", "Mamboru" },
                                    { "mgr", "Mambwe-Lungu", "Mambwe-Lungu" },
                                    { "maw", "Mampruli", "Mampruli" },
                                    { "mqx", "Mamuju", "Mamuju" },
                                    { "emm", "Mamulique", "Mamulique" },
                                    { "kdf", "Mamusi", "Mamusi" },
                                    { "mdi", "Mamvu", "Mamvu" },
                                    { "mml", "Man Met", "Man Met" },
                                    { "mva", "Manam", "Manam" },
                                    { "mle", "Manambu", "Manambu" },
                                    { "nmm", "Manangba", "Manangba" },
                                    { "znk", "Manangkari", "Manangkari" },
                                    { "mnc", "Manchu", "Manchu" },
                                    { "zma", "Manda (Australia)", "Manda (Australia)" },
                                    { "mha", "Manda (India)", "Manda (India)" },
                                    { "mgs", "Manda (Tanzania)", "Manda (Tanzania)" },
                                    { "mht", "Mandahuaca", "Mandahuaca" },
                                    { "mid", "Mandaic", "Mandaic" },
                                    { "myz", "Classical Mandaic", "Mandaic, Classical" },
                                    { "mhq", "Mandan", "Mandan" },
                                    { "zmk", "Mandandanyi", "Mandandanyi" },
                                    { "mdr", "Mandar", "Mandar" },
                                    { "tbf", "Mandara", "Mandara" },
                                    { "mqu", "Mandari", "Mandari" },
                                    { "mry", "Mandaya", "Mandaya" },
                                    { "mjl", "Mandeali", "Mandeali" },
                                    { "mqr", "Mander", "Mander" },
                                    { "man", "Mandingo", "Mandingo" },
                                    { "mnk", "Mandinka", "Mandinka" },
                                    { "mfv", "Mandjak", "Mandjak" },
                                    { "aax", "Mandobo Atas", "Mandobo Atas" },
                                    { "bwp", "Mandobo Bawah", "Mandobo Bawah" },
                                    { "bmd", "Baga Manduri", "Manduri, Baga" },
                                    { "jet", "Manem", "Manem" },
                                    { "zng", "Mang", "Mang" },
                                    { "mem", "Mangala", "Mangala" },
                                    { "mpc", "Mangarayi", "Mangarayi" },
                                    { "mrv", "Mangareva", "Mangareva" },
                                    { "zns", "Mangas", "Mangas" },
                                    { "myj", "Mangayat", "Mangayat" },
                                    { "mdj", "Mangbetu", "Mangbetu" },
                                    { "mdk", "Mangbutu", "Mangbutu" },
                                    { "zme", "Mangerr", "Mangerr" },
                                    { "mqy", "Manggarai", "Manggarai" },
                                    { "mge", "Mango", "Mango" },
                                    { "mqc", "Mangole", "Mangole" },
                                    { "mbh", "Mangseng", "Mangseng" },
                                    { "mom", "Mangue", "Mangue" },
                                    { "abd", "Manide", "Manide" },
                                    { "mnx", "Manikion", "Manikion" },
                                    { "myq", "Forest Maninka", "Maninka, Forest" },
                                    { "mku", "Konyanka Maninka", "Maninka, Konyanka" },
                                    { "msc", "Sankaran Maninka", "Maninka, Sankaran" },
                                    { "emk", "Eastern Maninkakan", "Maninkakan, Eastern" },
                                    { "mwk", "Kita Maninkakan", "Maninkakan, Kita" },
                                    { "mlq", "Western Maninkakan", "Maninkakan, Western" },
                                    { "mqp", "Manipa", "Manipa" },
                                    { "mni", "Manipuri", "Manipuri" },
                                    { "omp", "Old Manipuri", "Manipuri, Old" },
                                    { "knf", "Mankanya", "Mankanya" },
                                    { "mev", "Mann", "Mann" },
                                    { "mju", "Manna-Dora", "Manna-Dora" },
                                    { "mjv", "Mannan", "Mannan" },
                                    { "msm", "Agusan Manobo", "Manobo, Agusan" },
                                    { "atd", "Ata Manobo", "Manobo, Ata" },
                                    { "mta", "Cotabato Manobo", "Manobo, Cotabato" },
                                    { "mbd", "Dibabawon Manobo", "Manobo, Dibabawon" },
                                    { "mbi", "Ilianen Manobo", "Manobo, Ilianen" },
                                    { "mkx", "Kinamiging Manobo", "Manobo, Kinamiging" },
                                    { "mbt", "Matigsalug Manobo", "Manobo, Matigsalug" },
                                    { "obo", "Obo Manobo", "Manobo, Obo" },
                                    { "mqk", "Rajah Kabunsuwan Manobo", "Manobo, Rajah Kabunsuwan" },
                                    { "mbs", "Sarangani Manobo", "Manobo, Sarangani" },
                                    { "mbb", "Western Bukidnon Manobo", "Manobo, Western Bukidnon" },
                                    { "woo", "Manombai", "Manombai" },
                                    { "msk", "Mansaka", "Mansaka" },
                                    { "mns", "Mansi", "Mansi" },
                                    { "msw", "Mansoanka", "Mansoanka" },
                                    { "myg", "Manta", "Manta" },
                                    { "nty", "Mantsi", "Mantsi" },
                                    { "wha", "Manusela", "Manusela" },
                                    { "glv", "Manx", "Manx" },
                                    { "mzj", "Manya", "Manya" },
                                    { "mny", "Manyawa", "Manyawa" },
                                    { "mxc", "Manyika", "Manyika" },
                                    { "mzv", "Manza", "Manza" },
                                    { "mmd", "Maonan", "Maonan" },
                                    { "mri", "Maori", "Maori" },
                                    { "mlh", "Mape", "Mape" },
                                    { "mnm", "Mapena", "Mapena" },
                                    { "mpy", "Mapia", "Mapia" },
                                    { "mpw", "Mapidian", "Mapidian" },
                                    { "mcg", "Mapoyo", "Mapoyo" },
                                    { "arn", "Mapudungun", "Mapudungun" },
                                    { "sjm", "Mapun", "Mapun" },
                                    { "mch", "Maquiritari", "Maquiritari" },
                                    { "mec", "Mara", "Mara" },
                                    { "lri", "Marachi", "Marachi" },
                                    { "vmh", "Maraghei", "Maraghei" },
                                    { "mrs", "Maragus", "Maragus" },
                                    { "lrm", "Marama", "Marama" },
                                    { "myd", "Maramba", "Maramba" },
                                    { "mrw", "Maranao", "Maranao" },
                                    { "zmr", "Maranunggu", "Maranunggu" },
                                    { "mgb", "Mararit", "Mararit" },
                                    { "mar", "Marathi", "Marathi" },
                                    { "omr", "Old Marathi", "Marathi, Old" },
                                    { "mvr", "Marau", "Marau" },
                                    { "mpg", "Marba", "Marba" },
                                    { "vmr", "Marenje", "Marenje" },
                                    { "mvu", "Marfa", "Marfa" },
                                    { "zmc", "Margany", "Margany" },
                                    { "mrt", "Marghi Central", "Marghi Central" },
                                    { "mfm", "Marghi South", "Marghi South" },
                                    { "mhg", "Margu", "Margu" },
                                    { "mbx", "Mari (East Sepik Province)", "Mari (East Sepik Province)" },
                                    { "hob", "Mari (Madang Province)", "Mari (Madang Province)" },
                                    { "chm", "Mari (Russia)", "Mari (Russia)" },
                                    { "mhr", "Eastern Mari", "Mari, Eastern" },
                                    { "mrj", "Western Mari", "Mari, Western" },
                                    { "mrr", "Maria (India)", "Maria (India)" },
                                    { "mds", "Maria (Papua New Guinea)", "Maria (Papua New Guinea)" },
                                    { "daq", "Dandami Maria", "Maria, Dandami" },
                                    { "mrc", "Maricopa", "Maricopa" },
                                    { "zmd", "Maridan", "Maridan" },
                                    { "zmj", "Maridjabin", "Maridjabin" },
                                    { "dad", "Marik", "Marik" },
                                    { "zmm", "Marimanindji", "Marimanindji" },
                                    { "mrz", "Marind", "Marind" },
                                    { "bpv", "Bian Marind", "Marind, Bian" },
                                    { "mbw", "Maring", "Maring" },
                                    { "zmt", "Maringarr", "Maringarr" },
                                    { "mrb", "Marino", "Marino" },
                                    { "mqi", "Mariri", "Mariri" },
                                    { "mfr", "Marithiel", "Marithiel" },
                                    { "nsr", "Maritime Sign Language", "Maritime Sign Language" },
                                    { "msp", "Maritsauá", "Maritsauá" },
                                    { "zmy", "Mariyedi", "Mariyedi" },
                                    { "rkm", "Marka", "Marka" },
                                    { "enb", "Markweeta", "Markweeta" },
                                    { "rmz", "Marma", "Marma" },
                                    { "mvo", "Marovo", "Marovo" },
                                    { "mrq", "North Marquesan", "Marquesan, North" },
                                    { "mqm", "South Marquesan", "Marquesan, South" },
                                    { "xru", "Marriammu", "Marriammu" },
                                    { "umc", "Marrucinian", "Marrucinian" },
                                    { "mah", "Marshallese", "Marshallese" },
                                    { "ims", "Marsian", "Marsian" },
                                    { "mre", "Martha's Vineyard Sign Language", "Martha's Vineyard Sign Language" },
                                    { "zmg", "Marti Ke", "Marti Ke" },
                                    { "mpj", "Martu Wangka", "Martu Wangka" },
                                    { "vma", "Martuyhunira", "Martuyhunira" },
                                    { "mzr", "Marúbo", "Marúbo" },
                                    { "mwr", "Marwari", "Marwari" },
                                    { "rwr", "Marwari (India)", "Marwari (India)" },
                                    { "mve", "Marwari (Pakistan)", "Marwari (Pakistan)" },
                                    { "myx", "Masaaba", "Masaaba" },
                                    { "mas", "Masai", "Masai" },
                                    { "mls", "Masalit", "Masalit" },
                                    { "mcn", "Masana", "Masana" },
                                    { "msb", "Masbatenyo", "Masbatenyo" },
                                    { "mxz", "Central Masela", "Masela, Central" },
                                    { "vme", "East Masela", "Masela, East" },
                                    { "mss", "West Masela", "Masela, West" },
                                    { "cuj", "Mashco Piro", "Mashco Piro" },
                                    { "jms", "Mashi (Nigeria)", "Mashi (Nigeria)" },
                                    { "mho", "Mashi (Zambia)", "Mashi (Zambia)" },
                                    { "ism", "Masimasi", "Masimasi" },
                                    { "bnf", "Masiwang", "Masiwang" },
                                    { "klv", "Maskelynes", "Maskelynes" },
                                    { "mhh", "Maskoy Pidgin", "Maskoy Pidgin" },
                                    { "msv", "Maslam", "Maslam" },
                                    { "mes", "Masmaje", "Masmaje" },
                                    { "mdg", "Massalat", "Massalat" },
                                    { "mvs", "Massep", "Massep" },
                                    { "mtn", "Matagalpa", "Matagalpa" },
                                    { "mfh", "Matal", "Matal" },
                                    { "xmt", "Matbat", "Matbat" },
                                    { "mgv", "Matengo", "Matengo" },
                                    { "mqe", "Matepi", "Matepi" },
                                    { "mzo", "Matipuhy", "Matipuhy" },
                                    { "mpq", "Matís", "Matís" },
                                    { "ocu", "Atzingo Matlatzinca", "Matlatzinca, Atzingo" },
                                    { "mat", "San Francisco Matlatzinca", "Matlatzinca, San Francisco" },
                                    { "met", "Mato", "Mato" },
                                    { "mtm", "Mator", "Mator" },
                                    { "ymt", "Mator-Taygi-Karagas", "Mator-Taygi-Karagas" },
                                    { "mcf", "Matsés", "Matsés" },
                                    { "xnz", "Mattoki", "Mattoki" },
                                    { "mvb", "Mattole", "Mattole" },
                                    { "mjk", "Matukar", "Matukar" },
                                    { "mgw", "Matumbi", "Matumbi" },
                                    { "mph", "Maung", "Maung" },
                                    { "lsy", "Mauritian Sign Language", "Mauritian Sign Language" },
                                    { "mhl", "Mauwake", "Mauwake" },
                                    { "mcw", "Mawa (Chad)", "Mawa (Chad)" },
                                    { "wma", "Mawa (Nigeria)", "Mawa (Nigeria)" },
                                    { "mjj", "Mawak", "Mawak" },
                                    { "mcz", "Mawan", "Mawan" },
                                    { "mzx", "Mawayana", "Mawayana" },
                                    { "mke", "Mawchi", "Mawchi" },
                                    { "mgk", "Mawes", "Mawes" },
                                    { "mbl", "Maxakalí", "Maxakalí" },
                                    { "slz", "Ma'ya", "Ma'ya" },
                                    { "xmy", "Mayaguduna", "Mayaguduna" },
                                    { "emy", "Epigraphic Mayan", "Mayan, Epigraphic" },
                                    { "yan", "Mayangna", "Mayangna" },
                                    { "myc", "Mayeka", "Mayeka" },
                                    { "mnt", "Maykulan", "Maykulan" },
                                    { "mfy", "Mayo", "Mayo" },
                                    { "mdm", "Mayogo", "Mayogo" },
                                    { "dkx", "Mazagway", "Mazagway" },
                                    { "maz", "Central Mazahua", "Mazahua, Central" },
                                    { "mmc", "Michoacán Mazahua", "Mazahua, Michoacán" },
                                    { "mzn", "Mazanderani", "Mazanderani" },
                                    { "vmy", "Ayautla Mazatec", "Mazatec, Ayautla" },
                                    { "maq", "Chiquihuitlán Mazatec", "Mazatec, Chiquihuitlán" },
                                    { "mau", "Huautla Mazatec", "Mazatec, Huautla" },
                                    { "mzi", "Ixcatlán Mazatec", "Mazatec, Ixcatlán" },
                                    { "maj", "Jalapa De Díaz Mazatec", "Mazatec, Jalapa De Díaz" },
                                    { "vmz", "Mazatlán Mazatec", "Mazatec, Mazatlán" },
                                    { "maa", "San Jerónimo Tecóatl Mazatec", "Mazatec, San Jerónimo Tecóatl" },
                                    { "vmp", "Soyaltepec Mazatec", "Mazatec, Soyaltepec" },
                                    { "mfc", "Mba", "Mba" },
                                    { "vmb", "Mbabaram", "Mbabaram" },
                                    { "mdp", "Mbala", "Mbala" },
                                    { "lnb", "Mbalanhu", "Mbalanhu" },
                                    { "zmz", "Mbandja", "Mbandja" },
                                    { "mxg", "Mbangala", "Mbangala" },
                                    { "mgn", "Mbangi", "Mbangi" },
                                    { "zmn", "Mbangwe", "Mbangwe" },
                                    { "mvl", "Mbara (Australia)", "Mbara (Australia)" },
                                    { "mpk", "Mbara (Chad)", "Mbara (Chad)" },
                                    { "zmv", "Mbariman-Gudhinma", "Mbariman-Gudhinma" },
                                    { "mdn", "Mbati", "Mbati" },
                                    { "gwa", "Mbato", "Mbato" },
                                    { "myb", "Mbay", "Mbay" },
                                    { "mfo", "Mbe", "Mbe" },
                                    { "mtk", "Mbe'", "Mbe'" },
                                    { "mql", "Mbelime", "Mbelime" },
                                    { "mfn", "Cross River Mbembe", "Mbembe, Cross River" },
                                    { "nza", "Tigon Mbembe", "Mbembe, Tigon" },
                                    { "mdt", "Mbere", "Mbere" },
                                    { "zms", "Mbesa", "Mbesa" },
                                    { "mbo", "Mbo (Cameroon)", "Mbo (Cameroon)" },
                                    { "zmw", "Mbo (Democratic Republic of Congo)", "Mbo (Democratic Republic of Congo)" },
                                    { "moi", "Mboi", "Mboi" },
                                    { "mdu", "Mboko", "Mboko" },
                                    { "mdq", "Mbole", "Mbole" },
                                    { "xmb", "Mbonga", "Mbonga" },
                                    { "bgu", "Mbongno", "Mbongno" },
                                    { "mdw", "Mbosi", "Mbosi" },
                                    { "mxo", "Mbowe", "Mbowe" },
                                    { "mka", "Mbre", "Mbre" },
                                    { "muc", "Mbu'", "Mbu'" },
                                    { "xmd", "Mbudum", "Mbudum" },
                                    { "mhd", "Mbugu", "Mbugu" },
                                    { "mgz", "Mbugwe", "Mbugwe" },
                                    { "mqb", "Mbuko", "Mbuko" },
                                    { "mhw", "Mbukushu", "Mbukushu" },
                                    { "mna", "Mbula", "Mbula" },
                                    { "mbu", "Mbula-Bwazza", "Mbula-Bwazza" },
                                    { "mlb", "Mbule", "Mbule" },
                                    { "mbv", "Mbulungish", "Mbulungish" },
                                    { "mdd", "Mbum", "Mbum" },
                                    { "mck", "Mbunda", "Mbunda" },
                                    { "mgy", "Mbunga", "Mbunga" },
                                    { "bbt", "Mburku", "Mburku" },
                                    { "mfu", "Mbwela", "Mbwela" },
                                    { "meg", "Mea", "Mea" },
                                    { "mjm", "Medebur", "Medebur" },
                                    { "mue", "Media Lengua", "Media Lengua" },
                                    { "mwx", "Mediak", "Mediak" },
                                    { "xme", "Median", "Median" },
                                    { "byv", "Medumba", "Medumba" },
                                    { "mym", "Me'en", "Me'en" },
                                    { "mfj", "Mefele", "Mefele" },
                                    { "mef", "Megam", "Megam" },
                                    { "nux", "Mehek", "Mehek" },
                                    { "mmh", "Mehináku", "Mehináku" },
                                    { "gdq", "Mehri", "Mehri" },
                                    { "mek", "Mekeo", "Mekeo" },
                                    { "mvk", "Mekmek", "Mekmek" },
                                    { "msf", "Mekwei", "Mekwei" },
                                    { "mel", "Central Melanau", "Melanau, Central" },
                                    { "dro", "Daro-Matu Melanau", "Melanau, Daro-Matu" },
                                    { "kxn", "Kanowit-Tanjong Melanau", "Melanau, Kanowit-Tanjong" },
                                    { "sdx", "Sibu Melanau", "Melanau, Sibu" },
                                    { "mxe", "Mele-Fila", "Mele-Fila" },
                                    { "mfx", "Melo", "Melo" },
                                    { "med", "Melpa", "Melpa" },
                                    { "mby", "Memoni", "Memoni" },
                                    { "mfd", "Mendankwe-Nkwen", "Mendankwe-Nkwen" },
                                    { "sim", "Mende (Papua New Guinea)", "Mende (Papua New Guinea)" },
                                    { "men", "Mende (Sierra Leone)", "Mende (Sierra Leone)" },
                                    { "xmg", "Mengaka", "Mengaka" },
                                    { "mee", "Mengen", "Mengen" },
                                    { "mct", "Mengisa", "Mengisa" },
                                    { "mea", "Menka", "Menka" },
                                    { "mez", "Menominee", "Menominee" },
                                    { "mwv", "Mentawai", "Mentawai" },
                                    { "mcr", "Menya", "Menya" },
                                    { "emg", "Eastern Meohang", "Meohang, Eastern" },
                                    { "raf", "Western Meohang", "Meohang, Western" },
                                    { "mvx", "Meoswar", "Meoswar" },
                                    { "mnu", "Mer", "Mer" },
                                    { "mxm", "Meramera", "Meramera" },
                                    { "lmb", "Merei", "Merei" },
                                    { "meq", "Merey", "Merey" },
                                    { "ulk", "Meriam", "Meriam" },
                                    { "mrm", "Merlav", "Merlav" },
                                    { "xmr", "Meroitic", "Meroitic" },
                                    { "mer", "Meru", "Meru" },
                                    { "wry", "Merwari", "Merwari" },
                                    { "iyo", "Mesaka", "Mesaka" },
                                    { "mci", "Mese", "Mese" },
                                    { "sac", "Meskwaki", "Meskwaki" },
                                    { "zim", "Mesme", "Mesme" },
                                    { "mys", "Mesmes", "Mesmes" },
                                    { "mvz", "Mesqan", "Mesqan" },
                                    { "cms", "Messapic", "Messapic" },
                                    { "mgo", "Meta'", "Meta'" },
                                    { "mtr", "Mewari", "Mewari" },
                                    { "wtm", "Mewati", "Mewati" },
                                    { "mfs", "Mexican Sign Language", "Mexican Sign Language" },
                                    { "mej", "Meyah", "Meyah" },
                                    { "zmf", "Mfinu", "Mfinu" },
                                    { "nfu", "Mfumte", "Mfumte" },
                                    { "mia", "Miami", "Miami" },
                                    { "mpt", "Mian", "Mian" },
                                    { "pla", "Miani", "Miani" },
                                    { "cqd", "Chuanqiandian Cluster Miao", "Miao, Chuanqiandian Cluster" },
                                    { "hmd", "Da-Hua Miao", "Miao, Da-Hua" },
                                    { "hmq", "Eastern Qiandong Miao", "Miao, Eastern Qiandong" },
                                    { "muq", "Eastern Xiangxi Miao", "Miao, Eastern Xiangxi" },
                                    { "hrm", "Horned Miao", "Miao, Horned" },
                                    { "hea", "Northern Qiandong Miao", "Miao, Northern Qiandong" },
                                    { "sfm", "Small Flowery Miao", "Miao, Small Flowery" },
                                    { "hms", "Southern Qiandong Miao", "Miao, Southern Qiandong" },
                                    { "mmr", "Western Xiangxi Miao", "Miao, Western Xiangxi" },
                                    { "crg", "Michif", "Michif" },
                                    { "cmm", "Michigamea", "Michigamea" },
                                    { "mic", "Micmac", "Micmac" },
                                    { "mei", "Midob", "Midob" },
                                    { "bje", "Biao-Jiao Mien", "Mien, Biao-Jiao" },
                                    { "ium", "Iu Mien", "Mien, Iu" },
                                    { "mmy", "Migaama", "Migaama" },
                                    { "mpp", "Migabac", "Migabac" },
                                    { "klm", "Migum", "Migum" },
                                    { "sjl", "Miji", "Miji" },
                                    { "mik", "Mikasuki", "Mikasuki" },
                                    { "ymh", "Mili", "Mili" },
                                    { "mlj", "Miltu", "Miltu" },
                                    { "iml", "Miluk", "Miluk" },
                                    { "imy", "Milyan", "Milyan" },
                                    { "hna", "Mina (Cameroon)", "Mina (Cameroon)" },
                                    { "myi", "Mina (India)", "Mina (India)" },
                                    { "inm", "Minaean", "Minaean" },
                                    { "min", "Minangkabau", "Minangkabau" },
                                    { "mcv", "Minanibai", "Minanibai" },
                                    { "mvn", "Minaveha", "Minaveha" },
                                    { "drc", "Minderico", "Minderico" },
                                    { "mpn", "Mindiri", "Mindiri" },
                                    { "mko", "Mingang Doso", "Mingang Doso" },
                                    { "xmf", "Mingrelian", "Mingrelian" },
                                    { "wii", "Minidien", "Minidien" },
                                    { "vmg", "Minigir", "Minigir" },
                                    { "omn", "Minoan", "Minoan" },
                                    { "mqq", "Minokok", "Minokok" },
                                    { "mnq", "Minriq", "Minriq" },
                                    { "mzt", "Mintil", "Mintil" },
                                    { "yiq", "Miqie", "Miqie" },
                                    { "mwl", "Mirandese", "Mirandese" },
                                    { "zrg", "Mirgan", "Mirgan" },
                                    { "mmv", "Miriti", "Miriti" },
                                    { "mep", "Miriwung", "Miriwung" },
                                    { "mjs", "Miship", "Miship" },
                                    { "mpx", "Misima-Panaeati", "Misima-Panaeati" },
                                    { "mrg", "Mising", "Mising" },
                                    { "miq", "Mískito", "Mískito" },
                                    { "mwu", "Mittu", "Mittu" },
                                    { "zmq", "Mituku", "Mituku" },
                                    { "mpo", "Miu", "Miu" },
                                    { "vmi", "Miwa", "Miwa" },
                                    { "mkq", "Bay Miwok", "Miwok, Bay" },
                                    { "csm", "Central Sierra Miwok", "Miwok, Central Sierra" },
                                    { "csi", "Coast Miwok", "Miwok, Coast" },
                                    { "lmw", "Lake Miwok", "Miwok, Lake" },
                                    { "nsq", "Northern Sierra Miwok", "Miwok, Northern Sierra" },
                                    { "pmw", "Plains Miwok", "Miwok, Plains" },
                                    { "skd", "Southern Sierra Miwok", "Miwok, Southern Sierra" },
                                    { "mco", "Coatlán Mixe", "Mixe, Coatlán" },
                                    { "mir", "Isthmus Mixe", "Mixe, Isthmus" },
                                    { "mxq", "Juquila Mixe", "Mixe, Juquila" },
                                    { "mzl", "Mazatlán Mixe", "Mixe, Mazatlán" },
                                    { "neq", "North Central Mixe", "Mixe, North Central" },
                                    { "pxm", "Quetzaltepec Mixe", "Mixe, Quetzaltepec" },
                                    { "mxp", "Tlahuitoltepec Mixe", "Mixe, Tlahuitoltepec" },
                                    { "mto", "Totontepec Mixe", "Mixe, Totontepec" },
                                    { "mfg", "Mixifore", "Mixifore" },
                                    { "mim", "Alacatlatzala Mixtec", "Mixtec, Alacatlatzala" },
                                    { "xta", "Alcozauca Mixtec", "Mixtec, Alcozauca" },
                                    { "mbz", "Amoltepec Mixtec", "Mixtec, Amoltepec" },
                                    { "mip", "Apasco-Apoala Mixtec", "Mixtec, Apasco-Apoala" },
                                    { "mib", "Atatláhuca Mixtec", "Mixtec, Atatláhuca" },
                                    { "miy", "Ayutla Mixtec", "Mixtec, Ayutla" },
                                    { "miu", "Cacaloxtepec Mixtec", "Mixtec, Cacaloxtepec" },
                                    { "mih", "Chayuco Mixtec", "Mixtec, Chayuco" },
                                    { "xtb", "Chazumba Mixtec", "Mixtec, Chazumba" },
                                    { "mii", "Chigmecatitlán Mixtec", "Mixtec, Chigmecatitlán" },
                                    { "miz", "Coatzospan Mixtec", "Mixtec, Coatzospan" },
                                    { "xtu", "Cuyamecalco Mixtec", "Mixtec, Cuyamecalco" },
                                    { "xtd", "Diuxi-Tilantongo Mixtec", "Mixtec, Diuxi-Tilantongo" },
                                    { "mxs", "Huitepec Mixtec", "Mixtec, Huitepec" },
                                    { "mce", "Itundujia Mixtec", "Mixtec, Itundujia" },
                                    { "vmj", "Ixtayutla Mixtec", "Mixtec, Ixtayutla" },
                                    { "mxt", "Jamiltepec Mixtec", "Mixtec, Jamiltepec" },
                                    { "vmc", "Juxtlahuaca Mixtec", "Mixtec, Juxtlahuaca" },
                                    { "xtm", "Magdalena Peñasco Mixtec", "Mixtec, Magdalena Peñasco" },
                                    { "mxv", "Metlatónoc Mixtec", "Mixtec, Metlatónoc" },
                                    { "vmm", "Mitlatongo Mixtec", "Mixtec, Mitlatongo" },
                                    { "mix", "Mixtepec Mixtec", "Mixtec, Mixtepec" },
                                    { "xtn", "Northern Tlaxiaco Mixtec", "Mixtec, Northern Tlaxiaco" },
                                    { "mxa", "Northwest Oaxaca Mixtec", "Mixtec, Northwest Oaxaca" },
                                    { "mie", "Ocotepec Mixtec", "Mixtec, Ocotepec" },
                                    { "mil", "Peñoles Mixtec", "Mixtec, Peñoles" },
                                    { "mio", "Pinotepa Nacional Mixtec", "Mixtec, Pinotepa Nacional" },
                                    { "mjc", "San Juan Colorado Mixtec", "Mixtec, San Juan Colorado" },
                                    { "xtj", "San Juan Teita Mixtec", "Mixtec, San Juan Teita" },
                                    { "mig", "San Miguel El Grande Mixtec", "Mixtec, San Miguel El Grande" },
                                    { "xtp", "San Miguel Piedras Mixtec", "Mixtec, San Miguel Piedras" },
                                    { "mdv", "Santa Lucía Monteverde Mixtec", "Mixtec, Santa Lucía Monteverde" },
                                    { "mza", "Santa María Zacatepec Mixtec", "Mixtec, Santa María Zacatepec" },
                                    { "mks", "Silacayoapan Mixtec", "Mixtec, Silacayoapan" },
                                    { "xts", "Sindihui Mixtec", "Mixtec, Sindihui" },
                                    { "xti", "Sinicahua Mixtec", "Mixtec, Sinicahua" },
                                    { "mxy", "Southeastern Nochixtlán Mixtec", "Mixtec, Southeastern Nochixtlán" },
                                    { "mit", "Southern Puebla Mixtec", "Mixtec, Southern Puebla" },
                                    { "meh", "Southwestern Tlaxiaco Mixtec", "Mixtec, Southwestern Tlaxiaco" },
                                    { "vmq", "Soyaltepec Mixtec", "Mixtec, Soyaltepec" },
                                    { "xtt", "Tacahua Mixtec", "Mixtec, Tacahua" },
                                    { "vmx", "Tamazola Mixtec", "Mixtec, Tamazola" },
                                    { "mxb", "Tezoatlán Mixtec", "Mixtec, Tezoatlán" },
                                    { "mtx", "Tidaá Mixtec", "Mixtec, Tidaá" },
                                    { "xtl", "Tijaltepec Mixtec", "Mixtec, Tijaltepec" },
                                    { "mqh", "Tlazoyaltepec Mixtec", "Mixtec, Tlazoyaltepec" },
                                    { "mtu", "Tututepec Mixtec", "Mixtec, Tututepec" },
                                    { "jmx", "Western Juxtlahuaca Mixtec", "Mixtec, Western Juxtlahuaca" },
                                    { "xty", "Yoloxochitl Mixtec", "Mixtec, Yoloxochitl" },
                                    { "mpm", "Yosondúa Mixtec", "Mixtec, Yosondúa" },
                                    { "mvg", "Yucuañe Mixtec", "Mixtec, Yucuañe" },
                                    { "mab", "Yutanduchi Mixtec", "Mixtec, Yutanduchi" },
                                    { "mkf", "Miya", "Miya" },
                                    { "mvi", "Miyako", "Miyako" },
                                    { "soy", "Miyobe", "Miyobe" },
                                    { "mra", "Mlabri", "Mlabri" },
                                    { "lhs", "Mlahsö", "Mlahsö" },
                                    { "kja", "Mlap", "Mlap" },
                                    { "mlo", "Mlomp", "Mlomp" },
                                    { "mmu", "Mmaala", "Mmaala" },
                                    { "bfm", "Mmen", "Mmen" },
                                    { "cmo", "Central Mnong", "Mnong, Central" },
                                    { "mng", "Eastern Mnong", "Mnong, Eastern" },
                                    { "mnn", "Southern Mnong", "Mnong, Southern" },
                                    { "obm", "Moabite", "Moabite" },
                                    { "mfq", "Moba", "Moba" },
                                    { "mod", "Mobilian", "Mobilian" },
                                    { "mhn", "Mócheno", "Mócheno" },
                                    { "old", "Mochi", "Mochi" },
                                    { "omc", "Mochica", "Mochica" },
                                    { "mhc", "Mocho", "Mocho" },
                                    { "moc", "Mocoví", "Mocoví" },
                                    { "gbn", "Mo'da", "Mo'da" },
                                    { "mxd", "Modang", "Modang" },
                                    { "mqo", "Modole", "Modole" },
                                    { "mvq", "Moere", "Moere" },
                                    { "mfk", "North Mofu", "Mofu, North" },
                                    { "mif", "Mofu-Gudur", "Mofu-Gudur" },
                                    { "mhj", "Mogholi", "Mogholi" },
                                    { "mou", "Mogum", "Mogum" },
                                    { "mov", "Mohave", "Mohave" },
                                    { "moh", "Mohawk", "Mohawk" },
                                    { "xpq", "Mohegan-Pequot", "Mohegan-Pequot" },
                                    { "mow", "Moi (Congo)", "Moi (Congo)" },
                                    { "mxn", "Moi (Indonesia)", "Moi (Indonesia)" },
                                    { "mkp", "Moikodi", "Moikodi" },
                                    { "mwz", "Moingi", "Moingi" },
                                    { "ymi", "Moji", "Moji" },
                                    { "mqt", "Mok", "Mok" },
                                    { "mwt", "Moken", "Moken" },
                                    { "mft", "Mokerang", "Mokerang" },
                                    { "mkj", "Mokilese", "Mokilese" },
                                    { "mkm", "Moklen", "Moklen" },
                                    { "mkl", "Mokole", "Mokole" },
                                    { "bri", "Mokpwe", "Mokpwe" },
                                    { "vms", "Moksela", "Moksela" },
                                    { "mdf", "Moksha", "Moksha" },
                                    { "mbe", "Molale", "Molale" },
                                    { "pwm", "Molbog", "Molbog" },
                                    { "vsi", "Moldova Sign Language", "Moldova Sign Language" },
                                    { "ron", "Moldovan", "Moldovan" },
                                    { "bxc", "Molengue", "Molengue" },
                                    { "mox", "Molima", "Molima" },
                                    { "zmo", "Molo", "Molo" },
                                    { "msl", "Molof", "Molof" },
                                    { "mlw", "Moloko", "Moloko" },
                                    { "ver", "Mom Jango", "Mom Jango" },
                                    { "myl", "Moma", "Moma" },
                                    { "msz", "Momare", "Momare" },
                                    { "mso", "Mombum", "Mombum" },
                                    { "mmb", "Momina", "Momina" },
                                    { "mqf", "Momuna", "Momuna" },
                                    { "mnw", "Mon", "Mon" },
                                    { "omx", "Old Mon", "Mon, Old" },
                                    { "mzg", "Monastic Sign Language", "Monastic Sign Language" },
                                    { "mnd", "Mondé", "Mondé" },
                                    { "npn", "Mondropolon", "Mondropolon" },
                                    { "lol", "Mongo", "Mongo" },
                                    { "mgt", "Mongol", "Mongol" },
                                    { "mon", "Mongolian", "Mongolian" },
                                    { "msr", "Mongolian Sign Language", "Mongolian Sign Language" },
                                    { "cmg", "Classical Mongolian", "Mongolian, Classical" },
                                    { "khk", "Halh Mongolian", "Mongolian, Halh" },
                                    { "xng", "Middle Mongolian", "Mongolian, Middle" },
                                    { "mvf", "Peripheral Mongolian", "Mongolian, Peripheral" },
                                    { "mog", "Mongondow", "Mongondow" },
                                    { "mnz", "Moni", "Moni" },
                                    { "mru", "Mono (Cameroon)", "Mono (Cameroon)" },
                                    { "mnh", "Mono (Democratic Republic of Congo)", "Mono (Democratic Republic of Congo)" },
                                    { "mte", "Mono (Solomon Islands)", "Mono (Solomon Islands)" },
                                    { "mnr", "Mono (USA)", "Mono (USA)" },
                                    { "moo", "Monom", "Monom" },
                                    { "kkf", "Kalaktang Monpa", "Monpa, Kalaktang" },
                                    { "twm", "Tawang Monpa", "Monpa, Tawang" },
                                    { "moe", "Montagnais", "Montagnais" },
                                    { "mtl", "Montol", "Montol" },
                                    { "mxk", "Monumbo", "Monumbo" },
                                    { "moj", "Monzombo", "Monzombo" },
                                    { "gwg", "Moo", "Moo" },
                                    { "mop", "Mopán Maya", "Mopán Maya" },
                                    { "moq", "Mor (Bomberai Peninsula)", "Mor (Bomberai Peninsula)" },
                                    { "mhz", "Mor (Mor Islands)", "Mor (Mor Islands)" },
                                    { "msg", "Moraid", "Moraid" },
                                    { "mze", "Morawa", "Morawa" },
                                    { "xmo", "Morerebi", "Morerebi" },
                                    { "msx", "Moresada", "Moresada" },
                                    { "mzq", "Mori Atas", "Mori Atas" },
                                    { "xmz", "Mori Bawah", "Mori Bawah" },
                                    { "mdb", "Morigi", "Morigi" },
                                    { "mfe", "Morisyen", "Morisyen" },
                                    { "mor", "Moro", "Moro" },
                                    { "xms", "Moroccan Sign Language", "Moroccan Sign Language" },
                                    { "mgc", "Morokodo", "Morokodo" },
                                    { "bdo", "Morom", "Morom" },
                                    { "mqn", "Moronene", "Moronene" },
                                    { "mok", "Morori", "Morori" },
                                    { "mrp", "Morouas", "Morouas" },
                                    { "mrl", "Mortlockese", "Mortlockese" },
                                    { "mgd", "Moru", "Moru" },
                                    { "mqv", "Mosimo", "Mosimo" },
                                    { "mwy", "Mosiro", "Mosiro" },
                                    { "mtj", "Moskona", "Moskona" },
                                    { "mos", "Mossi", "Mossi" },
                                    { "mtt", "Mota", "Mota" },
                                    { "mlv", "Motlav", "Motlav" },
                                    { "meu", "Motu", "Motu" },
                                    { "mwh", "Mouk-Aria", "Mouk-Aria" },
                                    { "jmw", "Mouwase", "Mouwase" },
                                    { "mzp", "Movima", "Movima" },
                                    { "mzy", "Mozambican Sign Language", "Mozambican Sign Language" },
                                    { "mxi", "Mozarabic", "Mozarabic" },
                                    { "mpi", "Mpade", "Mpade" },
                                    { "xpj", "Mpalitjanh", "Mpalitjanh" },
                                    { "mpz", "Mpi", "Mpi" },
                                    { "mcx", "Mpiemo", "Mpiemo" },
                                    { "mpa", "Mpoto", "Mpoto" },
                                    { "mvt", "Mpotovoro", "Mpotovoro" },
                                    { "mgg", "Mpumpong", "Mpumpong" },
                                    { "zmp", "Mpuono", "Mpuono" },
                                    { "akc", "Mpur", "Mpur" },
                                    { "mro", "Mru", "Mru" },
                                    { "kqx", "Mser", "Mser" },
                                    { "mtd", "Mualang", "Mualang" },
                                    { "tsx", "Mubami", "Mubami" },
                                    { "mub", "Mubi", "Mubi" },
                                    { "ymd", "Muda", "Muda" },
                                    { "mwd", "Mudbura", "Mudbura" },
                                    { "udg", "Muduga", "Muduga" },
                                    { "aoj", "Mufian", "Mufian" },
                                    { "muk", "Mugom", "Mugom" },
                                    { "bmr", "Muinane", "Muinane" },
                                    { "ymx", "Northern Muji", "Muji, Northern" },
                                    { "ymq", "Qila Muji", "Muji, Qila" },
                                    { "ymc", "Southern Muji", "Muji, Southern" },
                                    { "mmk", "Mukha-Dora", "Mukha-Dora" },
                                    { "mfw", "Mulaha", "Mulaha" },
                                    { "mlm", "Mulam", "Mulam" },
                                    { "giu", "Mulao", "Mulao" },
                                    { "mvh", "Mulgi", "Mulgi" },
                                    { "mpb", "Mullukmulluk", "Mullukmulluk" },
                                    { "mul", "Multiple languages", "Multiple languages" },
                                    { "vmu", "Muluridyi", "Muluridyi" },
                                    { "kqa", "Mum", "Mum" },
                                    { "mzm", "Mumuye", "Mumuye" },
                                    { "mnb", "Muna", "Muna" },
                                    { "unx", "Munda", "Munda" },
                                    { "boe", "Mundabli", "Mundabli" },
                                    { "mua", "Mundang", "Mundang" },
                                    { "mnf", "Mundani", "Mundani" },
                                    { "unr", "Mundari", "Mundari" },
                                    { "mmf", "Mundat", "Mundat" },
                                    { "muh", "Mündü", "Mündü" },
                                    { "myu", "Mundurukú", "Mundurukú" },
                                    { "mhk", "Mungaka", "Mungaka" },
                                    { "mth", "Munggui", "Munggui" },
                                    { "mpv", "Mungkip", "Mungkip" },
                                    { "myr", "Muniche", "Muniche" },
                                    { "mtc", "Munit", "Munit" },
                                    { "mnj", "Munji", "Munji" },
                                    { "umu", "Munsee", "Munsee" },
                                    { "mtq", "Muong", "Muong" },
                                    { "asx", "Muratayak", "Muratayak" },
                                    { "emu", "Eastern Muria", "Muria, Eastern" },
                                    { "fmu", "Far Western Muria", "Muria, Far Western" },
                                    { "mut", "Western Muria", "Muria, Western" },
                                    { "mxr", "Murik (Malaysia)", "Murik (Malaysia)" },
                                    { "mtf", "Murik (Papua New Guinea)", "Murik (Papua New Guinea)" },
                                    { "rmh", "Murkim", "Murkim" },
                                    { "mur", "Murle", "Murle" },
                                    { "mwf", "Murrinh-Patha", "Murrinh-Patha" },
                                    { "muz", "Mursi", "Mursi" },
                                    { "mqw", "Murupi", "Murupi" },
                                    { "kxi", "Keningau Murut", "Murut, Keningau" },
                                    { "mvv", "Tagal Murut", "Murut, Tagal" },
                                    { "tih", "Timugon Murut", "Murut, Timugon" },
                                    { "zmu", "Muruwari", "Muruwari" },
                                    { "mmq", "Musak", "Musak" },
                                    { "mmi", "Musar", "Musar" },
                                    { "smm", "Musasa", "Musasa" },
                                    { "mse", "Musey", "Musey" },
                                    { "mug", "Musgu", "Musgu" },
                                    { "xma", "Mushungulu", "Mushungulu" },
                                    { "mui", "Musi", "Musi" },
                                    { "mje", "Muskum", "Muskum" },
                                    { "msu", "Musom", "Musom" },
                                    { "emi", "Mussau-Emira", "Mussau-Emira" },
                                    { "muv", "Muthuvan", "Muthuvan" },
                                    { "tuc", "Mutu", "Mutu" },
                                    { "mvm", "Muya", "Muya" },
                                    { "muy", "Muyang", "Muyang" },
                                    { "kti", "North Muyu", "Muyu, North" },
                                    { "kts", "South Muyu", "Muyu, South" },
                                    { "myw", "Muyuw", "Muyuw" },
                                    { "ymz", "Muzi", "Muzi" },
                                    { "mcj", "Mvanip", "Mvanip" },
                                    { "mxh", "Mvuba", "Mvuba" },
                                    { "sur", "Mwaghavul", "Mwaghavul" },
                                    { "moa", "Mwan", "Mwan" },
                                    { "wmw", "Mwani", "Mwani" },
                                    { "mwa", "Mwatebu", "Mwatebu" },
                                    { "mwe", "Mwera (Chimwera)", "Mwera (Chimwera)" },
                                    { "mjh", "Mwera (Nyasa)", "Mwera (Nyasa)" },
                                    { "mws", "Mwimbi-Muthambi", "Mwimbi-Muthambi" },
                                    { "mye", "Myene", "Myene" },
                                    { "yms", "Mysian", "Mysian" },
                                    { "ngh", "N/u", "N/u" },
                                    { "nbt", "Na", "Na" },
                                    { "nao", "Naaba", "Naaba" },
                                    { "nas", "Naasioi", "Naasioi" },
                                    { "mne", "Naba", "Naba" },
                                    { "naf", "Nabak", "Nabak" },
                                    { "mty", "Nabi", "Nabi" },
                                    { "ncd", "Nachering", "Nachering" },
                                    { "mbj", "Nadëb", "Nadëb" },
                                    { "ndf", "Nadruvian", "Nadruvian" },
                                    { "nfr", "Nafaanra", "Nafaanra" },
                                    { "srf", "Nafi", "Nafi" },
                                    { "nxx", "Nafri", "Nafri" },
                                    { "jbn", "Nafusi", "Nafusi" },
                                    { "nag", "Naga Pidgin", "Naga Pidgin" },
                                    { "nqy", "Akyaung Ari Naga", "Naga, Akyaung Ari" },
                                    { "njm", "Angami Naga", "Naga, Angami" },
                                    { "njo", "Ao Naga", "Naga, Ao" },
                                    { "nbc", "Chang Naga", "Naga, Chang" },
                                    { "nri", "Chokri Naga", "Naga, Chokri" },
                                    { "nct", "Chothe Naga", "Naga, Chothe" },
                                    { "nkf", "Inpui Naga", "Naga, Inpui" },
                                    { "kfw", "Kharam Naga", "Naga, Kharam" },
                                    { "nkh", "Khezha Naga", "Naga, Khezha" },
                                    { "kix", "Khiamniungan Naga", "Naga, Khiamniungan" },
                                    { "nkb", "Khoibu Naga", "Naga, Khoibu" },
                                    { "nxk", "Koki Naga", "Naga, Koki" },
                                    { "nbe", "Konyak Naga", "Naga, Konyak" },
                                    { "nqq", "Kyan-Karyaw Naga", "Naga, Kyan-Karyaw" },
                                    { "lzn", "Leinong Naga", "Naga, Leinong" },
                                    { "njn", "Liangmai Naga", "Naga, Liangmai" },
                                    { "lpn", "Long Phuri Naga", "Naga, Long Phuri" },
                                    { "njh", "Lotha Naga", "Naga, Lotha" },
                                    { "jmn", "Makuri Naga", "Naga, Makuri" },
                                    { "umn", "Makyan Naga", "Naga, Makyan" },
                                    { "nbi", "Mao Naga", "Naga, Mao" },
                                    { "nma", "Maram Naga", "Naga, Maram" },
                                    { "nng", "Maring Naga", "Naga, Maring" },
                                    { "nmh", "Monsang Naga", "Naga, Monsang" },
                                    { "nmo", "Moyon Naga", "Naga, Moyon" },
                                    { "nme", "Mzieme Naga", "Naga, Mzieme" },
                                    { "njb", "Nocte Naga", "Naga, Nocte" },
                                    { "nnl", "Northern Rengma Naga", "Naga, Northern Rengma" },
                                    { "pzn", "Para Naga", "Naga, Para" },
                                    { "nph", "Phom Naga", "Naga, Phom" },
                                    { "npo", "Pochuri Naga", "Naga, Pochuri" },
                                    { "npg", "Ponyo-Gongwang Naga", "Naga, Ponyo-Gongwang" },
                                    { "pmx", "Poumei Naga", "Naga, Poumei" },
                                    { "npu", "Puimei Naga", "Naga, Puimei" },
                                    { "puz", "Purum Naga", "Naga, Purum" },
                                    { "nbu", "Rongmei Naga", "Naga, Rongmei" },
                                    { "nsa", "Sangtam Naga", "Naga, Sangtam" },
                                    { "nre", "Southern Rengma Naga", "Naga, Southern Rengma" },
                                    { "nsm", "Sumi Naga", "Naga, Sumi" },
                                    { "nmf", "Tangkhul Naga (India)", "Naga, Tangkhul (India)" },
                                    { "ntx", "Tangkhul Naga (Myanmar)", "Naga, Tangkhul (Myanmar)" },
                                    { "tro", "Tarao Naga", "Naga, Tarao" },
                                    { "nst", "Tase Naga", "Naga, Tase" },
                                    { "nki", "Thangal Naga", "Naga, Thangal" },
                                    { "tvt", "Tutsa Naga", "Naga, Tutsa" },
                                    { "nnp", "Wancho Naga", "Naga, Wancho" },
                                    { "yim", "Yimchungru Naga", "Naga, Yimchungru" },
                                    { "nzm", "Zeme Naga", "Naga, Zeme" },
                                    { "nbg", "Nagarchal", "Nagarchal" },
                                    { "nxe", "Nage", "Nage" },
                                    { "xkb", "Northern Nago", "Nago, Northern" },
                                    { "nqg", "Southern Nago", "Nago, Southern" },
                                    { "ngv", "Nagumi", "Nagumi" },
                                    { "nlx", "Nahali", "Nahali" },
                                    { "nhh", "Nahari", "Nahari" },
                                    { "nhn", "Central Nahuatl", "Nahuatl, Central" },
                                    { "nch", "Central Huasteca Nahuatl", "Nahuatl, Central Huasteca" },
                                    { "ncx", "Central Puebla Nahuatl", "Nahuatl, Central Puebla" },
                                    { "nci", "Classical Nahuatl", "Nahuatl, Classical" },
                                    { "naz", "Coatepec Nahuatl", "Nahuatl, Coatepec" },
                                    { "azd", "Eastern Durango Nahuatl", "Nahuatl, Eastern Durango" },
                                    { "nhe", "Eastern Huasteca Nahuatl", "Nahuatl, Eastern Huasteca" },
                                    { "ngu", "Guerrero Nahuatl", "Nahuatl, Guerrero" },
                                    { "azz", "Highland Puebla Nahuatl", "Nahuatl, Highland Puebla" },
                                    { "nhq", "Huaxcaleca Nahuatl", "Nahuatl, Huaxcaleca" },
                                    { "nhk", "Isthmus-Cosoleacaque Nahuatl", "Nahuatl, Isthmus-Cosoleacaque" },
                                    { "nhx", "Isthmus-Mecayapan Nahuatl", "Nahuatl, Isthmus-Mecayapan" },
                                    { "nhp", "Isthmus-Pajapan Nahuatl", "Nahuatl, Isthmus-Pajapan" },
                                    { "ncl", "Michoacán Nahuatl", "Nahuatl, Michoacán" },
                                    { "nhm", "Morelos Nahuatl", "Nahuatl, Morelos" },
                                    { "nhy", "Northern Oaxaca Nahuatl", "Nahuatl, Northern Oaxaca" },
                                    { "ncj", "Northern Puebla Nahuatl", "Nahuatl, Northern Puebla" },
                                    { "nht", "Ometepec Nahuatl", "Nahuatl, Ometepec" },
                                    { "nlv", "Orizaba Nahuatl", "Nahuatl, Orizaba" },
                                    { "nhz", "Santa María La Alta Nahuatl", "Nahuatl, Santa María La Alta" },
                                    { "nsu", "Sierra Negra Nahuatl", "Nahuatl, Sierra Negra" },
                                    { "npl", "Southeastern Puebla Nahuatl", "Nahuatl, Southeastern Puebla" },
                                    { "nhc", "Tabasco Nahuatl", "Nahuatl, Tabasco" },
                                    { "nhv", "Temascaltepec Nahuatl", "Nahuatl, Temascaltepec" },
                                    { "nhg", "Tetelcingo Nahuatl", "Nahuatl, Tetelcingo" },
                                    { "nuz", "Tlamacazapa Nahuatl", "Nahuatl, Tlamacazapa" },
                                    { "azn", "Western Durango Nahuatl", "Nahuatl, Western Durango" },
                                    { "nhw", "Western Huasteca Nahuatl", "Nahuatl, Western Huasteca" },
                                    { "nhi", "Zacatlán-Ahuacatlán-Tepetzintla Nahuatl", "Nahuatl, Zacatlán-Ahuacatlán-Tepetzintla" },
                                    { "bio", "Nai", "Nai" },
                                    { "nae", "Naka'ela", "Naka'ela" },
                                    { "nkj", "Nakai", "Nakai" },
                                    { "nib", "Nakame", "Nakame" },
                                    { "nak", "Nakanai", "Nakanai" },
                                    { "nck", "Nakara", "Nakara" },
                                    { "nbk", "Nake", "Nake" },
                                    { "mff", "Naki", "Naki" },
                                    { "nax", "Nakwi", "Nakwi" },
                                    { "nlc", "Nalca", "Nalca" },
                                    { "nss", "Nali", "Nali" },
                                    { "nal", "Nalik", "Nalik" },
                                    { "nlz", "Nalögo", "Nalögo" },
                                    { "naj", "Nalu", "Nalu" },
                                    { "naq", "Nama (Namibia)", "Nama (Namibia)" },
                                    { "nmx", "Nama (Papua New Guinea)", "Nama (Papua New Guinea)" },
                                    { "nmk", "Namakura", "Namakura" },
                                    { "nkm", "Namat", "Namat" },
                                    { "nmb", "Big Nambas", "Nambas, Big" },
                                    { "nab", "Southern Nambikuára", "Nambikuára, Southern" },
                                    { "ncm", "Nambo", "Nambo" },
                                    { "nmq", "Nambya", "Nambya" },
                                    { "neo", "Ná-Meo", "Ná-Meo" },
                                    { "nnm", "Namia", "Namia" },
                                    { "nvm", "Namiae", "Namiae" },
                                    { "nbs", "Namibian Sign Language", "Namibian Sign Language" },
                                    { "naa", "Namla", "Namla" },
                                    { "mxw", "Namo", "Namo" },
                                    { "nmt", "Namonuito", "Namonuito" },
                                    { "bwb", "Namosi-Naitasiri-Serua", "Namosi-Naitasiri-Serua" },
                                    { "nmy", "Namuyi", "Namuyi" },
                                    { "gld", "Nanai", "Nanai" },
                                    { "nnc", "Nancere", "Nancere" },
                                    { "nnb", "Nande", "Nande" },
                                    { "niq", "Nandi", "Nandi" },
                                    { "nnk", "Nankina", "Nankina" },
                                    { "cox", "Nanti", "Nanti" },
                                    { "nnt", "Nanticoke", "Nanticoke" },
                                    { "afk", "Nanubae", "Nanubae" },
                                    { "npy", "Napu", "Napu" },
                                    { "npa", "Nar Phu", "Nar Phu" },
                                    { "nrb", "Nara", "Nara" },
                                    { "nac", "Narak", "Narak" },
                                    { "nrg", "Narango", "Narango" },
                                    { "nxu", "Narau", "Narau" },
                                    { "loh", "Narim", "Narim" },
                                    { "rnr", "NariNari", "NariNari" },
                                    { "nhr", "Naro", "Naro" },
                                    { "nrm", "Narom", "Narom" },
                                    { "xnt", "Narragansett", "Narragansett" },
                                    { "nay", "Narrinyeri", "Narrinyeri" },
                                    { "nru", "Narua", "Narua" },
                                    { "nnr", "Narungga", "Narungga" },
                                    { "nsy", "Nasal", "Nasal" },
                                    { "nvh", "Nasarian", "Nasarian" },
                                    { "nsk", "Naskapi", "Naskapi" },
                                    { "ywu", "Wumeng Nasu", "Nasu, Wumeng" },
                                    { "yig", "Wusa Nasu", "Nasu, Wusa" },
                                    { "nts", "Natagaimas", "Natagaimas" },
                                    { "ntz", "Natanzi", "Natanzi" },
                                    { "ncz", "Natchez", "Natchez" },
                                    { "ntm", "Nateni", "Nateni" },
                                    { "nte", "Nathembo", "Nathembo" },
                                    { "nti", "Natioro", "Natioro" },
                                    { "ntu", "Natügu", "Natügu" },
                                    { "nxa", "Nauete", "Nauete" },
                                    { "ncn", "Nauna", "Nauna" },
                                    { "nwo", "Nauo", "Nauo" },
                                    { "nau", "Nauru", "Nauru" },
                                    { "nav", "Navaho", "Navaho" },
                                    { "nsw", "Navut", "Navut" },
                                    { "nwr", "Nawaru", "Nawaru" },
                                    { "nwa", "Nawathinehena", "Nawathinehena" },
                                    { "nmz", "Nawdm", "Nawdm" },
                                    { "naw", "Nawuri", "Nawuri" },
                                    { "nxq", "Naxi", "Naxi" },
                                    { "noz", "Nayi", "Nayi" },
                                    { "nyq", "Nayini", "Nayini" },
                                    { "ncr", "Ncane", "Ncane" },
                                    { "nlu", "Nchumbulu", "Nchumbulu" },
                                    { "gke", "Ndai", "Ndai" },
                                    { "ndk", "Ndaka", "Ndaka" },
                                    { "ncp", "Ndaktup", "Ndaktup" },
                                    { "ndh", "Ndali", "Ndali" },
                                    { "ndm", "Ndam", "Ndam" },
                                    { "ndj", "Ndamba", "Ndamba" },
                                    { "nnz", "Nda'nda'", "Nda'nda'" },
                                    { "nda", "Ndasa", "Ndasa" },
                                    { "ndc", "Ndau", "Ndau" },
                                    { "nde", "North Ndebele", "Ndebele, North" },
                                    { "nbl", "South Ndebele", "Ndebele, South" },
                                    { "ned", "Nde-Gbite", "Nde-Gbite" },
                                    { "nml", "Ndemli", "Ndemli" },
                                    { "dne", "Ndendeule", "Ndendeule" },
                                    { "ndg", "Ndengereko", "Ndengereko" },
                                    { "ndd", "Nde-Nsele-Nta", "Nde-Nsele-Nta" },
                                    { "eli", "Nding", "Nding" },
                                    { "ndp", "Ndo", "Ndo" },
                                    { "ndw", "Ndobo", "Ndobo" },
                                    { "nbb", "Ndoe", "Ndoe" },
                                    { "ndz", "Ndogo", "Ndogo" },
                                    { "ndl", "Ndolo", "Ndolo" },
                                    { "nqm", "Ndom", "Ndom" },
                                    { "ndq", "Ndombe", "Ndombe" },
                                    { "njd", "Ndonde Hamba", "Ndonde Hamba" },
                                    { "ndo", "Ndonga", "Ndonga" },
                                    { "ndr", "Ndoola", "Ndoola" },
                                    { "dgt", "Ndrag'ngith", "Ndrag'ngith" },
                                    { "ndx", "Nduga", "Nduga" },
                                    { "nmd", "Ndumu", "Ndumu" },
                                    { "nuh", "Ndunda", "Ndunda" },
                                    { "ndt", "Ndunga", "Ndunga" },
                                    { "ndv", "Ndut", "Ndut" },
                                    { "njt", "Ndyuka-Trio Pidgin", "Ndyuka-Trio Pidgin" },
                                    { "nap", "Neapolitan", "Neapolitan" },
                                    { "nec", "Nedebang", "Nedebang" },
                                    { "nef", "Nefamese", "Nefamese" },
                                    { "dcr", "Negerhollands", "Negerhollands" },
                                    { "zmi", "Negeri Sembilan Malay", "Negeri Sembilan Malay" },
                                    { "neg", "Negidal", "Negidal" },
                                    { "nsn", "Nehan", "Nehan" },
                                    { "nif", "Nek", "Nek" },
                                    { "nkg", "Nekgini", "Nekgini" },
                                    { "nej", "Neko", "Neko" },
                                    { "nek", "Neku", "Neku" },
                                    { "nee", "Nêlêmwa-Nixumwak", "Nêlêmwa-Nixumwak" },
                                    { "nex", "Neme", "Neme" },
                                    { "nem", "Nemi", "Nemi" },
                                    { "nqn", "Nen", "Nen" },
                                    { "anh", "Nend", "Nend" },
                                    { "yrk", "Nenets", "Nenets" },
                                    { "nen", "Nengone", "Nengone" },
                                    { "neu", "Neo", "Neo" },
                                    { "aii", "Assyrian Neo-Aramaic", "Neo-Aramaic, Assyrian" },
                                    { "bjf", "Barzani Jewish Neo-Aramaic", "Neo-Aramaic, Barzani Jewish" },
                                    { "bhn", "Bohtan Neo-Aramaic", "Neo-Aramaic, Bohtan" },
                                    { "cld", "Chaldean Neo-Aramaic", "Neo-Aramaic, Chaldean" },
                                    { "amw", "Western Neo-Aramaic", "Neo-Aramaic, Western" },
                                    { "nwc", "Classical Nepal Bhasa", "Nepal Bhasa, Classical" },
                                    { "nsp", "Nepalese Sign Language", "Nepalese Sign Language" },
                                    { "npi", "Nepali (individual language)", "Nepali (individual language)" },
                                    { "nep", "Nepali (macrolanguage)", "Nepali (macrolanguage)" },
                                    { "net", "Nete", "Nete" },
                                    { "nzs", "New Zealand Sign Language", "New Zealand Sign Language" },
                                    { "nwx", "Middle Newar", "Newar, Middle" },
                                    { "new", "Newari", "Newari" },
                                    { "ney", "Neyo", "Neyo" },
                                    { "nez", "Nez Perce", "Nez Perce" },
                                    { "ntj", "Ngaanyatjarra", "Ngaanyatjarra" },
                                    { "gym", "Ngäbere", "Ngäbere" },
                                    { "nxg", "Ngad'a", "Ngad'a" },
                                    { "nea", "Eastern Ngad'a", "Ngad'a, Eastern" },
                                    { "nju", "Ngadjunmaya", "Ngadjunmaya" },
                                    { "jui", "Ngadjuri", "Ngadjuri" },
                                    { "nnf", "Ngaing", "Ngaing" },
                                    { "nij", "Ngaju", "Ngaju" },
                                    { "nud", "Ngala", "Ngala" },
                                    { "nig", "Ngalakan", "Ngalakan" },
                                    { "ngk", "Ngalkbun", "Ngalkbun" },
                                    { "szb", "Ngalum", "Ngalum" },
                                    { "nmc", "Ngam", "Ngam" },
                                    { "nbv", "Ngamambo", "Ngamambo" },
                                    { "sba", "Ngambay", "Ngambay" },
                                    { "nmv", "Ngamini", "Ngamini" },
                                    { "nbh", "Ngamo", "Ngamo" },
                                    { "nio", "Nganasan", "Nganasan" },
                                    { "nid", "Ngandi", "Ngandi" },
                                    { "ngd", "Ngando (Central African Republic)", "Ngando (Central African Republic)" },
                                    { "nxd", "Ngando (Democratic Republic of Congo)", "Ngando (Democratic Republic of Congo)" },
                                    { "nne", "Ngandyera", "Ngandyera" },
                                    { "gng", "Ngangam", "Ngangam" },
                                    { "nam", "Ngan'gityemerri", "Ngan'gityemerri" },
                                    { "nyx", "Nganyaywana", "Nganyaywana" },
                                    { "nbj", "Ngarinman", "Ngarinman" },
                                    { "ung", "Ngarinyin", "Ngarinyin" },
                                    { "nlr", "Ngarla", "Ngarla" },
                                    { "nrl", "Ngarluma", "Ngarluma" },
                                    { "anc", "Ngas", "Ngas" },
                                    { "nsg", "Ngasa", "Ngasa" },
                                    { "ngm", "Ngatik Men's Creole", "Ngatik Men's Creole" },
                                    { "nxn", "Ngawun", "Ngawun" },
                                    { "nwg", "Ngayawung", "Ngayawung" },
                                    { "nga", "Ngbaka", "Ngbaka" },
                                    { "nbm", "Ngbaka Ma'bo", "Ngbaka Ma'bo" },
                                    { "ngg", "Ngbaka Manza", "Ngbaka Manza" },
                                    { "ngb", "Northern Ngbandi", "Ngbandi, Northern" },
                                    { "nbw", "Southern Ngbandi", "Ngbandi, Southern" },
                                    { "jgb", "Ngbee", "Ngbee" },
                                    { "nbd", "Ngbinda", "Ngbinda" },
                                    { "nuu", "Ngbundu", "Ngbundu" },
                                    { "agh", "Ngelima", "Ngelima" },
                                    { "nge", "Ngemba", "Ngemba" },
                                    { "ngt", "Ngeq", "Ngeq" },
                                    { "nnn", "Ngete", "Ngete" },
                                    { "nbq", "Nggem", "Nggem" },
                                    { "ngx", "Nggwahyi", "Nggwahyi" },
                                    { "ngj", "Ngie", "Ngie" },
                                    { "nnh", "Ngiemboon", "Ngiemboon" },
                                    { "jle", "Ngile", "Ngile" },
                                    { "nnq", "Ngindo", "Ngindo" },
                                    { "niy", "Ngiti", "Ngiti" },
                                    { "ngi", "Ngizim", "Ngizim" },
                                    { "nra", "Ngom", "Ngom" },
                                    { "jgo", "Ngomba", "Ngomba" },
                                    { "nla", "Ngombale", "Ngombale" },
                                    { "nmj", "Ngombe (Central African Republic)", "Ngombe (Central African Republic)" },
                                    { "ngc", "Ngombe (Democratic Republic of Congo)", "Ngombe (Democratic Republic of Congo)" },
                                    { "nnx", "Ngong", "Ngong" },
                                    { "noq", "Ngongo", "Ngongo" },
                                    { "ngo", "Ngoni", "Ngoni" },
                                    { "ngq", "Ngoreme", "Ngoreme" },
                                    { "nsh", "Ngoshie", "Ngoshie" },
                                    { "nlo", "Ngul", "Ngul" },
                                    { "ngp", "Ngulu", "Ngulu" },
                                    { "nuw", "Nguluwan", "Nguluwan" },
                                    { "nui", "Ngumbi", "Ngumbi" },
                                    { "ndn", "Ngundi", "Ngundi" },
                                    { "nue", "Ngundu", "Ngundu" },
                                    { "ngz", "Ngungwel", "Ngungwel" },
                                    { "nuo", "Nguôn", "Nguôn" },
                                    { "nbx", "Ngura", "Ngura" },
                                    { "nrx", "Ngurmbur", "Ngurmbur" },
                                    { "ngw", "Ngwaba", "Ngwaba" },
                                    { "nwe", "Ngwe", "Ngwe" },
                                    { "ngn", "Ngwo", "Ngwo" },
                                    { "nha", "Nhanda", "Nhanda" },
                                    { "yrl", "Nhengatu", "Nhengatu" },
                                    { "nhf", "Nhuwala", "Nhuwala" },
                                    { "nia", "Nias", "Nias" },
                                    { "ncs", "Nicaraguan Sign Language", "Nicaraguan Sign Language" },
                                    { "caq", "Car Nicobarese", "Nicobarese, Car" },
                                    { "ncb", "Central Nicobarese", "Nicobarese, Central" },
                                    { "nik", "Southern Nicobarese", "Nicobarese, Southern" },
                                    { "nie", "Niellim", "Niellim" },
                                    { "nsi", "Nigerian Sign Language", "Nigerian Sign Language" },
                                    { "nll", "Nihali", "Nihali" },
                                    { "nii", "Nii", "Nii" },
                                    { "nad", "Nijadali", "Nijadali" },
                                    { "gbe", "Niksek", "Niksek" },
                                    { "nil", "Nila", "Nila" },
                                    { "nim", "Nilamba", "Nilamba" },
                                    { "noe", "Nimadi", "Nimadi" },
                                    { "nmp", "Nimanbur", "Nimanbur" },
                                    { "nmr", "Nimbari", "Nimbari" },
                                    { "nir", "Nimboran", "Nimboran" },
                                    { "nis", "Nimi", "Nimi" },
                                    { "niw", "Nimo", "Nimo" },
                                    { "nmw", "Nimoa", "Nimoa" },
                                    { "shb", "Ninam", "Ninam" },
                                    { "nxi", "Nindi", "Nindi" },
                                    { "nby", "Ningera", "Ningera" },
                                    { "nxr", "Ninggerum", "Ninggerum" },
                                    { "niz", "Ningil", "Ningil" },
                                    { "nns", "Ningye", "Ningye" },
                                    { "nin", "Ninzo", "Ninzo" },
                                    { "nps", "Nipsan", "Nipsan" },
                                    { "njs", "Nisa", "Nisa" },
                                    { "nsz", "Nisenan", "Nisenan" },
                                    { "ncg", "Nisga'a", "Nisga'a" },
                                    { "yso", "Nisi (China)", "Nisi (China)" },
                                    { "nos", "Eastern Nisu", "Nisu, Eastern" },
                                    { "yiv", "Northern Nisu", "Nisu, Northern" },
                                    { "nsf", "Northwestern Nisu", "Nisu, Northwestern" },
                                    { "nsd", "Southern Nisu", "Nisu, Southern" },
                                    { "nsv", "Southwestern Nisu", "Nisu, Southwestern" },
                                    { "num", "Niuafo'ou", "Niuafo'ou" },
                                    { "nkp", "Niuatoputapu", "Niuatoputapu" },
                                    { "niu", "Niuean", "Niuean" },
                                    { "cag", "Nivaclé", "Nivaclé" },
                                    { "njl", "Njalgulgule", "Njalgulgule" },
                                    { "nzb", "Njebi", "Njebi" },
                                    { "njj", "Njen", "Njen" },
                                    { "njr", "Njerep", "Njerep" },
                                    { "njy", "Njyem", "Njyem" },
                                    { "nkq", "Nkami", "Nkami" },
                                    { "nkn", "Nkangala", "Nkangala" },
                                    { "nkz", "Nkari", "Nkari" },
                                    { "isi", "Nkem-Nkum", "Nkem-Nkum" },
                                    { "khu", "Nkhumbi", "Nkhumbi" },
                                    { "nqo", "N'Ko", "N'Ko" },
                                    { "nkc", "Nkongho", "Nkongho" },
                                    { "nko", "Nkonya", "Nkonya" },
                                    { "nkx", "Nkoroo", "Nkoroo" },
                                    { "nka", "Nkoya", "Nkoya" },
                                    { "nbo", "Nkukoli", "Nkukoli" },
                                    { "nkw", "Nkutu", "Nkutu" },
                                    { "nbp", "Nnam", "Nnam" },
                                    { "zxx", "No linguistic content", "No linguistic content" },
                                    { "fia", "Nobiin", "Nobiin" },
                                    { "gaw", "Nobonob", "Nobonob" },
                                    { "nom", "Nocamán", "Nocamán" },
                                    { "nog", "Nogai", "Nogai" },
                                    { "noi", "Noiri", "Noiri" },
                                    { "nkk", "Nokuku", "Nokuku" },
                                    { "lem", "Nomaande", "Nomaande" },
                                    { "nof", "Nomane", "Nomane" },
                                    { "not", "Nomatsiguenga", "Nomatsiguenga" },
                                    { "noh", "Nomu", "Nomu" },
                                    { "noj", "Nonuya", "Nonuya" },
                                    { "nok", "Nooksack", "Nooksack" },
                                    { "snf", "Noon", "Noon" },
                                    { "nhu", "Noone", "Noone" },
                                    { "nrc", "Noric", "Noric" },
                                    { "nrn", "Norn", "Norn" },
                                    { "nrr", "Norra", "Norra" },
                                    { "non", "Old Norse", "Norse, Old" },
                                    { "xna", "Ancient North Arabian", "North Arabian, Ancient" },
                                    { "nor", "Norwegian", "Norwegian" },
                                    { "nob", "Norwegian Bokmål", "Norwegian Bokmål" },
                                    { "nno", "Norwegian Nynorsk", "Norwegian Nynorsk" },
                                    { "nsl", "Norwegian Sign Language", "Norwegian Sign Language" },
                                    { "rmg", "Traveller Norwegian", "Norwegian, Traveller" },
                                    { "bly", "Notre", "Notre" },
                                    { "ncf", "Notsi", "Notsi" },
                                    { "ntw", "Nottoway", "Nottoway" },
                                    { "nwy", "Nottoway-Meherrin", "Nottoway-Meherrin" },
                                    { "nov", "Novial", "Novial" },
                                    { "noy", "Noy", "Noy" },
                                    { "asj", "Nsari", "Nsari" },
                                    { "nse", "Nsenga", "Nsenga" },
                                    { "nsc", "Nshi", "Nshi" },
                                    { "nsx", "Nsongo", "Nsongo" },
                                    { "bud", "Ntcham", "Ntcham" },
                                    { "nto", "Ntomba", "Ntomba" },
                                    { "nni", "North Nuaulu", "Nuaulu, North" },
                                    { "nxl", "South Nuaulu", "Nuaulu, South" },
                                    { "baf", "Nubaca", "Nubaca" },
                                    { "kcn", "Nubi", "Nubi" },
                                    { "onw", "Old Nubian", "Nubian, Old" },
                                    { "kte", "Nubri", "Nubri" },
                                    { "nus", "Nuer", "Nuer" },
                                    { "nnv", "Nugunu (Australia)", "Nugunu (Australia)" },
                                    { "yas", "Nugunu (Cameroon)", "Nugunu (Cameroon)" },
                                    { "noc", "Nuk", "Nuk" },
                                    { "mbr", "Nukak Makú", "Nukak Makú" },
                                    { "klt", "Nukna", "Nukna" },
                                    { "nuc", "Nukuini", "Nukuini" },
                                    { "nuq", "Nukumanu", "Nukumanu" },
                                    { "nkr", "Nukuoro", "Nukuoro" },
                                    { "nur", "Nukuria", "Nukuria" },
                                    { "nbr", "Numana-Nunku-Gbantu-Numbu", "Numana-Nunku-Gbantu-Numbu" },
                                    { "nop", "Numanggang", "Numanggang" },
                                    { "sij", "Numbami", "Numbami" },
                                    { "tgs", "Nume", "Nume" },
                                    { "kdk", "Numee", "Numee" },
                                    { "nxm", "Numidian", "Numidian" },
                                    { "nut", "Nung (Viet Nam)", "Nung (Viet Nam)" },
                                    { "nug", "Nungali", "Nungali" },
                                    { "nuy", "Nunggubuyu", "Nunggubuyu" },
                                    { "rin", "Nungu", "Nungu" },
                                    { "nuv", "Northern Nuni", "Nuni, Northern" },
                                    { "nnw", "Southern Nuni", "Nuni, Southern" },
                                    { "npb", "Nupbikha", "Nupbikha" },
                                    { "nup", "Nupe-Nupe-Tako", "Nupe-Nupe-Tako" },
                                    { "nul", "Nusa Laut", "Nusa Laut" },
                                    { "nuf", "Nusu", "Nusu" },
                                    { "nuk", "Nuuchahnulth", "Nuuchahnulth" },
                                    { "nwb", "Nyabwa", "Nyabwa" },
                                    { "nev", "Nyaheun", "Nyaheun" },
                                    { "cbn", "Nyahkur", "Nyahkur" },
                                    { "nyy", "Nyakyusa-Ngonde", "Nyakyusa-Ngonde" },
                                    { "nle", "East Nyala", "Nyala, East" },
                                    { "yly", "Nyâlayu", "Nyâlayu" },
                                    { "nlj", "Nyali", "Nyali" },
                                    { "nmi", "Nyam", "Nyam" },
                                    { "nly", "Nyamal", "Nyamal" },
                                    { "now", "Nyambo", "Nyambo" },
                                    { "nwm", "Nyamusa-Molo", "Nyamusa-Molo" },
                                    { "mwn", "Nyamwanga", "Nyamwanga" },
                                    { "nym", "Nyamwezi", "Nyamwezi" },
                                    { "nyk", "Nyaneka", "Nyaneka" },
                                    { "nyj", "Nyanga", "Nyanga" },
                                    { "nyc", "Nyanga-li", "Nyanga-li" },
                                    { "nnj", "Nyangatom", "Nyangatom" },
                                    { "nyb", "Nyangbo", "Nyangbo" },
                                    { "nny", "Nyangga", "Nyangga" },
                                    { "nyp", "Nyang'i", "Nyang'i" },
                                    { "nna", "Nyangumarta", "Nyangumarta" },
                                    { "nyn", "Nyankole", "Nyankole" },
                                    { "yes", "Nyankpa", "Nyankpa" },
                                    { "rim", "Nyaturu", "Nyaturu" },
                                    { "nyw", "Nyaw", "Nyaw" },
                                    { "nyt", "Nyawaygi", "Nyawaygi" },
                                    { "nba", "Nyemba", "Nyemba" },
                                    { "nye", "Nyengo", "Nyengo" },
                                    { "neh", "Nyenkha", "Nyenkha" },
                                    { "nyl", "Nyeu", "Nyeu" },
                                    { "nyh", "Nyigina", "Nyigina" },
                                    { "nyr", "Nyiha (Malawi)", "Nyiha (Malawi)" },
                                    { "nih", "Nyiha (Tanzania)", "Nyiha (Tanzania)" },
                                    { "nkv", "Nyika (Malawi and Zambia)", "Nyika (Malawi and Zambia)" },
                                    { "nkt", "Nyika (Tanzania)", "Nyika (Tanzania)" },
                                    { "lid", "Nyindrou", "Nyindrou" },
                                    { "nyg", "Nyindu", "Nyindu" },
                                    { "njz", "Nyishi", "Nyishi" },
                                    { "nvo", "Nyokon", "Nyokon" },
                                    { "nuj", "Nyole", "Nyole" },
                                    { "muo", "Nyong", "Nyong" },
                                    { "nyd", "Nyore", "Nyore" },
                                    { "nyo", "Nyoro", "Nyoro" },
                                    { "nyv", "Nyulnyul", "Nyulnyul" },
                                    { "nys", "Nyunga", "Nyunga" },
                                    { "nyu", "Nyungwe", "Nyungwe" },
                                    { "nzy", "Nzakambay", "Nzakambay" },
                                    { "nzk", "Nzakara", "Nzakara" },
                                    { "nja", "Nzanyi", "Nzanyi" },
                                    { "nzi", "Nzima", "Nzima" },
                                    { "oun", "O!ung", "O!ung" },
                                    { "bzy", "Obanliku", "Obanliku" },
                                    { "obi", "Obispeño", "Obispeño" },
                                    { "obl", "Oblo", "Oblo" },
                                    { "afz", "Obokuitai", "Obokuitai" },
                                    { "ann", "Obolo", "Obolo" },
                                    { "obu", "Obulom", "Obulom" },
                                    { "oca", "Ocaina", "Ocaina" },
                                    { "oci", "Occitan (post 1500)", "Occitan (post 1500)" },
                                    { "xoc", "O'chi'chi'", "O'chi'chi'" },
                                    { "odk", "Od", "Od" },
                                    { "bhf", "Odiai", "Odiai" },
                                    { "kkc", "Odoodee", "Odoodee" },
                                    { "tyh", "O'du", "O'du" },
                                    { "odu", "Odual", "Odual" },
                                    { "oda", "Odut", "Odut" },
                                    { "opy", "Ofayé", "Ofayé" },
                                    { "ofo", "Ofo", "Ofo" },
                                    { "ogc", "Ogbah", "Ogbah" },
                                    { "ogb", "Ogbia", "Ogbia" },
                                    { "ogg", "Ogbogolo", "Ogbogolo" },
                                    { "ogu", "Ogbronuagum", "Ogbronuagum" },
                                    { "eri", "Ogea", "Ogea" },
                                    { "cst", "Northern Ohlone", "Ohlone, Northern" },
                                    { "css", "Southern Ohlone", "Ohlone, Southern" },
                                    { "xal", "Oirat", "Oirat" },
                                    { "xwo", "Written Oirat", "Oirat, Written" },
                                    { "oia", "Oirata", "Oirata" },
                                    { "oji", "Ojibwa", "Ojibwa" },
                                    { "ojc", "Central Ojibwa", "Ojibwa, Central" },
                                    { "ojg", "Eastern Ojibwa", "Ojibwa, Eastern" },
                                    { "ojb", "Northwestern Ojibwa", "Ojibwa, Northwestern" },
                                    { "ojs", "Severn Ojibwa", "Ojibwa, Severn" },
                                    { "ojw", "Western Ojibwa", "Ojibwa, Western" },
                                    { "oka", "Okanagan", "Okanagan" },
                                    { "oki", "Okiek", "Okiek" },
                                    { "ryu", "Central Okinawan", "Okinawan, Central" },
                                    { "okn", "Oki-No-Erabu", "Oki-No-Erabu" },
                                    { "okb", "Okobo", "Okobo" },
                                    { "okd", "Okodia", "Okodia" },
                                    { "oks", "Oko-Eni-Osayen", "Oko-Eni-Osayen" },
                                    { "okj", "Oko-Juwoi", "Oko-Juwoi" },
                                    { "kqv", "Okolod", "Okolod" },
                                    { "opa", "Okpamheri", "Okpamheri" },
                                    { "okx", "Okpe (Northwestern Edo)", "Okpe (Northwestern Edo)" },
                                    { "oke", "Okpe (Southwestern Edo)", "Okpe (Southwestern Edo)" },
                                    { "opm", "Oksapmin", "Oksapmin" },
                                    { "oku", "Oku", "Oku" },
                                    { "ole", "Olekha", "Olekha" },
                                    { "ong", "Olo", "Olo" },
                                    { "olm", "Oloma", "Oloma" },
                                    { "olr", "Olrat", "Olrat" },
                                    { "lul", "Olu'bo", "Olu'bo" },
                                    { "iko", "Olulumo-Ikom", "Olulumo-Ikom" },
                                    { "lsm", "Olusamia", "Olusamia" },
                                    { "lto", "Olutsotso", "Olutsotso" },
                                    { "lwg", "Oluwanga", "Oluwanga" },
                                    { "omg", "Omagua", "Omagua" },
                                    { "oma", "Omaha-Ponca", "Omaha-Ponca" },
                                    { "mbm", "Ombamba", "Ombamba" },
                                    { "oml", "Ombo", "Ombo" },
                                    { "ome", "Omejes", "Omejes" },
                                    { "omi", "Omi", "Omi" },
                                    { "aom", "Ömie", "Ömie" },
                                    { "omk", "Omok", "Omok" },
                                    { "omt", "Omotik", "Omotik" },
                                    { "omu", "Omurano", "Omurano" },
                                    { "ona", "Ona", "Ona" },
                                    { "oin", "Inebu One", "One, Inebu" },
                                    { "onk", "Kabore One", "One, Kabore" },
                                    { "okk", "Kwamtim One", "One, Kwamtim" },
                                    { "aun", "Molmo One", "One, Molmo" },
                                    { "onr", "Northern One", "One, Northern" },
                                    { "osu", "Southern One", "One, Southern" },
                                    { "one", "Oneida", "Oneida" },
                                    { "oog", "Ong", "Ong" },
                                    { "oon", "Önge", "Önge" },
                                    { "oni", "Onin", "Onin" },
                                    { "onx", "Onin Based Pidgin", "Onin Based Pidgin" },
                                    { "onj", "Onjob", "Onjob" },
                                    { "ons", "Ono", "Ono" },
                                    { "onn", "Onobasulu", "Onobasulu" },
                                    { "ono", "Onondaga", "Onondaga" },
                                    { "ont", "Ontenu", "Ontenu" },
                                    { "ojv", "Ontong Java", "Ontong Java" },
                                    { "oor", "Oorlams", "Oorlams" },
                                    { "opo", "Opao", "Opao" },
                                    { "opt", "Opata", "Opata" },
                                    { "lgn", "Opuuo", "Opuuo" },
                                    { "orn", "Orang Kanaq", "Orang Kanaq" },
                                    { "ors", "Orang Seletar", "Orang Seletar" },
                                    { "ore", "Orejón", "Orejón" },
                                    { "org", "Oring", "Oring" },
                                    { "ory", "Oriya (individual language)", "Oriya (individual language)" },
                                    { "ori", "Oriya (macrolanguage)", "Oriya (macrolanguage)" },
                                    { "ort", "Adivasi Oriya", "Oriya, Adivasi" },
                                    { "orc", "Orma", "Orma" },
                                    { "orz", "Ormu", "Ormu" },
                                    { "oru", "Ormuri", "Ormuri" },
                                    { "orx", "Oro", "Oro" },
                                    { "orw", "Oro Win", "Oro Win" },
                                    { "oac", "Oroch", "Oroch" },
                                    { "ora", "Oroha", "Oroha" },
                                    { "oaa", "Orok", "Orok" },
                                    { "okv", "Orokaiva", "Orokaiva" },
                                    { "bdu", "Oroko", "Oroko" },
                                    { "oro", "Orokolo", "Orokolo" },
                                    { "orm", "Oromo", "Oromo" },
                                    { "gax", "Borana-Arsi-Guji Oromo", "Oromo, Borana-Arsi-Guji" },
                                    { "hae", "Eastern Oromo", "Oromo, Eastern" },
                                    { "gaz", "West Central Oromo", "Oromo, West Central" },
                                    { "orh", "Oroqen", "Oroqen" },
                                    { "bpk", "Orowe", "Orowe" },
                                    { "orr", "Oruma", "Oruma" },
                                    { "ury", "Orya", "Orya" },
                                    { "osa", "Osage", "Osage" },
                                    { "ost", "Osatu", "Osatu" },
                                    { "osc", "Oscan", "Oscan" },
                                    { "osi", "Osing", "Osing" },
                                    { "oso", "Ososo", "Ososo" },
                                    { "oss", "Ossetian", "Ossetian" },
                                    { "oos", "Old Ossetic", "Ossetic, Old" },
                                    { "otd", "Ot Danum", "Ot Danum" },
                                    { "uta", "Otank", "Otank" },
                                    { "oti", "Oti", "Oti" },
                                    { "otm", "Eastern Highland Otomi", "Otomi, Eastern Highland" },
                                    { "ots", "Estado de México Otomi", "Otomi, Estado de México" },
                                    { "otz", "Ixtenco Otomi", "Otomi, Ixtenco" },
                                    { "ote", "Mezquital Otomi", "Otomi, Mezquital" },
                                    { "otq", "Querétaro Otomi", "Otomi, Querétaro" },
                                    { "ott", "Temoaya Otomi", "Otomi, Temoaya" },
                                    { "otn", "Tenango Otomi", "Otomi, Tenango" },
                                    { "otx", "Texcatepec Otomi", "Otomi, Texcatepec" },
                                    { "otl", "Tilapa Otomi", "Otomi, Tilapa" },
                                    { "otr", "Otoro", "Otoro" },
                                    { "otw", "Ottawa", "Ottawa" },
                                    { "lot", "Otuho", "Otuho" },
                                    { "otu", "Otuke", "Otuke" },
                                    { "oum", "Ouma", "Ouma" },
                                    { "oue", "Oune", "Oune" },
                                    { "stn", "Owa", "Owa" },
                                    { "wsr", "Owenia", "Owenia" },
                                    { "owi", "Owiniga", "Owiniga" },
                                    { "oyb", "Oy", "Oy" },
                                    { "oyy", "Oya'oya", "Oya'oya" },
                                    { "oyd", "Oyda", "Oyda" },
                                    { "pdi", "Pa Di", "Pa Di" },
                                    { "pqa", "Pa'a", "Pa'a" },
                                    { "pfa", "Pááfang", "Pááfang" },
                                    { "drl", "Paakantyi", "Paakantyi" },
                                    { "pma", "Paama", "Paama" },
                                    { "sig", "Paasaal", "Paasaal" },
                                    { "pcp", "Pacahuara", "Pacahuara" },
                                    { "pac", "Pacoh", "Pacoh" },
                                    { "pdo", "Padoe", "Padoe" },
                                    { "pkc", "Paekche", "Paekche" },
                                    { "pgn", "Paelignian", "Paelignian" },
                                    { "pbb", "Páez", "Páez" },
                                    { "pgi", "Pagi", "Pagi" },
                                    { "pae", "Pagibete", "Pagibete" },
                                    { "pgu", "Pagu", "Pagu" },
                                    { "kfx", "Kullu Pahari", "Pahari, Kullu" },
                                    { "bfz", "Mahasu Pahari", "Pahari, Mahasu" },
                                    { "phr", "Pahari-Potwari", "Pahari-Potwari" },
                                    { "lgt", "Pahi", "Pahi" },
                                    { "phv", "Pahlavani", "Pahlavani" },
                                    { "pal", "Pahlavi", "Pahlavi" },
                                    { "pha", "Pa-Hng", "Pa-Hng" },
                                    { "pta", "Pai Tavytera", "Pai Tavytera" },
                                    { "pri", "Paicî", "Paicî" },
                                    { "ppi", "Paipai", "Paipai" },
                                    { "pao", "Northern Paiute", "Paiute, Northern" },
                                    { "pwn", "Paiwan", "Paiwan" },
                                    { "pav", "Pakaásnovos", "Pakaásnovos" },
                                    { "pkn", "Pakanha", "Pakanha" },
                                    { "pks", "Pakistan Sign Language", "Pakistan Sign Language" },
                                    { "pkg", "Pak-Tong", "Pak-Tong" },
                                    { "pku", "Paku", "Paku" },
                                    { "abw", "Pal", "Pal" },
                                    { "plq", "Palaic", "Palaic" },
                                    { "pau", "Palauan", "Palauan" },
                                    { "pce", "Ruching Palaung", "Palaung, Ruching" },
                                    { "rbb", "Rumai Palaung", "Palaung, Rumai" },
                                    { "pll", "Shwe Palaung", "Palaung, Shwe" },
                                    { "plw", "Brooke's Point Palawano", "Palawano, Brooke's Point" },
                                    { "plc", "Central Palawano", "Palawano, Central" },
                                    { "plv", "Southwest Palawano", "Palawano, Southwest" },
                                    { "pln", "Palenquero", "Palenquero" },
                                    { "pli", "Pali", "Pali" },
                                    { "plu", "Palikúr", "Palikúr" },
                                    { "pcf", "Paliyan", "Paliyan" },
                                    { "pmd", "Pallanganmiddang", "Pallanganmiddang" },
                                    { "fap", "Palor", "Palor" },
                                    { "plp", "Palpa", "Palpa" },
                                    { "plz", "Paluan", "Paluan" },
                                    { "ple", "Palu'e", "Palu'e" },
                                    { "phl", "Palula", "Palula" },
                                    { "pmc", "Palumata", "Palumata" },
                                    { "pmn", "Pam", "Pam" },
                                    { "pmb", "Pambia", "Pambia" },
                                    { "pbs", "Central Pame", "Pame, Central" },
                                    { "pmq", "Northern Pame", "Pame, Northern" },
                                    { "pmz", "Southern Pame", "Pame, Southern" },
                                    { "pmk", "Pamlico", "Pamlico" },
                                    { "pmf", "Pamona", "Pamona" },
                                    { "hih", "Pamosu", "Pamosu" },
                                    { "pam", "Pampanga", "Pampanga" },
                                    { "pnq", "Pana (Burkina Faso)", "Pana (Burkina Faso)" },
                                    { "pnz", "Pana (Central African Republic)", "Pana (Central African Republic)" },
                                    { "par", "Panamint", "Panamint" },
                                    { "pcr", "Panang", "Panang" },
                                    { "kre", "Panará", "Panará" },
                                    { "psn", "Panasuan", "Panasuan" },
                                    { "pwb", "Panawa", "Panawa" },
                                    { "pnp", "Pancana", "Pancana" },
                                    { "tdb", "Panchpargania", "Panchpargania" },
                                    { "bkj", "Pande", "Pande" },
                                    { "pag", "Pangasinan", "Pangasinan" },
                                    { "pgs", "Pangseng", "Pangseng" },
                                    { "pbr", "Pangwa", "Pangwa" },
                                    { "pgg", "Pangwali", "Pangwali" },
                                    { "pnr", "Panim", "Panim" },
                                    { "pcg", "Paniya", "Paniya" },
                                    { "pmu", "Mirpur Panjabi", "Panjabi, Mirpur" },
                                    { "pnb", "Western Panjabi", "Panjabi, Western" },
                                    { "pax", "Pankararé", "Pankararé" },
                                    { "paz", "Pankararú", "Pankararú" },
                                    { "pkh", "Pankhu", "Pankhu" },
                                    { "pnc", "Pannei", "Pannei" },
                                    { "mqz", "Pano", "Pano" },
                                    { "xpk", "Kulina Pano", "Pano, Kulina" },
                                    { "pno", "Panobo", "Panobo" },
                                    { "pnw", "Panytyima", "Panytyima" },
                                    { "ppa", "Pao", "Pao" },
                                    { "blk", "Pa'O", "Pa'O" },
                                    { "ppn", "Papapana", "Papapana" },
                                    { "dpp", "Papar", "Papar" },
                                    { "pas", "Papasena", "Papasena" },
                                    { "pbo", "Papel", "Papel" },
                                    { "ppe", "Papi", "Papi" },
                                    { "pap", "Papiamento", "Papiamento" },
                                    { "pat", "Papitalai", "Papitalai" },
                                    { "ppu", "Papora", "Papora" },
                                    { "ppm", "Papuma", "Papuma" },
                                    { "prc", "Parachi", "Parachi" },
                                    { "pys", "Paraguayan Sign Language", "Paraguayan Sign Language" },
                                    { "pak", "Parakanã", "Parakanã" },
                                    { "prf", "Paranan", "Paranan" },
                                    { "paf", "Paranawát", "Paranawát" },
                                    { "pbg", "Paraujano", "Paraujano" },
                                    { "prk", "Parauk", "Parauk" },
                                    { "prw", "Parawen", "Parawen" },
                                    { "pch", "Pardhan", "Pardhan" },
                                    { "pcl", "Pardhi", "Pardhi" },
                                    { "ppt", "Pare", "Pare" },
                                    { "pab", "Parecís", "Parecís" },
                                    { "pcj", "Parenga", "Parenga" },
                                    { "lkr", "Päri", "Päri" },
                                    { "pbi", "Parkwa", "Parkwa" },
                                    { "prp", "Parsi", "Parsi" },
                                    { "prd", "Parsi-Dari", "Parsi-Dari" },
                                    { "xpr", "Parthian", "Parthian" },
                                    { "paq", "Parya", "Parya" },
                                    { "aee", "Northeast Pashayi", "Pashayi, Northeast" },
                                    { "glh", "Northwest Pashayi", "Pashayi, Northwest" },
                                    { "psi", "Southeast Pashayi", "Pashayi, Southeast" },
                                    { "psh", "Southwest Pashayi", "Pashayi, Southwest" },
                                    { "pus", "Pashto", "Pashto" },
                                    { "pst", "Central Pashto", "Pashto, Central" },
                                    { "pbu", "Northern Pashto", "Pashto, Northern" },
                                    { "pbt", "Southern Pashto", "Pashto, Southern" },
                                    { "psq", "Pasi", "Pasi" },
                                    { "pbc", "Patamona", "Patamona" },
                                    { "ptn", "Patani", "Patani" },
                                    { "pth", "Pataxó Hã-Ha-Hãe", "Pataxó Hã-Ha-Hãe" },
                                    { "ptp", "Patep", "Patep" },
                                    { "pty", "Pathiya", "Pathiya" },
                                    { "gfk", "Patpatar", "Patpatar" },
                                    { "lae", "Pattani", "Pattani" },
                                    { "plh", "Paulohi", "Paulohi" },
                                    { "pad", "Paumarí", "Paumarí" },
                                    { "pnk", "Paunaka", "Paunaka" },
                                    { "psm", "Pauserna", "Pauserna" },
                                    { "pwa", "Pawaia", "Pawaia" },
                                    { "paw", "Pawnee", "Pawnee" },
                                    { "pmr", "Paynamar", "Paynamar" },
                                    { "pai", "Pe", "Pe" },
                                    { "pcb", "Pear", "Pear" },
                                    { "pay", "Pech", "Pech" },
                                    { "xpc", "Pecheneg", "Pecheneg" },
                                    { "pfe", "Peere", "Peere" },
                                    { "ppq", "Pei", "Pei" },
                                    { "pel", "Pekal", "Pekal" },
                                    { "bxd", "Pela", "Pela" },
                                    { "ata", "Pele-Ata", "Pele-Ata" },
                                    { "ppp", "Pelende", "Pelende" },
                                    { "aoc", "Pemon", "Pemon" },
                                    { "pev", "Pémono", "Pémono" },
                                    { "pez", "Eastern Penan", "Penan, Eastern" },
                                    { "pne", "Western Penan", "Penan, Western" },
                                    { "psg", "Penang Sign Language", "Penang Sign Language" },
                                    { "pek", "Penchal", "Penchal" },
                                    { "ums", "Pendau", "Pendau" },
                                    { "peg", "Pengo", "Pengo" },
                                    { "pnh", "Penrhyn", "Penrhyn" },
                                    { "ptw", "Pentlatch", "Pentlatch" },
                                    { "wet", "Perai", "Perai" },
                                    { "pip", "Pero", "Pero" },
                                    { "fas", "Persian", "Persian" },
                                    { "psc", "Persian Sign Language", "Persian Sign Language" },
                                    { "prs", "Afghan Persian", "Persian, Afghan" },
                                    { "pes", "Iranian Persian", "Persian, Iranian" },
                                    { "xmn", "Manichaean Middle Persian", "Persian, Manichaean Middle" },
                                    { "peo", "Old Persian (ca. 600-400 B.C.)", "Persian, Old (ca. 600-400 B.C.)" },
                                    { "prl", "Peruvian Sign Language", "Peruvian Sign Language" },
                                    { "pex", "Petats", "Petats" },
                                    { "pey", "Petjo", "Petjo" },
                                    { "lme", "Pévé", "Pévé" },
                                    { "pfl", "Pfaelzisch", "Pfaelzisch" },
                                    { "prt", "Phai", "Phai" },
                                    { "phk", "Phake", "Phake" },
                                    { "ypa", "Phala", "Phala" },
                                    { "phq", "Phana'", "Phana'" },
                                    { "phw", "Phangduwali", "Phangduwali" },
                                    { "pem", "Phende", "Phende" },
                                    { "psp", "Philippine Sign Language", "Philippine Sign Language" },
                                    { "phm", "Phimbi", "Phimbi" },
                                    { "phn", "Phoenician", "Phoenician" },
                                    { "ypg", "Phola", "Phola" },
                                    { "ypo", "Alo Phola", "Phola, Alo" },
                                    { "yip", "Pholo", "Pholo" },
                                    { "pnx", "Phong-Kniang", "Phong-Kniang" },
                                    { "ypn", "Ani Phowa", "Phowa, Ani" },
                                    { "yhl", "Hlepho Phowa", "Phowa, Hlepho" },
                                    { "ypb", "Labo Phowa", "Phowa, Labo" },
                                    { "xpg", "Phrygian", "Phrygian" },
                                    { "pht", "Phu Thai", "Phu Thai" },
                                    { "phu", "Phuan", "Phuan" },
                                    { "phd", "Phudagi", "Phudagi" },
                                    { "pug", "Phuie", "Phuie" },
                                    { "phh", "Phukha", "Phukha" },
                                    { "ypm", "Phuma", "Phuma" },
                                    { "pho", "Phunoi", "Phunoi" },
                                    { "phg", "Phuong", "Phuong" },
                                    { "ypp", "Phupa", "Phupa" },
                                    { "yph", "Phupha", "Phupha" },
                                    { "ypz", "Phuza", "Phuza" },
                                    { "ptr", "Piamatsina", "Piamatsina" },
                                    { "pin", "Piame", "Piame" },
                                    { "pio", "Piapoco", "Piapoco" },
                                    { "pid", "Piaroa", "Piaroa" },
                                    { "pcd", "Picard", "Picard" },
                                    { "nrp", "North Picene", "Picene, North" },
                                    { "spx", "South Picene", "Picene, South" },
                                    { "xpi", "Pictish", "Pictish" },
                                    { "cpi", "Chinese Pidgin English", "Pidgin English, Chinese" },
                                    { "gpe", "Ghanaian Pidgin English", "Pidgin English, Ghanaian" },
                                    { "wes", "Cameroon Pidgin", "Pidgin, Cameroon" },
                                    { "pcm", "Nigerian Pidgin", "Pidgin, Nigerian" },
                                    { "tvy", "Timor Pidgin", "Pidgin, Timor" },
                                    { "pms", "Piemontese", "Piemontese" },
                                    { "pij", "Pijao", "Pijao" },
                                    { "piz", "Pije", "Pije" },
                                    { "pis", "Pijin", "Pijin" },
                                    { "plg", "Pilagá", "Pilagá" },
                                    { "piv", "Pileni", "Pileni" },
                                    { "pia", "Pima Bajo", "Pima Bajo" },
                                    { "piw", "Pimbwe", "Pimbwe" },
                                    { "pnn", "Pinai-Hagahai", "Pinai-Hagahai" },
                                    { "pif", "Pingelapese", "Pingelapese" },
                                    { "pii", "Pini", "Pini" },
                                    { "pnv", "Pinigura", "Pinigura" },
                                    { "pic", "Pinji", "Pinji" },
                                    { "pti", "Pintiini", "Pintiini" },
                                    { "piu", "Pintupi-Luritja", "Pintupi-Luritja" },
                                    { "pny", "Pinyin", "Pinyin" },
                                    { "ppl", "Pipil", "Pipil" },
                                    { "myp", "Pirahã", "Pirahã" },
                                    { "pir", "Piratapuyo", "Piratapuyo" },
                                    { "bxi", "Pirlatapa", "Pirlatapa" },
                                    { "pie", "Piro", "Piro" },
                                    { "ppr", "Piru", "Piru" },
                                    { "pig", "Pisabo", "Pisabo" },
                                    { "psy", "Piscataway", "Piscataway" },
                                    { "xps", "Pisidian", "Pisidian" },
                                    { "pih", "Pitcairn-Norfolk", "Pitcairn-Norfolk" },
                                    { "pcn", "Piti", "Piti" },
                                    { "pjt", "Pitjantjatjara", "Pitjantjatjara" },
                                    { "pit", "Pitta Pitta", "Pitta Pitta" },
                                    { "pix", "Piu", "Piu" },
                                    { "piy", "Piya-Kwonci", "Piya-Kwonci" },
                                    { "psd", "Plains Indian Sign Language", "Plains Indian Sign Language" },
                                    { "pdt", "Plautdietsch", "Plautdietsch" },
                                    { "gob", "Playero", "Playero" },
                                    { "pbv", "Pnar", "Pnar" },
                                    { "xpo", "Pochutec", "Pochutec" },
                                    { "pdn", "Podena", "Podena" },
                                    { "poy", "Pogolo", "Pogolo" },
                                    { "pon", "Pohnpeian", "Pohnpeian" },
                                    { "pok", "Pokangá", "Pokangá" },
                                    { "pof", "Poke", "Poke" },
                                    { "pkb", "Pokomo", "Pokomo" },
                                    { "pko", "Pökoot", "Pökoot" },
                                    { "pox", "Polabian", "Polabian" },
                                    { "pld", "Polari", "Polari" },
                                    { "plj", "Polci", "Polci" },
                                    { "pol", "Polish", "Polish" },
                                    { "pso", "Polish Sign Language", "Polish Sign Language" },
                                    { "plb", "Polonombauk", "Polonombauk" },
                                    { "pmo", "Pom", "Pom" },
                                    { "pmm", "Pomo", "Pomo" },
                                    { "poo", "Central Pomo", "Pomo, Central" },
                                    { "peb", "Eastern Pomo", "Pomo, Eastern" },
                                    { "pef", "Northeastern Pomo", "Pomo, Northeastern" },
                                    { "pej", "Northern Pomo", "Pomo, Northern" },
                                    { "pom", "Southeastern Pomo", "Pomo, Southeastern" },
                                    { "peq", "Southern Pomo", "Pomo, Southern" },
                                    { "ncc", "Ponam", "Ponam" },
                                    { "pod", "Ponares", "Ponares" },
                                    { "png", "Pongu", "Pongu" },
                                    { "pns", "Ponosakan", "Ponosakan" },
                                    { "pnt", "Pontic", "Pontic" },
                                    { "pbf", "Coyotepec Popoloca", "Popoloca, Coyotepec" },
                                    { "pbe", "Mezontla Popoloca", "Popoloca, Mezontla" },
                                    { "pow", "San Felipe Otlaltepec Popoloca", "Popoloca, San Felipe Otlaltepec" },
                                    { "poe", "San Juan Atzingo Popoloca", "Popoloca, San Juan Atzingo" },
                                    { "pps", "San Luís Temalacayuca Popoloca", "Popoloca, San Luís Temalacayuca" },
                                    { "pls", "San Marcos Tlalcoyalco Popoloca", "Popoloca, San Marcos Tlalcoyalco" },
                                    { "pca", "Santa Inés Ahuatempan Popoloca", "Popoloca, Santa Inés Ahuatempan" },
                                    { "poi", "Highland Popoluca", "Popoluca, Highland" },
                                    { "plo", "Oluta Popoluca", "Popoluca, Oluta" },
                                    { "pos", "Sayula Popoluca", "Popoluca, Sayula" },
                                    { "poq", "Texistepec Popoluca", "Popoluca, Texistepec" },
                                    { "poc", "Poqomam", "Poqomam" },
                                    { "poh", "Poqomchi'", "Poqomchi'" },
                                    { "prh", "Porohanon", "Porohanon" },
                                    { "psw", "Port Sandwich", "Port Sandwich" },
                                    { "ptv", "Port Vato", "Port Vato" },
                                    { "por", "Portuguese", "Portuguese" },
                                    { "psr", "Portuguese Sign Language", "Portuguese Sign Language" },
                                    { "pot", "Potawatomi", "Potawatomi" },
                                    { "pog", "Potiguára", "Potiguára" },
                                    { "bye", "Pouye", "Pouye" },
                                    { "pwr", "Powari", "Powari" },
                                    { "pim", "Powhatan", "Powhatan" },
                                    { "pyn", "Poyanáwa", "Poyanáwa" },
                                    { "pka", "Ardhamāgadhī Prākrit", "Prākrit, Ardhamāgadhī" },
                                    { "pmh", "Māhārāṣṭri Prākrit", "Prākrit, Māhārāṣṭri" },
                                    { "psu", "Sauraseni Prākrit", "Prākrit, Sauraseni" },
                                    { "prn", "Prasuni", "Prasuni" },
                                    { "pry", "Pray 3", "Pray 3" },
                                    { "pre", "Principense", "Principense" },
                                    { "pro", "Old Provençal (to 1500)", "Provençal, Old (to 1500)" },
                                    { "prz", "Providencia Sign Language", "Providencia Sign Language" },
                                    { "prg", "Prussian", "Prussian" },
                                    { "kvj", "Psikye", "Psikye" },
                                    { "puk", "Pu Ko", "Pu Ko" },
                                    { "pux", "Puare", "Puare" },
                                    { "pue", "Puelche", "Puelche" },
                                    { "psl", "Puerto Rican Sign Language", "Puerto Rican Sign Language" },
                                    { "pui", "Puinave", "Puinave" },
                                    { "pkp", "Pukapuka", "Pukapuka" },
                                    { "fuc", "Pulaar", "Pulaar" },
                                    { "pup", "Pulabu", "Pulabu" },
                                    { "fuf", "Pular", "Pular" },
                                    { "puw", "Puluwatese", "Puluwatese" },
                                    { "pum", "Puma", "Puma" },
                                    { "yae", "Pumé", "Pumé" },
                                    { "pmi", "Northern Pumi", "Pumi, Northern" },
                                    { "pmj", "Southern Pumi", "Pumi, Southern" },
                                    { "xpm", "Pumpokol", "Pumpokol" },
                                    { "pud", "Punan Aput", "Punan Aput" },
                                    { "pna", "Punan Bah-Biau", "Punan Bah-Biau" },
                                    { "pnm", "Punan Batu 1", "Punan Batu 1" },
                                    { "puf", "Punan Merah", "Punan Merah" },
                                    { "puc", "Punan Merap", "Punan Merap" },
                                    { "puj", "Punan Tubu", "Punan Tubu" },
                                    { "xpu", "Punic", "Punic" },
                                    { "pan", "Punjabi", "Punjabi" },
                                    { "puu", "Punu", "Punu" },
                                    { "puo", "Puoc", "Puoc" },
                                    { "puq", "Puquina", "Puquina" },
                                    { "pru", "Puragi", "Puragi" },
                                    { "iar", "Purari", "Purari" },
                                    { "tsz", "Purepecha", "Purepecha" },
                                    { "pua", "Western Highland Purepecha", "Purepecha, Western Highland" },
                                    { "prr", "Puri", "Puri" },
                                    { "prx", "Purik", "Purik" },
                                    { "puy", "Purisimeño", "Purisimeño" },
                                    { "suv", "Puroik", "Puroik" },
                                    { "pur", "Puruborá", "Puruborá" },
                                    { "pub", "Purum", "Purum" },
                                    { "mfl", "Putai", "Putai" },
                                    { "put", "Putoh", "Putoh" },
                                    { "afe", "Putukwam", "Putukwam" },
                                    { "xpy", "Puyo", "Puyo" },
                                    { "xpp", "Puyo-Paekche", "Puyo-Paekche" },
                                    { "pyu", "Puyuma", "Puyuma" },
                                    { "pme", "Pwaamei", "Pwaamei" },
                                    { "pop", "Pwapwa", "Pwapwa" },
                                    { "pcw", "Pyapun", "Pyapun" },
                                    { "pyy", "Pyen", "Pyen" },
                                    { "pby", "Pyu", "Pyu" },
                                    { "pyx", "Pyu (Myanmar)", "Pyu (Myanmar)" },
                                    { "laq", "Qabiao", "Qabiao" },
                                    { "byx", "Qaqet", "Qaqet" },
                                    { "qxq", "Qashqa'i", "Qashqa'i" },
                                    { "xqt", "Qatabanian", "Qatabanian" },
                                    { "gqu", "Qau", "Qau" },
                                    { "alc", "Qawasqar", "Qawasqar" },
                                    { "cng", "Northern Qiang", "Qiang, Northern" },
                                    { "qxs", "Southern Qiang", "Qiang, Southern" },
                                    { "ahg", "Qimant", "Qimant" },
                                    { "qua", "Quapaw", "Quapaw" },
                                    { "fcs", "Quebec Sign Language", "Quebec Sign Language" },
                                    { "yum", "Quechan", "Quechan" },
                                    { "que", "Quechua", "Quechua" },
                                    { "qva", "Ambo-Pasco Quechua", "Quechua, Ambo-Pasco" },
                                    { "qxu", "Arequipa-La Unión Quechua", "Quechua, Arequipa-La Unión" },
                                    { "quy", "Ayacucho Quechua", "Quechua, Ayacucho" },
                                    { "qvc", "Cajamarca Quechua", "Quechua, Cajamarca" },
                                    { "qvl", "Cajatambo North Lima Quechua", "Quechua, Cajatambo North Lima" },
                                    { "quk", "Chachapoyas Quechua", "Quechua, Chachapoyas" },
                                    { "cqu", "Chilean Quechua", "Quechua, Chilean" },
                                    { "qxc", "Chincha Quechua", "Quechua, Chincha" },
                                    { "qxa", "Chiquián Ancash Quechua", "Quechua, Chiquián Ancash" },
                                    { "qwc", "Classical Quechua", "Quechua, Classical" },
                                    { "qwa", "Corongo Ancash Quechua", "Quechua, Corongo Ancash" },
                                    { "quz", "Cusco Quechua", "Quechua, Cusco" },
                                    { "qve", "Eastern Apurímac Quechua", "Quechua, Eastern Apurímac" },
                                    { "qub", "Huallaga Huánuco Quechua", "Quechua, Huallaga Huánuco" },
                                    { "qvh", "Huamalíes-Dos de Mayo Huánuco Quechua", "Quechua, Huamalíes-Dos de Mayo Huánuco" },
                                    { "qwh", "Huaylas Ancash Quechua", "Quechua, Huaylas Ancash" },
                                    { "qvw", "Huaylla Wanca Quechua", "Quechua, Huaylla Wanca" },
                                    { "qxw", "Jauja Wanca Quechua", "Quechua, Jauja Wanca" },
                                    { "quf", "Lambayeque Quechua", "Quechua, Lambayeque" },
                                    { "qvm", "Margos-Yarowilca-Lauricocha Quechua", "Quechua, Margos-Yarowilca-Lauricocha" },
                                    { "qvo", "Napo Lowland Quechua", "Quechua, Napo Lowland" },
                                    { "qul", "North Bolivian Quechua", "Quechua, North Bolivian" },
                                    { "qvn", "North Junín Quechua", "Quechua, North Junín" },
                                    { "qxn", "Northern Conchucos Ancash Quechua", "Quechua, Northern Conchucos Ancash" },
                                    { "qvp", "Pacaraos Quechua", "Quechua, Pacaraos" },
                                    { "qxh", "Panao Huánuco Quechua", "Quechua, Panao Huánuco" },
                                    { "qxp", "Puno Quechua", "Quechua, Puno" },
                                    { "qvs", "San Martín Quechua", "Quechua, San Martín" },
                                    { "qxt", "Santa Ana de Tusi Pasco Quechua", "Quechua, Santa Ana de Tusi Pasco" },
                                    { "qws", "Sihuas Ancash Quechua", "Quechua, Sihuas Ancash" },
                                    { "quh", "South Bolivian Quechua", "Quechua, South Bolivian" },
                                    { "qxo", "Southern Conchucos Ancash Quechua", "Quechua, Southern Conchucos Ancash" },
                                    { "qup", "Southern Pastaza Quechua", "Quechua, Southern Pastaza" },
                                    { "qur", "Yanahuanca Pasco Quechua", "Quechua, Yanahuanca Pasco" },
                                    { "qux", "Yauyos Quechua", "Quechua, Yauyos" },
                                    { "qya", "Quenya", "Quenya" },
                                    { "qvy", "Queyu", "Queyu" },
                                    { "quc", "Quiché", "Quiché" },
                                    { "qud", "Calderón Highland Quichua", "Quichua, Calderón Highland" },
                                    { "qxr", "Cañar Highland Quichua", "Quichua, Cañar Highland" },
                                    { "qug", "Chimborazo Highland Quichua", "Quichua, Chimborazo Highland" },
                                    { "qvi", "Imbabura Highland Quichua", "Quichua, Imbabura Highland" },
                                    { "qvj", "Loja Highland Quichua", "Quichua, Loja Highland" },
                                    { "qvz", "Northern Pastaza Quichua", "Quichua, Northern Pastaza" },
                                    { "qxl", "Salasaca Highland Quichua", "Quichua, Salasaca Highland" },
                                    { "qus", "Santiago del Estero Quichua", "Quichua, Santiago del Estero" },
                                    { "quw", "Tena Lowland Quichua", "Quichua, Tena Lowland" },
                                    { "qui", "Quileute", "Quileute" },
                                    { "qun", "Quinault", "Quinault" },
                                    { "quq", "Quinqui", "Quinqui" },
                                    { "qyp", "Quiripi", "Quiripi" },
                                    { "rah", "Rabha", "Rabha" },
                                    { "rad", "Rade", "Rade" },
                                    { "xrr", "Raetic", "Raetic" },
                                    { "raz", "Rahambuu", "Rahambuu" },
                                    { "raj", "Rajasthani", "Rajasthani" },
                                    { "rjs", "Rajbanshi", "Rajbanshi" },
                                    { "rji", "Raji", "Raji" },
                                    { "rjg", "Rajong", "Rajong" },
                                    { "rkh", "Rakahanga-Manihiki", "Rakahanga-Manihiki" },
                                    { "rki", "Rakhine", "Rakhine" },
                                    { "ral", "Ralte", "Ralte" },
                                    { "rma", "Rama", "Rama" },
                                    { "rai", "Ramoaaina", "Ramoaaina" },
                                    { "kjx", "Ramopa", "Ramopa" },
                                    { "lje", "Rampi", "Rampi" },
                                    { "rax", "Rang", "Rang" },
                                    { "rgk", "Rangkas", "Rangkas" },
                                    { "rnl", "Ranglong", "Ranglong" },
                                    { "rkt", "Rangpuri", "Rangpuri" },
                                    { "rao", "Rao", "Rao" },
                                    { "ray", "Rapa", "Rapa" },
                                    { "rap", "Rapanui", "Rapanui" },
                                    { "kyx", "Rapoisi", "Rapoisi" },
                                    { "rpt", "Rapting", "Rapting" },
                                    { "lra", "Rara Bakati'", "Rara Bakati'" },
                                    { "rar", "Rarotongan", "Rarotongan" },
                                    { "rac", "Rasawa", "Rasawa" },
                                    { "btn", "Ratagnon", "Ratagnon" },
                                    { "rth", "Ratahan", "Ratahan" },
                                    { "rtw", "Rathawi", "Rathawi" },
                                    { "rau", "Raute", "Raute" },
                                    { "yea", "Ravula", "Ravula" },
                                    { "rwo", "Rawa", "Rawa" },
                                    { "raw", "Rawang", "Rawang" },
                                    { "jnl", "Rawat", "Rawat" },
                                    { "rwa", "Rawo", "Rawo" },
                                    { "rat", "Razajerdi", "Razajerdi" },
                                    { "atu", "Reel", "Reel" },
                                    { "rej", "Rejang", "Rejang" },
                                    { "rei", "Reli", "Reli" },
                                    { "bow", "Rema", "Rema" },
                                    { "rmb", "Rembarunga", "Rembarunga" },
                                    { "reb", "Rembong", "Rembong" },
                                    { "rem", "Remo", "Remo" },
                                    { "rmp", "Rempi", "Rempi" },
                                    { "lkj", "Remun", "Remun" },
                                    { "rel", "Rendille", "Rendille" },
                                    { "ren", "Rengao", "Rengao" },
                                    { "mnv", "Rennell-Bellona", "Rennell-Bellona" },
                                    { "rsi", "Rennellese Sign Language", "Rennellese Sign Language" },
                                    { "rpn", "Repanbitip", "Repanbitip" },
                                    { "rer", "Rer Bare", "Rer Bare" },
                                    { "rea", "Rerau", "Rerau" },
                                    { "pgk", "Rerep", "Rerep" },
                                    { "res", "Reshe", "Reshe" },
                                    { "rgr", "Resígaro", "Resígaro" },
                                    { "ret", "Retta", "Retta" },
                                    { "rey", "Reyesano", "Reyesano" },
                                    { "ria", "Riang (India)", "Riang (India)" },
                                    { "ril", "Riang (Myanmar)", "Riang (Myanmar)" },
                                    { "ran", "Riantana", "Riantana" },
                                    { "rir", "Ribun", "Ribun" },
                                    { "rie", "Rien", "Rien" },
                                    { "rkb", "Rikbaktsa", "Rikbaktsa" },
                                    { "rgu", "Ringgou", "Ringgou" },
                                    { "rri", "Ririo", "Ririo" },
                                    { "rit", "Ritarungo", "Ritarungo" },
                                    { "riu", "Riung", "Riung" },
                                    { "roc", "Cacgia Roglai", "Roglai, Cacgia" },
                                    { "rog", "Northern Roglai", "Roglai, Northern" },
                                    { "rgs", "Southern Roglai", "Roglai, Southern" },
                                    { "rod", "Rogo", "Rogo" },
                                    { "rhg", "Rohingya", "Rohingya" },
                                    { "rmm", "Roma", "Roma" },
                                    { "rgn", "Romagnol", "Romagnol" },
                                    { "rmx", "Romam", "Romam" },
                                    { "rmn", "Balkan Romani", "Romani, Balkan" },
                                    { "rml", "Baltic Romani", "Romani, Baltic" },
                                    { "rmc", "Carpathian Romani", "Romani, Carpathian" },
                                    { "rmf", "Kalo Finnish Romani", "Romani, Kalo Finnish" },
                                    { "rmo", "Sinte Romani", "Romani, Sinte" },
                                    { "rmu", "Tavringer Romani", "Romani, Tavringer" },
                                    { "rmy", "Vlax Romani", "Romani, Vlax" },
                                    { "rmw", "Welsh Romani", "Romani, Welsh" },
                                    { "rms", "Romanian Sign Language", "Romanian Sign Language" },
                                    { "ruo", "Istro Romanian", "Romanian, Istro" },
                                    { "rup", "Macedo-Romanian", "Romanian, Macedo-" },
                                    { "ruq", "Megleno Romanian", "Romanian, Megleno" },
                                    { "rge", "Romano-Greek", "Romano-Greek" },
                                    { "rsb", "Romano-Serbian", "Romano-Serbian" },
                                    { "rmv", "Romanova", "Romanova" },
                                    { "roh", "Romansh", "Romansh" },
                                    { "rom", "Romany", "Romany" },
                                    { "rol", "Romblomanon", "Romblomanon" },
                                    { "rof", "Rombo", "Rombo" },
                                    { "rmk", "Romkun", "Romkun" },
                                    { "cla", "Ron", "Ron" },
                                    { "rng", "Ronga", "Ronga" },
                                    { "ror", "Rongga", "Rongga" },
                                    { "rnp", "Rongpo", "Rongpo" },
                                    { "roe", "Ronji", "Ronji" },
                                    { "rnn", "Roon", "Roon" },
                                    { "rga", "Roria", "Roria" },
                                    { "roo", "Rotokas", "Rotokas" },
                                    { "rtm", "Rotuman", "Rotuman" },
                                    { "rug", "Roviana", "Roviana" },
                                    { "rdb", "Rudbari", "Rudbari" },
                                    { "rui", "Rufiji", "Rufiji" },
                                    { "ruh", "Ruga", "Ruga" },
                                    { "dru", "Rukai", "Rukai" },
                                    { "ruz", "Ruma", "Ruma" },
                                    { "klq", "Rumu", "Rumu" },
                                    { "rna", "Runa", "Runa" },
                                    { "run", "Rundi", "Rundi" },
                                    { "rou", "Runga", "Runga" },
                                    { "drg", "Rungus", "Rungus" },
                                    { "rnw", "Rungwa", "Rungwa" },
                                    { "rus", "Russian", "Russian" },
                                    { "rsl", "Russian Sign Language", "Russian Sign Language" },
                                    { "orv", "Old Russian", "Russian, Old" },
                                    { "rue", "Rusyn", "Rusyn" },
                                    { "rut", "Rutul", "Rutul" },
                                    { "ruc", "Ruuli", "Ruuli" },
                                    { "rnd", "Ruund", "Ruund" },
                                    { "rwk", "Rwa", "Rwa" },
                                    { "sax", "Sa", "Sa" },
                                    { "apb", "Sa'a", "Sa'a" },
                                    { "sav", "Saafi-Saafi", "Saafi-Saafi" },
                                    { "raq", "Saam", "Saam" },
                                    { "sxr", "Saaroa", "Saaroa" },
                                    { "saa", "Saba", "Saba" },
                                    { "xsa", "Sabaean", "Sabaean" },
                                    { "snv", "Sa'ban", "Sa'ban" },
                                    { "sae", "Sabanê", "Sabanê" },
                                    { "spy", "Sabaot", "Sabaot" },
                                    { "sbv", "Sabine", "Sabine" },
                                    { "hvn", "Sabu", "Sabu" },
                                    { "sbo", "Sabüm", "Sabüm" },
                                    { "quv", "Sacapulteco", "Sacapulteco" },
                                    { "sck", "Sadri", "Sadri" },
                                    { "sdr", "Oraon Sadri", "Sadri, Oraon" },
                                    { "skb", "Saek", "Saek" },
                                    { "spd", "Saep", "Saep" },
                                    { "saf", "Safaliba", "Safaliba" },
                                    { "apz", "Safeyoka", "Safeyoka" },
                                    { "sbk", "Safwa", "Safwa" },
                                    { "sbm", "Sagala", "Sagala" },
                                    { "tga", "Sagalla", "Sagalla" },
                                    { "ssy", "Saho", "Saho" },
                                    { "saj", "Sahu", "Sahu" },
                                    { "xsy", "Saisiyat", "Saisiyat" },
                                    { "sjb", "Sajau Basap", "Sajau Basap" },
                                    { "sch", "Sakachep", "Sakachep" },
                                    { "sku", "Sakao", "Sakao" },
                                    { "skt", "Sakata", "Sakata" },
                                    { "sak", "Sake", "Sake" },
                                    { "skf", "Sakirabiá", "Sakirabiá" },
                                    { "shq", "Sala", "Sala" },
                                    { "slx", "Salampasu", "Salampasu" },
                                    { "slr", "Salar", "Salar" },
                                    { "sgu", "Salas", "Salas" },
                                    { "slq", "Salchuq", "Salchuq" },
                                    { "sau", "Saleman", "Saleman" },
                                    { "sbe", "Saliba", "Saliba" },
                                    { "slc", "Sáliba", "Sáliba" },
                                    { "sln", "Salinan", "Salinan" },
                                    { "slh", "Southern Puget Sound Salish", "Salish, Southern Puget Sound" },
                                    { "str", "Straits Salish", "Salish, Straits" },
                                    { "sdz", "Sallands", "Sallands" },
                                    { "sll", "Salt-Yui", "Salt-Yui" },
                                    { "slj", "Salumá", "Salumá" },
                                    { "esn", "Salvadoran Sign Language", "Salvadoran Sign Language" },
                                    { "snx", "Sam", "Sam" },
                                    { "smd", "Sama", "Sama" },
                                    { "sse", "Bangingih Sama", "Sama, Bangingih" },
                                    { "sml", "Central Sama", "Sama, Central" },
                                    { "slm", "Pangutaran Sama", "Sama, Pangutaran" },
                                    { "ssb", "Southern Sama", "Sama, Southern" },
                                    { "smp", "Samaritan", "Samaritan" },
                                    { "tmj", "Samarokena", "Samarokena" },
                                    { "ysd", "Samatao", "Samatao" },
                                    { "smx", "Samba", "Samba" },
                                    { "ndi", "Samba Leko", "Samba Leko" },
                                    { "xsb", "Sambal", "Sambal" },
                                    { "sbl", "Botolan Sambal", "Sambal, Botolan" },
                                    { "spv", "Sambalpuri", "Sambalpuri" },
                                    { "xab", "Sambe", "Sambe" },
                                    { "ssx", "Samberigi", "Samberigi" },
                                    { "saq", "Samburu", "Samburu" },
                                    { "smh", "Samei", "Samei" },
                                    { "sia", "Akkala Sami", "Sami, Akkala" },
                                    { "smn", "Inari Sami", "Sami, Inari" },
                                    { "sjk", "Kemi Sami", "Sami, Kemi" },
                                    { "sjd", "Kildin Sami", "Sami, Kildin" },
                                    { "sme", "Northern Sami", "Sami, Northern" },
                                    { "sje", "Pite Sami", "Sami, Pite" },
                                    { "sms", "Skolt Sami", "Sami, Skolt" },
                                    { "sma", "Southern Sami", "Sami, Southern" },
                                    { "sjt", "Ter Sami", "Sami, Ter" },
                                    { "sju", "Ume Sami", "Sami, Ume" },
                                    { "smq", "Samo", "Samo" },
                                    { "stj", "Matya Samo", "Samo, Matya" },
                                    { "sym", "Maya Samo", "Samo, Maya" },
                                    { "sbd", "Southern Samo", "Samo, Southern" },
                                    { "smo", "Samoan", "Samoan" },
                                    { "sgs", "Samogitian", "Samogitian" },
                                    { "swm", "Samosa", "Samosa" },
                                    { "rav", "Sampang", "Sampang" },
                                    { "sxm", "Samre", "Samre" },
                                    { "stu", "Samtao", "Samtao" },
                                    { "smv", "Samvedi", "Samvedi" },
                                    { "sap", "Sanapaná", "Sanapaná" },
                                    { "sad", "Sandawe", "Sandawe" },
                                    { "sng", "Sanga (Democratic Republic of Congo)", "Sanga (Democratic Republic of Congo)" },
                                    { "xsn", "Sanga (Nigeria)", "Sanga (Nigeria)" },
                                    { "scg", "Sanggau", "Sanggau" },
                                    { "snl", "Sangil", "Sangil" },
                                    { "sxn", "Sangir", "Sangir" },
                                    { "sgr", "Sangisari", "Sangisari" },
                                    { "sgk", "Sangkong", "Sangkong" },
                                    { "sgy", "Sanglechi", "Sanglechi" },
                                    { "sag", "Sango", "Sango" },
                                    { "snj", "Riverain Sango", "Sango, Riverain" },
                                    { "snq", "Sangu (Gabon)", "Sangu (Gabon)" },
                                    { "sbp", "Sangu (Tanzania)", "Sangu (Tanzania)" },
                                    { "ysn", "Sani", "Sani" },
                                    { "ysy", "Sanie", "Sanie" },
                                    { "sny", "Saniyo-Hiyewe", "Saniyo-Hiyewe" },
                                    { "ssi", "Sansi", "Sansi" },
                                    { "san", "Sanskrit", "Sanskrit" },
                                    { "sat", "Santali", "Santali" },
                                    { "xsu", "Sanumá", "Sanumá" },
                                    { "scq", "Sa'och", "Sa'och" },
                                    { "cri", "Sãotomense", "Sãotomense" },
                                    { "spr", "Saparua", "Saparua" },
                                    { "spc", "Sapé", "Sapé" },
                                    { "krn", "Sapo", "Sapo" },
                                    { "spi", "Saponi", "Saponi" },
                                    { "sps", "Saposa", "Saposa" },
                                    { "spu", "Sapuan", "Sapuan" },
                                    { "mwm", "Sar", "Sar" },
                                    { "sre", "Sara", "Sara" },
                                    { "koj", "Sara Dunjo", "Sara Dunjo" },
                                    { "sbz", "Sara Kaba", "Sara Kaba" },
                                    { "kwg", "Sara Kaba Deme", "Sara Kaba Deme" },
                                    { "kwv", "Sara Kaba Náà", "Sara Kaba Náà" },
                                    { "srm", "Saramaccan", "Saramaccan" },
                                    { "zsa", "Sarasira", "Sarasira" },
                                    { "sar", "Saraveca", "Saraveca" },
                                    { "srd", "Sardinian", "Sardinian" },
                                    { "sro", "Campidanese Sardinian", "Sardinian, Campidanese" },
                                    { "sdn", "Gallurese Sardinian", "Sardinian, Gallurese" },
                                    { "src", "Logudorese Sardinian", "Sardinian, Logudorese" },
                                    { "sdc", "Sassarese Sardinian", "Sardinian, Sassarese" },
                                    { "srh", "Sarikoli", "Sarikoli" },
                                    { "sdf", "Sarli", "Sarli" },
                                    { "srs", "Sarsi", "Sarsi" },
                                    { "onp", "Sartang", "Sartang" },
                                    { "swy", "Sarua", "Sarua" },
                                    { "sdu", "Sarudu", "Sarudu" },
                                    { "sra", "Saruga", "Saruga" },
                                    { "sas", "Sasak", "Sasak" },
                                    { "sxs", "Sasaru", "Sasaru" },
                                    { "stw", "Satawalese", "Satawalese" },
                                    { "mav", "Sateré-Mawé", "Sateré-Mawé" },
                                    { "stq", "Saterfriesisch", "Saterfriesisch" },
                                    { "sdl", "Saudi Arabian Sign Language", "Saudi Arabian Sign Language" },
                                    { "saz", "Saurashtra", "Saurashtra" },
                                    { "srt", "Sauri", "Sauri" },
                                    { "mjt", "Sauria Paharia", "Sauria Paharia" },
                                    { "sao", "Sause", "Sause" },
                                    { "ssj", "Sausi", "Sausi" },
                                    { "svr", "Savara", "Savara" },
                                    { "sdg", "Savi", "Savi" },
                                    { "svs", "Savosavo", "Savosavo" },
                                    { "szw", "Sawai", "Sawai" },
                                    { "swr", "Saweru", "Saweru" },
                                    { "saw", "Sawi", "Sawi" },
                                    { "swt", "Sawila", "Sawila" },
                                    { "swn", "Sawknah", "Sawknah" },
                                    { "osx", "Old Saxon", "Saxon, Old" },
                                    { "sxu", "Upper Saxon", "Saxon, Upper" },
                                    { "say", "Saya", "Saya" },
                                    { "sco", "Scots", "Scots" },
                                    { "trl", "Traveller Scottish", "Scottish, Traveller" },
                                    { "xsc", "Scythian", "Scythian" },
                                    { "kdg", "Seba", "Seba" },
                                    { "sgw", "Sebat Bet Gurage", "Sebat Bet Gurage" },
                                    { "sbx", "Seberuang", "Seberuang" },
                                    { "sib", "Sebop", "Sebop" },
                                    { "snb", "Sebuyau", "Sebuyau" },
                                    { "sec", "Sechelt", "Sechelt" },
                                    { "sey", "Secoya", "Secoya" },
                                    { "sed", "Sedang", "Sedang" },
                                    { "tvw", "Sedoa", "Sedoa" },
                                    { "sos", "Seeku", "Seeku" },
                                    { "sge", "Segai", "Segai" },
                                    { "seg", "Segeju", "Segeju" },
                                    { "sbg", "Seget", "Seget" },
                                    { "sfw", "Sehwi", "Sehwi" },
                                    { "ssg", "Seimat", "Seimat" },
                                    { "hik", "Seit-Kaitetu", "Seit-Kaitetu" },
                                    { "sek", "Sekani", "Sekani" },
                                    { "skp", "Sekapan", "Sekapan" },
                                    { "skz", "Sekar", "Sekar" },
                                    { "skj", "Seke (Nepal)", "Seke (Nepal)" },
                                    { "ske", "Seke (Vanuatu)", "Seke (Vanuatu)" },
                                    { "syi", "Seki", "Seki" },
                                    { "skx", "Seko Padang", "Seko Padang" },
                                    { "sko", "Seko Tengah", "Seko Tengah" },
                                    { "lip", "Sekpele", "Sekpele" },
                                    { "kgi", "Selangor Sign Language", "Selangor Sign Language" },
                                    { "slu", "Selaru", "Selaru" },
                                    { "sly", "Selayar", "Selayar" },
                                    { "snw", "Selee", "Selee" },
                                    { "spl", "Selepet", "Selepet" },
                                    { "sxl", "Selian", "Selian" },
                                    { "sel", "Selkup", "Selkup" },
                                    { "slg", "Selungai Murut", "Selungai Murut" },
                                    { "sws", "Seluwasan", "Seluwasan" },
                                    { "sea", "Semai", "Semai" },
                                    { "sdm", "Semandang", "Semandang" },
                                    { "szc", "Semaq Beri", "Semaq Beri" },
                                    { "sbr", "Sembakung Murut", "Sembakung Murut" },
                                    { "sza", "Semelai", "Semelai" },
                                    { "etz", "Semimi", "Semimi" },
                                    { "ssm", "Semnam", "Semnam" },
                                    { "smy", "Semnani", "Semnani" },
                                    { "xse", "Sempan", "Sempan" },
                                    { "seh", "Sena", "Sena" },
                                    { "swk", "Malawi Sena", "Sena, Malawi" },
                                    { "syn", "Senaya", "Senaya" },
                                    { "sej", "Sene", "Sene" },
                                    { "see", "Seneca", "Seneca" },
                                    { "sds", "Sened", "Sened" },
                                    { "szg", "Sengele", "Sengele" },
                                    { "snu", "Senggi", "Senggi" },
                                    { "spk", "Sengo", "Sengo" },
                                    { "ssz", "Sengseng", "Sengseng" },
                                    { "sjs", "Senhaja De Srair", "Senhaja De Srair" },
                                    { "sef", "Cebaara Senoufo", "Senoufo, Cebaara" },
                                    { "dyi", "Djimini Senoufo", "Senoufo, Djimini" },
                                    { "myk", "Mamara Senoufo", "Senoufo, Mamara" },
                                    { "sen", "Nanerigé Sénoufo", "Sénoufo, Nanerigé" },
                                    { "sev", "Nyarafolo Senoufo", "Senoufo, Nyarafolo" },
                                    { "plr", "Palaka Senoufo", "Senoufo, Palaka" },
                                    { "seq", "Senara Sénoufo", "Sénoufo, Senara" },
                                    { "seb", "Shempire Senoufo", "Senoufo, Shempire" },
                                    { "sep", "Sìcìté Sénoufo", "Sénoufo, Sìcìté" },
                                    { "spp", "Supyire Senoufo", "Senoufo, Supyire" },
                                    { "shz", "Syenara Senoufo", "Senoufo, Syenara" },
                                    { "tgw", "Tagwana Senoufo", "Senoufo, Tagwana" },
                                    { "sni", "Sensi", "Sensi" },
                                    { "set", "Sentani", "Sentani" },
                                    { "std", "Sentinel", "Sentinel" },
                                    { "spb", "Sepa (Indonesia)", "Sepa (Indonesia)" },
                                    { "spe", "Sepa (Papua New Guinea)", "Sepa (Papua New Guinea)" },
                                    { "sry", "Sera", "Sera" },
                                    { "skr", "Seraiki", "Seraiki" },
                                    { "srp", "Serbian", "Serbian" },
                                    { "hbs", "Serbo-Croatian", "Serbo-Croatian" },
                                    { "swf", "Sere", "Sere" },
                                    { "srr", "Serer", "Serer" },
                                    { "sei", "Seri", "Seri" },
                                    { "sve", "Serili", "Serili" },
                                    { "kqu", "Seroa", "Seroa" },
                                    { "ser", "Serrano", "Serrano" },
                                    { "szd", "Seru", "Seru" },
                                    { "srw", "Serua", "Serua" },
                                    { "srk", "Serudung Murut", "Serudung Murut" },
                                    { "seu", "Serui-Laut", "Serui-Laut" },
                                    { "stf", "Seta", "Seta" },
                                    { "stm", "Setaman", "Setaman" },
                                    { "sbi", "Seti", "Seti" },
                                    { "sta", "Settla", "Settla" },
                                    { "sew", "Sewa Bay", "Sewa Bay" },
                                    { "sze", "Seze", "Seze" },
                                    { "scw", "Sha", "Sha" },
                                    { "sdb", "Shabak", "Shabak" },
                                    { "sbf", "Shabo", "Shabo" },
                                    { "srz", "Shahmirzadi", "Shahmirzadi" },
                                    { "shm", "Shahrudi", "Shahrudi" },
                                    { "sha", "Shall-Zwall", "Shall-Zwall" },
                                    { "xsh", "Shamang", "Shamang" },
                                    { "sqa", "Shama-Sambuga", "Shama-Sambuga" },
                                    { "ksb", "Shambala", "Shambala" },
                                    { "shn", "Shan", "Shan" },
                                    { "swo", "Shanenawa", "Shanenawa" },
                                    { "sho", "Shanga", "Shanga" },
                                    { "jih", "Shangzhai", "Shangzhai" },
                                    { "mcd", "Sharanahua", "Sharanahua" },
                                    { "ssv", "Shark Bay", "Shark Bay" },
                                    { "swq", "Sharwa", "Sharwa" },
                                    { "sht", "Shasta", "Shasta" },
                                    { "shj", "Shatt", "Shatt" },
                                    { "sqh", "Shau", "Shau" },
                                    { "sjw", "Shawnee", "Shawnee" },
                                    { "shx", "She", "She" },
                                    { "shv", "Shehri", "Shehri" },
                                    { "swv", "Shekhawati", "Shekhawati" },
                                    { "moy", "Shekkacho", "Shekkacho" },
                                    { "she", "Sheko", "Sheko" },
                                    { "sth", "Shelta", "Shelta" },
                                    { "shl", "Shendu", "Shendu" },
                                    { "scv", "Sheni", "Sheni" },
                                    { "bun", "Sherbro", "Sherbro" },
                                    { "sdp", "Sherdukpen", "Sherdukpen" },
                                    { "xsr", "Sherpa", "Sherpa" },
                                    { "shr", "Shi", "Shi" },
                                    { "gua", "Shiki", "Shiki" },
                                    { "shk", "Shilluk", "Shilluk" },
                                    { "scl", "Shina", "Shina" },
                                    { "plk", "Kohistani Shina", "Shina, Kohistani" },
                                    { "snh", "Shinabo", "Shinabo" },
                                    { "shp", "Shipibo-Conibo", "Shipibo-Conibo" },
                                    { "sxg", "Shixing", "Shixing" },
                                    { "sle", "Sholaga", "Sholaga" },
                                    { "sii", "Shom Peng", "Shom Peng" },
                                    { "sna", "Shona", "Shona" },
                                    { "bcv", "Shoo-Minda-Nye", "Shoo-Minda-Nye" },
                                    { "cjs", "Shor", "Shor" },
                                    { "shh", "Shoshoni", "Shoshoni" },
                                    { "shg", "Shua", "Shua" },
                                    { "sdt", "Shuadit", "Shuadit" },
                                    { "jiv", "Shuar", "Shuar" },
                                    { "suj", "Shubi", "Shubi" },
                                    { "sgh", "Shughni", "Shughni" },
                                    { "sts", "Shumashti", "Shumashti" },
                                    { "scu", "Shumcho", "Shumcho" },
                                    { "shs", "Shuswap", "Shuswap" },
                                    { "ksa", "Shuwa-Zamani", "Shuwa-Zamani" },
                                    { "shw", "Shwai", "Shwai" },
                                    { "slw", "Sialum", "Sialum" },
                                    { "sif", "Siamou", "Siamou" },
                                    { "spg", "Sian", "Sian" },
                                    { "snp", "Siane", "Siane" },
                                    { "sya", "Siang", "Siang" },
                                    { "sjr", "Siar-Lak", "Siar-Lak" },
                                    { "mmp", "Siawi", "Siawi" },
                                    { "nco", "Sibe", "Sibe" },
                                    { "sxc", "Sicanian", "Sicanian" },
                                    { "scx", "Sicel", "Sicel" },
                                    { "scn", "Sicilian", "Sicilian" },
                                    { "sid", "Sidamo", "Sidamo" },
                                    { "xsd", "Sidetic", "Sidetic" },
                                    { "erg", "Sie", "Sie" },
                                    { "sgx", "Sierra Leone Sign Language", "Sierra Leone Sign Language" },
                                    { "sxe", "Sighu", "Sighu" },
                                    { "snr", "Sihan", "Sihan" },
                                    { "ski", "Sika", "Sika" },
                                    { "sky", "Sikaiana", "Sikaiana" },
                                    { "tty", "Sikaritai", "Sikaritai" },
                                    { "sik", "Sikiana", "Sikiana" },
                                    { "sip", "Sikkimese", "Sikkimese" },
                                    { "bla", "Siksika", "Siksika" },
                                    { "skh", "Sikule", "Sikule" },
                                    { "slt", "Sila", "Sila" },
                                    { "sbq", "Sileibi", "Sileibi" },
                                    { "szl", "Silesian", "Silesian" },
                                    { "sli", "Lower Silesian", "Silesian, Lower" },
                                    { "wul", "Silimo", "Silimo" },
                                    { "mkc", "Siliput", "Siliput" },
                                    { "xsp", "Silopi", "Silopi" },
                                    { "stv", "Silt'e", "Silt'e" },
                                    { "sie", "Simaa", "Simaa" },
                                    { "sbw", "Simba", "Simba" },
                                    { "smg", "Simbali", "Simbali" },
                                    { "smb", "Simbari", "Simbari" },
                                    { "sbb", "Simbo", "Simbo" },
                                    { "smz", "Simeku", "Simeku" },
                                    { "smr", "Simeulue", "Simeulue" },
                                    { "smt", "Simte", "Simte" },
                                    { "siu", "Sinagen", "Sinagen" },
                                    { "sst", "Sinasina", "Sinasina" },
                                    { "snc", "Sinaugoro", "Sinaugoro" },
                                    { "sjn", "Sindarin", "Sindarin" },
                                    { "snd", "Sindhi", "Sindhi" },
                                    { "sgm", "Singa", "Singa" },
                                    { "sls", "Singapore Sign Language", "Singapore Sign Language" },
                                    { "sgp", "Singpho", "Singpho" },
                                    { "sin", "Sinhalese", "Sinhalese" },
                                    { "skq", "Sininkere", "Sininkere" },
                                    { "snz", "Sinsauru", "Sinsauru" },
                                    { "sys", "Sinyar", "Sinyar" },
                                    { "xsi", "Sio", "Sio" },
                                    { "snn", "Siona", "Siona" },
                                    { "qum", "Sipacapense", "Sipacapense" },
                                    { "swj", "Sira", "Sira" },
                                    { "fos", "Siraya", "Siraya" },
                                    { "sir", "Siri", "Siri" },
                                    { "sri", "Siriano", "Siriano" },
                                    { "srq", "Sirionó", "Sirionó" },
                                    { "srx", "Sirmauri", "Sirmauri" },
                                    { "ssd", "Siroi", "Siroi" },
                                    { "sil", "Tumulung Sisaala", "Sisaala, Tumulung" },
                                    { "ssl", "Western Sisaala", "Sisaala, Western" },
                                    { "sld", "Sissala", "Sissala" },
                                    { "sso", "Sissano", "Sissano" },
                                    { "sis", "Siuslaw", "Siuslaw" },
                                    { "siy", "Sivandi", "Sivandi" },
                                    { "siw", "Siwai", "Siwai" },
                                    { "siz", "Siwi", "Siwi" },
                                    { "akp", "Siwu", "Siwu" },
                                    { "ska", "Skagit", "Skagit" },
                                    { "svx", "Skalvian", "Skalvian" },
                                    { "skv", "Skou", "Skou" },
                                    { "den", "Slave (Athapascan)", "Slave (Athapascan)" },
                                    { "scs", "North Slavey", "Slavey, North" },
                                    { "xsl", "South Slavey", "Slavey, South" },
                                    { "chu", "Church Slavic", "Slavic, Church" },
                                    { "slk", "Slovak", "Slovak" },
                                    { "svk", "Slovakian Sign Language", "Slovakian Sign Language" },
                                    { "slv", "Slovenian", "Slovenian" },
                                    { "sno", "Snohomish", "Snohomish" },
                                    { "sss", "Sô", "Sô" },
                                    { "soc", "So (Democratic Republic of Congo)", "So (Democratic Republic of Congo)" },
                                    { "ssq", "So'a", "So'a" },
                                    { "sob", "Sobei", "Sobei" },
                                    { "xog", "Soga", "Soga" },
                                    { "sog", "Sogdian", "Sogdian" },
                                    { "soj", "Soi", "Soi" },
                                    { "skk", "Sok", "Sok" },
                                    { "sok", "Sokoro", "Sokoro" },
                                    { "xso", "Solano", "Solano" },
                                    { "sby", "Soli", "Soli" },
                                    { "aaw", "Solong", "Solong" },
                                    { "sol", "Solos", "Solos" },
                                    { "smc", "Som", "Som" },
                                    { "som", "Somali", "Somali" },
                                    { "bmu", "Somba-Siawari", "Somba-Siawari" },
                                    { "sor", "Somrai", "Somrai" },
                                    { "smu", "Somray", "Somray" },
                                    { "kgt", "Somyev", "Somyev" },
                                    { "ysg", "Sonaga", "Sonaga" },
                                    { "shc", "Sonde", "Sonde" },
                                    { "sgo", "Songa", "Songa" },
                                    { "sop", "Songe", "Songe" },
                                    { "ses", "Koyraboro Senni Songhai", "Songhai, Koyraboro Senni" },
                                    { "hmb", "Humburi Senni Songhay", "Songhay, Humburi Senni" },
                                    { "khq", "Koyra Chiini Songhay", "Songhay, Koyra Chiini" },
                                    { "soo", "Songo", "Songo" },
                                    { "soe", "Songomeno", "Songomeno" },
                                    { "sod", "Songoora", "Songoora" },
                                    { "tst", "Tondi Songway Kiini", "Songway Kiini, Tondi" },
                                    { "soi", "Sonha", "Sonha" },
                                    { "siq", "Sonia", "Sonia" },
                                    { "snk", "Soninke", "Soninke" },
                                    { "sov", "Sonsorol", "Sonsorol" },
                                    { "teu", "Soo", "Soo" },
                                    { "urw", "Sop", "Sop" },
                                    { "sqt", "Soqotri", "Soqotri" },
                                    { "srb", "Sora", "Sora" },
                                    { "dsb", "Lower Sorbian", "Sorbian, Lower" },
                                    { "hsb", "Upper Sorbian", "Sorbian, Upper" },
                                    { "sbh", "Sori-Harengan", "Sori-Harengan" },
                                    { "sqo", "Sorkhei", "Sorkhei" },
                                    { "sxo", "Sorothaptic", "Sorothaptic" },
                                    { "bks", "Northern Sorsoganon", "Sorsoganon, Northern" },
                                    { "srv", "Southern Sorsoganon", "Sorsoganon, Southern" },
                                    { "sdk", "Sos Kundi", "Sos Kundi" },
                                    { "nso", "Northern Sotho", "Sotho, Northern" },
                                    { "sot", "Southern Sotho", "Sotho, Southern" },
                                    { "sqq", "Sou", "Sou" },
                                    { "sfs", "South African Sign Language", "South African Sign Language" },
                                    { "sns", "South West Bay", "South West Bay" },
                                    { "sww", "Sowa", "Sowa" },
                                    { "sow", "Sowanda", "Sowanda" },
                                    { "spa", "Spanish", "Spanish" },
                                    { "ssp", "Spanish Sign Language", "Spanish Sign Language" },
                                    { "spq", "Loreto-Ucayali Spanish", "Spanish, Loreto-Ucayali" },
                                    { "osp", "Old Spanish", "Spanish, Old" },
                                    { "spo", "Spokane", "Spokane" },
                                    { "squ", "Squamish", "Squamish" },
                                    { "srn", "Sranan Tongo", "Sranan Tongo" },
                                    { "sqs", "Sri Lankan Sign Language", "Sri Lankan Sign Language" },
                                    { "stl", "Stellingwerfs", "Stellingwerfs" },
                                    { "stt", "Budeh Stieng", "Stieng, Budeh" },
                                    { "sti", "Bulo Stieng", "Stieng, Bulo" },
                                    { "sto", "Stoney", "Stoney" },
                                    { "szp", "Suabo", "Suabo" },
                                    { "seo", "Suarmin", "Suarmin" },
                                    { "swp", "Suau", "Suau" },
                                    { "sxb", "Suba", "Suba" },
                                    { "syb", "Central Subanen", "Subanen, Central" },
                                    { "sfe", "Eastern Subanen", "Subanen, Eastern" },
                                    { "stb", "Northern Subanen", "Subanen, Northern" },
                                    { "laa", "Southern Subanen", "Subanen, Southern" },
                                    { "skn", "Kolibugan Subanon", "Subanon, Kolibugan" },
                                    { "suc", "Western Subanon", "Subanon, Western" },
                                    { "ssc", "Suba-Simbiti", "Suba-Simbiti" },
                                    { "xsj", "Subi", "Subi" },
                                    { "sbs", "Subiya", "Subiya" },
                                    { "sut", "Subtiaba", "Subtiaba" },
                                    { "tgo", "Sudest", "Sudest" },
                                    { "xsv", "Sudovian", "Sudovian" },
                                    { "sue", "Suena", "Suena" },
                                    { "sgi", "Suga", "Suga" },
                                    { "sug", "Suganga", "Suganga" },
                                    { "swi", "Sui", "Sui" },
                                    { "sui", "Suki", "Suki" },
                                    { "sub", "Suku", "Suku" },
                                    { "suk", "Sukuma", "Sukuma" },
                                    { "syk", "Sukur", "Sukur" },
                                    { "zsu", "Sukurum", "Sukurum" },
                                    { "szn", "Sula", "Sula" },
                                    { "sua", "Sulka", "Sulka" },
                                    { "srg", "Sulod", "Sulod" },
                                    { "sqm", "Suma", "Suma" },
                                    { "siv", "Sumariup", "Sumariup" },
                                    { "six", "Sumau", "Sumau" },
                                    { "smw", "Sumbawa", "Sumbawa" },
                                    { "suw", "Sumbwa", "Sumbwa" },
                                    { "sux", "Sumerian", "Sumerian" },
                                    { "ssk", "Sunam", "Sunam" },
                                    { "sun", "Sundanese", "Sundanese" },
                                    { "suz", "Sunwar", "Sunwar" },
                                    { "syo", "Suoy", "Suoy" },
                                    { "tdl", "Sur", "Sur" },
                                    { "sbj", "Surbakhal", "Surbakhal" },
                                    { "sgj", "Surgujia", "Surgujia" },
                                    { "suq", "Suri", "Suri" },
                                    { "sgd", "Surigaonon", "Surigaonon" },
                                    { "sjp", "Surjapuri", "Surjapuri" },
                                    { "sgz", "Sursurunga", "Sursurunga" },
                                    { "swx", "Suruahá", "Suruahá" },
                                    { "sde", "Surubu", "Surubu" },
                                    { "sru", "Suruí", "Suruí" },
                                    { "mdz", "Suruí Do Pará", "Suruí Do Pará" },
                                    { "sqn", "Susquehannock", "Susquehannock" },
                                    { "sus", "Susu", "Susu" },
                                    { "ssu", "Susuami", "Susuami" },
                                    { "sdj", "Suundi", "Suundi" },
                                    { "swu", "Suwawa", "Suwawa" },
                                    { "suy", "Suyá", "Suyá" },
                                    { "sva", "Svan", "Svan" },
                                    { "swg", "Swabian", "Swabian" },
                                    { "swh", "Swahili (individual language)", "Swahili (individual language)" },
                                    { "swa", "Swahili (macrolanguage)", "Swahili (macrolanguage)" },
                                    { "swc", "Congo Swahili", "Swahili, Congo" },
                                    { "ssw", "Swati", "Swati" },
                                    { "swe", "Swedish", "Swedish" },
                                    { "swl", "Swedish Sign Language", "Swedish Sign Language" },
                                    { "ssr", "Swiss-French Sign Language", "Swiss-French Sign Language" },
                                    { "sgg", "Swiss-German Sign Language", "Swiss-German Sign Language" },
                                    { "slf", "Swiss-Italian Sign Language", "Swiss-Italian Sign Language" },
                                    { "sox", "Swo", "Swo" },
                                    { "syl", "Sylheti", "Sylheti" },
                                    { "syr", "Syriac", "Syriac" },
                                    { "syc", "Classical Syriac", "Syriac, Classical" },
                                    { "tap", "Taabwa", "Taabwa" },
                                    { "tby", "Tabaru", "Tabaru" },
                                    { "tab", "Tabassaran", "Tabassaran" },
                                    { "tnm", "Tabla", "Tabla" },
                                    { "knv", "Tabo", "Tabo" },
                                    { "tzx", "Tabriak", "Tabriak" },
                                    { "tna", "Tacana", "Tacana" },
                                    { "shy", "Tachawit", "Tachawit" },
                                    { "shi", "Tachelhit", "Tachelhit" },
                                    { "dsq", "Tadaksahak", "Tadaksahak" },
                                    { "tdy", "Tadyawan", "Tadyawan" },
                                    { "rob", "Tae'", "Tae'" },
                                    { "tcd", "Tafi", "Tafi" },
                                    { "bgs", "Tagabawa", "Tagabawa" },
                                    { "klg", "Tagakaulo", "Tagakaulo" },
                                    { "tgz", "Tagalaka", "Tagalaka" },
                                    { "tgl", "Tagalog", "Tagalog" },
                                    { "oua", "Tagargrent", "Tagargrent" },
                                    { "tbw", "Tagbanwa", "Tagbanwa" },
                                    { "tbk", "Calamian Tagbanwa", "Tagbanwa, Calamian" },
                                    { "tgt", "Central Tagbanwa", "Tagbanwa, Central" },
                                    { "tbm", "Tagbu", "Tagbu" },
                                    { "tda", "Tagdal", "Tagdal" },
                                    { "tgj", "Tagin", "Tagin" },
                                    { "tgx", "Tagish", "Tagish" },
                                    { "tag", "Tagoi", "Tagoi" },
                                    { "tah", "Tahitian", "Tahitian" },
                                    { "tht", "Tahltan", "Tahltan" },
                                    { "taw", "Tai", "Tai" },
                                    { "tyr", "Tai Daeng", "Tai Daeng" },
                                    { "blt", "Tai Dam", "Tai Dam" },
                                    { "tyj", "Tai Do", "Tai Do" },
                                    { "twh", "Tai Dón", "Tai Dón" },
                                    { "thc", "Tai Hang Tong", "Tai Hang Tong" },
                                    { "tiz", "Tai Hongjin", "Tai Hongjin" },
                                    { "tjl", "Tai Laing", "Tai Laing" },
                                    { "tlq", "Tai Loi", "Tai Loi" },
                                    { "thi", "Tai Long", "Tai Long" },
                                    { "tmp", "Tai Mène", "Tai Mène" },
                                    { "tdd", "Tai Nüa", "Tai Nüa" },
                                    { "tpo", "Tai Pao", "Tai Pao" },
                                    { "tmm", "Tai Thanh", "Tai Thanh" },
                                    { "cuu", "Tai Ya", "Tai Ya" },
                                    { "gpn", "Taiap", "Taiap" },
                                    { "aos", "Taikat", "Taikat" },
                                    { "ago", "Tainae", "Tainae" },
                                    { "tnq", "Taino", "Taino" },
                                    { "tbg", "North Tairora", "Tairora, North" },
                                    { "omw", "South Tairora", "Tairora, South" },
                                    { "uar", "Tairuma", "Tairuma" },
                                    { "tss", "Taiwan Sign Language", "Taiwan Sign Language" },
                                    { "pee", "Taje", "Taje" },
                                    { "tgk", "Tajik", "Tajik" },
                                    { "tdj", "Tajio", "Tajio" },
                                    { "tja", "Tajuasohn", "Tajuasohn" },
                                    { "tkm", "Takelma", "Takelma" },
                                    { "tks", "Takestani", "Takestani" },
                                    { "tbc", "Takia", "Takia" },
                                    { "tkz", "Takua", "Takua" },
                                    { "nho", "Takuu", "Takuu" },
                                    { "tke", "Takwane", "Takwane" },
                                    { "tal", "Tal", "Tal" },
                                    { "tak", "Tala", "Tala" },
                                    { "tld", "Talaud", "Talaud" },
                                    { "tlv", "Taliabu", "Taliabu" },
                                    { "tdf", "Talieng", "Talieng" },
                                    { "tlj", "Talinga-Bwisi", "Talinga-Bwisi" },
                                    { "tlr", "Talise", "Talise" },
                                    { "tlo", "Talodi", "Talodi" },
                                    { "tlk", "Taloki", "Taloki" },
                                    { "tln", "Talondo'", "Talondo'" },
                                    { "yta", "Talu", "Talu" },
                                    { "ilw", "Talur", "Talur" },
                                    { "tly", "Talysh", "Talysh" },
                                    { "tma", "Tama (Chad)", "Tama (Chad)" },
                                    { "ten", "Tama (Colombia)", "Tama (Colombia)" },
                                    { "tcg", "Tamagario", "Tamagario" },
                                    { "thv", "Tahaggart Tamahaq", "Tamahaq, Tahaggart" },
                                    { "ttq", "Tawallammat Tamajaq", "Tamajaq, Tawallammat" },
                                    { "thz", "Tayart Tamajeq", "Tamajeq, Tayart" },
                                    { "tmn", "Taman (Indonesia)", "Taman (Indonesia)" },
                                    { "tcl", "Taman (Myanmar)", "Taman (Myanmar)" },
                                    { "tmz", "Tamanaku", "Tamanaku" },
                                    { "taj", "Eastern Tamang", "Tamang, Eastern" },
                                    { "tge", "Eastern Gorkha Tamang", "Tamang, Eastern Gorkha" },
                                    { "tmk", "Northwestern Tamang", "Tamang, Northwestern" },
                                    { "tsf", "Southwestern Tamang", "Tamang, Southwestern" },
                                    { "tdg", "Western Tamang", "Tamang, Western" },
                                    { "tmh", "Tamashek", "Tamashek" },
                                    { "taq", "Tamasheq", "Tamasheq" },
                                    { "tzm", "Central Atlas Tamazight", "Tamazight, Central Atlas" },
                                    { "tjo", "Temacine Tamazight", "Tamazight, Temacine" },
                                    { "tia", "Tidikelt Tamazight", "Tamazight, Tidikelt" },
                                    { "tdk", "Tambas", "Tambas" },
                                    { "xxt", "Tambora", "Tambora" },
                                    { "tls", "Tambotalo", "Tambotalo" },
                                    { "tmy", "Tami", "Tami" },
                                    { "tam", "Tamil", "Tamil" },
                                    { "oty", "Old Tamil", "Tamil, Old" },
                                    { "tax", "Tamki", "Tamki" },
                                    { "tpu", "Tampuan", "Tampuan" },
                                    { "tpm", "Tampulma", "Tampulma" },
                                    { "tcb", "Tanacross", "Tanacross" },
                                    { "tcm", "Tanahmerah", "Tanahmerah" },
                                    { "tfn", "Tanaina", "Tanaina" },
                                    { "taa", "Lower Tanana", "Tanana, Lower" },
                                    { "tau", "Upper Tanana", "Tanana, Upper" },
                                    { "tpv", "Tanapag", "Tanapag" },
                                    { "tgn", "Tandaganon", "Tandaganon" },
                                    { "tni", "Tandia", "Tandia" },
                                    { "tnx", "Tanema", "Tanema" },
                                    { "tan", "Tangale", "Tangale" },
                                    { "tnv", "Tangchangya", "Tangchangya" },
                                    { "tgg", "Tangga", "Tangga" },
                                    { "tgu", "Tanggu", "Tanggu" },
                                    { "tkx", "Tangko", "Tangko" },
                                    { "ytl", "Tanglang", "Tanglang" },
                                    { "tgp", "Tangoa", "Tangoa" },
                                    { "tbs", "Tanguat", "Tanguat" },
                                    { "txg", "Tangut", "Tangut" },
                                    { "tbe", "Tanimbili", "Tanimbili" },
                                    { "tnc", "Tanimuca-Retuarã", "Tanimuca-Retuarã" },
                                    { "uji", "Tanjijili", "Tanjijili" },
                                    { "tnn", "North Tanna", "Tanna, North" },
                                    { "nwi", "Southwest Tanna", "Tanna, Southwest" },
                                    { "tza", "Tanzanian Sign Language", "Tanzanian Sign Language" },
                                    { "tto", "Lower Ta'oih", "Ta'oih, Lower" },
                                    { "tth", "Upper Ta'oih", "Ta'oih, Upper" },
                                    { "tbb", "Tapeba", "Tapeba" },
                                    { "afp", "Tapei", "Tapei" },
                                    { "tpj", "Tapieté", "Tapieté" },
                                    { "taf", "Tapirapé", "Tapirapé" },
                                    { "tar", "Central Tarahumara", "Tarahumara, Central" },
                                    { "tac", "Lowland Tarahumara", "Tarahumara, Lowland" },
                                    { "thh", "Northern Tarahumara", "Tarahumara, Northern" },
                                    { "tcu", "Southeastern Tarahumara", "Tarahumara, Southeastern" },
                                    { "twr", "Southwestern Tarahumara", "Tarahumara, Southwestern" },
                                    { "tre", "East Tarangan", "Tarangan, East" },
                                    { "txn", "West Tarangan", "Tarangan, West" },
                                    { "tgr", "Tareng", "Tareng" },
                                    { "tae", "Tariana", "Tariana" },
                                    { "rif", "Tarifit", "Tarifit" },
                                    { "yer", "Tarok", "Tarok" },
                                    { "trv", "Taroko", "Taroko" },
                                    { "tov", "Upper Taromi", "Taromi, Upper" },
                                    { "tpf", "Tarpia", "Tarpia" },
                                    { "txr", "Tartessian", "Tartessian" },
                                    { "twq", "Tasawaq", "Tasawaq" },
                                    { "xtz", "Tasmanian", "Tasmanian" },
                                    { "tmt", "Tasmate", "Tasmate" },
                                    { "ttt", "Muslim Tat", "Tat, Muslim" },
                                    { "txx", "Tatana", "Tatana" },
                                    { "tat", "Tatar", "Tatar" },
                                    { "tav", "Tatuyo", "Tatuyo" },
                                    { "ttd", "Tauade", "Tauade" },
                                    { "tuh", "Taulil", "Taulil" },
                                    { "tco", "Taungyo", "Taungyo" },
                                    { "tpa", "Taupota", "Taupota" },
                                    { "tad", "Tause", "Tause" },
                                    { "trr", "Taushiro", "Taushiro" },
                                    { "tsg", "Tausug", "Tausug" },
                                    { "tya", "Tauya", "Tauya" },
                                    { "tvs", "Taveta", "Taveta" },
                                    { "tvn", "Tavoyan", "Tavoyan" },
                                    { "tbo", "Tawala", "Tawala" },
                                    { "xtw", "Tawandê", "Tawandê" },
                                    { "twl", "Tawara", "Tawara" },
                                    { "bnj", "Eastern Tawbuid", "Tawbuid, Eastern" },
                                    { "twb", "Western Tawbuid", "Tawbuid, Western" },
                                    { "tbp", "Taworta", "Taworta" },
                                    { "twy", "Tawoyan", "Tawoyan" },
                                    { "tyz", "Tày", "Tày" },
                                    { "tas", "Tay Boi", "Tay Boi" },
                                    { "tnu", "Tay Khang", "Tay Khang" },
                                    { "tys", "Tày Sa Pa", "Tày Sa Pa" },
                                    { "tyt", "Tày Tac", "Tày Tac" },
                                    { "cks", "Tayo", "Tayo" },
                                    { "grr", "Taznatit", "Taznatit" },
                                    { "tbl", "Tboli", "Tboli" },
                                    { "tck", "Tchitchege", "Tchitchege" },
                                    { "bqa", "Tchumbuli", "Tchumbuli" },
                                    { "tkw", "Teanu", "Teanu" },
                                    { "tsy", "Tebul Sign Language", "Tebul Sign Language" },
                                    { "tuq", "Tedaga", "Tedaga" },
                                    { "tkq", "Tee", "Tee" },
                                    { "lor", "Téén", "Téén" },
                                    { "tfo", "Tefaro", "Tefaro" },
                                    { "ras", "Tegali", "Tegali" },
                                    { "kps", "Tehit", "Tehit" },
                                    { "teh", "Tehuelche", "Tehuelche" },
                                    { "tek", "Ibali Teke", "Teke, Ibali" },
                                    { "ebo", "Teke-Ebo", "Teke-Ebo" },
                                    { "ifm", "Teke-Fuumu", "Teke-Fuumu" },
                                    { "kkw", "Teke-Kukuya", "Teke-Kukuya" },
                                    { "lli", "Teke-Laali", "Teke-Laali" },
                                    { "nzu", "Teke-Nzikou", "Teke-Nzikou" },
                                    { "teg", "Teke-Tege", "Teke-Tege" },
                                    { "tyi", "Teke-Tsaayi", "Teke-Tsaayi" },
                                    { "tyx", "Teke-Tyee", "Teke-Tyee" },
                                    { "ttc", "Tektiteko", "Tektiteko" },
                                    { "tvm", "Tela-Masbuar", "Tela-Masbuar" },
                                    { "tlf", "Telefol", "Telefol" },
                                    { "tel", "Telugu", "Telugu" },
                                    { "tlt", "Teluti", "Teluti" },
                                    { "kdh", "Tem", "Tem" },
                                    { "tqb", "Tembé", "Tembé" },
                                    { "tbt", "Tembo (Kitembo)", "Tembo (Kitembo)" },
                                    { "tmv", "Tembo (Motembo)", "Tembo (Motembo)" },
                                    { "tdo", "Teme", "Teme" },
                                    { "teq", "Temein", "Temein" },
                                    { "soz", "Temi", "Temi" },
                                    { "tea", "Temiar", "Temiar" },
                                    { "tmo", "Temoq", "Temoq" },
                                    { "tmw", "Temuan", "Temuan" },
                                    { "tct", "T'en", "T'en" },
                                    { "tes", "Tengger", "Tengger" },
                                    { "pah", "Tenharim", "Tenharim" },
                                    { "tqn", "Tenino", "Tenino" },
                                    { "tns", "Tenis", "Tenis" },
                                    { "tex", "Tennet", "Tennet" },
                                    { "tio", "Teop", "Teop" },
                                    { "tev", "Teor", "Teor" },
                                    { "tep", "Tepecano", "Tepecano" },
                                    { "tee", "Huehuetla Tepehua", "Tepehua, Huehuetla" },
                                    { "tpp", "Pisaflores Tepehua", "Tepehua, Pisaflores" },
                                    { "tpt", "Tlachichilco Tepehua", "Tepehua, Tlachichilco" },
                                    { "ntp", "Northern Tepehuan", "Tepehuan, Northern" },
                                    { "stp", "Southeastern Tepehuan", "Tepehuan, Southeastern" },
                                    { "tla", "Southwestern Tepehuan", "Tepehuan, Southwestern" },
                                    { "ttr", "Tera", "Tera" },
                                    { "trb", "Terebu", "Terebu" },
                                    { "buo", "Terei", "Terei" },
                                    { "ter", "Tereno", "Tereno" },
                                    { "tef", "Teressa", "Teressa" },
                                    { "twg", "Tereweng", "Tereweng" },
                                    { "tfr", "Teribe", "Teribe" },
                                    { "tec", "Terik", "Terik" },
                                    { "twu", "Termanu", "Termanu" },
                                    { "tft", "Ternate", "Ternate" },
                                    { "tmg", "Ternateño", "Ternateño" },
                                    { "keg", "Tese", "Tese" },
                                    { "twc", "Teshenawa", "Teshenawa" },
                                    { "teo", "Teso", "Teso" },
                                    { "tll", "Tetela", "Tetela" },
                                    { "teb", "Tetete", "Tetete" },
                                    { "tet", "Tetum", "Tetum" },
                                    { "tdt", "Tetun Dili", "Tetun Dili" },
                                    { "tve", "Te'un", "Te'un" },
                                    { "twe", "Tewa (Indonesia)", "Tewa (Indonesia)" },
                                    { "tew", "Tewa (USA)", "Tewa (USA)" },
                                    { "twx", "Tewe", "Tewe" },
                                    { "thy", "Tha", "Tha" },
                                    { "thn", "Thachanadan", "Thachanadan" },
                                    { "tha", "Thai", "Thai" },
                                    { "tsq", "Thai Sign Language", "Thai Sign Language" },
                                    { "soa", "Thai Song", "Thai Song" },
                                    { "tts", "Northeastern Thai", "Thai, Northeastern" },
                                    { "nod", "Northern Thai", "Thai, Northern" },
                                    { "sou", "Southern Thai", "Thai, Southern" },
                                    { "ths", "Thakali", "Thakali" },
                                    { "thf", "Thangmi", "Thangmi" },
                                    { "ssf", "Thao", "Thao" },
                                    { "thk", "Tharaka", "Tharaka" },
                                    { "the", "Chitwania Tharu", "Tharu, Chitwania" },
                                    { "thl", "Dangaura Tharu", "Tharu, Dangaura" },
                                    { "tkt", "Kathoriya Tharu", "Tharu, Kathoriya" },
                                    { "thq", "Kochila Tharu", "Tharu, Kochila" },
                                    { "thr", "Rana Tharu", "Tharu, Rana" },
                                    { "thd", "Thayore", "Thayore" },
                                    { "typ", "Thaypan", "Thaypan" },
                                    { "thx", "The", "The" },
                                    { "tou", "Tho", "Tho" },
                                    { "thp", "Thompson", "Thompson" },
                                    { "ytp", "Thopho", "Thopho" },
                                    { "txh", "Thracian", "Thracian" },
                                    { "tyl", "Thu Lao", "Thu Lao" },
                                    { "thw", "Thudam", "Thudam" },
                                    { "tdh", "Thulung", "Thulung" },
                                    { "tbh", "Thurawal", "Thurawal" },
                                    { "thu", "Thuri", "Thuri" },
                                    { "mnl", "Tiale", "Tiale" },
                                    { "tbj", "Tiang", "Tiang" },
                                    { "ngy", "Tibea", "Tibea" },
                                    { "bod", "Tibetan", "Tibetan" },
                                    { "adx", "Amdo Tibetan", "Tibetan, Amdo" },
                                    { "xct", "Classical Tibetan", "Tibetan, Classical" },
                                    { "khg", "Khams Tibetan", "Tibetan, Khams" },
                                    { "otb", "Old Tibetan", "Tibetan, Old" },
                                    { "tcn", "Tichurong", "Tichurong" },
                                    { "tca", "Ticuna", "Ticuna" },
                                    { "tid", "Tidong", "Tidong" },
                                    { "tvo", "Tidore", "Tidore" },
                                    { "tiq", "Tiéfo", "Tiéfo" },
                                    { "tii", "Tiene", "Tiene" },
                                    { "tif", "Tifal", "Tifal" },
                                    { "tgc", "Tigak", "Tigak" },
                                    { "tig", "Tigre", "Tigre" },
                                    { "tir", "Tigrinya", "Tigrinya" },
                                    { "txq", "Tii", "Tii" },
                                    { "tik", "Tikar", "Tikar" },
                                    { "tkp", "Tikopia", "Tikopia" },
                                    { "til", "Tillamook", "Tillamook" },
                                    { "tij", "Tilung", "Tilung" },
                                    { "tms", "Tima", "Tima" },
                                    { "tim", "Timbe", "Timbe" },
                                    { "tem", "Timne", "Timne" },
                                    { "tjm", "Timucua", "Timucua" },
                                    { "lbf", "Tinani", "Tinani" },
                                    { "tin", "Tindi", "Tindi" },
                                    { "tgv", "Tingui-Boto", "Tingui-Boto" },
                                    { "tit", "Tinigua", "Tinigua" },
                                    { "tpz", "Tinputz", "Tinputz" },
                                    { "tpe", "Tippera", "Tippera" },
                                    { "tic", "Tira", "Tira" },
                                    { "tra", "Tirahi", "Tirahi" },
                                    { "cir", "Tiri", "Tiri" },
                                    { "tiy", "Tiruray", "Tiruray" },
                                    { "tdq", "Tita", "Tita" },
                                    { "ttv", "Titan", "Titan" },
                                    { "tiv", "Tiv", "Tiv" },
                                    { "lax", "Tiwa", "Tiwa" },
                                    { "twf", "Northern Tiwa", "Tiwa, Northern" },
                                    { "tix", "Southern Tiwa", "Tiwa, Southern" },
                                    { "tiw", "Tiwi", "Tiwi" },
                                    { "tju", "Tjurruru", "Tjurruru" },
                                    { "tpx", "Acatepec Tlapanec", "Tlapanec, Acatepec" },
                                    { "tpc", "Azoyú Tlapanec", "Tlapanec, Azoyú" },
                                    { "tcf", "Malinaltepec Tlapanec", "Tlapanec, Malinaltepec" },
                                    { "tpl", "Tlacoapa Tlapanec", "Tlapanec, Tlacoapa" },
                                    { "tlh", "tlhIngan-Hol", "tlhIngan-Hol" },
                                    { "tli", "Tlingit", "Tlingit" },
                                    { "toz", "To", "To" },
                                    { "mlu", "To'abaita", "To'abaita" },
                                    { "tqo", "Toaripi", "Toaripi" },
                                    { "tob", "Toba", "Toba" },
                                    { "tmf", "Toba-Maskoy", "Toba-Maskoy" },
                                    { "tng", "Tobanga", "Tobanga" },
                                    { "tti", "Tobati", "Tobati" },
                                    { "tlb", "Tobelo", "Tobelo" },
                                    { "tox", "Tobian", "Tobian" },
                                    { "tgb", "Tobilung", "Tobilung" },
                                    { "tbv", "Tobo", "Tobo" },
                                    { "taz", "Tocho", "Tocho" },
                                    { "tcx", "Toda", "Toda" },
                                    { "tdr", "Todrah", "Todrah" },
                                    { "tlg", "Tofanma", "Tofanma" },
                                    { "tgy", "Togoyo", "Togoyo" },
                                    { "ood", "Tohono O'odham", "Tohono O'odham" },
                                    { "toj", "Tojolabal", "Tojolabal" },
                                    { "tpi", "Tok Pisin", "Tok Pisin" },
                                    { "zuh", "Tokano", "Tokano" },
                                    { "tkl", "Tokelau", "Tokelau" },
                                    { "xto", "Tokharian A", "Tokharian A" },
                                    { "txb", "Tokharian B", "Tokharian B" },
                                    { "tkn", "Toku-No-Shima", "Toku-No-Shima" },
                                    { "jic", "Tol", "Tol" },
                                    { "lbw", "Tolaki", "Tolaki" },
                                    { "tlm", "Tolomako", "Tolomako" },
                                    { "tol", "Tolowa", "Tolowa" },
                                    { "tod", "Toma", "Toma" },
                                    { "tdi", "Tomadino", "Tomadino" },
                                    { "ttp", "Tombelala", "Tombelala" },
                                    { "txa", "Tombonuo", "Tombonuo" },
                                    { "tom", "Tombulu", "Tombulu" },
                                    { "toe", "Tomedes", "Tomedes" },
                                    { "txm", "Tomini", "Tomini" },
                                    { "tqp", "Tomoip", "Tomoip" },
                                    { "tdn", "Tondano", "Tondano" },
                                    { "tog", "Tonga (Nyasa)", "Tonga (Nyasa)" },
                                    { "tnz", "Tonga (Thailand)", "Tonga (Thailand)" },
                                    { "ton", "Tonga (Tonga Islands)", "Tonga (Tonga Islands)" },
                                    { "toi", "Tonga (Zambia)", "Tonga (Zambia)" },
                                    { "tny", "Tongwe", "Tongwe" },
                                    { "tjn", "Tonjon", "Tonjon" },
                                    { "tqw", "Tonkawa", "Tonkawa" },
                                    { "tnw", "Tonsawang", "Tonsawang" },
                                    { "txs", "Tonsea", "Tonsea" },
                                    { "tnt", "Tontemboan", "Tontemboan" },
                                    { "ttj", "Tooro", "Tooro" },
                                    { "toy", "Topoiyo", "Topoiyo" },
                                    { "toq", "Toposa", "Toposa" },
                                    { "trz", "Torá", "Torá" },
                                    { "sda", "Toraja-Sa'dan", "Toraja-Sa'dan" },
                                    { "trj", "Toram", "Toram" },
                                    { "ttu", "Torau", "Torau" },
                                    { "tdv", "Toro", "Toro" },
                                    { "tno", "Toromono", "Toromono" },
                                    { "tqr", "Torona", "Torona" },
                                    { "tei", "Torricelli", "Torricelli" },
                                    { "trw", "Torwali", "Torwali" },
                                    { "ttl", "Totela", "Totela" },
                                    { "txo", "Toto", "Toto" },
                                    { "txe", "Totoli", "Totoli" },
                                    { "toc", "Coyutla Totonac", "Totonac, Coyutla" },
                                    { "tlp", "Filomena Mata-Coahuitlán Totonac", "Totonac, Filomena Mata-Coahuitlán" },
                                    { "tos", "Highland Totonac", "Totonac, Highland" },
                                    { "top", "Papantla Totonac", "Totonac, Papantla" },
                                    { "tcw", "Tecpatlán Totonac", "Totonac, Tecpatlán" },
                                    { "tku", "Upper Necaxa Totonac", "Totonac, Upper Necaxa" },
                                    { "tqt", "Western Totonac", "Totonac, Western" },
                                    { "too", "Xicotepec De Juárez Totonac", "Totonac, Xicotepec De Juárez" },
                                    { "tlc", "Yecuatla Totonac", "Totonac, Yecuatla" },
                                    { "ttk", "Totoro", "Totoro" },
                                    { "tqu", "Touo", "Touo" },
                                    { "neb", "Toura (Côte d'Ivoire)", "Toura (Côte d'Ivoire)" },
                                    { "don", "Toura (Papua New Guinea)", "Toura (Papua New Guinea)" },
                                    { "tsp", "Northern Toussian", "Toussian, Northern" },
                                    { "wib", "Southern Toussian", "Toussian, Southern" },
                                    { "ttn", "Towei", "Towei" },
                                    { "trm", "Tregami", "Tregami" },
                                    { "tme", "Tremembé", "Tremembé" },
                                    { "stg", "Trieng", "Trieng" },
                                    { "tip", "Trimuris", "Trimuris" },
                                    { "tgq", "Tring", "Tring" },
                                    { "lst", "Trinidad and Tobago Sign Language", "Trinidad and Tobago Sign Language" },
                                    { "trn", "Trinitario", "Trinitario" },
                                    { "tri", "Trió", "Trió" },
                                    { "xtr", "Early Tripuri", "Tripuri, Early" },
                                    { "trs", "Chicahuaxtla Triqui", "Triqui, Chicahuaxtla" },
                                    { "trc", "Copala Triqui", "Triqui, Copala" },
                                    { "trq", "San Martín Itunyoso Triqui", "Triqui, San Martín Itunyoso" },
                                    { "tka", "Truká", "Truká" },
                                    { "tpy", "Trumai", "Trumai" },
                                    { "tsa", "Tsaangi", "Tsaangi" },
                                    { "tkr", "Tsakhur", "Tsakhur" },
                                    { "tsd", "Tsakonian", "Tsakonian" },
                                    { "tsb", "Tsamai", "Tsamai" },
                                    { "huq", "Tsat", "Tsat" },
                                    { "kvz", "Tsaukambo", "Tsaukambo" },
                                    { "tsk", "Tseku", "Tseku" },
                                    { "txc", "Tsetsaut", "Tsetsaut" },
                                    { "tsj", "Tshangla", "Tshangla" },
                                    { "kdl", "Tsikimba", "Tsikimba" },
                                    { "cas", "Tsimané", "Tsimané" },
                                    { "tsi", "Tsimshian", "Tsimshian" },
                                    { "tsw", "Tsishingini", "Tsishingini" },
                                    { "ldp", "Tso", "Tso" },
                                    { "hio", "Tsoa", "Tsoa" },
                                    { "tsv", "Tsogo", "Tsogo" },
                                    { "tso", "Tsonga", "Tsonga" },
                                    { "fly", "Tsotsitaal", "Tsotsitaal" },
                                    { "tsu", "Tsou", "Tsou" },
                                    { "ttz", "Tsum", "Tsum" },
                                    { "tsl", "Ts'ün-Lao", "Ts'ün-Lao" },
                                    { "tvd", "Tsuvadi", "Tsuvadi" },
                                    { "tsh", "Tsuvan", "Tsuvan" },
                                    { "tsc", "Tswa", "Tswa" },
                                    { "tsn", "Tswana", "Tswana" },
                                    { "two", "Tswapong", "Tswapong" },
                                    { "mjg", "Tu", "Tu" },
                                    { "pmt", "Tuamotuan", "Tuamotuan" },
                                    { "tbu", "Tubar", "Tubar" },
                                    { "tub", "Tübatulabal", "Tübatulabal" },
                                    { "tuo", "Tucano", "Tucano" },
                                    { "tuy", "Tugen", "Tugen" },
                                    { "tzn", "Tugun", "Tugun" },
                                    { "tuj", "Tugutil", "Tugutil" },
                                    { "tji", "Northern Tujia", "Tujia, Northern" },
                                    { "tjs", "Southern Tujia", "Tujia, Southern" },
                                    { "khc", "Tukang Besi North", "Tukang Besi North" },
                                    { "bhq", "Tukang Besi South", "Tukang Besi South" },
                                    { "bag", "Tuki", "Tuki" },
                                    { "tpq", "Tukpa", "Tukpa" },
                                    { "tkd", "Tukudede", "Tukudede" },
                                    { "tkf", "Tukumanféd", "Tukumanféd" },
                                    { "tul", "Tula", "Tula" },
                                    { "tlu", "Tulehu", "Tulehu" },
                                    { "tey", "Tulishi", "Tulishi" },
                                    { "tcy", "Tulu", "Tulu" },
                                    { "rak", "Tulu-Bohuai", "Tulu-Bohuai" },
                                    { "iou", "Tuma-Irumu", "Tuma-Irumu" },
                                    { "tmc", "Tumak", "Tumak" },
                                    { "tum", "Tumbuka", "Tumbuka" },
                                    { "kku", "Tumi", "Tumi" },
                                    { "tmq", "Tumleo", "Tumleo" },
                                    { "xtq", "Tumshuqese", "Tumshuqese" },
                                    { "tbr", "Tumtum", "Tumtum" },
                                    { "mzb", "Tumzabt", "Tumzabt" },
                                    { "tnd", "Angosturas Tunebo", "Tunebo, Angosturas" },
                                    { "tbn", "Barro Negro Tunebo", "Tunebo, Barro Negro" },
                                    { "tuf", "Central Tunebo", "Tunebo, Central" },
                                    { "tnb", "Western Tunebo", "Tunebo, Western" },
                                    { "tvu", "Tunen", "Tunen" },
                                    { "lcm", "Tungag", "Tungag" },
                                    { "trt", "Tunggare", "Tunggare" },
                                    { "tug", "Tunia", "Tunia" },
                                    { "tun", "Tunica", "Tunica" },
                                    { "tse", "Tunisian Sign Language", "Tunisian Sign Language" },
                                    { "tjg", "Tunjung", "Tunjung" },
                                    { "tqq", "Tunni", "Tunni" },
                                    { "dza", "Tunzu", "Tunzu" },
                                    { "ttf", "Tuotomb", "Tuotomb" },
                                    { "tpr", "Tuparí", "Tuparí" },
                                    { "tpw", "Tupí", "Tupí" },
                                    { "tpn", "Tupinambá", "Tupinambá" },
                                    { "tpk", "Tupinikin", "Tupinikin" },
                                    { "tui", "Tupuri", "Tupuri" },
                                    { "trh", "Turaka", "Turaka" },
                                    { "trd", "Turi", "Turi" },
                                    { "twt", "Turiwára", "Turiwára" },
                                    { "tuz", "Turka", "Turka" },
                                    { "tuv", "Turkana", "Turkana" },
                                    { "tur", "Turkish", "Turkish" },
                                    { "tsm", "Turkish Sign Language", "Turkish Sign Language" },
                                    { "bgx", "Balkan Gagauz Turkish", "Turkish, Balkan Gagauz" },
                                    { "crh", "Crimean Turkish", "Turkish, Crimean" },
                                    { "otk", "Old Turkish", "Turkish, Old" },
                                    { "ota", "Ottoman Turkish (1500-1928)", "Turkish, Ottoman (1500-1928)" },
                                    { "tuk", "Turkmen", "Turkmen" },
                                    { "tru", "Turoyo", "Turoyo" },
                                    { "tqm", "Turumsa", "Turumsa" },
                                    { "try", "Turung", "Turung" },
                                    { "tus", "Tuscarora", "Tuscarora" },
                                    { "ttm", "Northern Tutchone", "Tutchone, Northern" },
                                    { "tce", "Southern Tutchone", "Tutchone, Southern" },
                                    { "tta", "Tutelo", "Tutelo" },
                                    { "ttg", "Tutong", "Tutong" },
                                    { "tmi", "Tutuba", "Tutuba" },
                                    { "tuu", "Tututni", "Tututni" },
                                    { "tvl", "Tuvalu", "Tuvalu" },
                                    { "tyv", "Tuvinian", "Tuvinian" },
                                    { "tww", "Tuwari", "Tuwari" },
                                    { "bov", "Tuwuli", "Tuwuli" },
                                    { "tud", "Tuxá", "Tuxá" },
                                    { "tux", "Tuxináwa", "Tuxináwa" },
                                    { "tue", "Tuyuca", "Tuyuca" },
                                    { "twa", "Twana", "Twana" },
                                    { "twn", "Twendi", "Twendi" },
                                    { "twd", "Twents", "Twents" },
                                    { "twi", "Twi", "Twi" },
                                    { "kcg", "Tyap", "Tyap" },
                                    { "woa", "Tyaraity", "Tyaraity" },
                                    { "tzh", "Tzeltal", "Tzeltal" },
                                    { "tzo", "Tzotzil", "Tzotzil" },
                                    { "tzj", "Tz'utujil", "Tz'utujil" },
                                    { "uuu", "U", "U" },
                                    { "aoz", "Uab Meto", "Uab Meto" },
                                    { "uam", "Uamué", "Uamué" },
                                    { "ksj", "Uare", "Uare" },
                                    { "byc", "Ubaghara", "Ubaghara" },
                                    { "uba", "Ubang", "Ubang" },
                                    { "ubi", "Ubi", "Ubi" },
                                    { "ubr", "Ubir", "Ubir" },
                                    { "uby", "Ubykh", "Ubykh" },
                                    { "uda", "Uda", "Uda" },
                                    { "udi", "Udi", "Udi" },
                                    { "ude", "Udihe", "Udihe" },
                                    { "udm", "Udmurt", "Udmurt" },
                                    { "udu", "Uduk", "Uduk" },
                                    { "ufi", "Ufim", "Ufim" },
                                    { "ugn", "Ugandan Sign Language", "Ugandan Sign Language" },
                                    { "uga", "Ugaritic", "Ugaritic" },
                                    { "uge", "Ughele", "Ughele" },
                                    { "ugo", "Ugong", "Ugong" },
                                    { "uha", "Uhami", "Uhami" },
                                    { "oui", "Old Uighur", "Uighur, Old" },
                                    { "uis", "Uisai", "Uisai" },
                                    { "udj", "Ujir", "Ujir" },
                                    { "kcf", "Ukaan", "Ukaan" },
                                    { "ukh", "Ukhwejo", "Ukhwejo" },
                                    { "umi", "Ukit", "Ukit" },
                                    { "ukp", "Ukpe-Bayobiri", "Ukpe-Bayobiri" },
                                    { "akd", "Ukpet-Ehom", "Ukpet-Ehom" },
                                    { "ukr", "Ukrainian", "Ukrainian" },
                                    { "ukl", "Ukrainian Sign Language", "Ukrainian Sign Language" },
                                    { "uku", "Ukue", "Ukue" },
                                    { "ukg", "Ukuriguma", "Ukuriguma" },
                                    { "ukq", "Ukwa", "Ukwa" },
                                    { "ukw", "Ukwuani-Aboh-Ndoni", "Ukwuani-Aboh-Ndoni" },
                                    { "svb", "Ulau-Suain", "Ulau-Suain" },
                                    { "ulc", "Ulch", "Ulch" },
                                    { "uli", "Ulithian", "Ulithian" },
                                    { "ull", "Ullatan", "Ullatan" },
                                    { "ulb", "Ulukwumi", "Ulukwumi" },
                                    { "ulm", "Ulumanda'", "Ulumanda'" },
                                    { "ulw", "Ulwa", "Ulwa" },
                                    { "ppk", "Uma", "Uma" },
                                    { "xky", "Uma' Lasan", "Uma' Lasan" },
                                    { "ulu", "Uma' Lung", "Uma' Lung" },
                                    { "gdn", "Umanakaina", "Umanakaina" },
                                    { "uma", "Umatilla", "Umatilla" },
                                    { "umd", "Umbindhamu", "Umbindhamu" },
                                    { "xum", "Umbrian", "Umbrian" },
                                    { "umr", "Umbugarla", "Umbugarla" },
                                    { "umb", "Umbundu", "Umbundu" },
                                    { "ubu", "Umbu-Ungu", "Umbu-Ungu" },
                                    { "umg", "Umbuygamu", "Umbuygamu" },
                                    { "upi", "Umeda", "Umeda" },
                                    { "xud", "Umiida", "Umiida" },
                                    { "umm", "Umon", "Umon" },
                                    { "umo", "Umotína", "Umotína" },
                                    { "ump", "Umpila", "Umpila" },
                                    { "xup", "Upper Umpqua", "Umpqua, Upper" },
                                    { "mtg", "Una", "Una" },
                                    { "unm", "Unami", "Unami" },
                                    { "mis", "Uncoded languages", "Uncoded languages" },
                                    { "und", "Undetermined", "Undetermined" },
                                    { "bbn", "Uneapa", "Uneapa" },
                                    { "une", "Uneme", "Uneme" },
                                    { "xun", "Unggarranggu", "Unggarranggu" },
                                    { "xgu", "Unggumi", "Unggumi" },
                                    { "uln", "Unserdeutsch", "Unserdeutsch" },
                                    { "onu", "Unua", "Unua" },
                                    { "uok", "Uokha", "Uokha" },
                                    { "uro", "Ura (Papua New Guinea)", "Ura (Papua New Guinea)" },
                                    { "uur", "Ura (Vanuatu)", "Ura (Vanuatu)" },
                                    { "urf", "Uradhi", "Uradhi" },
                                    { "urk", "Urak Lawoi'", "Urak Lawoi'" },
                                    { "url", "Urali", "Urali" },
                                    { "urm", "Urapmin", "Urapmin" },
                                    { "ura", "Urarina", "Urarina" },
                                    { "xur", "Urartian", "Urartian" },
                                    { "urt", "Urat", "Urat" },
                                    { "urd", "Urdu", "Urdu" },
                                    { "urh", "Urhobo", "Urhobo" },
                                    { "uvh", "Uri", "Uri" },
                                    { "urg", "Urigina", "Urigina" },
                                    { "uri", "Urim", "Urim" },
                                    { "urx", "Urimo", "Urimo" },
                                    { "upv", "Uripiv-Wala-Rano-Atchin", "Uripiv-Wala-Rano-Atchin" },
                                    { "urc", "Urningangg", "Urningangg" },
                                    { "ure", "Uru", "Uru" },
                                    { "urn", "Uruangnirin", "Uruangnirin" },
                                    { "urv", "Uruava", "Uruava" },
                                    { "urb", "Urubú-Kaapor", "Urubú-Kaapor" },
                                    { "uks", "Urubú-Kaapor Sign Language", "Urubú-Kaapor Sign Language" },
                                    { "urz", "Uru-Eu-Wau-Wau", "Uru-Eu-Wau-Wau" },
                                    { "ugy", "Uruguayan Sign Language", "Uruguayan Sign Language" },
                                    { "uum", "Urum", "Urum" },
                                    { "uru", "Urumi", "Urumi" },
                                    { "urp", "Uru-Pa-In", "Uru-Pa-In" },
                                    { "usk", "Usaghade", "Usaghade" },
                                    { "wnu", "Usan", "Usan" },
                                    { "usa", "Usarufa", "Usarufa" },
                                    { "ush", "Ushojo", "Ushojo" },
                                    { "ulf", "Usku", "Usku" },
                                    { "usp", "Uspanteco", "Uspanteco" },
                                    { "usi", "Usui", "Usui" },
                                    { "omo", "Utarmbung", "Utarmbung" },
                                    { "ute", "Ute-Southern Paiute", "Ute-Southern Paiute" },
                                    { "gel", "ut-Ma'in", "ut-Ma'in" },
                                    { "utu", "Utu", "Utu" },
                                    { "evh", "Uvbie", "Uvbie" },
                                    { "uve", "West Uvean", "Uvean, West" },
                                    { "usu", "Uya", "Uya" },
                                    { "duk", "Uyajitaya", "Uyajitaya" },
                                    { "uig", "Uyghur", "Uyghur" },
                                    { "uzb", "Uzbek", "Uzbek" },
                                    { "uzn", "Northern Uzbek", "Uzbek, Northern" },
                                    { "uzs", "Southern Uzbek", "Uzbek, Southern" },
                                    { "eze", "Uzekwe", "Uzekwe" },
                                    { "vaa", "Vaagri Booli", "Vaagri Booli" },
                                    { "vaf", "Vafsi", "Vafsi" },
                                    { "bij", "Vaghat-Ya-Bijim-Legeri", "Vaghat-Ya-Bijim-Legeri" },
                                    { "vgr", "Vaghri", "Vaghri" },
                                    { "tva", "Vaghua", "Vaghua" },
                                    { "vag", "Vagla", "Vagla" },
                                    { "vai", "Vai", "Vai" },
                                    { "vap", "Vaiphei", "Vaiphei" },
                                    { "vae", "Vale", "Vale" },
                                    { "vsv", "Valencian Sign Language", "Valencian Sign Language" },
                                    { "van", "Valman", "Valman" },
                                    { "vlp", "Valpei", "Valpei" },
                                    { "mkt", "Vamale", "Vamale" },
                                    { "mlr", "Vame", "Vame" },
                                    { "xvn", "Vandalic", "Vandalic" },
                                    { "mpr", "Vangunu", "Vangunu" },
                                    { "vam", "Vanimo", "Vanimo" },
                                    { "vnk", "Vano", "Vano" },
                                    { "vau", "Vanuma", "Vanuma" },
                                    { "vao", "Vao", "Vao" },
                                    { "vah", "Varhadi-Nagpuri", "Varhadi-Nagpuri" },
                                    { "vrs", "Varisi", "Varisi" },
                                    { "vav", "Varli", "Varli" },
                                    { "vas", "Vasavi", "Vasavi" },
                                    { "vaj", "Vasekela Bushman", "Vasekela Bushman" },
                                    { "ved", "Veddah", "Veddah" },
                                    { "val", "Vehes", "Vehes" },
                                    { "vel", "Veluws", "Veluws" },
                                    { "vem", "Vemgo-Mabas", "Vemgo-Mabas" },
                                    { "ven", "Venda", "Venda" },
                                    { "vec", "Venetian", "Venetian" },
                                    { "xve", "Venetic", "Venetic" },
                                    { "vsl", "Venezuelan Sign Language", "Venezuelan Sign Language" },
                                    { "bav", "Vengo", "Vengo" },
                                    { "veo", "Ventureño", "Ventureño" },
                                    { "vep", "Veps", "Veps" },
                                    { "vra", "Vera'a", "Vera'a" },
                                    { "xvs", "Vestinian", "Vestinian" },
                                    { "vid", "Vidunda", "Vidunda" },
                                    { "vig", "Viemo", "Viemo" },
                                    { "vie", "Vietnamese", "Vietnamese" },
                                    { "vil", "Vilela", "Vilela" },
                                    { "vif", "Vili", "Vili" },
                                    { "vnm", "Vinmavis", "Vinmavis" },
                                    { "vin", "Vinza", "Vinza" },
                                    { "vis", "Vishavan", "Vishavan" },
                                    { "vit", "Viti", "Viti" },
                                    { "vto", "Vitou", "Vitou" },
                                    { "wiv", "Vitu", "Vitu" },
                                    { "vls", "Vlaams", "Vlaams" },
                                    { "vgt", "Vlaamse Gebarentaal", "Vlaamse Gebarentaal" },
                                    { "vol", "Volapük", "Volapük" },
                                    { "xvo", "Volscian", "Volscian" },
                                    { "kch", "Vono", "Vono" },
                                    { "vor", "Voro", "Voro" },
                                    { "vro", "Võro", "Võro" },
                                    { "vot", "Votic", "Votic" },
                                    { "vum", "Vumbu", "Vumbu" },
                                    { "vnp", "Vunapu", "Vunapu" },
                                    { "vun", "Vunjo", "Vunjo" },
                                    { "msn", "Vurës", "Vurës" },
                                    { "vut", "Vute", "Vute" },
                                    { "wbi", "Vwanji", "Vwanji" },
                                    { "wbm", "Wa", "Wa" },
                                    { "wwa", "Waama", "Waama" },
                                    { "wmn", "Waamwang", "Waamwang" },
                                    { "ssn", "Waata", "Waata" },
                                    { "wab", "Wab", "Wab" },
                                    { "wbb", "Wabo", "Wabo" },
                                    { "kmx", "Waboda", "Waboda" },
                                    { "wdg", "Wadaginam", "Wadaginam" },
                                    { "wbq", "Waddar", "Waddar" },
                                    { "wdj", "Wadjiginy", "Wadjiginy" },
                                    { "wdu", "Wadjigu", "Wadjigu" },
                                    { "wrx", "Wae Rana", "Wae Rana" },
                                    { "wag", "Wa'ema", "Wa'ema" },
                                    { "waj", "Waffa", "Waffa" },
                                    { "wgb", "Wagawaga", "Wagawaga" },
                                    { "wga", "Wagaya", "Wagaya" },
                                    { "wbr", "Wagdi", "Wagdi" },
                                    { "waq", "Wageman", "Wageman" },
                                    { "fad", "Wagi", "Wagi" },
                                    { "wgi", "Wahgi", "Wahgi" },
                                    { "whg", "North Wahgi", "Wahgi, North" },
                                    { "wbk", "Waigali", "Waigali" },
                                    { "wgo", "Waigeo", "Waigeo" },
                                    { "wlk", "Wailaki", "Wailaki" },
                                    { "wlr", "Wailapa", "Wailapa" },
                                    { "rro", "Waima", "Waima" },
                                    { "wmh", "Waima'a", "Waima'a" },
                                    { "bao", "Waimaha", "Waimaha" },
                                    { "atr", "Waimiri-Atroari", "Waimiri-Atroari" },
                                    { "wli", "Waioli", "Waioli" },
                                    { "waw", "Waiwai", "Waiwai" },
                                    { "wja", "Waja", "Waja" },
                                    { "wbv", "Wajarri", "Wajarri" },
                                    { "wav", "Waka", "Waka" },
                                    { "wwb", "Wakabunga", "Wakabunga" },
                                    { "wkw", "Wakawaka", "Wakawaka" },
                                    { "wkd", "Wakde", "Wakde" },
                                    { "wbl", "Wakhi", "Wakhi" },
                                    { "waf", "Wakoná", "Wakoná" },
                                    { "lgl", "Wala", "Wala" },
                                    { "wlw", "Walak", "Walak" },
                                    { "wlx", "Wali (Ghana)", "Wali (Ghana)" },
                                    { "wll", "Wali (Sudan)", "Wali (Sudan)" },
                                    { "wly", "Waling", "Waling" },
                                    { "wla", "Walio", "Walio" },
                                    { "waa", "Walla Walla", "Walla Walla" },
                                    { "wls", "Wallisian", "Wallisian" },
                                    { "wln", "Walloon", "Walloon" },
                                    { "wmt", "Walmajarri", "Walmajarri" },
                                    { "wae", "Walser", "Walser" },
                                    { "ola", "Walungge", "Walungge" },
                                    { "wmc", "Wamas", "Wamas" },
                                    { "wmb", "Wambaya", "Wambaya" },
                                    { "wms", "Wambon", "Wambon" },
                                    { "wme", "Wambule", "Wambule" },
                                    { "cou", "Wamey", "Wamey" },
                                    { "wmi", "Wamin", "Wamin" },
                                    { "wam", "Wampanoag", "Wampanoag" },
                                    { "lbq", "Wampar", "Wampar" },
                                    { "waz", "Wampur", "Wampur" },
                                    { "wan", "Wan", "Wan" },
                                    { "wnb", "Wanambre", "Wanambre" },
                                    { "wnp", "Wanap", "Wanap" },
                                    { "alw", "Wanbasana", "Wanbasana" },
                                    { "wbh", "Wanda", "Wanda" },
                                    { "mfi", "Wandala", "Wandala" },
                                    { "wad", "Wandamen", "Wandamen" },
                                    { "wnd", "Wandarang", "Wandarang" },
                                    { "wdd", "Wandji", "Wandji" },
                                    { "hwa", "Wané", "Wané" },
                                    { "wne", "Waneci", "Waneci" },
                                    { "wyb", "Wangaaybuwan-Ngiyambaa", "Wangaaybuwan-Ngiyambaa" },
                                    { "wnm", "Wanggamala", "Wanggamala" },
                                    { "wgg", "Wangganguru", "Wangganguru" },
                                    { "wng", "Wanggom", "Wanggom" },
                                    { "wbt", "Wanman", "Wanman" },
                                    { "jub", "Wannu", "Wannu" },
                                    { "wno", "Wano", "Wano" },
                                    { "wnc", "Wantoat", "Wantoat" },
                                    { "wnk", "Wanukaka", "Wanukaka" },
                                    { "wny", "Wanyi", "Wanyi" },
                                    { "auc", "Waorani", "Waorani" },
                                    { "juk", "Wapan", "Wapan" },
                                    { "juw", "Wãpha", "Wãpha" },
                                    { "wap", "Wapishana", "Wapishana" },
                                    { "wao", "Wappo", "Wappo" },
                                    { "wbf", "Wara", "Wara" },
                                    { "tci", "Wára", "Wára" },
                                    { "wba", "Warao", "Warao" },
                                    { "wra", "Warapu", "Warapu" },
                                    { "wrz", "Waray (Australia)", "Waray (Australia)" },
                                    { "war", "Waray (Philippines)", "Waray (Philippines)" },
                                    { "wrr", "Wardaman", "Wardaman" },
                                    { "wrd", "Warduji", "Warduji" },
                                    { "wsa", "Warembori", "Warembori" },
                                    { "wai", "Wares", "Wares" },
                                    { "wrs", "Waris", "Waris" },
                                    { "wbe", "Waritai", "Waritai" },
                                    { "wri", "Wariyangga", "Wariyangga" },
                                    { "aml", "War-Jaintia", "War-Jaintia" },
                                    { "wji", "Warji", "Warji" },
                                    { "bgv", "Warkay-Bipim", "Warkay-Bipim" },
                                    { "wrl", "Warlmanpa", "Warlmanpa" },
                                    { "wbp", "Warlpiri", "Warlpiri" },
                                    { "wrb", "Warluwara", "Warluwara" },
                                    { "wrn", "Warnang", "Warnang" },
                                    { "wrp", "Waropen", "Waropen" },
                                    { "wgy", "Warrgamay", "Warrgamay" },
                                    { "wwr", "Warrwa", "Warrwa" },
                                    { "wru", "Waru", "Waru" },
                                    { "wrm", "Warumungu", "Warumungu" },
                                    { "wrv", "Waruna", "Waruna" },
                                    { "wrg", "Warungu", "Warungu" },
                                    { "wss", "Wasa", "Wasa" },
                                    { "wac", "Wasco-Wishram", "Wasco-Wishram" },
                                    { "gsp", "Wasembo", "Wasembo" },
                                    { "was", "Washo", "Washo" },
                                    { "wsk", "Waskia", "Waskia" },
                                    { "wsu", "Wasu", "Wasu" },
                                    { "wtk", "Watakataui", "Watakataui" },
                                    { "wax", "Watam", "Watam" },
                                    { "wtf", "Watiwa", "Watiwa" },
                                    { "wah", "Watubela", "Watubela" },
                                    { "mpl", "Middle Watut", "Watut, Middle" },
                                    { "una", "North Watut", "Watut, North" },
                                    { "mcy", "South Watut", "Watut, South" },
                                    { "kop", "Waube", "Waube" },
                                    { "wau", "Waurá", "Waurá" },
                                    { "wuy", "Wauyai", "Wauyai" },
                                    { "www", "Wawa", "Wawa" },
                                    { "wow", "Wawonii", "Wawonii" },
                                    { "wxa", "Waxianghua", "Waxianghua" },
                                    { "oym", "Wayampi", "Wayampi" },
                                    { "way", "Wayana", "Wayana" },
                                    { "wyr", "Wayoró", "Wayoró" },
                                    { "vay", "Wayu", "Wayu" },
                                    { "guc", "Wayuu", "Wayuu" },
                                    { "wob", "Wè Northern", "Wè Northern" },
                                    { "gxx", "Wè Southern", "Wè Southern" },
                                    { "wec", "Wè Western", "Wè Western" },
                                    { "wed", "Wedau", "Wedau" },
                                    { "weh", "Weh", "Weh" },
                                    { "wew", "Wejewa", "Wejewa" },
                                    { "klh", "Weliki", "Weliki" },
                                    { "cym", "Welsh", "Welsh" },
                                    { "wlm", "Middle Welsh", "Welsh, Middle" },
                                    { "owl", "Old Welsh", "Welsh, Old" },
                                    { "weo", "Wemale", "Wemale" },
                                    { "wer", "Weri", "Weri" },
                                    { "kvw", "Wersing", "Wersing" },
                                    { "wep", "Westphalien", "Westphalien" },
                                    { "wwo", "Wetamut", "Wetamut" },
                                    { "wea", "Wewaw", "Wewaw" },
                                    { "woy", "Weyto", "Weyto" },
                                    { "tnp", "Whitesands", "Whitesands" },
                                    { "tua", "Wiarumus", "Wiarumus" },
                                    { "mzh", "Wichí Lhamtés Güisnay", "Wichí Lhamtés Güisnay" },
                                    { "mtp", "Wichí Lhamtés Nocten", "Wichí Lhamtés Nocten" },
                                    { "wlv", "Wichí Lhamtés Vejoz", "Wichí Lhamtés Vejoz" },
                                    { "wic", "Wichita", "Wichita" },
                                    { "wik", "Wikalkan", "Wikalkan" },
                                    { "wie", "Wik-Epa", "Wik-Epa" },
                                    { "wij", "Wik-Iiyanh", "Wik-Iiyanh" },
                                    { "wif", "Wik-Keyangan", "Wik-Keyangan" },
                                    { "wih", "Wik-Me'anha", "Wik-Me'anha" },
                                    { "wim", "Wik-Mungkan", "Wik-Mungkan" },
                                    { "wig", "Wik-Ngathana", "Wik-Ngathana" },
                                    { "wua", "Wikngenchera", "Wikngenchera" },
                                    { "wil", "Wilawila", "Wilawila" },
                                    { "wit", "Wintu", "Wintu" },
                                    { "kst", "Winyé", "Winyé" },
                                    { "gdr", "Wipi", "Wipi" },
                                    { "wrh", "Wiradhuri", "Wiradhuri" },
                                    { "wir", "Wiraféd", "Wiraféd" },
                                    { "wgu", "Wirangu", "Wirangu" },
                                    { "wiu", "Wiru", "Wiru" },
                                    { "wiy", "Wiyot", "Wiyot" },
                                    { "xwc", "Woccon", "Woccon" },
                                    { "wog", "Wogamusin", "Wogamusin" },
                                    { "woc", "Wogeo", "Wogeo" },
                                    { "wbw", "Woi", "Woi" },
                                    { "jod", "Wojenaka", "Wojenaka" },
                                    { "wle", "Wolane", "Wolane" },
                                    { "wod", "Wolani", "Wolani" },
                                    { "wal", "Wolaytta", "Wolaytta" },
                                    { "woe", "Woleaian", "Woleaian" },
                                    { "wlo", "Wolio", "Wolio" },
                                    { "wol", "Wolof", "Wolof" },
                                    { "wof", "Gambian Wolof", "Wolof, Gambian" },
                                    { "wom", "Wom (Nigeria)", "Wom (Nigeria)" },
                                    { "wmo", "Wom (Papua New Guinea)", "Wom (Papua New Guinea)" },
                                    { "wmx", "Womo", "Womo" },
                                    { "won", "Wongo", "Wongo" },
                                    { "wor", "Woria", "Woria" },
                                    { "kda", "Worimi", "Worimi" },
                                    { "jud", "Worodougou", "Worodougou" },
                                    { "wro", "Worrorra", "Worrorra" },
                                    { "wsv", "Wotapuri-Katarqalai", "Wotapuri-Katarqalai" },
                                    { "wtw", "Wotu", "Wotu" },
                                    { "noa", "Woun Meu", "Woun Meu" },
                                    { "wud", "Wudu", "Wudu" },
                                    { "wlu", "Wuliwuli", "Wuliwuli" },
                                    { "wux", "Wulna", "Wulna" },
                                    { "bqm", "Wumboko", "Wumboko" },
                                    { "wum", "Wumbvu", "Wumbvu" },
                                    { "wub", "Wunambal", "Wunambal" },
                                    { "wur", "Wurrugu", "Wurrugu" },
                                    { "bse", "Wushi", "Wushi" },
                                    { "wsi", "Wusi", "Wusi" },
                                    { "wut", "Wutung", "Wutung" },
                                    { "wuh", "Wutunhua", "Wutunhua" },
                                    { "wuv", "Wuvulu-Aua", "Wuvulu-Aua" },
                                    { "udl", "Wuzlam", "Wuzlam" },
                                    { "wya", "Wyandot", "Wyandot" },
                                    { "wym", "Wymysorys", "Wymysorys" },
                                    { "kao", "Xaasongaxango", "Xaasongaxango" },
                                    { "xkr", "Xakriabá", "Xakriabá" },
                                    { "xam", "Xam", "Xam" },
                                    { "xan", "Xamtanga", "Xamtanga" },
                                    { "ane", "Xârâcùù", "Xârâcùù" },
                                    { "axx", "Xaragure", "Xaragure" },
                                    { "xav", "Xavánte", "Xavánte" },
                                    { "xeg", "Xegwi", "Xegwi" },
                                    { "xer", "Xerénte", "Xerénte" },
                                    { "xet", "Xetá", "Xetá" },
                                    { "xho", "Xhosa", "Xhosa" },
                                    { "xia", "Xiandao", "Xiandao" },
                                    { "sjo", "Xibe", "Xibe" },
                                    { "xin", "Xinca", "Xinca" },
                                    { "xiy", "Xipaya", "Xipaya" },
                                    { "xip", "Xipináwa", "Xipináwa" },
                                    { "xii", "Xiri", "Xiri" },
                                    { "xir", "Xiriâna", "Xiriâna" },
                                    { "xok", "Xokleng", "Xokleng" },
                                    { "nmn", "Xóõ", "Xóõ" },
                                    { "xoo", "Xukurú", "Xukurú" },
                                    { "gfx", "Mangetti Dune !Xung", "Xung, Mangetti Dune" },
                                    { "muu", "Yaaku", "Yaaku" },
                                    { "ybn", "Yabaâna", "Yabaâna" },
                                    { "yar", "Yabarana", "Yabarana" },
                                    { "jae", "Yabem", "Yabem" },
                                    { "ybm", "Yaben", "Yaben" },
                                    { "ybo", "Yabong", "Yabong" },
                                    { "yxy", "Yabula Yabula", "Yabula Yabula" },
                                    { "ekr", "Yace", "Yace" },
                                    { "rys", "Yaeyama", "Yaeyama" },
                                    { "yxg", "Yagara", "Yagara" },
                                    { "ygr", "Yagaria", "Yagaria" },
                                    { "yai", "Yagnobi", "Yagnobi" },
                                    { "ygm", "Yagomi", "Yagomi" },
                                    { "yad", "Yagua", "Yagua" },
                                    { "ygw", "Yagwoia", "Yagwoia" },
                                    { "ner", "Yahadian", "Yahadian" },
                                    { "rhp", "Yahang", "Yahang" },
                                    { "ynu", "Yahuna", "Yahuna" },
                                    { "axk", "Yaka (Central African Republic)", "Yaka (Central African Republic)" },
                                    { "iyx", "Yaka (Congo)", "Yaka (Congo)" },
                                    { "yaf", "Yaka (Democratic Republic of Congo)", "Yaka (Democratic Republic of Congo)" },
                                    { "ykk", "Yakaikeke", "Yakaikeke" },
                                    { "yak", "Yakama", "Yakama" },
                                    { "yka", "Yakan", "Yakan" },
                                    { "ybh", "Yakha", "Yakha" },
                                    { "yky", "Yakoma", "Yakoma" },
                                    { "sah", "Yakut", "Yakut" },
                                    { "yba", "Yala", "Yala" },
                                    { "jal", "Yalahatan", "Yalahatan" },
                                    { "xyl", "Yalakalore", "Yalakalore" },
                                    { "ylr", "Yalarnnga", "Yalarnnga" },
                                    { "nce", "Yale", "Yale" },
                                    { "kkl", "Kosarek Yale", "Yale, Kosarek" },
                                    { "ylb", "Yaleba", "Yaleba" },
                                    { "yli", "Angguruk Yali", "Yali, Angguruk" },
                                    { "nlk", "Ninia Yali", "Yali, Ninia" },
                                    { "yac", "Pass Valley Yali", "Yali, Pass Valley" },
                                    { "yal", "Yalunka", "Yalunka" },
                                    { "yag", "Yámana", "Yámana" },
                                    { "ymp", "Yamap", "Yamap" },
                                    { "yam", "Yamba", "Yamba" },
                                    { "ymb", "Yambes", "Yambes" },
                                    { "yat", "Yambeta", "Yambeta" },
                                    { "jmd", "Yamdena", "Yamdena" },
                                    { "yme", "Yameo", "Yameo" },
                                    { "tao", "Yami", "Yami" },
                                    { "yaa", "Yaminahua", "Yaminahua" },
                                    { "ymn", "Yamna", "Yamna" },
                                    { "ymg", "Yamongeri", "Yamongeri" },
                                    { "ybi", "Yamphu", "Yamphu" },
                                    { "lrr", "Southern Yamphu", "Yamphu, Southern" },
                                    { "ynn", "Yana", "Yana" },
                                    { "ynd", "Yandruwandha", "Yandruwandha" },
                                    { "ame", "Yanesha'", "Yanesha'" },
                                    { "yav", "Yangben", "Yangben" },
                                    { "ynh", "Yangho", "Yangho" },
                                    { "bsx", "Yangkam", "Yangkam" },
                                    { "jng", "Yangman", "Yangman" },
                                    { "yng", "Yango", "Yango" },
                                    { "ynl", "Yangulam", "Yangulam" },
                                    { "yde", "Yangum Dey", "Yangum Dey" },
                                    { "ygl", "Yangum Gel", "Yangum Gel" },
                                    { "ymo", "Yangum Mon", "Yangum Mon" },
                                    { "kdd", "Yankunytjatjara", "Yankunytjatjara" },
                                    { "jay", "Yan-nhangu", "Yan-nhangu" },
                                    { "wca", "Yanomámi", "Yanomámi" },
                                    { "guu", "Yanomamö", "Yanomamö" },
                                    { "yns", "Yansi", "Yansi" },
                                    { "jao", "Yanyuwa", "Yanyuwa" },
                                    { "yao", "Yao", "Yao" },
                                    { "yre", "Yaouré", "Yaouré" },
                                    { "yap", "Yapese", "Yapese" },
                                    { "yev", "Yapunda", "Yapunda" },
                                    { "jaq", "Yaqay", "Yaqay" },
                                    { "yaq", "Yaqui", "Yaqui" },
                                    { "yrw", "Yarawata", "Yarawata" },
                                    { "yrb", "Yareba", "Yareba" },
                                    { "yri", "Yarí", "Yarí" },
                                    { "yrs", "Yarsun", "Yarsun" },
                                    { "yko", "Yasa", "Yasa" },
                                    { "ysc", "Yassic", "Yassic" },
                                    { "yuw", "Yau (Morobe Province)", "Yau (Morobe Province)" },
                                    { "yyu", "Yau (Sandaun Province)", "Yau (Sandaun Province)" },
                                    { "yla", "Yaul", "Yaul" },
                                    { "yax", "Yauma", "Yauma" },
                                    { "jau", "Yaur", "Yaur" },
                                    { "yvt", "Yavitero", "Yavitero" },
                                    { "yva", "Yawa", "Yawa" },
                                    { "yaw", "Yawalapití", "Yawalapití" },
                                    { "ywn", "Yawanawa", "Yawanawa" },
                                    { "yww", "Yawarawarga", "Yawarawarga" },
                                    { "yby", "Yaweyuha", "Yaweyuha" },
                                    { "jbw", "Yawijibaya", "Yawijibaya" },
                                    { "ybx", "Yawiyo", "Yawiyo" },
                                    { "ywr", "Yawuru", "Yawuru" },
                                    { "yah", "Yazgulyam", "Yazgulyam" },
                                    { "jei", "Yei", "Yei" },
                                    { "ets", "Yekhee", "Yekhee" },
                                    { "ykr", "Yekora", "Yekora" },
                                    { "yel", "Yela", "Yela" },
                                    { "yle", "Yele", "Yele" },
                                    { "jel", "Yelmek", "Yelmek" },
                                    { "ylg", "Yelogu", "Yelogu" },
                                    { "ybb", "Yemba", "Yemba" },
                                    { "jnj", "Yemsa", "Yemsa" },
                                    { "ynq", "Yendang", "Yendang" },
                                    { "yei", "Yeni", "Yeni" },
                                    { "yec", "Yeniche", "Yeniche" },
                                    { "yra", "Yerakai", "Yerakai" },
                                    { "gop", "Yeretuar", "Yeretuar" },
                                    { "yrn", "Yerong", "Yerong" },
                                    { "yeu", "Yerukula", "Yerukula" },
                                    { "yss", "Yessan-Mayo", "Yessan-Mayo" },
                                    { "yet", "Yetfa", "Yetfa" },
                                    { "yej", "Yevanic", "Yevanic" },
                                    { "yey", "Yeyi", "Yeyi" },
                                    { "yix", "Axi Yi", "Yi, Axi" },
                                    { "ylo", "Naluo Yi", "Yi, Naluo" },
                                    { "iii", "Sichuan Yi", "Yi, Sichuan" },
                                    { "ywq", "Wuding-Luquan Yi", "Yi, Wuding-Luquan" },
                                    { "yid", "Yiddish", "Yiddish" },
                                    { "yds", "Yiddish Sign Language", "Yiddish Sign Language" },
                                    { "ydd", "Eastern Yiddish", "Yiddish, Eastern" },
                                    { "yih", "Western Yiddish", "Yiddish, Western" },
                                    { "ydg", "Yidgha", "Yidgha" },
                                    { "yii", "Yidiny", "Yidiny" },
                                    { "yll", "Yil", "Yil" },
                                    { "yee", "Yimas", "Yimas" },
                                    { "yin", "Yinchia", "Yinchia" },
                                    { "yij", "Yindjibarndi", "Yindjibarndi" },
                                    { "yil", "Yindjilandji", "Yindjilandji" },
                                    { "pib", "Yine", "Yine" },
                                    { "yia", "Yinggarda", "Yinggarda" },
                                    { "yiy", "Yir Yoront", "Yir Yoront" },
                                    { "yis", "Yis", "Yis" },
                                    { "gek", "Yiwom", "Yiwom" },
                                    { "yob", "Yoba", "Yoba" },
                                    { "yog", "Yogad", "Yogad" },
                                    { "ydk", "Yoidik", "Yoidik" },
                                    { "yki", "Yoke", "Yoke" },
                                    { "yok", "Yokuts", "Yokuts" },
                                    { "yol", "Yola", "Yola" },
                                    { "pil", "Yom", "Yom" },
                                    { "yom", "Yombe", "Yombe" },
                                    { "yoi", "Yonaguni", "Yonaguni" },
                                    { "yno", "Yong", "Yong" },
                                    { "yon", "Yongkom", "Yongkom" },
                                    { "yut", "Yopno", "Yopno" },
                                    { "mts", "Yora", "Yora" },
                                    { "yox", "Yoron", "Yoron" },
                                    { "xyy", "Yorta Yorta", "Yorta Yorta" },
                                    { "yor", "Yoruba", "Yoruba" },
                                    { "yos", "Yos", "Yos" },
                                    { "yot", "Yotti", "Yotti" },
                                    { "ytw", "Yout Wam", "Yout Wam" },
                                    { "yoy", "Yoy", "Yoy" },
                                    { "nua", "Yuaga", "Yuaga" },
                                    { "msd", "Yucatec Maya Sign Language", "Yucatec Maya Sign Language" },
                                    { "yua", "Yucateco", "Yucateco" },
                                    { "yuc", "Yuchi", "Yuchi" },
                                    { "ycn", "Yucuna", "Yucuna" },
                                    { "yug", "Yug", "Yug" },
                                    { "yub", "Yugambal", "Yugambal" },
                                    { "yuu", "Yugh", "Yugh" },
                                    { "ysl", "Yugoslavian Sign Language", "Yugoslavian Sign Language" },
                                    { "yuy", "East Yugur", "Yugur, East" },
                                    { "ybe", "West Yugur", "Yugur, West" },
                                    { "yab", "Yuhup", "Yuhup" },
                                    { "ykg", "Northern Yukaghir", "Yukaghir, Northern" },
                                    { "yux", "Southern Yukaghir", "Yukaghir, Southern" },
                                    { "yuk", "Yuki", "Yuki" },
                                    { "yup", "Yukpa", "Yukpa" },
                                    { "ybl", "Yukuben", "Yukuben" },
                                    { "yul", "Yulu", "Yulu" },
                                    { "esu", "Central Yupik", "Yupik, Central" },
                                    { "ess", "Central Siberian Yupik", "Yupik, Central Siberian" },
                                    { "ynk", "Naukan Yupik", "Yupik, Naukan" },
                                    { "ems", "Pacific Gulf Yupik", "Yupik, Pacific Gulf" },
                                    { "ysr", "Sirenik Yupik", "Yupik, Sirenik" },
                                    { "yuq", "Yuqui", "Yuqui" },
                                    { "yuz", "Yuracare", "Yuracare" },
                                    { "yur", "Yurok", "Yurok" },
                                    { "yui", "Yurutí", "Yurutí" },
                                    { "yau", "Yuwana", "Yuwana" },
                                    { "kji", "Zabana", "Zabana" },
                                    { "zag", "Zaghawa", "Zaghawa" },
                                    { "atb", "Zaiwa", "Zaiwa" },
                                    { "zkr", "Zakhring", "Zakhring" },
                                    { "zsl", "Zambian Sign Language", "Zambian Sign Language" },
                                    { "zna", "Zan Gula", "Zan Gula" },
                                    { "zak", "Zanaki", "Zanaki" },
                                    { "zne", "Zande (individual language)", "Zande (individual language)" },
                                    { "zau", "Zangskari", "Zangskari" },
                                    { "zah", "Zangwal", "Zangwal" },
                                    { "zro", "Záparo", "Záparo" },
                                    { "zap", "Zapotec", "Zapotec" },
                                    { "zaq", "Aloápam Zapotec", "Zapotec, Aloápam" },
                                    { "zpo", "Amatlán Zapotec", "Zapotec, Amatlán" },
                                    { "xzp", "Ancient Zapotec", "Zapotec, Ancient" },
                                    { "zoo", "Asunción Mixtepec Zapotec", "Zapotec, Asunción Mixtepec" },
                                    { "zaf", "Ayoquesco Zapotec", "Zapotec, Ayoquesco" },
                                    { "zad", "Cajonos Zapotec", "Zapotec, Cajonos" },
                                    { "zpv", "Chichicapan Zapotec", "Zapotec, Chichicapan" },
                                    { "zpc", "Choapan Zapotec", "Zapotec, Choapan" },
                                    { "zca", "Coatecas Altas Zapotec", "Zapotec, Coatecas Altas" },
                                    { "zps", "Coatlán Zapotec", "Zapotec, Coatlán" },
                                    { "zpp", "El Alto Zapotec", "Zapotec, El Alto" },
                                    { "zte", "Elotepec Zapotec", "Zapotec, Elotepec" },
                                    { "zpg", "Guevea De Humboldt Zapotec", "Zapotec, Guevea De Humboldt" },
                                    { "ztu", "Güilá Zapotec", "Zapotec, Güilá" },
                                    { "zai", "Isthmus Zapotec", "Zapotec, Isthmus" },
                                    { "zpa", "Lachiguiri Zapotec", "Zapotec, Lachiguiri" },
                                    { "zpl", "Lachixío Zapotec", "Zapotec, Lachixío" },
                                    { "ztl", "Lapaguía-Guivini Zapotec", "Zapotec, Lapaguía-Guivini" },
                                    { "ztp", "Loxicha Zapotec", "Zapotec, Loxicha" },
                                    { "zpy", "Mazaltepec Zapotec", "Zapotec, Mazaltepec" },
                                    { "zam", "Miahuatlán Zapotec", "Zapotec, Miahuatlán" },
                                    { "zaw", "Mitla Zapotec", "Zapotec, Mitla" },
                                    { "zpm", "Mixtepec Zapotec", "Zapotec, Mixtepec" },
                                    { "zac", "Ocotlán Zapotec", "Zapotec, Ocotlán" },
                                    { "zao", "Ozolotepec Zapotec", "Zapotec, Ozolotepec" },
                                    { "zpe", "Petapa Zapotec", "Zapotec, Petapa" },
                                    { "zpj", "Quiavicuzas Zapotec", "Zapotec, Quiavicuzas" },
                                    { "ztq", "Quioquitani-Quierí Zapotec", "Zapotec, Quioquitani-Quierí" },
                                    { "zar", "Rincón Zapotec", "Zapotec, Rincón" },
                                    { "ztm", "San Agustín Mixtepec Zapotec", "Zapotec, San Agustín Mixtepec" },
                                    { "zpx", "San Baltazar Loxicha Zapotec", "Zapotec, San Baltazar Loxicha" },
                                    { "zab", "San Juan Guelavía Zapotec", "Zapotec, San Juan Guelavía" },
                                    { "zpf", "San Pedro Quiatoni Zapotec", "Zapotec, San Pedro Quiatoni" },
                                    { "zpt", "San Vicente Coatlán Zapotec", "Zapotec, San Vicente Coatlán" },
                                    { "ztn", "Santa Catarina Albarradas Zapotec", "Zapotec, Santa Catarina Albarradas" },
                                    { "zpn", "Santa Inés Yatzechi Zapotec", "Zapotec, Santa Inés Yatzechi" },
                                    { "zpi", "Santa María Quiegolani Zapotec", "Zapotec, Santa María Quiegolani" },
                                    { "zpr", "Santiago Xanica Zapotec", "Zapotec, Santiago Xanica" },
                                    { "zas", "Santo Domingo Albarradas Zapotec", "Zapotec, Santo Domingo Albarradas" },
                                    { "zaa", "Sierra de Juárez Zapotec", "Zapotec, Sierra de Juárez" },
                                    { "zpd", "Southeastern Ixtlán Zapotec", "Zapotec, Southeastern Ixtlán" },
                                    { "zsr", "Southern Rincon Zapotec", "Zapotec, Southern Rincon" },
                                    { "zat", "Tabaa Zapotec", "Zapotec, Tabaa" },
                                    { "ztt", "Tejalapan Zapotec", "Zapotec, Tejalapan" },
                                    { "zpz", "Texmelucan Zapotec", "Zapotec, Texmelucan" },
                                    { "zts", "Tilquiapan Zapotec", "Zapotec, Tilquiapan" },
                                    { "zpk", "Tlacolulita Zapotec", "Zapotec, Tlacolulita" },
                                    { "zph", "Totomachapan Zapotec", "Zapotec, Totomachapan" },
                                    { "zax", "Xadani Zapotec", "Zapotec, Xadani" },
                                    { "ztg", "Xanaguía Zapotec", "Zapotec, Xanaguía" },
                                    { "zpu", "Yalálag Zapotec", "Zapotec, Yalálag" },
                                    { "zae", "Yareni Zapotec", "Zapotec, Yareni" },
                                    { "zty", "Yatee Zapotec", "Zapotec, Yatee" },
                                    { "zav", "Yatzachi Zapotec", "Zapotec, Yatzachi" },
                                    { "zpb", "Yautepec Zapotec", "Zapotec, Yautepec" },
                                    { "ztx", "Zaachila Zapotec", "Zapotec, Zaachila" },
                                    { "zpw", "Zaniza Zapotec", "Zapotec, Zaniza" },
                                    { "zpq", "Zoogocho Zapotec", "Zapotec, Zoogocho" },
                                    { "zaj", "Zaramo", "Zaramo" },
                                    { "zaz", "Zari", "Zari" },
                                    { "dje", "Zarma", "Zarma" },
                                    { "zrp", "Zarphatic", "Zarphatic" },
                                    { "zal", "Zauzou", "Zauzou" },
                                    { "zwa", "Zay", "Zay" },
                                    { "zay", "Zayse-Zergulla", "Zayse-Zergulla" },
                                    { "zza", "Zazaki", "Zazaki" },
                                    { "jaj", "Zazao", "Zazao" },
                                    { "zua", "Zeem", "Zeem" },
                                    { "zea", "Zeeuws", "Zeeuws" },
                                    { "dhm", "Zemba", "Zemba" },
                                    { "xzm", "Zemgalian", "Zemgalian" },
                                    { "zeg", "Zenag", "Zenag" },
                                    { "zen", "Zenaga", "Zenaga" },
                                    { "zrn", "Zerenkel", "Zerenkel" },
                                    { "zhb", "Zhaba", "Zhaba" },
                                    { "xzh", "Zhang-Zhung", "Zhang-Zhung" },
                                    { "zhi", "Zhire", "Zhire" },
                                    { "zhw", "Zhoa", "Zhoa" },
                                    { "zha", "Zhuang", "Zhuang" },
                                    { "zch", "Central Hongshuihe Zhuang", "Zhuang, Central Hongshuihe" },
                                    { "zhd", "Dai Zhuang", "Zhuang, Dai" },
                                    { "zeh", "Eastern Hongshuihe Zhuang", "Zhuang, Eastern Hongshuihe" },
                                    { "zgb", "Guibei Zhuang", "Zhuang, Guibei" },
                                    { "zgn", "Guibian Zhuang", "Zhuang, Guibian" },
                                    { "zln", "Lianshan Zhuang", "Zhuang, Lianshan" },
                                    { "zlj", "Liujiang Zhuang", "Zhuang, Liujiang" },
                                    { "zlq", "Liuqian Zhuang", "Zhuang, Liuqian" },
                                    { "zgm", "Minz Zhuang", "Zhuang, Minz" },
                                    { "zhn", "Nong Zhuang", "Zhuang, Nong" },
                                    { "zqe", "Qiubei Zhuang", "Zhuang, Qiubei" },
                                    { "zyg", "Yang Zhuang", "Zhuang, Yang" },
                                    { "zyb", "Yongbei Zhuang", "Zhuang, Yongbei" },
                                    { "zyn", "Yongnan Zhuang", "Zhuang, Yongnan" },
                                    { "zyj", "Youjiang Zhuang", "Zhuang, Youjiang" },
                                    { "zzj", "Zuojiang Zhuang", "Zhuang, Zuojiang" },
                                    { "zia", "Zia", "Zia" },
                                    { "zil", "Zialo", "Zialo" },
                                    { "ziw", "Zigula", "Zigula" },
                                    { "zik", "Zimakani", "Zimakani" },
                                    { "zmb", "Zimba", "Zimba" },
                                    { "zib", "Zimbabwe Sign Language", "Zimbabwe Sign Language" },
                                    { "zin", "Zinza", "Zinza" },
                                    { "sih", "Zire", "Zire" },
                                    { "zir", "Ziriya", "Ziriya" },
                                    { "ziz", "Zizilivakan", "Zizilivakan" },
                                    { "pto", "Zo'é", "Zo'é" },
                                    { "yzk", "Zokhuo", "Zokhuo" },
                                    { "zoh", "Chimalapa Zoque", "Zoque, Chimalapa" },
                                    { "zoc", "Copainalá Zoque", "Zoque, Copainalá" },
                                    { "zos", "Francisco León Zoque", "Zoque, Francisco León" },
                                    { "zor", "Rayón Zoque", "Zoque, Rayón" },
                                    { "zoq", "Tabasco Zoque", "Zoque, Tabasco" },
                                    { "wfg", "Zorop", "Zorop" },
                                    { "zom", "Zou", "Zou" },
                                    { "gnd", "Zulgo-Gemzek", "Zulgo-Gemzek" },
                                    { "zul", "Zulu", "Zulu" },
                                    { "zuy", "Zumaya", "Zumaya" },
                                    { "jmb", "Zumbun", "Zumbun" },
                                    { "zun", "Zuni", "Zuni" },
                                    { "zyp", "Zyphe", "Zyphe" }
                                                   };

        public static int ISOLanguageCodesLength
        {
            get { return ISOLanguageCodes.Length / 3; }
        }

        public static string GetLanguageName(string languageCode)
        {
            for (int i=0; i<ISOLanguageCodes.Length/3; i++)
                if (ISOLanguageCodes[i,0].ToLower() == languageCode.ToLower())
                    return ISOLanguageCodes[i,2]; // Return the inverted language name for the 3 digit code

            throw new System.ArgumentException("Language code does not exist", "languageCode"); // nothing found
        }

        public static string GetLanguageCode(string languageName)
        {
            for (int i = 0; i < ISOLanguageCodes.Length / 3; i++)
                if ((ISOLanguageCodes[i, 1].ToLower() == languageName.ToLower()) || (ISOLanguageCodes[i, 2].ToLower() == languageName.ToLower()))
                    return ISOLanguageCodes[i, 0]; // Return the 3 digit language code

            throw new System.ArgumentException("Language name does not exist", "languageName"); // nothing found
        }
    }
}
